SystemOrganization addCategory: #HoneyGinger!
SystemOrganization addCategory: 'HoneyGinger-Actions-Elasticity'!
SystemOrganization addCategory: 'HoneyGinger-Actions-FluidDynamics'!
SystemOrganization addCategory: 'HoneyGinger-Actions-Kernel'!
SystemOrganization addCategory: 'HoneyGinger-Actions-Mechanics'!
SystemOrganization addCategory: 'HoneyGinger-Actions-Networking'!
SystemOrganization addCategory: 'HoneyGinger-Actions-Simulation'!
SystemOrganization addCategory: 'HoneyGinger-Actions-Thermal'!
SystemOrganization addCategory: 'HoneyGinger-Actions-UI'!
SystemOrganization addCategory: 'HoneyGinger-Communications-Serializers'!
SystemOrganization addCategory: 'HoneyGinger-Communications-Server'!
SystemOrganization addCategory: 'HoneyGinger-Communications-Streams'!
SystemOrganization addCategory: 'HoneyGinger-Communications-Tests'!
SystemOrganization addCategory: 'HoneyGinger-Geometry-Neighbors'!
SystemOrganization addCategory: 'HoneyGinger-Geometry-Points'!
SystemOrganization addCategory: 'HoneyGinger-Geometry-Regions'!
SystemOrganization addCategory: 'HoneyGinger-Geometry-Tests'!
SystemOrganization addCategory: 'HoneyGinger-Geometry-Voronoi'!
SystemOrganization addCategory: 'HoneyGinger-Particles'!
SystemOrganization addCategory: 'HoneyGinger-Simulator'!
SystemOrganization addCategory: 'HoneyGinger-Tests-Abstract'!
SystemOrganization addCategory: 'HoneyGinger-Utilities'!

Morph subclass: #HGImageClipper
	instanceVariableNames: 'basedir filenameIndex breadMorphs fileListMorph sourceImageMorph clippedImageMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Utilities'!

!HGImageClipper class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGImageClipper class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGImageClipper methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 08:16'!
basedir: aFileDirectory
	basedir := aFileDirectory.
	self updateBreadsMorphs.
	self changed: #filenames! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/19/2011 11:51'!
breadsDirectoriesFor: aFileDirectory
	| components dir parent |
	components := OrderedCollection with: aFileDirectory.
	dir := aFileDirectory.
	parent := dir containingDirectory.
	[parent = dir] whileFalse: [
		dir := parent.
		components add: dir.
		parent := dir containingDirectory].
	^ components reversed! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/19/2011 11:29'!
fileChanged: aString
! !

!HGImageClipper methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 08:13'!
filename
	^ [self filenames at: filenameIndex] ifError: []! !

!HGImageClipper methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 08:13'!
filenameIndex
	^ filenameIndex! !

!HGImageClipper methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 08:13'!
filenameIndex: anInteger
	filenameIndex := anInteger.
	self updateSourceImage.
	self changed: #filenameIndex.
	self changed: #filename! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/19/2011 11:39'!
filenames
	^ basedir entries collect: [:e | e name]! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/20/2011 08:14'!
flushSourceImage
	sourceImageMorph image: (Form extent: 64 @ 64 depth: 32)! !

!HGImageClipper methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/20/2011 08:13'!
initialize
	super initialize.
	filenameIndex := 0.
	self layoutPolicy: ProportionalLayout new.
	basedir := FileDirectory default.
	breadMorphs := Morph new.
	breadMorphs color: Color white.
	breadMorphs
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight.
	self addMorph: breadMorphs fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).
	self updateBreadsMorphs.
	fileListMorph := PluggableListMorph
		on: self
		list: #filenames
		selected: #filenameIndex
		changeSelected: #filenameIndex:.
	self
		addMorph: fileListMorph
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0.5) offsets: (0 @ 26 corner: 0 @ 0)).
	sourceImageMorph := (Form extent: 64 @ 64 depth: 32) asMorph.
	self addMorph: sourceImageMorph fullFrame: (LayoutFrame fractions: (0 @ 0.5 corner: 0.5 @ 1)).
	clippedImageMorph := (Form extent: 64 @ 64 depth: 32) asMorph.
	self addMorph: clippedImageMorph fullFrame: (LayoutFrame fractions: (0.5 @ 0.5 corner: 1 @ 1))! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/20/2011 08:16'!
newBreadFor: aFileDirectory
	| buttonMorph |
	buttonMorph := PluggableButtonMorph on: self getState: nil action: nil.
	buttonMorph actionBlock:  [self basedir: aFileDirectory].
	^ buttonMorph! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/19/2011 13:55'!
updateBreadsMorphs
	| dirs morphs |
	dirs := self breadsDirectoriesFor: basedir.
	morphs := breadMorphs submorphs copy.
	1 to: (dirs size min: morphs size) do: [ :index | 
		| dir |
		dir := dirs at: index.
		(morphs at: index) action: [self basedir: dir]].
	dirs size > morphs size
		ifTrue: [ morphs size + 1 to: dirs size do: [ :index | breadMorphs addMorph: (self newBreadFor: (dirs at: index)) ] ]
		ifFalse: [ dirs size + 1 to: morphs size do: [ :index | breadMorphs removeMorph: (morphs at: index)]]! !

!HGImageClipper methodsFor: 'updating' stamp: 'TomohiroOda 10/20/2011 08:14'!
updateSourceImage
	| name |
	name := self filename.
	name ifNil: [ ^ self flushSourceImage ].
	(name asLowercase endsWith: '.jpg')
		ifFalse: [ ^ self flushSourceImage ].
	(basedir isAFileNamed: self filename)
		ifFalse: [ ^ self flushSourceImage ].
	[ 
	| image |
	image := Form fromFileNamed: (basedir fullNameFor: name).
	image width > sourceImageMorph bounds width
		ifTrue: [ image := image magnifyBy: sourceImageMorph bounds width / image width ].
	image height > sourceImageMorph bounds height
		ifTrue: [ image := image magnifyBy: sourceImageMorph bounds height / image height ].
	sourceImageMorph image: image ] value! !

Morph subclass: #HGWalker
	instanceVariableNames: 'v w'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Utilities'!

!HGWalker class methodsFor: 'utility' stamp: 'TomohiroOda 5/24/2012 09:40'!
atHand
	"HGWalker atHand"
	| walker |
	walker := self v: (Point r: 30.0 degrees: (World topLeft - ActiveHand center) degrees) w: 0.05.
	walker center: ActiveHand position.
	walker extent: 50@30.
	walker openInWorld! !

!HGWalker class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/24/2012 09:05'!
v: aPoint w: aNumber
	^ self new setV: aPoint w: aNumber! !

!HGWalker methodsFor: 'private' stamp: 'TomohiroOda 5/24/2012 09:01'!
setV: aPoint w: aNumber
	v := aPoint.
	w := aNumber! !

!HGWalker methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 5/24/2012 09:08'!
step
	v := Point r: v r degrees: v theta + w * 180.0 / Float pi.
	self position: self position + v.
	(World containsPoint: self center) ifFalse: [self delete]! !

!HGWalker methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 5/24/2012 09:37'!
stepTime
	^ 20! !

Morph subclass: #HoneyGingerLauncher
	instanceVariableNames: 'simulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Utilities'!

!HoneyGingerLauncher class methodsFor: 'instance creation' stamp: 'TomohiroOda 3/19/2012 18:22'!
open
	"HoneyGingerLauncher open"
	self new openInWindowLabeled: 'HoneyGinger Launcher'! !

!HoneyGingerLauncher methodsFor: 'initialization' stamp: 'TomohiroOda 3/19/2012 18:12'!
initialize
	super initialize.
	self color: Color white.
	self changeTableLayout.
	self listDirection: #bottomToTop.
	self wrapCentering: #center.
	self simulatorSelectors
		do: [ :selector | 
			| morph |
			morph := (SimpleButtonMorph newWithLabel: selector asString)
				on: #mouseDown send: #value to: [ self launch: selector ];
				yourself.
			self addMorph: morph.
			morph hResizing: #spaceFill ].
	^ self! !

!HoneyGingerLauncher methodsFor: 'actions' stamp: 'TomohiroOda 3/19/2012 18:15'!
launch: aSymbol
	| morph |
	simulator ifNotNilDo: [ :sim | sim delete ].
	morph := HGSimulator perform: aSymbol.
	[morph isKindOf: SystemWindow] whileFalse: [morph := morph owner].
	simulator := morph! !

!HoneyGingerLauncher methodsFor: 'menu' stamp: 'TomohiroOda 5/24/2012 08:54'!
simulatorSelectors
	^ #(
	greasyPit sandtrap3D
	silkyString5 gumString5 arrestingWire5 slackFence
	lagoonDots lagoonPolygons lagoonPressureMap lagoonPerspectiveDots
	splashDots splashPressureMap splashPressureBorderlineGraffitiFill
	lagoonPressureMapWorld
	watershowDots watershowPressureMap watershowSourceCode washoutDots
	jelloAtDie rockAtDie butterBallAtDie
	stickyBeans stickyBeansAtDie
	coldButterHotKnife hotButterColdKnife)! !

Stream subclass: #HoneyGingerTestSocketStream
	instanceVariableNames: 'readStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerTestSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HoneyGingerTestSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerTestSocketStream class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/9/2011 13:15'!
readBuffer: aBuffer writeBuffer: anotherBuffer
	^ (self basicNew)
		initialize;
		readBuffer: aBuffer writeBuffer: anotherBuffer;
		yourself! !

!HoneyGingerTestSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:23'!
binary
	! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:28'!
close
	readStream := nil.
	writeStream := nil! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:28'!
next
	^ readStream next! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:28'!
next: anInteger
	^ readStream next: anInteger! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:28'!
nextPut: anObject
	^ writeStream nextPut: anObject ! !

!HoneyGingerTestSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:28'!
nextPutAll: aCollection
	^ writeStream nextPutAll: aCollection! !

!HoneyGingerTestSocketStream methodsFor: 'printing' stamp: 'TomohiroOda 10/9/2011 13:37'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	readStream printOn: aStream.
	aStream nextPut: $,.
	writeStream printOn: aStream.
	aStream nextPut: $)! !

!HoneyGingerTestSocketStream methodsFor: 'private' stamp: 'TomohiroOda 10/9/2011 12:28'!
readBuffer: aBuffer writeBuffer: anotherBuffer
	readStream := aBuffer.
	writeStream := anotherBuffer! !

Stream subclass: #HoneyGingerTestStream
	instanceVariableNames: 'bytes readIndex writeIndex readSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerTestStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HoneyGingerTestStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerTestStream class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/9/2011 13:13'!
new
	^ (self basicNew)
		initialize;
		yourself! !

!HoneyGingerTestStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerTestStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/5/2011 13:28'!
contents
	^ bytes copyFrom: 1 to: writeIndex - 1! !

!HoneyGingerTestStream methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/9/2011 13:51'!
initialize
	super initialize.
	bytes := ByteArray new: 10.
	readIndex := 1.
	writeIndex := 1.
	readSemaphore := Semaphore new! !

!HoneyGingerTestStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:50'!
next
	readSemaphore wait.
	[ ^ bytes at: readIndex ] ensure: [ readIndex := readIndex + 1 ]! !

!HoneyGingerTestStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/5/2011 13:57'!
next: anInteger
	| result |
	result := Array new: anInteger.
	1 to: anInteger do: [ :index | result at: index put: self next ].
	^ result! !

!HoneyGingerTestStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:51'!
nextPut: anInteger
	writeIndex > bytes size
		ifTrue: [ 
			| newBytes |
			newBytes := ByteArray new: bytes size * 2.
			newBytes writeStream nextPutAll: bytes.
			bytes := newBytes ].
	[ ^ bytes at: writeIndex put: anInteger ] ensure: [ writeIndex := writeIndex + 1. readSemaphore signal ]! !

!HoneyGingerTestStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/5/2011 13:54'!
nextPutAll: aCollection
	aCollection do: [ :object | self nextPut: object ].
	^ aCollection! !

!HoneyGingerTestStream methodsFor: 'printing' stamp: 'TomohiroOda 10/9/2011 13:38'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	bytes printOn: aStream.
	aStream nextPut: $,.
	readIndex printOn: aStream.
	aStream nextPut: $,.
	writeIndex printOn: aStream.
	aStream nextPut: $)! !

BorderedMorph subclass: #HGSimulator
	instanceVariableNames: 'random simulationOrigin simulationCorner simulationTime viewExtent offset actions initializers particleMap particleMapResolution particles visibleForm form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Simulator'!

!HGSimulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSimulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 6/11/2012 08:06'!
aerowing
	"HGSimulator aerowing"

	| form1 form2 form simulator vy background |
	vy := -10.0.
	form1 := Form extent: 500@500 depth: 32.
	form1 getCanvas fillColor: Color white; drawImage: (Form fromFileNamed: 'wing.png') at: 0@100; flush.	
	form2 := Form extent: 500@500 depth: 32.
	form2 getCanvas fillColor: Color white; drawImage: (Form fromFileNamed: 'wing2.png') at: 0@100; flush.
	form := form1.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: 0.0 y: vy)).
	simulator addInitializer: (HGTemperatureInitialization with: 390).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.3 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGSlipperyObstacle with: (HG2dBlockRegion on: [ :position | (form colorAt: position asPoint) luminance < 0.5 ])).	
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [
		simulator particlesDo: [ :particle |
			(particle position x < 10.0 or: [particle position x > 490.0]) ifTrue: [particle velocity x: 0.0; y: vy]]]).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [
		simulator particlesDo: [ :particle |
			(particle position y < 10.0) ifTrue: [particle position x: simulator random next * 500; y: particle position y + 490.0.
				particle velocity: (HG2dPoint x: 0.0 y: vy)]]]).
	simulator addAction: (HGTriggerBlockAction whenever: [false] do: [vy := vy - 0.01]).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ ActiveHand anyButtonPressed ifTrue: [form := form2] ifFalse: [form := form1]. background form: form]).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: form).
	"simulator addAction: (HGDotsVisualizer radius: 3 color: Color blue)."
	simulator
		addAction:
			((HGMeshVelocityVisualizer xgrids: 30
		ygrids: 30
		kernel: (HGSimpleKernel support: 40)
		radius: 1
		width: 1
		scale: 2.0
		color: Color black)).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Flood'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/9/2012 12:20'!
arrestingWire1
	"HGSimulator arrestingWire1"

	| random simulator bindingAction stick firsts lasts |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 20
				convergenceCoefficient: 0.1
				color: Color gray
				width: 4).
	simulator addAction: (HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	250 to: 250 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 200.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		200 to: 300 by: 10 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 5) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ].
	(self
		verticalPanel:
			(Array with: (self selectorPanel: 'Tension' do: [ :steps | bindingAction steps: steps ] withAll: #(1 5 10 20))))
		 addMorph: simulator; openInWindowLabeled: 'Arresting Wire 1'.
	simulator startStepping..
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/13/2012 15:57'!
arrestingWire5
	"HGSimulator arrestingWire5"

	| random simulator bindingAction stick firsts lasts |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 20
				convergenceCoefficient: 0.1
				color: Color gray
				width: 2).
	simulator addAction: (HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	240 to: 260 by: 4 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 200.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		200 to: 300 by: 10 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 5.0) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ].
	(self
		verticalPanel:
			(Array with: (self selectorPanel: 'Tension' do: [ :steps | bindingAction steps: steps ] withAll: #(1 5 10 20))))
		 addMorph: simulator; openInWindowLabeled: 'Arresting Wire 5'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:50'!
bouncingBalls
	"HGSimulator bouncingBalls"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: (HG2dPoint fromPoint: simulator bounds origin)
				corner: (HG2dPoint fromPoint: simulator bounds corner)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: 0.01 y: 0.0)).
	simulator addInitializer: (HGPressureInitialization with: 2.0).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 24.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.098)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.9).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGFormVisualizer footballs.
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 400 ].
	simulator openInWindowLabeled: 'Football'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-servers' stamp: 'TomohiroOda 10/3/2011 10:37'!
bouncingBallsServer
	"HGSimulator bouncingBallsServer"

	"HGSimulator allInstancesDo: [ :m | m delete]"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: (HG2dPoint fromPoint: simulator bounds origin)
				corner: (HG2dPoint fromPoint: simulator bounds corner)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: 0.01 y: 0.0)).
	simulator addInitializer: (HGPressureInitialization with: 2.0).
	simulator addInitializer: (HGPVTUploader address: #[127 0 0 1] port: 9800).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 24.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.098)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.9).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPVTUploader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGFormVisualizer footballs.
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 400 ].
	simulator openInWindowLabeled: 'Football Server'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'tomooda 4/20/2015 16:58'!
burningHand
	"HGSimulator burningHand"
	| random simulator refraction heat gravity |
	random := Random new.
	simulator := HGSimulator new.
	simulator
		color: ((Color brown mixed: 0.4 with: Color gray)
				alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator
		simulationOrigin: (HG2dPoint x: 0.0 y: 0.0)
		corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator
		addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator
		addAction: (HGPositionNoise
				withBlock: [random next @ random next * 0.01]).
	simulator
		addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction: (HGPressure
				gasConstant: 0.01
				kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: (gravity := HGGravity
					g: (HG2dPoint x: 0 y: -2.0)).
	simulator
		addAction: (HGPressureRepulsion
				kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator
		addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction: (HGViscosityTraction
				kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: HGLocalityMap withOutOfBoundsRemoval.
	simulator
		addAction: (HGTriggerBlockAction
				whenever: [simulator bounds containsPoint: ActiveHand position]
				do: [20
						timesRepeat: [(simulator
								addParticleAt: simulator random next - 0.5 @ (simulator random next * 2.0 - 1.8) * 40 + ActiveHand position - simulator position
								temperature: 370.0
								mass: 300.0)
								viscosity: 79.0]]).
	simulator
		addAction: (HGBackgroundImageVisualizer
				form: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (heat := HGMeshPressureVisualizer
					scale: 0.0
					bias: 0.0
					color: (Color lightOrange mixed: 0.2 with: Color lightRed)).
	simulator addAction: (refraction := HGRefractionVisualizer
					xgrids: 60
					ygrids: 60
					kernel: (HGSimpleKernel support: 5.0)
					scale: 0.0
					image: nil).
	(self
		verticalPanel: (Array
				with: (self
						selectorPanel: 'Temperature'
						do: [:scale | 
							heat scale: scale / 500.0.
							refraction scale: scale / 10.0]
						withAll: #(0 100 300 ))
				with: (self
						selectorPanel: 'Upstream'
						do: [:gy | gravity g y: gy negated]
						withAll: #(0.5 1.0 2.0 4.0 8.0 )))) addMorphBack: simulator;
		 openInWindowLabeled: 'Burning Hand'.
	simulator setupSimulation; startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 10/3/2011 10:36'!
butterBall
	"HGSimulator butterBall"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dCircle center: (HG2dPoint x: 100.0 y: 350.0) radius: 110.0) color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 2.5 color: Color yellow).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 100.0 ].
	simulator openInWindowLabeled: 'Butter Ball'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 10/3/2011 10:37'!
butterBallAtDie
	"HGSimulator butterBallAtDie"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 2.5 color: Color yellow).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Butter Ball at a Die'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 2/24/2012 10:19'!
butterBallAtDie3D
	"HGSimulator butterBallAtDie3D"

	| simulator perspective |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	"simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1))."
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveDotsVisualizer
				radius: 5.0
				color: Color yellow
				eyeHeight: 10
				vanishingPoint: 250 @ 500
				depthBlock: [ :sim :particle | particle pressure * -5.0 max: -9 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective sightPoint: p - simulator position ] ]).

	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Butter Ball at a Die'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 10/3/2011 10:38'!
butterBallAtTriangle
	"HGSimulator butterBallAtTriangle"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 230.0) on: (HG2dPoint x: 300.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 2.5 color: Color yellow).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Butter Ball at a Triangle'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 11/4/2011 15:08'!
butterBallGraffitiAtDie
	"HGSimulator butterBallGraffitiAtDie"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			((HGBorderlineFillPressureVisualizer pressure: 0.01 color: Color yellow)
				kernel: (HGSimpleKernel support: 10.0);
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.01 width: 3 color: Color black)
				xgrids: 50;
				ygrids: 50;
				kernel: (HGSimpleKernel support: 10.0);
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.01 width: 3 color: Color black)
				kernel: (HGSimpleKernel support: 10.0);
				xgrids: 60;
				ygrids: 60;
				yourself).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Butter Ball at a Die (Graffiti)'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 11/4/2011 15:08'!
butterBallToonAtDie
	"HGSimulator butterBallToonAtDie"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			((HGBorderlineFillPressureVisualizer pressure: 0.01 color: Color yellow)
				kernel: (HGSimpleKernel support: 10.0);
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.01 width: 4 color: Color black)
				kernel: (HGSimpleKernel support: 10.0);
				yourself).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Butter Ball at a Die (Toon)'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/16/2011 16:29'!
butterKnifeCold
	"HGSimulator butterKnifeCold"

	| simulator view |
	simulator := HGSimulator new.
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(HGDynamicDotsVisualizer
				radius: [ :s :p | 4 ]
				color: [ :s :p | Color yellow alpha: ((373.15 - p temperature) / 100.0 * 0.9 + 0.1 min: 1.0 max: 0.1) ]).
	simulator addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3 color: (Color gray: 0.7))).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Cold Butter Knife'.
	simulator color: (Color gray: 0.98).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/17/2011 18:11'!
butterKnifeHot
	"HGSimulator butterKnifeHot"

	| simulator view |
	simulator := HGSimulator new.
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 300).
	simulator addAction: (HGTriggerBlockAction whenever: [ true ] do: [ (simulator particleAt: 1) temperature: 370 ]).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 7.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 17.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(HGDynamicDotsVisualizer
				radius: [ :s :p | 4 ]
				color: [ :s :p | Color yellow alpha: ((373.15 - p temperature) / 100.0 * 0.9 + 0.1 min: 1.0 max: 0.1) ]).
	simulator
		addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3 color: (Color gray: 0.7))).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Hot Butter Knife'.
	simulator color: (Color gray: 0.98).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:51'!
capuccino
	"HGSimulator capuccino"
	
	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 400).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGFormVisualizer capuccino.
	simulator
		addAction:
			(HGFakeHand
				at: 1
				mickey: 0.25
				image:
					(HGInertialFakeHand circle: 8 color: Color red)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 24 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Capuccino Art'.
	simulator color: Color brown.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/27/2012 11:35'!
capuccino3D
	"HGSimulator capuccino3D"
	
	| simulator perspective |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 400).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveDotsVisualizer
				radius: 10
				color: Color white
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 - (particle pressure * 3) max: -29 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed  ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	simulator
		addAction:
			(HGFakeHand
				at: 1
				mickey: 0.25
				image:
					(HGInertialFakeHand circle: 8 color: Color red)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 24 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Capuccino Art'.
	simulator color: Color brown.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/16/2011 16:46'!
capuccinoPower
	"HGSimulator capuccinoPower"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 400).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGFormVisualizer capuccino.
	simulator
		addAction:
			(HGInertialFakeHand
				at: 1
				mickey: 2.0
				image:
					(HGInertialFakeHand circle: 8 color: Color red)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 24 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Capuccino Art'.
	simulator color: Color brown.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'tomooda 4/20/2015 16:58'!
clearGreasyPit
	"HGSimulator clearGreasyPit"

	| simulator friction sweeping stick |
	simulator := HGSimulator new.
	simulator extent: 300 @ 300.
	simulator color: Color white.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 100 @ 100 corner: 300 @ 300).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: (friction := HGFacialFriction mu: 0.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGTriggerAction
				whenever: [ sweeping ]
				action:
					(HGBumpyObstacle
						with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 50.0)
						color: nil)).
	sweeping := false.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGRefractionVisualizer scale: 40.0 image: (Form fromDisplay: (0@0 corner: 300@300))).
	simulator addAction: ((HGMeshPressureVisualizer color: Color blue) kernel: (HGSimpleKernel support: 30)).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	(self
		verticalPanel:
			(Array
				with: (self selectorPanel: 'Radius' do: [:radius | stick radius: radius asFloat] withAll: #(30 50 60 70 80 100))
				with: (self selectorPanel: 'Friction' do: [ :mu | friction mu: mu asFloat ] withAll: #(0.0 0.01 0.02))))
		addMorph: simulator;
		openInWindowLabeled: 'Clear Greasy Pit'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/16/2011 16:29'!
coldButterColdKnife
	"HGSimulator coldButterColdKnife"

	| simulator view |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGThermalDotsVisualizer radius: 3.0 blueTemperature: 273.15 redTemperature: 373.15).
	simulator
		addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 4 color: (Color gray: 0.9))).
	simulator addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Butter Knife'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/16/2011 16:29'!
coldButterHotKnife
	"HGSimulator coldButterHotKnife"

	| simulator view |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [(simulator particleAt: 1) temperature: 400]).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 15.0)).	
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction:  (HGThermalDotsVisualizer radius: 3.0 blueTemperature: 273.15 redTemperature: 373.15).
	simulator addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Butter Knife'.
	^ simulator! !

!HGSimulator class methodsFor: 'images' stamp: 'TomohiroOda 8/10/2011 15:01'!
dot
	| form |
	form := Form extent: 1 @ 1 depth: 32.
	(form getCanvas)
		fillColor: Color black;
		flush.
	^ form! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 16:59'!
dotsInUserImage: rate
	"HGSimulator dotsInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [true]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator addAction: (HGDotsVisualizer radius: 4 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/5/2011 15:09'!
dotsViewer
	"HGSimulator dotsViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: (HGHandParticle at: 2).
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color black).
	simulator addAction: (HGDotVisualizer at: 2 radius: 3.0 color: Color red).
	simulator
		addAction:
			((HGPVTUploader address: #[127 0 0 1] port: 9800)
				suchThat: [ :particleIndex | particleIndex = 1 and: [ActiveHand anyButtonPressed ] ];
				yourself).
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Dots Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:40'!
floodPolygons
	"HGSimulator floodPolygons"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: (Color lightBlue mixed: 0.8 with: Color blue)).
	400
		timesRepeat: [ 
			simulator
				addParticleAt: 0 @ 0
				temperature: 390
				mass: 300 ].
	simulator openInWindowLabeled: 'Flood'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:41'!
floodPressureMap
	"HGSimulator floodPressureMap"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Flood'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:42'!
footballViewer
	"HGSimulator footballViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: (HGHandParticle at: 3).
	simulator addAction: (HGPVTUploader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGFormVisualizer footballs.
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Football Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 16:59'!
graffitiInUserImage: rate
	"HGSimulator graffitiInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator
		addAction:
			((HGBorderlineFillPressureVisualizer pressure: 0.05 color: (Color blue alpha: 0.5)) kernel: (HGSimpleKernel support: 20)).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.05 width: 2 color: Color black)
				xgrids: 50;
				ygrids: 50;
				kernel: (HGSimpleKernel support: 20)).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.05 width: 2 color: Color black)
				xgrids: 60;
				ygrids: 60;
				kernel: (HGSimpleKernel support: 20)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 6/7/2012 08:00'!
grease
	"HGSimulator grease"

	| sweeping random simulator width randomPosition viscosity pressure friction smoothing stick stud resetButton viscosityPanel solidityPanel radiusPanel studPanel |
	sweeping := false.
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color lightGray muchLighter.
	simulator extent: 500 @ 500.
	simulator particleMapResolution: 10.
	width := 10.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (randomPosition := HGRandomPosition origin: 200 @ 200 corner: 300 @ 300).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (viscosity := HGViscosityInitialization with: 1.0).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (pressure := HGPressureRepulsion kernel: (HGSimpleKernel support: 1.0) maxPressure: 100.0).
	simulator addAction: (friction := HGFacialFriction mu: 5.0 viscuss: false).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (smoothing := HGViscosityBySmoothing kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			((HGBumpyObstacle
				with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0)
				color: nil)
				afterEffect: [ :particle :deltaT | particle addVelocity: stick to - stick from by: 0.5 * particle viscosity / deltaT ];
				yourself).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(stud := HGStudsVisualizer
				offset: 0 @ 0
				radius: 8.0
				color: Color yellow darker
				offset: 0 @ -1
				radius: 8.0
				color: Color yellow).
	500 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	resetButton := (SimpleButtonMorph newWithLabel: 'RESET')
		on: #mouseDown
			send: #value
			to: [ 
					sweeping := false.
					simulator setupSimulation ];
		yourself.
	viscosityPanel := self
		selectorPanel: 'Viscosity'
		do: [ :v | 
			viscosity viscosity: v.
			sweeping := false.
			simulator setupSimulation ]
		withAll: #(1.0 0.5 0.1 0.0).
	solidityPanel := self
		selectorPanel: 'Solidity'
		do: [ :h | 
			smoothing kernel setSupport: h asFloat.
			sweeping := false.
			simulator setupSimulation ]
		withAll: #(1 5 10 20).
	radiusPanel := self
		selectorPanel: 'Radius'
		do: [ :r | 
			stick radius: r.
			sweeping := false.
			simulator setupSimulation ]
		withAll: #(10 20 30).
	studPanel := self
		selectorPanel: 'Stud'
		do: [ :h |
			stud offset: 0 @ 0
				radius: 8.0
				color: Color yellow darker
				offset: 0 @ (0 - h)
				radius: 8.0
				color: Color yellow.
				simulator setupSimulation]
			withAll: #(1 4 8 12).
	(self
		verticalPanel:
			(Array
				with: resetButton
				with: viscosityPanel
				with: solidityPanel
				with: radiusPanel
				with: studPanel))
		addMorph: simulator;
		openInWindowLabeled: 'Porsche'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 3/13/2012 11:08'!
greasyPit
	"HGSimulator greasyPit"

	| simulator friction sweeping stick color1 color2 perspective1 perspective2 |
	simulator := HGSimulator new.
	simulator extent: 300 @ 300.
	simulator color: Color white.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 100 @ 100 corner: 300 @ 300).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: (friction := HGFacialFriction mu: 0.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGTriggerAction
				whenever: [ sweeping ]
				action:
					(HGBumpyObstacle
						with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 50.0)
						color: nil)).
	sweeping := false.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	color1 := ValueHolder new.
	color1 contents: (Color gray: 0.9).
	color2 := ValueHolder new.
	color2 contents: (Color gray: 0.5).
	simulator
		addAction:
			(perspective1 := HGPerspectiveDotsVisualizer
				radius: 18
				color: nil
				eyeHeight: 30
				vanishingPoint: 150 @ 150
				depthBlock: [ :sim :particle | 20 ]
				colorBlock: [ :c :z | color2 contents]).
	simulator
		addAction:
			(perspective2 := HGPerspectiveDotsVisualizer
				radius: 18
				color: nil
				eyeHeight: 30
				vanishingPoint: 150 @ 150
				depthBlock: [ :sim :particle | 20 - (particle pressure * 10) max: -29 ]
				colorBlock: [ :c :z | | w | w := (1.0 - (z / 30.0) min: 1.0 max: 0.0).  (color1 contents mixed: w with: color2 contents) alpha: color1 contents alpha * w + (color2 contents alpha * (1.0 - w)) ]).
	"simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective1 vanishingPoint: p - simulator position.
							perspective2 vanishingPoint: p - simulator position ] ])."
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective1
								projectPoint: p - simulator position
								z: 20.0
								in: simulator
								do: [ :x :y :z :a | 
									simulator form getCanvas
										in: [ :canvas | 
											canvas
												line: p - simulator position
												to: x @ y
												width: 5
												color: Color black ] ] ] ]).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	(self
		verticalPanel:
			(Array
				with: ((ColorChooserMorph on: color1 color: #contents changeColor: #contents:) extent: 200@20)
				with: ((ColorChooserMorph on: color2 color: #contents changeColor: #contents:) extent: 200@20)
				with: (self selectorPanel: 'Radius' do: [:radius | stick radius: radius asFloat] withAll: #(30 50 60 70 80 100))
				with: (self selectorPanel: 'Friction' do: [ :mu | friction mu: mu asFloat ] withAll: #(0.0 0.01 0.02))))
		addMorph: simulator;
		openInWindowLabeled: 'Greasy Pit'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/13/2012 15:58'!
gumString1
	"HGSimulator gumString1"

	| random simulator bindingAction stick resetBlock firsts lasts |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 10
				convergenceCoefficient: 0.1
				color: Color gray
				width: 4).
	bindingAction breakrate: 4.0.
	simulator addAction: (HGStickyObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	resetBlock := [ 
	bindingAction removeBindingSuchThat: [ :binding | true ].
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	simulator clearParticles.
	250 to: 250 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 0.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		2 to: 500 by: 4 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 1) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ] ].
	resetBlock value.
	(self
		verticalPanel:
			(Array
				with:
					((SimpleButtonMorph newWithLabel: 'RESET')
						on: #mouseDown send: #value to: resetBlock;
						yourself)
				with:
					(self selectorPanel: 'Tension' do: [:steps | bindingAction steps: steps] withAll: #(1 2 5 10))
				with: (self selectorPanel: 'Strength' do: [ :rate | bindingAction breakrate: rate asFloat] withAll: #(3 4 5)))) 		 addMorph: simulator; openInWindowLabeled: 'Gum String 1'.
	simulator startStepping..

	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/9/2012 10:29'!
gumString5
	"HGSimulator gumString5"

	| random simulator bindingAction stick firsts lasts resetBlock |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 10
				convergenceCoefficient: 0.1
				color: Color gray
				width: 1).
	bindingAction breakrate: 4.0.
	simulator addAction: (HGStickyObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	resetBlock := [ 
	simulator clearParticles.
	bindingAction removeBindingSuchThat: [ :binding | true ].
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	240 to: 260 by: 4 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 0.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		5 to: 500 by: 4 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 2) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ] ].
	resetBlock value.
	(self
		verticalPanel:
			(Array
				with:
					((SimpleButtonMorph newWithLabel: 'RESET')
						on: #mouseDown send: #value to: resetBlock;
						yourself)
				with: (self selectorPanel: 'Tension' do: [ :steps | bindingAction steps: steps ] withAll: #(1 2 5 10))
				with: (self selectorPanel: 'Strength' do: [ :rate | bindingAction breakrate: rate asFloat ] withAll: #(3 4 5))))
		 addMorph: simulator; openInWindowLabeled: 'Gum String5'.
	simulator startStepping..
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:35'!
handVelocityViewer
	"HGSimulator handVelocityViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.0 color: Color black).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 40.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: true;
				yourself).
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Hand-Velocity Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'utilities' stamp: 'TomohiroOda 2/7/2012 13:35'!
horizontalPanel: anArrayOfMorphs
	| panel |
	panel := Morph new.
	panel color: Color white.
	panel changeTableLayout.
	panel listDirection: #rightToLeft.
	panel wrapCentering: #bottomRight.
	anArrayOfMorphs
		do: [ :morph | 
			panel addMorph: morph ].
	^ panel! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/16/2011 16:29'!
hotButterColdKnife
	"HGSimulator hotButterColdKnife"

	| simulator view |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 400).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [(simulator particleAt: 1) temperature: 270]).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 15.0)).	
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction:  (HGThermalDotsVisualizer radius: 3.0 blueTemperature: 273.15 redTemperature: 373.15).
	simulator addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Butter Knife'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-thermal' stamp: 'TomohiroOda 10/16/2011 16:29'!
hotButterHotKnife
	"HGSimulator hotButterHotKnife"

	| simulator view |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 300 @ 300.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 200 @ 200).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 400).
	simulator addAction: (HGHeatTransferBySmoothing rate: 0.9 kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 0.02).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGThermalDotsVisualizer radius: 3.0 blueTemperature: 273.15 redTemperature: 373.15).
	simulator addAction: (HGInertialFakeHand at: 1 mickey: 1.0 image: (HGInertialFakeHand circle: 3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Butter Knife'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 17:00'!
illustratedInUserImage: rate
	"HGSimulator illustratedInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator
		addAction:
			((HGBorderlineFillPressureVisualizer pressure: 0.05 color: (Color blue alpha: 0.5)) kernel: (HGSimpleKernel support: 20)).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.05 width: 2 color: Color black) kernel: (HGSimpleKernel support: 20)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/4/2011 15:05'!
impossibeRiverBorderline
	"HGSimulator impossibeRiverBorderline"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlinePressureVisualizer pressure: 0.4 width: 3 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Mesh'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/4/2011 15:06'!
impossibeRiverBorderlineFill
	"HGSimulator impossibeRiverBorderlineFill"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Mesh'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:42'!
impossibeRiverDots
	"HGSimulator impossibeRiverDots"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color black).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River by Dots'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/4/2011 15:08'!
impossibeRiverGraffiti
	"HGSimulator impossibeRiverGraffiti"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color blue).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 3 color: Color black)
				xgrids: 60;
				ygrids: 60;
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 4 color: Color black)
				xgrids: 50;
				ygrids: 50;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River (Graffiti)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:42'!
impossibeRiverMesh
	"HGSimulator impossibeRiverMesh"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			((HGMeshVelocityVisualizer new)).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Mesh'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 2/23/2012 11:37'!
impossibeRiverPerspectiveDots
	"HGSimulator impossibeRiverPerspectiveDots"

	| simulator perspective |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveDotsVisualizer
				radius: 10
				color: Color blue
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 20 - (particle pressure * 10) max: -19 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River by Pseudo 3D Dots'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 10/3/2011 10:45'!
impossibeRiverPolygon
	"HGSimulator impossibeRiverPolygon"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: Color lightBlue ).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Polygons'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:46'!
impossibeRiverPressureMap
	"HGSimulator impossibeRiverPressureMap"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Mesh'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'tomooda 4/20/2015 17:00'!
impossibeRiverRefraction
	"HGSimulator impossibeRiverRefraction"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBackgroundImageVisualizer form: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (HGMeshPressureVisualizer scale: 0.1 bias: 0.0 color: Color blue lighter).
	simulator addAction: (HGRefractionVisualizer scale: 10.0).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Mesh'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 6/26/2012 09:51'!
impossibeRiverSmokey
	"HGSimulator impossibeRiverSmokey"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 25.0) scale: 20.0 color: (Color lightGray alpha: 0.3)).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River of Smokey Gas'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:46'!
impossibeRiverSound
	"HGSimulator impossibeRiverSound"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color black).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 100.0)
				kernel: (HGSimpleKernel support: 20.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator
		addAction:
			(HGCollisionPhonator at: 1 radius: 20.0 sound: (SampledSound samples: SampledSound coffeeCupClink samplingRate: 11025)).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River by Dots'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 2/20/2012 10:29'!
impossibeRiverVoronoi
	"HGSimulator impossibeRiverVoronoi"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| diagram color1 color2 color3 |
					color1 := Color white mixed: 0.2 with: Color lightBlue.
					color2 := Color white mixed: 0.3 with: Color lightBlue.
					color3 := Color white mixed: 0.45 with: Color lightBlue.
					diagram := HGVoronoiDiagram new.
					simulator form getCanvas
						in: [ :canvas | 
							2 to: 101 do: [ :index | diagram addRegionAt: (simulator particleAt: index) position ].
							diagram
								origin: 0 @ 0
								corner: 500 @ 500
								pairsDo: [ :point1 :point2 | 
									| p1 p2 |
									p1 := point1 asPoint.
									p2 := point2 asPoint.
									canvas
										line: p1
										to: p2
										width: 14
										color: color1.
									canvas
										line: p1
										to: p2
										width: 5
										color: color2.
									canvas
										line: p1
										to: p2
										width: 1
										color: color3 ] ] ]).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Voronoi'.
	simulator color: Color lightBlue.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:46'!
impossibeRiverWireframe
	"HGSimulator impossibeRiverWireframe"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGWireframeVisualizer width: 2 color: Color black).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Impossible River in Wireframes'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-elastic' stamp: 'TomohiroOda 11/2/2011 12:39'!
jelloAtDie
	"HGSimulator jelloAtDie"

	| simulator forms random trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction := HGSpringTrindingElasticForce k: 5.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)
				numberOfParticles: 200
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 8 color: Color yellow).
	simulator openInWindowLabeled: 'Jello at a Die'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-elastic' stamp: 'TomohiroOda 11/2/2011 12:40'!
jelloAtGun
	"HGSimulator jelloAtGun"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction := HGSpringTrindingElasticForce k: 15.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 250 y: 100) radius: 100.0)
				numberOfParticles: 10
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint zero)).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					(simulator particleAt: 1)
						position: (HG2dPoint fromPoint: ActiveHand position - simulator position);
						velocity: (HG2dPoint x: 0.0 y: -20.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotVisualizer at: 1 radius: 2 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.0.
	simulator openInWindowLabeled: 'Jello at Gun'.
	simulator color: (Color lightGray ).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:51'!
jelloAtMouse
	"HGSimulator jelloAtMouse"

	| simulator forms random trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction := HGSpringTrindingElasticForce k: 5.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 100.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 100.0.
	simulator color: Color lightGray.
	simulator openInWindowLabeled: 'Jello at Mouse'.
	ActiveHand showTemporaryCursor: Cursor blank.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/2/2011 11:16'!
jelloAtMouse2
	"HGSimulator jelloAtMouse2"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction := HGSpringTrindingElasticForce k: 15.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 100.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerAction
				when: [ (simulator particleAt: 1) position y between: 230 and: 270 ]
				action: (HGVelocityInitialization with: (HG2dPoint x: -2.0 y: 0.0))).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 100.0.
	simulator openInWindowLabeled: 'Jello at Mouse 2'.
	ActiveHand showTemporaryCursor: HGSimulator dot.
	simulator color: (Color lightGray).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/3/2011 10:57'!
jelloAtMouse3
	"HGSimulator jelloAtMouse3"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction := HGSpringTrindingElasticForce k: 15.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 100.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerAction
				when: [ (simulator particleAt: 1) position y between: 230 and: 270 ]
				action: (HGVelocityInitialization with: (HG2dPoint x: -4.0 y: 0.0))).
	simulator
		addAction:
			(HGTriggerBlockAction
				when: [ (simulator particleAt: 1) position x < 50.0 ]
				do: [ (simulator particleAt: 1) mass: 1000.0 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				when: [ (simulator particleAt: 1) position x < 50.0 ]
				do: [ simulator addAction: (HGCrusher at: 1 radius: 10.0 against: trindingElasticForceAction) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 500 @ 500 temperature: 390 mass: 100.0.
	simulator color: Color lightGray.
	simulator openInWindowLabeled: 'Jello at Mouse 3'.
	ActiveHand showTemporaryCursor: HGSimulator dot.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 1/23/2012 16:56'!
jetbathDots
	"HGSimulator jetbathDots"

	| simulator oldClicked clicked |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 2 color: (Color black)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	700 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'JetBath (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 1/18/2012 15:24'!
jetbathGraffiti
	"HGSimulator jetbathGraffiti"

	| simulator oldClicked clicked |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.1 color: Color lightBlue).
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.2 color: (Color lightBlue mixed: 0.95 with: Color blue)).
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.3 color: (Color lightBlue mixed: 0.9 with: Color blue)).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.1 width: 1 color: Color black)
				xgrids: 60;
				ygrids: 60;
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.1 width: 2 color: Color black)
				xgrids: 50;
				ygrids: 50;
				yourself).

	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	700 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'JetBath (Graffiti)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 1/18/2012 15:17'!
jetbathPressureMap
	"HGSimulator jetbathPressureMap"

	| simulator oldClicked clicked |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: ((HGMeshPressureVisualizer scale: 1.0 bias: 0.0 color: Color blue) kernel: (HGSimpleKernel support: 30)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	700 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'JetBath (PressureMap)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'tomooda 4/20/2015 17:01'!
jetbathRefraction
	"HGSimulator jetbathRefraction"

	| simulator oldClicked clicked |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGRefractionVisualizer scale: 10.0 image: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	700 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'JetBath (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 6/5/2012 10:50'!
jetbathSmoke
	"HGSimulator jetbathSmoke"

	| simulator oldClicked clicked |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 20.0) scale: 50.0 color: (Color lightGray alpha: 0.3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	700 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'JetBath (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 1/18/2012 15:25'!
jetbathSourceCode
	"HGSimulator jetbathSourceCode"

	| simulator oldClicked clicked sourceStream |
	clicked := false.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 30.0
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGStringVisualizer color: (Color black) defaultString: ' ').
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	sourceStream := thisContext method getSource readStream.
	700 timesRepeat: [ (simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300) at: #string put: (String with: sourceStream next) ].
	simulator openInWindowLabeled: 'Jet Bath (Source Code)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:52'!
lagoonDots
	"HGSimulator lagoonDots"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 2 color: (Color black)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/4/2011 15:08'!
lagoonGraffiti
	"HGSimulator lagoonGraffiti"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.8 color: Color lightBlue).
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 1.2 color: (Color lightBlue mixed: 0.95 with: Color blue)).
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 1.6 color: (Color lightBlue mixed: 0.9 with: Color blue)).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.8 width: 1 color: Color black)
				xgrids: 60;
				ygrids: 60;
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.8 width: 2 color: Color black)
				xgrids: 50;
				ygrids: 50;
				yourself).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Graffiti)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/27/2012 11:25'!
lagoonPerspectiveDots
	"HGSimulator lagoonPerspectiveDots"

	| simulator perspective |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveDotsVisualizer
				radius: 10
				color: Color blue
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 - (particle pressure * 3) max: -29 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed  ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Pseudo 3D Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/27/2012 11:52'!
lagoonPerspectivePolygons
	"HGSimulator lagoonPerspectivePolygons"

	| simulator perspective |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).	"simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm)."
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ (simulator particleAt: 1) position: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectivePolygonVisualizer
				color: Color blue
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 - (particle pressure * 3) max: -29 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective
								projectPoint: p - simulator position
								z: (10 - ((simulator particleAt: 1) pressure * 3) max: -29)
								in: simulator
								do: [ :x :y :z :a | 
									simulator form getCanvas
										in: [ :canvas | 
											canvas
												line: p - simulator position
												to: x @ y
												width: 5
												color: Color black ] ] ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Pseudo 3D Polygons)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/27/2012 16:05'!
lagoonPerspectiveStudDots
	"HGSimulator lagoonPerspectiveStudDots"

	| simulator perspective1 perspective2 stick sweeping |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator color: Color white.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 300.0 y: 300.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 300 @ 300).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 100.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGTriggerAction
				whenever: [ sweeping ]
				action:
					(HGBumpyObstacle
						with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 80.0)
						color: nil)).
	sweeping := false.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective1 := HGPerspectiveDotsVisualizer
				radius: 18
				color: Color yellow muchDarker
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 ]
				colorBlock: [ :c :z | c ]).
	simulator
		addAction:
			(perspective2 := HGPerspectiveDotsVisualizer
				radius: 18
				color: Color yellow
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 - (particle pressure * 10) max: -29 ]
				colorBlock: [ :c :z | c ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective1 vanishingPoint: p - simulator position.
							perspective2 vanishingPoint: p - simulator position ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective1
								projectPoint: p - simulator position
								z: 10.0
								in: simulator
								do: [ :x :y :z :a | 
									simulator form getCanvas
										in: [ :canvas | 
											canvas
												line: p - simulator position
												to: x @ y
												width: 5
												color: Color black ] ] ] ]).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	Morph new
		extent: 1000 @ 500;
		changeTableLayout;
		listDirection: #rightToLeft;
		wrapCentering: #center;
		listCentering: #center;
		addMorph: simulator;
		openInWindowLabeled: 'Grease Tank (Studs)'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/27/2012 11:53'!
lagoonPerspectiveWireframe
	"HGSimulator lagoonPerspectiveWireframe"

	| simulator perspective |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	"simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm)."
	simulator addAction: (HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [(simulator particleAt: 1) position: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveWireframeVisualizer 
				width: 2
				color: Color blue
				eyeHeight: 30
				vanishingPoint: 250 @ 250
				depthBlock: [ :sim :particle | 10 - (particle pressure * 3) max: -29 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ 
							perspective
								projectPoint: p - simulator position
								z: (10 - ((simulator particleAt: 1) pressure * 3) max: -29)
								in: simulator
								do: [ :x :y :z :a | 
									simulator form getCanvas
										in: [ :canvas | 
											canvas
												line: p - simulator position
												to: x @ y
												width: 5
												color: Color black ] ] ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed  ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Pseudo 3D Wireframe)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 14:53'!
lagoonPolygons
	"HGSimulator lagoonPolygons"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: (Color lightBlue mixed: 0.8 with: Color blue)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Polygon)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/4/2011 11:45'!
lagoonPressureMap
	"HGSimulator lagoonPressureMap"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: ((HGMeshPressureVisualizer color: Color blue) kernel: (HGSimpleKernel support: 30)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 4.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 5/24/2012 09:42'!
lagoonPressureMapWorld
	"HGSimulator lagoonPressureMapWorld"

	| random simulator |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGWorldSubmorphsObstacle withBoundsExpansion: 30).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: ((HGMeshPressureVisualizer color: Color blue) kernel: (HGSimpleKernel support: 30)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 4.0 color: Color red).
	simulator addAction: (HGDotVisualizer at: 2 radius: 4.0 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 3 radius: 4.0 color: Color yellow).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'tomooda 4/20/2015 17:01'!
lagoonReflectionWorld
	"HGSimulator lagoonReflectionWorld"

	| random simulator |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGWorldSubmorphsObstacle withBoundsExpansion: 30).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGRefractionVisualizer scale: 1.0 image: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (HGReflectionVisualizer vector: (HG2dPoint x: 0.0 y: -0.7) color: Color yellow lighter muchLighter).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon Reflection World'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'tomooda 1/30/2015 18:34'!
lagoonRefractionWorld
	"HGSimulator lagoonRefractionWorld"

	| random simulator |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGWorldSubmorphsObstacle withBoundsExpansion: 30).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGRefractionVisualizer scale: 10.0 image: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon Refraction World'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 6/5/2012 10:37'!
lagoonSmokeyWorld
	"HGSimulator lagoonSmokeyWorld"

	| random simulator |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGWorldSubmorphsObstacle withBoundsExpansion: 30).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 20.0) scale: 5.0 color: (Color lightGray alpha: 0.3)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon Refraction World'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:52'!
lagoonTilt
	"HGSimulator lagoonTilt"

	| simulator gravity |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: ((ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0) * 4.0.
					g := g min: (HG2dPoint x: 4.0 y: 4.0) max: (HG2dPoint x: -4.0 y: -4.0).
					gravity g: g ]).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 60.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer color: Color blue muchLighter).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon Tilt'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'tomooda 4/20/2015 17:02'!
lagoonTiltRefraction
	"HGSimulator lagoonTiltRefraction"

	| simulator gravity |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: ((ActiveHand position - simulator position) / simulator bounds extent * 0.5 - 0.25) * 4.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: g ]).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBackgroundImageVisualizer form: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (HGMeshPressureVisualizer scale: 0.1 bias: 0.0 color: Color blue lighter).
	simulator addAction: (HGRefractionVisualizer scale: 10.0).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon Tilt'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 2/17/2012 15:29'!
lagoonVoronoi
	"HGSimulator lagoonVoronoi"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color lightBlue.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| diagram color1 color2 color3 |
					color1 := Color white mixed: 0.2 with: Color lightBlue.
					color2 := Color white mixed: 0.3 with: Color lightBlue.
					color3 := Color white mixed: 0.45 with: Color lightBlue.
					diagram := HGVoronoiDiagram new.
					simulator form getCanvas
						in: [ :canvas | 
							2 to: 41 do: [ :index | diagram addRegionAt: (simulator particleAt: index) position ].
							diagram
								origin: 0 @ 0
								corner: 500 @ 500
								pairsDo: [ :point1 :point2 | 
									| p1 p2 |
									p1 := point1 asPoint.
									p2 := point2 asPoint.
									canvas
										line: p1
										to: p2
										width: 14
										color: color1.
									canvas
										line: p1
										to: p2
										width: 5
										color: color2.
									canvas
										line: p1
										to: p2
										width: 1
										color: color3 ] ] ]).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon (Voronoi)'.
	simulator color: Color lightBlue.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 11:52'!
lagoonWireframe
	"HGSimulator lagoonWireframe"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGWireframeVisualizer width: 2 color: (Color black)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1200.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Lagoon(Wireframe)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/7/2012 12:12'!
lint1000
	"HGSimulator lint1000"

	| random  simulator bindingAction stick origin |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator particleMapResolution: 10.  
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := (HG2dPoint x: 250.0 y: 500.0).
	simulator addAction: (HGTriggerBlockAction whenever: [ActiveHand anyButtonPressed] do: [simulator particlesDo: [ :p | p addForce: (origin unitVector: p position) by: ((500000.0 / (origin to: stick center distance: p position) squared) min: 1000.0) ]]).
	simulator addAction: (HGPressure gasConstant: 1.0 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0  ).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 2.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle
				with:
					(stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0)
				color: (Color gray: 0.8)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ | position | position := ActiveHand position. (simulator bounds containsPoint: position) ifTrue: [stick center: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	50 timesRepeat: [
		| position p1 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		19 timesRepeat: [ | degrees p2 |
			degrees := random next * 360.
			p2 := simulator addParticleAt: (position := (Point r: 1 degrees: degrees) + position) temperature: nil mass: 300.
			bindingAction addBindingBetween: p1 and: p2.
			p1 := p2]].
	simulator openInWindowLabeled: 'Lint 1000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/4/2012 22:17'!
lint2000
	"HGSimulator lint2000"

	| random simulator bindingAction stick origin |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (500000.0 / (origin to: stick center distance: p position) squared min: 1000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 1.0 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 2.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	100
		timesRepeat: [ 
			| position p1 |
			position := random next @ random next * 500.
			p1 := simulator addParticleAt: position temperature: nil mass: 300.
			19
				timesRepeat: [ 
					| degrees p2 |
					degrees := random next * 360.
					p2 := simulator addParticleAt: (position := (Point r: 1 degrees: degrees) + position) temperature: nil mass: 300.
					bindingAction addBindingBetween: p1 and: p2.
					p1 := p2 ] ].
	simulator openInWindowLabeled: 'Lint 2000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-bindings' stamp: 'TomohiroOda 1/20/2012 15:21'!
liquidOxgen
	"HGSimulator liquidOxgen"

	| random  simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle
				with:
					(stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0)
				color: (Color gray: 0.8)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ | position | position := ActiveHand position. (simulator bounds containsPoint: position) ifTrue: [stick center: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 4 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	400 timesRepeat: [
		| position p1 p2 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		p2 := simulator addParticleAt: (Point r: 10 degrees: random next * 360) + position temperature: nil mass: 300.
		bindingAction addBindingBetween: p1 and: p2].
	simulator openInWindowLabeled: 'LiquidOxgen'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:34'!
meshVelocityViewer
	"HGSimulator meshVelocityViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGMeshVelocityVisualizer new.
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Mesh-Velocity Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:24'!
nattoViewer
	"HGSimulator nattoViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: (HGHandParticle at: 2).
	simulator addAction: (HGPVTUploader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGFormVisualizer natto.
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Beans Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:37'!
particlesVelocityViewer
	"HGSimulator particlesVelocityViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator
		addAction:
			(HGParticlesVelocityVisualizer
				radius: 1.5
				width: 1.0
				scale: 10.0
				color: Color black).
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Particles-Velocity Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:38'!
polygonViewer
	"HGSimulator polygonViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: Color blue).
	10 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Polygon Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-bindings' stamp: 'TomohiroOda 1/20/2012 15:19'!
polymer10
	"HGSimulator polymer10"

	| random  simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle
				with:
					(stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0)
				color: (Color gray: 0.8)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ | position | position := ActiveHand position. (simulator bounds containsPoint: position) ifTrue: [stick center: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 4 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	80 timesRepeat: [
		| position p1 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		9 timesRepeat: [ | p2 |
			p2 := simulator addParticleAt: (position := (Point r: 10 degrees: random next * 360) + position) temperature: nil mass: 300.
			bindingAction addBindingBetween: p1 and: p2.
			p1 := p2]].
	simulator openInWindowLabeled: 'Polymer 10'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-bindings' stamp: 'TomohiroOda 2/3/2012 07:58'!
polymer100
	"HGSimulator polymer100"

	| random  simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle
				with:
					(stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0)
				color: (Color gray: 0.8)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ | position | position := ActiveHand position. (simulator bounds containsPoint: position) ifTrue: [stick center: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 4 color: Color black).
	8 timesRepeat: [
		| position p1 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		99 timesRepeat: [ | degrees p2 |
			degrees := random next * 360.
			p2 := simulator addParticleAt: (position := (Point r: 10 degrees: degrees) + position) temperature: nil mass: 300.
			bindingAction addBindingBetween: p1 and: p2.
			p1 := p2]].
	simulator openInWindowLabeled: 'Polymer 100'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-bindings' stamp: 'TomohiroOda 1/20/2012 15:20'!
polymer800
	"HGSimulator polymer800"

	| random  simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGFakeHand at: 1 mickey: 0.5 image: Cursor normal asCursorForm).
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray).
	simulator
		addAction:
			(HGObstacle
				with:
					(stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0)
				color: (Color gray: 0.8)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ | position | position := ActiveHand position. (simulator bounds containsPoint: position) ifTrue: [stick center: (HG2dPoint fromPoint: position - simulator position)]]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 4 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	1 timesRepeat: [
		| position p1 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		799 timesRepeat: [ | degrees p2 |
			degrees := random next * 360.
			p2 := simulator addParticleAt: (position := (Point r: 10 degrees: degrees) + position) temperature: nil mass: 300.
			bindingAction addBindingBetween: p1 and: p2.
			p1 := p2]].
	simulator openInWindowLabeled: 'Polymer 800'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:39'!
powder1000
	"HGSimulator powder1000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (500000.0 / (origin to: stick center distance: p position) squared min: 3000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 0.5 color: Color black).
	1000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'powder 1000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:40'!
powder2000
	"HGSimulator powder2000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (500000.0 / (origin to: stick center distance: p position) squared min: 3000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 0.5 color: Color black).
	2000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'powder 2000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:40'!
powder3000
	"HGSimulator powder3000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (500000.0 / (origin to: stick center distance: p position) squared min: 3000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 0.5 color: Color black).
	3000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'powder 3000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/7/2012 12:13'!
powder4000
	"HGSimulator powder4000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator particleMapResolution: 10.  
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (500000.0 / (origin to: stick center distance: p position) squared min: 3000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 0.5 color: Color black).
	4000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'powder 4000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 17:02'!
pressureMapInUserImage: rate
	"HGSimulator pressureMapInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator
		addAction:
			(HGMeshPressureVisualizer scale: 1.0 bias: 0.0 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:39'!
propagateLicense
	"HGSimulator propagateLicense"

	(Smalltalk organization categoriesMatching: 'HoneyGinger-*')
		do: [ :classCategory | 
			(Smalltalk organization classesInCategory: classCategory)
				do: [ :c | 
					(c class selectors includes: #LICENSE)
						ifFalse: [ 
							c class compileSilently: 'LICENSE ^ self MITLicense' classified: 'copyrights'.
							c class reformatMethodAt: #LICENSE ].
					(c class selectors includes: #showLicense)
						ifTrue: [ 
							c class
								compileSilently:
									('showLicense\	(self LICENSE asText asMorph)\wrapFlag: true;\autoFit: false;\extent: 400 @ 400;\justified;\openInWindowLabeled: ''LICENSE''')
										withCRs
								classified: 'copyrights'.
							c class reformatMethodAt: #showLicense ].
					(c class selectors includes: #MITLicense)
						ifFalse: [ 
							c class
								compileSilently:
									'MITLicense ^ ''Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'' withCRs'
								classified: 'copyrights'.
							c class reformatMethodAt: #MITLicense ] ] ]! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/4/2011 11:11'!
raftingDots
	"HGSimulator raftingDots"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 3.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 250 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 600.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Rafting'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 14:46'!
raftingPolygons
	"HGSimulator raftingPolygons"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 3.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 250 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: (Color lightBlue mixed: 0.8 with: Color blue)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 600.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Rafting'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 11/2/2011 14:48'!
raftingPressureMap
	"HGSimulator raftingPressureMap"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 3.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 250 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 mickey: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 600.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Rafting'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 5/30/2012 20:22'!
raftingPressureSpeaker
	"HGSimulator raftingPressureSpeaker"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 3.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 250 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator addAction: (HGStationaryPressureSpeaker kernel: (HGSimpleKernel support: 50.0)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 600.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Rafting'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-bindings' stamp: 'TomohiroOda 1/23/2012 16:56'!
ramen
	"HGSimulator ramen"

	| random  simulator stick bindingAction |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 9.8))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (bindingAction := HGHardBindingElasticForce steps: 4 convergenceCoefficient: 0.1 color: Color yellow muchLighter).
	bindingAction width: 5.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	50 timesRepeat: [
		| position p1 |
		position := random next @ random next * 500.
		p1 := simulator addParticleAt: position temperature: nil mass: 300.
		19 timesRepeat: [ | degrees p2 |
			degrees := random next * 360.
			p2 := simulator addParticleAt: (position := (Point r: 20 degrees: degrees) + position) temperature: nil mass: 300.
			bindingAction addBindingBetween: p1 and: p2.
			p1 := p2]].
	simulator openInWindowLabeled: 'Ramen'.
	simulator color: (Color gray: 0.9).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 17:03'!
refractionMapInUserImage: rate
	"HGSimulator refractionMapInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator addAction: (HGRefractionVisualizer scale: 20.0 image: (background form)).
	simulator
		addAction:
			(HGMeshPressureVisualizer scale: 1.0 bias: 0.0 color: (Color blue alpha: 0.1)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-elastic' stamp: 'TomohiroOda 11/2/2011 12:40'!
rockAtDie
	"HGSimulator rockAtDie"

	| simulator forms random trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 50.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -10.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 10.0 y: 300.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 10.0 y: 200.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator openInWindowLabeled: 'Rock at Die Server'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-elastic' stamp: 'TomohiroOda 11/2/2011 12:40'!
rockAtGun
	"HGSimulator rockAtGun"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: trindingElasticForceAction
				region: (HG2dCircle center: (HG2dPoint x: 100 y: 250) radius: 30.0)
				numberOfParticles: 10
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					(simulator particleAt: 1)
						position: (HG2dPoint fromPoint: ActiveHand position - simulator position);
						velocity: (HG2dPoint x: 0.0 y: -20.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotVisualizer at: 1 radius: 2 color: Color black).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 5000.0.
	simulator openInWindowLabeled: 'Rock at Gun'.
	simulator color: Color white.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/2/2011 11:16'!
rockAtMouse
	"HGSimulator rockAtMouse"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 50
				mass: 1000.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: trindingElasticForceAction
				region: (HG2dCircle center: (HG2dPoint x: 100 y: 250) radius: 30.0)
				numberOfParticles: 10
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 1000.0.
	simulator openInWindowLabeled: 'Rock at Mouse'.
	ActiveHand showTemporaryCursor: Cursor blank.
	simulator color: Color white.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/2/2011 11:16'!
rockAtMouse2
	"HGSimulator rockAtMouse2"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 5 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 100
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				when: [ (simulator particleAt: 1) position y between: 230 and: 270 ]
				do: [ 2 to: simulator numberOfParticles do: [ :index | (simulator particleAt: index) velocity: (HG2dPoint x: -5.0 y: 0.0) ] ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 500 @ 500 temperature: 390 mass: 1000.0.
	simulator openInWindowLabeled: 'Rock at Mouse 2'.
	ActiveHand showTemporaryCursor: Cursor blank.
	simulator color: Color white.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/3/2011 11:20'!
rockAtMouse3
	"HGSimulator rockAtMouse3"

	| simulator trindingElasticForceAction |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 5 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 100
				mass: 1000.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 270).
	simulator
		addAction:
			(HGTriggerBlockAction
				when: [ (simulator particleAt: 1) position y between: 230 and: 270 ]
				do: [ 2 to: simulator numberOfParticles do: [ :index | (simulator particleAt: index) velocity: (HG2dPoint x: -6.0 y: 0.0) ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				when: [ (simulator particleAt: 1) position x < 50.0 ]
				do: [ simulator addAction: (HGCrusher at: 1 radius: 10.0 against: trindingElasticForceAction) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: (HGFakeHand at: 1 image: Cursor normal asCursorForm).
	simulator addAction: HGLocalityMap new.
	simulator addParticleAt: 500 @ 500 temperature: 390 mass: 400.0.
	simulator openInWindowLabeled: 'Rock at Mouse 3'.
	ActiveHand showTemporaryCursor: Cursor blank.
	simulator color: Color white.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-elastic' stamp: 'TomohiroOda 10/3/2011 11:21'!
rockIce
	"HGSimulator rockIce"

	| simulator trindingElasticForceAction1 trindingElasticForceAction2 |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 400 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction1 := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.5 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 400) radius: 50.0)
				numberOfParticles: 40
				mass: 1000.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction2 := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.5 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 100 y: 100) radius: 50.0)
				numberOfParticles: 40
				mass: 1000.0).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: trindingElasticForceAction1.
	simulator addAction: trindingElasticForceAction2.
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.2 kernel: (HGSimpleKernel support: 20.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 1.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: nil mass: 1000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'Rock Ice'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-UI' stamp: 'TomohiroOda 10/21/2011 19:12'!
rocknjello
	"HGSimulator rocknjello"

	| simulator bindingElasticForceAction trindingElasticForceAction1 trindingElasticForceAction2 picker |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on: (trindingElasticForceAction1 := HGSpringTrindingElasticForce k: 5.0 color: Color yellow)
				region: (HG2dCircle center: (HG2dPoint x: 100 y: 100) radius: 100.0)
				numberOfParticles: 10
				mass: 100.0).
	simulator addInitializer: HGLocalityMap new.
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addInitializer: (HGPressureInitialization with: 0.2).
	simulator addAction: (picker := HGParticleGripper within: 60.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.5)).
	simulator addAction: trindingElasticForceAction1.
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.5).
	simulator addAction: HGLocalityMap new.
	picker ifNotNil: [ simulator addAction: (HGParticlePickerVisualizer on: picker radius: 3.0 color: Color red) ].
	simulator addAction: (HGDotsVisualizer radius: 3 color: Color yellow).
	simulator openInWindowLabeled: 'Rock''n Jello'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:31'!
sandbox1000
	"HGSimulator sandbox1000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (50000.0 / (origin to: stick center distance: p position) squared min: 5000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							| p |
							p := HG2dPoint fromPoint: position - simulator position.
							(stick center distance: p) > 1.0
								ifTrue: [ p := p + (HG2dPoint theta: random next * Float pi * 2 r: random next * 2) ].
							stick center: p ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMassDotsVisualizer radius: 0.0015 color: Color black).
	1000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 600 * (random next * 0.5 + 0.5) ].
	simulator openInWindowLabeled: 'Sandbox 1000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:42'!
sandbox2000
	"HGSimulator sandbox2000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (50000.0 / (origin to: stick center distance: p position) squared min: 5000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							| p |
							p := HG2dPoint fromPoint: position - simulator position.
							(stick center distance: p) > 1.0
								ifTrue: [ p := p + (HG2dPoint theta: random next * Float pi * 2 r: random next * 2) ].
							stick center: p ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMassDotsVisualizer radius: 0.0015 color: Color gray).
	2000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 600 * (random next * 0.5 + 0.5) ].
	simulator openInWindowLabeled: 'Sandbox 2000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:33'!
sandbox3000
	"HGSimulator sandbox3000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (50000.0 / (origin to: stick center distance: p position) squared min: 5000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							| p |
							p := HG2dPoint fromPoint: position - simulator position.
							(stick center distance: p) > 1.0
								ifTrue: [ p := p + (HG2dPoint theta: random next * Float pi * 2 r: random next * 2) ].
							stick center: p ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMassDotsVisualizer radius: 0.0015 color: Color black).
	3000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 600 * (random next * 0.5 + 0.5) ].
	simulator openInWindowLabeled: 'Sandbox 3000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-zen' stamp: 'TomohiroOda 2/6/2012 08:42'!
sandbox4000
	"HGSimulator sandbox4000"

	| random origin simulator bindingAction stick |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					simulator
						particlesDo: [ :p | 
							p
								addForce: (origin unitVector: p position)
								by: (50000.0 / (origin to: stick center distance: p position) squared min: 5000.0) ] ]).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 25.0)).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 40.0) color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							| p |
							p := HG2dPoint fromPoint: position - simulator position.
							(stick center distance: p) > 1.0
								ifTrue: [ p := p + (HG2dPoint theta: random next * Float pi * 2 r: random next * 2) ].
							stick center: p ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMassDotsVisualizer radius: 0.0015 color: Color black).
	4000
		timesRepeat: [ 
			| position p |
			position := random next @ random next * 500.
			p := simulator addParticleAt: position temperature: nil mass: 600 * (random next * 0.5 + 0.5) ].
	simulator openInWindowLabeled: 'Sandbox 4000'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/13/2012 14:44'!
sandtrap
	"HGSimulator sandtrap"

	| random width origin simulator stick resetButton friction friction10 friction01 friction1 pressure grain1 grain2 grain3 frictionPanel grainPanel widthPanel randomPosition sweeping |
	sweeping := false.
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator particleMapResolution: 10.
	width := 10.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(randomPosition := HGRandomPosition origin: (250 - (width / 2.0)) @ 250 corner: (250 + (width / 2.0)) @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (pressure := HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: (friction := HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGBumpyObstacle
				with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0)
				color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 0.5 color: Color black).
	1000 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	resetButton := (SimpleButtonMorph newWithLabel: 'RESET')
		on: #mouseDown send: #value to: [ simulator setupSimulation ];
		yourself.
	frictionPanel := self selectorPanel: 'Friction' do: [ :mu | friction mu: mu asFloat ] withAll: #(0.1 1 10).
	grainPanel := self selectorPanel: 'Grain' do: [ :h | pressure kernel setSupport: h asFloat ] withAll: #(1 2 3).
	widthPanel := self
		selectorPanel: 'Width'
		do: [ :w | 
			randomPosition width: w.
			simulator setupSimulation ]
		withAll: #(1 5 10 20 50).
	(self
		verticalPanel:
			(Array
				with: resetButton
				with: frictionPanel
				with: grainPanel
				with: widthPanel))
		addMorph: simulator;
		openInWindowLabeled: 'sandtrap'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/23/2012 11:37'!
sandtrap3D
	"HGSimulator sandtrap3D"

	| random width origin simulator stick resetButton friction friction10 friction01 friction1 pressure grain1 grain2 grain3 frictionPanel grainPanel widthPanel randomPosition sweeping perspective |
	sweeping := false.
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator particleMapResolution: 10.
	width := 10.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(randomPosition := HGRandomPosition origin: (250 - (width / 2.0)) @ 150 corner: (250 + (width / 2.0)) @ 350).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	origin := HG2dPoint x: 250.0 y: 500.0.
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 3.0)).
	simulator addAction: (pressure := HGPressureRepulsion kernel: (HGSimpleKernel support: 3.0) maxPressure: 100.0).
	simulator addAction: (friction := HGFacialFriction mu: 10.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGBumpyObstacle
				with: (stick := HG2dSweep from: (HG2dPoint x: 0.0 y: 0.0) to: (HG2dPoint x: 0.0 y: 0.0) radius: 10.0)
				color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick from: stick to to: (HG2dPoint fromPoint: position - simulator position) ]
						ifFalse: [ sweeping := false ] ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ sweeping not ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ 
							stick
								from: (HG2dPoint fromPoint: position - simulator position)
								to: (HG2dPoint fromPoint: position - simulator position).
							sweeping := true ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(perspective := HGPerspectiveDotsVisualizer
				radius: 0.5
				color: Color black
				eyeHeight: 10
				vanishingPoint: 250 @ 500
				depthBlock: [ :sim :particle | particle pressure * -0.3 max: -9 ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ ActiveHand anyButtonPressed ]
				do: [ 
					| p |
					p := ActiveHand position.
					(simulator bounds containsPoint: p)
						ifTrue: [ perspective vanishingPoint: p - simulator position ] ]).
	1000 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	resetButton := (SimpleButtonMorph newWithLabel: 'RESET')
		on: #mouseDown send: #value to: [ simulator setupSimulation ];
		yourself.
	frictionPanel := self selectorPanel: 'Friction' do: [ :mu | friction mu: mu asFloat ] withAll: #(0.1 1 10).
	grainPanel := self selectorPanel: 'Grain' do: [ :h | pressure kernel setSupport: h asFloat ] withAll: #(1 2 3).
	widthPanel := self
		selectorPanel: 'Width'
		do: [ :w | 
			randomPosition width: w.
			simulator setupSimulation ]
		withAll: #(1 5 10 20 50).
	(self
		verticalPanel:
			(Array
				with: resetButton
				with: frictionPanel
				with: grainPanel
				with: widthPanel))
		addMorph: simulator;
		openInWindowLabeled: '3D sandtrap'.
	simulator
		setupSimulation;
		startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'utilities' stamp: 'TomohiroOda 2/7/2012 13:44'!
selectorPanel: aString do: aBlock withAll: anArrayOfValues
	| panel |
	panel := self horizontalPanel: (Array with: aString asMorph).
	anArrayOfValues do: [ :value |
		panel addMorph: ((SimpleButtonMorph newWithLabel: value asString)
			on: #mouseDown send: #value to: [ aBlock value: value])].
	^ panel! !

!HGSimulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/13/2012 16:03'!
silkyString1
	"HGSimulator silkyString1"

	| random simulator bindingAction stick resetBlock firsts lasts |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 10
				convergenceCoefficient: 0.1
				color: Color gray
				width: 4).
	bindingAction breakrate: 4.0.
	simulator addAction: (HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	resetBlock := [ 
	bindingAction removeBindingSuchThat: [ :binding | true ].
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	simulator clearParticles.
	250 to: 250 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 0.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		2 to: 500 by: 10 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 1) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ] ].
	resetBlock value.
	(self
		verticalPanel:
			(Array
				with:
					((SimpleButtonMorph newWithLabel: 'RESET')
						on: #mouseDown send: #value to: resetBlock;
						yourself)
				with:
					(self selectorPanel: 'Tension' do: [:steps | bindingAction steps: steps] withAll: #(1 2 5 10))
				with: (self selectorPanel: 'Strength' do: [ :rate | bindingAction breakrate: rate asFloat] withAll: #(3 4 5)))) 		 addMorph: simulator; openInWindowLabeled: 'Silky String 1'.
	simulator startStepping..

	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/13/2012 09:37'!
silkyString5
	"HGSimulator silkyString5"

	| random simulator bindingAction stick firsts lasts resetBlock |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 10
				convergenceCoefficient: 0.1
				color: Color gray
				width: 1).
	bindingAction breakrate: 4.0.
	simulator addAction: (HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 20.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	resetBlock := [ 
	simulator clearParticles.
	bindingAction removeBindingSuchThat: [ :binding | true ].
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	240 to: 260 by: 4 do: [ :x | 
		| p1 last |
		p1 := simulator addParticleAt: x asFloat @ 0.0 temperature: nil mass: 300.
		firsts add: p1 -> p1 position copy.
		5 to: 500 by: 4 do: [ :y | 
			| p2 |
			last := simulator addParticleAt: x asFloat @ (y - 2) asFloat temperature: nil mass: 300.
			p2 := last.
			bindingAction addBindingBetween: p1 and: p2.
			p2 position: (HG2dPoint x: x asFloat y: y asFloat).
			p1 := p2 ].
		lasts add: last -> last position copy ] ].
	resetBlock value.
	(self
		verticalPanel:
			(Array
				with:
					((SimpleButtonMorph newWithLabel: 'RESET')
						on: #mouseDown send: #value to: resetBlock;
						yourself)
				with: (self selectorPanel: 'Tension' do: [ :steps | bindingAction steps: steps ] withAll: #(1 2 5 10))
				with: (self selectorPanel: 'Strength' do: [ :rate | bindingAction breakrate: rate asFloat ] withAll: #(3 4 5 10 20))))
		 addMorph: simulator; openInWindowLabeled: 'Silky String5'.
	simulator startStepping..
	^ simulator! !

!HGSimulator class methodsFor: 'applications-barriers' stamp: 'TomohiroOda 2/9/2012 13:18'!
slackFence
	"HGSimulator slackFence"

	| random simulator bindingAction stick firsts lasts showMap |
	random := Random new.
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	showMap := false.
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ showMap ]
				do: [ 
					(simulator form getCanvas)
						fillColor: Color yellow muchLighter;
						drawPolygon: (Array with: 0 @ 0 with: 250 @ 100 with: 500 @ 0)
							color: Color blue muchLighter
							borderWidth: 0
							borderColor: Color blue;
						drawPolygon:
								(Array
									with: 0 @ 0
									with: 0 @ 500
									with: 100 @ 400
									with: 250 @ 100)
							color: Color red muchLighter
							borderWidth: 0
							borderColor: Color red;
						drawPolygon: (Array with: 250 @ 100 with: 100 @ 400 with: 400 @ 350)
							color: Color green muchLighter
							borderWidth: 0
							borderColor: Color lightGray ]).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					firsts do: [ :assoc | assoc key position: assoc value ].
					lasts do: [ :assoc | assoc key position: assoc value ] ]).
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(bindingAction := HGHardBindingElasticForce
				steps: 20
				convergenceCoefficient: 0.1
				color: Color gray
				width: 4).
	simulator addAction: (HGObstacle with: (stick := HG2dCircle center: (HG2dPoint x: 0.0 y: 0.0) radius: 30.0) color: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ true ]
				do: [ 
					| position |
					position := ActiveHand position.
					(simulator bounds containsPoint: position)
						ifTrue: [ stick center: (HG2dPoint fromPoint: position - simulator position) ] ]).
	simulator addAction: (HGBoundingBox reflectionRate: 1.0).
	simulator addAction: HGLocalityMap new.
	firsts := OrderedCollection new.
	lasts := OrderedCollection new.
	(Array
		with: 250.0 @ 100.0
		with: 100.0 @ 400.0
		with: 400.0 @ 350.0
		with: 0.0 @ 0.0
		with: 500.0 @ 0.0
		with: 0.0 @ 500.0)
		with:
			(Array
				with: 100.0 @ 400.0
				with: 400.0 @ 350.0
				with: 250.0 @ 100.0
				with: 250.0 @ 100.0
				with: 250.0 @ 100.0
				with: 100.0 @ 400.0)
		do: [ :start :end | 
			| p1 v last step |
			p1 := simulator addParticleAt: start temperature: nil mass: 300.
			last := p1.
			v := end - start.
			firsts add: p1 -> p1 position copy.
			step := 10.0 / (start dist: end).
			step to: 1.0 by: step do: [ :t | 
				| p2 |
				p2 := simulator addParticleAt: v * (t - (step / 2.0)) + start temperature: nil mass: 300.
				bindingAction addBindingBetween: last and: p2.
				p2 position: (HG2dPoint fromPoint: v * t + start).
				last := p2 ].
			lasts add: last -> last position copy ].
	(self
		verticalPanel:
			(Array
				with: (self selectorPanel: 'Tension' do: [ :steps | bindingAction steps: steps ] withAll: #(1 5 10 20))
				with: (self selectorPanel: 'Map' do: [ :choice | showMap := choice = 'SHOW' ] withAll: #('SHOW' 'HIDE'))))
		addMorph: simulator;
		openInWindowLabeled: 'Slack Fence'.
	simulator startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-constraints' stamp: 'tomooda 4/20/2015 17:03'!
smokeInUserImage: rate
	"HGSimulator smokeInUserImage: 0.5"

	| form luminances border cursorForm simulator background gravity |
	form := Form fromDisplay: (0@0 corner: 50@50).
	luminances := OrderedCollection new: 2500.
	1 to: 50 do: [ :x | 1 to: 50 do: [ :y | luminances add: (form colorAt: x @ y) luminance ] ].
	border := luminances asSortedCollection at: ((2500 * rate) rounded min: 2500 max: 1).
	luminances := nil.
	cursorForm := Cursor normal asCursorForm.
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGViscosityInitialization with: 0.1).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: 500 @ 500).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [true]
				do: [ 
					| g |
					g := HG2dPoint fromPoint: (ActiveHand position - simulator position) / simulator bounds extent * 2.0 - 1.0.
					g := g min: (HG2dPoint x: 1.0 y: 1.0) max: (HG2dPoint x: -1.0 y: -1.0).
					gravity g: (g mul: 1.0) ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.1 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (background form colorAt: position asPoint) luminance < border ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.0).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (background := HGBackgroundImageVisualizer form: (form magnifyBy: 10)).
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 25.0) scale: 20.0 color: (Color black)).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	200 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Obstacles from User Image (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/3/2011 17:32'!
splashDots
	"HGSimulator splashDots"

	| simulator forms random |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.5 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:46'!
splashPolygon
	"HGSimulator splashPolygon"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGPolygonVisualizer color: Color lightBlue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Polygons)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/3/2011 18:48'!
splashPressureBorderline
	"HGSimulator splashPressureBorderline"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlinePressureVisualizer pressure: 0.4 width: 1 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Borderline)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/3/2011 18:48'!
splashPressureBorderlineFill
	"HGSimulator splashPressureBorderlineFill"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color lightBlue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Borderline Fill)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/4/2011 15:08'!
splashPressureBorderlineGraffitiFill
	"HGSimulator splashPressureBorderlineGraffitiFill"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color blue).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 3 color: Color black)
				xgrids: 60;
				ygrids: 60;
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 4 color: Color black)
				xgrids: 50;
				ygrids: 50;
				yourself).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Graffiti)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/3/2011 18:46'!
splashPressureBorderlineToonFill
	"HGSimulator splashPressureBorderlineToonFill"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color blue).
	simulator addAction: (HGBorderlinePressureVisualizer pressure: 0.4 width: 3 color: Color black).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Toon)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 11/2/2011 12:47'!
splashPressureMap
	"HGSimulator splashPressureMap"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'tomooda 4/20/2015 17:03'!
splashRefraction
	"HGSimulator splashRefraction"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBackgroundImageVisualizer form: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (HGMeshPressureVisualizer scale: 0.1 bias: 0.0 color: Color blue lighter).
	simulator addAction: (HGRefractionVisualizer scale: 10.0).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-flows' stamp: 'TomohiroOda 6/26/2012 08:43'!
splashSmoke
	"HGSimulator splashSmoke"

	| simulator |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 150 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 25.0) scale: 20.0 color: (Color blue)).
	simulator addAction: (HGDotVisualizer at: 1 radius: 3.0 color: Color red).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	399 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Splash (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:40'!
stationaryVelocityViewer
	"HGSimulator stationaryVelocityViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 1.0 color: Color black).
	simulator
		addAction:
			((HGStationaryVelocityVisualizer
				at: (HG2dPoint x: 250.0 y: 300.0)
				kernel: (HGSimpleKernel support: 50.0)
				radius: 2.0
				width: 2.0
				scale: 10.0
				color: Color brown)
				isTouchy: false;
				yourself).
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: nil mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Stationary-Velocity Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-presentations' stamp: 'TomohiroOda 6/26/2012 09:29'!
steampaint
	"HGSimulator steampaint"

	| random form mask simulator rate gravity window refraction smoke |
	random := Random new.
	form := Form
		fromBinaryStream:
			((UITheme current
				fileOpenIn: World
				title: 'Choose a file'
				extensions: #('png' 'jpg' 'bmp' 'gif')
				path: nil
				preview: #image) ifNil: [ ^ self ]).
	form := form scaledToSize: 500 @ (500 * form extent y / form extent x).
	rate := 1.0.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: form extent.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint fromPoint: form extent).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: form extent).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity
					g: (HG2dPoint x: 0 y: -2.0)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: HGLocalityMap withOutOfBoundsRemoval.
	simulator addAction: (HGBackgroundImageVisualizer form: form).
	simulator addAction: (smoke := HGSmokeyVisualizer kernel: (HGSimpleKernel support: 20.0) scale: 0.0 color: Color white).
	simulator
		addAction:
			(refraction := HGRefractionVisualizer
				xgrids: 60
				ygrids: 60
				kernel: (HGSimpleKernel support: 5)
				scale: 0.0
				image: nil).
	simulator
		addAction: (HGTriggerBlockAction
				whenever: [ActiveHand anyButtonPressed and: [simulator bounds containsPoint: ActiveHand position]]
				do: [ | point |
					point := ActiveHand position - simulator position.
					simulator addAction: (HGTriggerBlockAction whenever: [simulator random next < rate] do: [(simulator
								addParticleAt: simulator random next - 0.5 @ (simulator random next * 2.0 - 1.8) * 40 + point
								temperature: 370.0
								mass: 300.0)
								viscosity: 79.0])]).
	(self
		verticalPanel: (Array
				with: (self
						selectorPanel: 'Refraction'
						do: [:scale | 
							refraction scale: scale * 1.0]
						withAll: #(0 10 20 30 ))
				with: (self
						selectorPanel: 'Smoke'
						do: [:scale | 
							smoke scale: scale]
						withAll: #(0 100 200 300 ))
				with: (self
						selectorPanel: 'Upstream'
						do: [:gy | gravity g y: gy negated]
						withAll: #(0.1 0.2 0.5 1.0 2.0 4.0 8.0 ))
				with: (self
						selectorPanel: 'Amount'
						do: [:m | rate := m / 100.0]
						withAll: #(1 10 100)))) addMorphBack: simulator;
		 openInWindowLabeled: 'Steam-Paint'.
	simulator setupSimulation; startStepping.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 3/19/2012 18:20'!
stickyBeans
	"HGSimulator stickyBeans"

	| simulator forms random |
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 300 @ 300 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.2 kernel: (HGSimpleKernel support: 15.0)).
	simulator
		addAction:
			(HGLocalAction
				on: (HGGravity g: (HG2dPoint x: 0 y: 1.0))
				in: (HG2dRectangle origin: (HG2dPoint fromPoint: 400 @ 0) corner: (HG2dPoint fromPoint: 500 @ 500))).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 15.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGFormVisualizer natto.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 400 mass: 300 ].
	simulator openInWindowLabeled: 'Sticky Beans'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-viscous' stamp: 'TomohiroOda 10/4/2011 09:32'!
stickyBeansAtDie
	"HGSimulator stickyBeansAtDie"

	| simulator |
	simulator := HGSimulator new.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGRandomPosition
				origin: 300 @ 150
				corner: 500 @ 350
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 100.0)).
	simulator addInitializer: (HGVelocityInitialization with: (HG2dPoint x: -20.0 y: 0.0)).
	simulator addInitializer: (HGTemperatureInitialization with: 360).
	simulator addAction: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0.0 y: 0.1)).
	simulator addAction: (HGPressure gasConstant: 0.01 kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 10.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 80.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 260.0) on: (HG2dPoint x: 200.0 y: 450.0) on: (HG2dPoint x: 50.0 y: 400.0))
				color: (Color gray: 0.8)).
	simulator
		addAction:
			(HGObstacle
				with:
					(HG2dTriangle on: (HG2dPoint x: 200.0 y: 240.0) on: (HG2dPoint x: 50.0 y: 100.0) on: (HG2dPoint x: 200.0 y: 30.0))
				color: (Color gray: 0.8)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: HGFormVisualizer natto.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 200.0 ].
	simulator openInWindowLabeled: 'Sticky Beans at a Die'.
	simulator color: (Color gray: 0.87).
	^ simulator! !

!HGSimulator class methodsFor: 'applications-jun' stamp: 'tomooda 4/20/2015 16:55'!
submarineByJun4Pharo
	"HGSimulator submarineByJun4Pharo"

	| random form0 form1 form2 form rc1 rc2 ball ball2 a1 a2 r simulator contact |
	random := Random new.
	form0 := Form fromDisplay: (0@0 corner: 500@500).
	form1 := Form extent: form0 extent depth: form0 depth.
	form2 := Form extent: form0 extent depth: form0 depth.
	form := Form extent: form0 extent depth: form0 depth.
	rc1 := (Smalltalk at: #JunWodenRenderingContext) on: form1.
	rc1 projection: (JunPerspectiveProjection
		eyePoint: (0, 0, 10)
		sightPoint: 0, 0, 5
		upVector: 0 , 1, 0
		fovy: 30 asDegrees
		near: 0.1
		far: 10.0).
	rc1 disableCullface.
	rc1 ambientLight: Color darkGray.
	rc1 lightIndex: 0 parallel: (0.5, 0.3, 6.0) negated color: Color gray.
	rc2 := (Smalltalk at: #JunWodenRenderingContext) on: form2.
	rc2 projection: (JunPerspectiveProjection
		eyePoint: (0, 0, 10)
		sightPoint: 0, 0, 5
		upVector: 0 , 1, 0
		fovy: 30 asDegrees
		near: 0.1
		far: 5.0).
	rc2 disableCullface.
	rc2 ambientLight: Color darkGray.
	rc2 lightIndex: 0 parallel: (0.5, 0.3, 6.0) negated color: Color gray.
	ball := Jun3dDisplayObject sphere: 15 radius: 0.3.
	a1 := 0.0 asDegrees.
	a2 := 0.0 asDegrees.
	r := 2 * 3 sqrt / 5 * 250.
	contact := HG2dCircle center: (HG2dPoint x: 250.0 y: 250.0) radius: 0.0.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 200 @ 200 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.3 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 60.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ 
		| x y z |
		x := a1 cos.
		y := a1 sin.
		z := a2 sin * 0.5 + 4.5.
		a1 := a1 + 3 asDegrees.
		a2 := a2 + 7 asDegrees. 
		rc1 backgroundColor: (Color white).
		rc1 clear.
		rc1 backgroundColor: (Color transparent).
		rc1 clear.
		(ball2 := ball transform: (Jun3dTransformation translate: x, y, z)) renderOn: rc1.
		rc1 flush.
		contact center: (HG2dPoint fromPoint: x, y negated * r + 250).
		contact radius: (1.0 - (z - 5) abs * r * 0.7).
		form getCanvas drawImage: form0 at: 0@0; paintImage: form1 at: 0@0; flush]).
	simulator
		addAction:
			(HGObstacle
				with:
					(contact)
				color: (Color transparent)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGRefractionVisualizer scale: 10.0 image: (form)).
	simulator addAction: ((HGMeshPressureVisualizer color: Color blue) kernel: (HGSimpleKernel support: 60); scale:0.3).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [ 
		rc2 backgroundColor: (Color transparent).
		rc2 clear.
		ball2 renderOn: rc2.
		rc2 flush.
		simulator form getCanvas paintImage: form2 at: 0@0; flush]).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 3000.
	400 timesRepeat: [ simulator addParticleAt: 0 @ 0 temperature: 390 mass: 300 ].
	simulator openInWindowLabeled: 'Submarine'.
	^ simulator! !

!HGSimulator class methodsFor: 'utilities' stamp: 'TomohiroOda 2/7/2012 13:35'!
verticalPanel: anArrayOfMorphs
	| panel |
	panel := Morph new.
	panel color: Color white.
	panel changeTableLayout.
	panel listDirection: #bottomToTop.
	panel wrapCentering: #center.
	anArrayOfMorphs
		do: [ :morph | 
			panel addMorph: morph.
			morph hResizing: #spaceFill ].
	^ panel! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 1/23/2012 17:43'!
washoutDots
	"HGSimulator washoutDots"

	| source random simulator clicked oldClicked trindingElasticForceAction |
	source := thisContext method getSource.
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 20
				mass: 200.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGPump
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 10.0
								at: (p)) ]).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 1.0 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.9).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 3 color: Color blue).
	simulator openInWindowLabeled: 'Washout (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 1/23/2012 17:50'!
washoutPressureMap
	"HGSimulator washoutPressureMap"

	| source random simulator clicked oldClicked trindingElasticForceAction |
	source := thisContext method getSource.
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 20
				mass: 200.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGPump
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 10.0
								at: (p)) ]).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.9).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator addAction: trindingElasticForceAction.
	simulator openInWindowLabeled: 'Washout (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'tomooda 4/20/2015 17:04'!
washoutRefraction
	"HGSimulator washoutRefraction"

	| source random simulator clicked oldClicked trindingElasticForceAction |
	source := thisContext method getSource.
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addInitializer:
			(HGAddTrindingElasticBody
				on:
					(trindingElasticForceAction := HGHardTrindingElasticForce steps: 3 convergenceCoefficient: 0.1 color: Color gray)
				region: (HG2dCircle center: (HG2dPoint x: 400 y: 250) radius: 80.0)
				numberOfParticles: 20
				mass: 200.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGPump
								v: (p unitVector: (HG2dPoint x: 250.0 y: 250.0)) * 10.0
								at: (p)) ]).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 1.0 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGRefractionVisualizer scale: 3.0 image: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: trindingElasticForceAction.
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.9).
	simulator addAction: HGLocalityMap new.
	simulator openInWindowLabeled: 'Washout (Refraction)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-distributed-viewers' stamp: 'TomohiroOda 10/3/2011 15:41'!
waterImageViewer
	"HGSimulator waterImageViewer"

	| simulator |
	simulator := HGSimulator new.
	simulator color: Color white.
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addAction: (HGPVTDownloader address: #[127 0 0 1] port: 9800).
	simulator addAction: HGFormVisualizer water.
	10
		timesRepeat: [ 
			simulator
				addParticleAt: 0 @ 0
				temperature: nil
				mass: 300 ].
	simulator openInWindowLabeled: 'HoneyGinger Water Viewer'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-presentations' stamp: 'TomohiroOda 6/25/2012 13:08'!
waterpaint
	"HGSimulator waterpaint"

	| random form mask simulator gravity window |
	random := Random new.
	form := Form
		fromBinaryStream:
			((UITheme current
				fileOpenIn: World
				title: 'Choose a file'
				extensions: #('png' 'jpg' 'bmp' 'gif')
				path: nil
				preview: #image) ifNil: [ ^ self ]).
	form := form scaledToSize: 500 @ (500 * form extent y / form extent x).
	mask := Form extent: form extent depth: 1.
	mask getCanvas fillColor: Color white.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: form extent.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint fromPoint: form extent).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: form extent).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (mask colorAt: position asPoint) luminance > 0.5 ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBackgroundImageVisualizer form: form).
	simulator
		addAction:
			(HGRefractionVisualizer
				xgrids: 100
				ygrids: 100
				kernel: (HGSimpleKernel support: 40)
				scale: 10.0
				image: nil).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ random next < 0.1 ]
				do: [ gravity g: (HG2dPoint theta: random next * 3.14 * 2 r: 0.1) ]).
	simulator addAction: (HGTriggerBlockAction
		whenever: [ActiveHand anyButtonPressed and: [simulator bounds containsPoint: ActiveHand position ]] do: [
			| point |
			point := ActiveHand position - simulator position.
			mask getCanvas fillOval: (point - 20 extent: 41) color: Color black; flush.
			simulator random next < 0.3 ifTrue: [(simulator addParticleAt: point temperature: 370.0 mass: 300.0) viscosity: 79.0  ]]).
	simulator
		setupSimulation;
		startStepping.
	window := simulator openInWindowLabeled: 'Water-Paint'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-presentations' stamp: 'TomohiroOda 6/19/2012 08:48'!
waterpaintFromUser
	"HGSimulator waterpaintFromUser"

	| random form mask simulator gravity window |
	random := Random new.
	form := Form
		fromUser.
	form ifNil: [^self].
	form := form scaledToSize: 500 @ (500 * form extent y / form extent x).
	mask := Form extent: form extent depth: 1.
	mask getCanvas fillColor: Color white.
	simulator := HGSimulator new.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: form extent.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint fromPoint: form extent).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 0 corner: form extent).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 370).
	simulator addInitializer: HGTemperatureViscosityCurve butter.
	simulator addAction: (HGPositionNoise withBlock: [ random next @ random next * 0.01 ]).
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (gravity := HGGravity g: (HG2dPoint x: 0.0 y: 0.0)).
	simulator addAction: (HGPressure gasConstant: 0.7 kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator
		addAction:
			(HGObstacle with: (HG2dBlockRegion on: [ :position | (mask colorAt: position asPoint) luminance > 0.5 ])).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator
		addAction:
			(HGRefractionVisualizer
				xgrids: 100
				ygrids: 100
				kernel: (HGSimpleKernel support: 40)
				scale: 15.0
				image: form).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ random next < 0.1 ]
				do: [ gravity g: (HG2dPoint theta: random next * 3.14 * 2 r: 0.1) ]).
	simulator addAction: (HGTriggerBlockAction
		whenever: [ActiveHand anyButtonPressed and: [simulator bounds containsPoint: ActiveHand position ]] do: [
			| point |
			point := ActiveHand position - simulator position.
			mask getCanvas fillOval: (point - 20 extent: 41) color: Color black; flush.
			simulator random next < 0.2 ifTrue: [(simulator addParticleAt: point temperature: 370.0 mass: 300.0) viscosity: 79.0  ]]).
	simulator
		setupSimulation;
		startStepping.
	window := simulator openInWindowLabeled: 'Water-Paint'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 12/29/2011 08:51'!
watershowDots
	"HGSimulator watershowDots"

	| random simulator clicked oldClicked |
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: 10.0 y: -20.0) at: (HG2dPoint x: 10.0 y: 200.0)).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	"simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction HGVelocityIntegration new."
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGDotsVisualizer radius: 3.0 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Watershow (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 12/29/2011 08:51'!
watershowGraffiti
	"HGSimulator watershowGraffiti"

	| random simulator clicked oldClicked |
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: 10.0 y: -20.0) at: (HG2dPoint x: 10.0 y: 200.0)).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	"simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction HGVelocityIntegration new."
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBorderlineFillPressureVisualizer pressure: 0.4 color: Color blue).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 3 color: Color black)
				xgrids: 60;
				ygrids: 60;
				yourself).
	simulator
		addAction:
			((HGBorderlinePressureVisualizer pressure: 0.4 width: 4 color: Color black)
				xgrids: 50;
				ygrids: 50;
				yourself).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Watershow (Graffiti)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 12/29/2011 08:45'!
watershowPressureMap
	"HGSimulator watershowPressureMap"

	| random simulator clicked oldClicked |
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: 10.0 y: -20.0) at: (HG2dPoint x: 10.0 y: 200.0)).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	"simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction HGVelocityIntegration new."
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGMeshPressureVisualizer scale: 0.2 bias: 0.0 color: Color blue).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Watershow (Pressure Map)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'tomooda 4/20/2015 17:04'!
watershowRefraction
	"HGSimulator watershowRefraction"

	| random simulator clicked oldClicked |
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: 10.0 y: -20.0) at: (HG2dPoint x: 10.0 y: 200.0)).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	"simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGViscosityTraction kernel: (HGSimpleKernel support: 70.0)).
	simulator addAction: HGForceIntegration new.
	simulator addAction HGVelocityIntegration new."
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGBackgroundImageVisualizer form: (Form fromDisplay: (0@0 corner: 500@500))).
	simulator addAction: (HGMeshPressureVisualizer scale: 0.05 bias: 0.0 color: Color blue lighter).
	simulator addAction: (HGRefractionVisualizer scale: 10.0).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Watershow (Dots)'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 6/26/2012 11:36'!
watershowSmoke
	"HGSimulator watershowSmoke"

	| random simulator clicked oldClicked |
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator addInitializer: (HGRandomPosition origin: 0 @ 400 corner: 500 @ 500).
	simulator addInitializer: (HGVelocityInitialization with: HG2dPoint zero).
	simulator addInitializer: (HGTemperatureInitialization with: 380).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: 10.0 y: -20.0) at: (HG2dPoint x: 10.0 y: 200.0)).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 50.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.098)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 20.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 30.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGSmokeyVisualizer kernel: (HGSimpleKernel support: 20.0) scale: 5.0 color: Color lightGray).
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Smoke show'.
	^ simulator! !

!HGSimulator class methodsFor: 'applications-watershows' stamp: 'TomohiroOda 1/23/2012 16:56'!
watershowSourceCode
	"HGSimulator watershowSourceCode"

	| source random simulator clicked oldClicked |
	source := thisContext method getSource.
	random := Random new.
	simulator := HGSimulator new.
	clicked := false.
	simulator color: ((Color brown mixed: 0.4 with: Color gray) alpha: 0.2).
	simulator extent: 500 @ 500.
	simulator simulationOrigin: (HG2dPoint x: 0.0 y: 0.0) corner: (HG2dPoint x: 500.0 y: 500.0).
	simulator
		addAction:
			(HGTriggerBlockAction
				whenever: [ 
					oldClicked := clicked.
					clicked := ActiveHand anyButtonPressed.
					oldClicked not and: [ clicked ] ]
				do: [ 
					| p d |
					p := HG2dPoint fromPoint: ActiveHand position - simulator position.
					d := HG2dPoint x: 20.0 y: 20.0.
					simulator
						addAction:
							(HGJet
								v: (HG2dPoint x: (250 - p x) / 20 y: -25)
								in: (HG2dRectangle origin: p - d corner: p + d)) ]).
	simulator addAction: (HGPump v: (HG2dPoint x: -10.0 y: -20.0) at: (HG2dPoint x: 490.0 y: 200.0)).
	simulator addAction: (HGTriggerBlockAction whenever: [true] do: [(simulator particleAt: (simulator numberOfParticles)) ifNotNilDo: [ : p | p at: #string put: (String with: (source at: (simulator numberOfParticles \\ source size + 1)))]]).
	simulator addAction: (HGHandParticle at: 1).
	simulator addAction: HGTemperatureViscosityCurve normalizedButter.
	simulator addAction: (HGForceInitialization with: HG2dPoint zero).
	simulator addAction: (HGPressure gasConstant: 0.5 kernel: (HGSimpleKernel support: 20.0)).
	simulator addAction: (HGGravity g: (HG2dPoint x: 0 y: 0.98)).
	simulator addAction: (HGPressureRepulsion kernel: (HGSimpleKernel support: 5.0) maxPressure: 1000.0).
	simulator addAction: HGForceIntegration new.
	simulator addAction: HGVelocityIntegration new.
	simulator addAction: (HGViscosityBySmoothing kernel: (HGSimpleKernel support: 40.0)).
	simulator addAction: (HGBoundingBox reflectionRate: 0.1).
	simulator addAction: HGLocalityMap new.
	simulator addAction: (HGStringVisualizer color: Color blue defaultString: 'O').
	simulator addParticleAt: 0 @ 0 temperature: 390 mass: 2000.
	simulator openInWindowLabeled: 'Watershow (SourceCode)'.
	^ simulator! !

!HGSimulator methodsFor: 'rules' stamp: 'TomohiroOda 6/22/2011 09:51'!
addAction: anHGAction
	actions add: anHGAction! !

!HGSimulator methodsFor: 'rules' stamp: 'TomohiroOda 6/21/2011 10:33'!
addInitializer: anHGRule
	initializers add: anHGRule! !

!HGSimulator methodsFor: 'particles' stamp: 'TomohiroOda 10/2/2011 11:15'!
addParticleAt: aPoint temperature: temperature mass: mass
	| particle |
	particle := HGParticle
		at: (HG2dPoint fromPoint: aPoint)
		velocity: HG2dPoint zero
		temperature: temperature
		mass: mass
		in: self.
	particles := particles copyWith: particle.
	^ particle! !

!HGSimulator methodsFor: 'particles' stamp: 'TomohiroOda 2/7/2012 12:11'!
clearParticles
	particles := Array new.
	self updateParticleMap! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:23'!
color: aColor
	super color: aColor.
	form ifNotNil: [ form getCanvas fillColor: self color ].
	visibleForm ifNotNil: [ visibleForm getCanvas fillColor: self color ]! !

!HGSimulator methodsFor: 'fields' stamp: 'TomohiroOda 7/1/2011 08:10'!
countAt: anHG2dPoint kernel: anHGKernel
	| count |
	count := 0.
	self
		neighborsOf: anHG2dPoint
		within: anHGKernel support
		do: [ :neighbor :distance | count := count + (anHGKernel r: distance) ].
	^ count! !

!HGSimulator methodsFor: 'drawing' stamp: 'TomohiroOda 10/19/2011 10:15'!
drawOn: aCanvas
	visibleForm ifNotNilDo: [ :f | aCanvas drawImage: f at: self position sourceRect: (0 @ 0 extent: self extent) ]! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:07'!
form
	^form! !

!HGSimulator methodsFor: 'event handling' stamp: 'TomohiroOda 5/17/2011 09:41'!
handlerForBlueButtonDown: anEvent
	^ nil  ! !

!HGSimulator methodsFor: 'event handling' stamp: 'TomohiroOda 5/17/2011 09:41'!
handlesMouseDown: anEvent
	^(super handlesMouseDown: anEvent) or: [anEvent redButtonPressed]  ! !

!HGSimulator methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/7/2012 07:22'!
initialize
	super initialize.
	actions := OrderedCollection new.
	initializers := OrderedCollection new.
	particles := Array new.
	particleMapResolution := 50.
	random := Random new.
	self updateParticleMap.
! !

!HGSimulator methodsFor: 'enumerating' stamp: 'TomohiroOda 7/1/2011 07:53'!
neighborsOf: anHG2dPoint within: aNumber do: aBlock
	| x y r |
	x := anHG2dPoint x.
	y := anHG2dPoint y.
	r := aNumber squared.
	particleMap
		at: anHG2dPoint
		within: aNumber
		do: [ :particle | 
						| p dx dy |
			p := particle position.
			dx := x - p x.
			((dx := dx * dx) < r
				and: [ 
					dy := y - p y.
					(dy := dy * dy) < r ])
				ifTrue: [ 
					| d |
					(d := dx + dy) < r
						ifTrue: [ aBlock value: particle value: d sqrt ] ] ]! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/21/2011 13:40'!
numberOfParticles
	^ particles size! !

!HGSimulator methodsFor: 'user interface' stamp: 'TomohiroOda 8/9/2011 14:10'!
openInWindowLabeled: aString
	| window |
	window := super openInWindowLabeled: aString.
	self setupSimulation.
	^ window! !

!HGSimulator methodsFor: 'user interface' stamp: 'TomohiroOda 8/10/2011 15:11'!
openInWorld
	| window |
	window := super openInWorld.
	self setupSimulation.
	^ window! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 14:35'!
particleAt: anInteger
	^ particles at: anInteger ifAbsent: []! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 08:04'!
particleMapResolution
	^ particleMapResolution! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 08:05'!
particleMapResolution: anInteger
	particleMapResolution := anInteger.
	self updateParticleMap ! !

!HGSimulator methodsFor: 'enumerating' stamp: 'TomohiroOda 6/21/2011 11:26'!
particlesDo: aBlock
	particles do: aBlock! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/7/2012 07:23'!
random
	^ random! !

!HGSimulator methodsFor: 'rules' stamp: 'TomohiroOda 8/4/2011 14:39'!
removeAction: anHGAction ifAbsent: errorBlock
	^ actions remove: anHGAction ifAbsent: errorBlock! !

!HGSimulator methodsFor: 'particles' stamp: 'TomohiroOda 6/25/2012 11:30'!
removeParticlesSuchThat: aBlock
	particles := particles reject: aBlock.
	self updateParticleMap! !

!HGSimulator methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 5/17/2011 09:46'!
setupSimulation
	self setupSimulationAt: Time millisecondClockValue! !

!HGSimulator methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 7/15/2011 13:24'!
setupSimulationAt: millisecondClockValue
	"| time |
	time := self timeFromMillis: millisecondClockValue.
	self particlesDo: [ :particle | particle setupState: time ]"

	simulationTime := self timeFromMillis: millisecondClockValue.
	initializers do: [ :rule | rule effectIn: self deltaT: 0.0 ]! !

!HGSimulator methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:21'!
showLicense
	self class showLicense! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 14:24'!
simulationCorner
	^simulationCorner! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 14:23'!
simulationOrigin
	^ simulationOrigin! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:20'!
simulationOrigin: anHG2dPoint corner: anotherHG2dPoint
	simulationOrigin := anHG2dPoint.
	simulationCorner := anotherHG2dPoint.
	form := Form extent: (anotherHG2dPoint x - anHG2dPoint x) @ (anotherHG2dPoint y - anHG2dPoint y) depth: 32.
	form getCanvas fillColor: self color.
	visibleForm := Form extent: (anotherHG2dPoint x - anHG2dPoint x) @ (anotherHG2dPoint y - anHG2dPoint y) depth: 32.
	visibleForm getCanvas fillColor: self color.
	self updateParticleMap! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 15:28'!
simulationTime
	^ simulationTime! !

!HGSimulator methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 5/17/2011 09:47'!
step
	self stepAt: Time millisecondClockValue ! !

!HGSimulator methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 7/6/2011 11:16'!
stepAt: millisecondClockValue
	| time deltaT |
	"deltaT := (time := self timeFromMillis: millisecondClockValue) - simulationTime."
	deltaT := 1.0.
	actions do: [ :rule | rule effectIn: self deltaT: deltaT ].
	self updateForm.
	simulationTime := time.
	self invalidRect: self fullBounds! !

!HGSimulator methodsFor: 'stepping and presenter' stamp: 'TomohiroOda 6/22/2011 11:01'!
stepTime
	^10.0! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 5/17/2011 09:39'!
time
	^ self timeFromMillis: Time millisecondClockValue! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 11:57'!
timeFromMillis: aNumber
	^ aNumber / 200.0.! !

!HGSimulator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 07:24'!
updateForm
	| t |
	t := visibleForm.
	visibleForm := form.
	form := t.
	(form getCanvas)
		fillColor: self color;
		flush! !

!HGSimulator methodsFor: 'particles' stamp: 'TomohiroOda 2/7/2012 08:04'!
updateParticleMap
	(simulationOrigin notNil and: [ simulationCorner notNil ])
		ifTrue: [ 
			| newParticleMap |
			newParticleMap := HGSpatialPartitionedCollection origin: simulationOrigin corner: simulationCorner step: particleMapResolution.
			self particlesDo: [ :particle | newParticleMap at: particle position add: particle ].
			particleMap := newParticleMap ]! !

!HGSimulator methodsFor: 'fields' stamp: 'TomohiroOda 10/2/2011 10:31'!
velocityAt: anHG2dPoint kernel: anHGKernel
	| velocity denominator |
	velocity := HG2dPoint zero.
	denominator := 0.0.
	self
		neighborsOf: anHG2dPoint
		within: anHGKernel support
		do: [ :neighbor :distance | 
			| r |
			r := anHGKernel r: distance.
			velocity add: neighbor velocity by: r.
			denominator := denominator + r ].
	^ denominator > 0.0
		ifTrue: [ velocity / denominator ]
		ifFalse: [ velocity ]! !

TestCase subclass: #HGTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Tests-Abstract'!

HGTestCase subclass: #HG2dPointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Tests'!

!HG2dPointTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dPointTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dPointTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:39'!
testAbs
	self assert: 3.0 equals: (HG2dPoint x: 1.0 y: -2.0) abs! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:05'!
testAddBy
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point add: (HG2dPoint x: 3.0 y: 4.0) by: 5.0.
	self assert: (HG2dPoint x: 16.0 y: 22.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:06'!
testAddMinusBy
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point add: (HG2dPoint x: 3.0 y: 4.0) minus: (HG2dPoint x: 5.0 y: 7.0) by: 5.0.
	self assert: (HG2dPoint x: -9.0 y: -13.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:07'!
testAddOver
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point add: (HG2dPoint x: 3.0 y: 4.0) over: 2.0.
	self assert: (HG2dPoint x: 2.5 y: 4.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:08'!
testAsPoint
	self assert: 1@2 equals: (HG2dPoint x: 1 y: 2) asPoint! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:09'!
testCeiling
	self assert: (HG2dPoint x: 2 y: 3) equals: (HG2dPoint x: 1.1 y: 2.8) ceiling! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:12'!
testCornerDo
	| points |
	points := Array new writeStream.
	(HG2dPoint x: 1 y: 2) corner: (HG2dPoint x: 3 y: 4) do: [ :point | points nextPut: point ].
	self
		assert:
			{(HG2dPoint x: 1 y: 2).
			(HG2dPoint x: 1 y: 3).
			(HG2dPoint x: 1 y: 4).
			(HG2dPoint x: 2 y: 2).
			(HG2dPoint x: 2 y: 3).
			(HG2dPoint x: 2 y: 4).
			(HG2dPoint x: 3 y: 2).
			(HG2dPoint x: 3 y: 3).
			(HG2dPoint x: 3 y: 4)}
		equals: points contents! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:13'!
testCornerElementsDo
	| points |
	points := Array new writeStream.
	(HG2dPoint x: 1 y: 2) corner: (HG2dPoint x: 3 y: 4) elementsDo: [ :x :y | points nextPut: (HG2dPoint x: x y: y) ].
	self
		assert:
			{(HG2dPoint x: 1 y: 2).
			(HG2dPoint x: 1 y: 3).
			(HG2dPoint x: 1 y: 4).
			(HG2dPoint x: 2 y: 2).
			(HG2dPoint x: 2 y: 3).
			(HG2dPoint x: 2 y: 4).
			(HG2dPoint x: 3 y: 2).
			(HG2dPoint x: 3 y: 3).
			(HG2dPoint x: 3 y: 4)}
		equals: points contents! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:40'!
testDimensions
	self assert: 2 equals: (HG2dPoint x: 3 y: 4) dimensions ! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:15'!
testDistance
	self
		assert: 2.0
		equals: ((HG2dPoint x: 1 y: 2) distance: (HG2dPoint x: 1 y: 2) + (HG2dPoint theta: 1.0 r: 2.0))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/12/2011 09:17'!
testDiv
	| point |
	point := HG2dPoint x: 1.0 y: 3.0.
	point div: 2.0.
	self assert: (HG2dPoint x: 0.5 y: 1.5) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:18'!
testDot
	self assert: 7 equals: ((HG2dPoint x: 1 y: 2) dot: (HG2dPoint x: -3 y: 5))! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:00'!
testEqual
	| center |
	center := HG2dPoint x: 0.0 y: 0.0.
	self deny: center = (HG2dPoint x: 1.0 y: 1.0).
	self deny: center = (HG2dPoint x: 1.0 y: 0.0).
	self deny: center = (HG2dPoint x: 1.0 y: -1.0).
	self deny: center = (HG2dPoint x: 0.0 y: 1.0).
	self assert: center = (HG2dPoint x: 0.0 y: 0.0).
	self deny: center = (HG2dPoint x: 0.0 y: -1.0).
	self deny: center = (HG2dPoint x: -1.0 y: 1.0).
	self deny: center = (HG2dPoint x: -1.0 y: 0.0).
	self deny: center = (HG2dPoint x: -1.0 y: -1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:19'!
testFloor
	self assert: (HG2dPoint x: 1 y: 2) equals: (HG2dPoint x: 1.1 y: 2.8) floor! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:02'!
testGreaterOrEqual
	| center |
	center := HG2dPoint x: 0.0 y: 0.0.
	self deny: center >= (HG2dPoint x: 1.0 y: 1.0).
	self deny: center >= (HG2dPoint x: 1.0 y: 0.0).
	self deny: center >= (HG2dPoint x: 1.0 y: -1.0).
	self deny: center >= (HG2dPoint x: 0.0 y: 1.0).
	self assert: center >= (HG2dPoint x: 0.0 y: 0.0).
	self assert: center >= (HG2dPoint x: 0.0 y: -1.0).
	self deny: center >= (HG2dPoint x: -1.0 y: 1.0).
	self assert: center >= (HG2dPoint x: -1.0 y: 0.0).
	self assert: center >= (HG2dPoint x: -1.0 y: -1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:02'!
testGreaterThan
	| center |
	center := HG2dPoint x: 0.0 y: 0.0.
	self deny: center > (HG2dPoint x: 1.0 y: 1.0).
	self deny: center > (HG2dPoint x: 1.0 y: 0.0).
	self deny: center > (HG2dPoint x: 1.0 y: -1.0).
	self deny: center > (HG2dPoint x: 0.0 y: 1.0).
	self deny: center > (HG2dPoint x: 0.0 y: 0.0).
	self deny: center > (HG2dPoint x: 0.0 y: -1.0).
	self deny: center > (HG2dPoint x: -1.0 y: 1.0).
	self deny: center > (HG2dPoint x: -1.0 y: 0.0).
	self assert: center > (HG2dPoint x: -1.0 y: -1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:20'!
testHash
	self assert: (HG2dPoint x: 1 y: 2) hash equals: (HG2dPoint x: 1 y: 2) hash.
	self assert: (HG2dPoint x: 1.0 y: 2.0) hash equals: (HG2dPoint x: 1.0 y: 2.0) hash! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:21'!
testInRadius1
	| point1 point2 |
	point1 := HG2dPoint x: 1.0 y: 2.0.
	point2 := point1 + (HG2dPoint theta: 1.0 r: 2.0).
	self assert: (point1 in: point2 radius: 3.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:21'!
testInRadius2
	| point1 point2 |
	point1 := HG2dPoint x: 1.0 y: 2.0.
	point2 := point1 + (HG2dPoint theta: 1.0 r: 2.0).
	self deny: (point1 in: point2 radius: 1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:28'!
testIndexIn
	| corner indices |
	corner := HG2dPoint x: 10 y: 10.
	indices := Array new writeStream.
	(HG2dPoint x: 0 y: 0) corner: (HG2dPoint x: 9 y: 9) do: [ :point | indices nextPut: (point indexIn: corner) ].
	self assert: (1 to: 100) asArray equals: indices contents! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:34'!
testLaplace
	| field |
	field := [ :point | (point x * point x) + (point y * point y) ].
	self assert: 4.0 equals: ((HG2dPoint x: 0.0 y: 0.0) laplace: field delta: 0.01) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:41'!
testLength1
	self assert: (HG2dPoint theta: 1.0 r: 3.0) equals: ((HG2dPoint theta: 1.0 r: 2.0) length: 3.0) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:41'!
testLength2
	self assert: 2.0 equals: (HG2dPoint theta: 1.0 r: 2.0) length accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:59'!
testLessOrEqual
	| center |
	center := HG2dPoint x: 0.0 y: 0.0.
	self assert: center <= (HG2dPoint x: 1.0 y: 1.0).
	self assert: center <= (HG2dPoint x: 1.0 y: 0.0).
	self deny: center <= (HG2dPoint x: 1.0 y: -1.0).
	self assert: center <= (HG2dPoint x: 0.0 y: 1.0).
	self assert: center <= (HG2dPoint x: 0.0 y: 0.0).
	self deny: center <= (HG2dPoint x: 0.0 y: -1.0).
	self deny: center <= (HG2dPoint x: -1.0 y: 1.0).
	self deny: center <= (HG2dPoint x: -1.0 y: 0.0).
	self deny: center <= (HG2dPoint x: -1.0 y: -1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:59'!
testLessThan
	| center |
	center := HG2dPoint x: 0.0 y: 0.0.
	self assert: center < (HG2dPoint x: 1.0 y: 1.0).
	self deny: center < (HG2dPoint x: 1.0 y: 0.0).
	self deny: center < (HG2dPoint x: 1.0 y: -1.0).
	self deny: center < (HG2dPoint x: 0.0 y: 1.0).
	self deny: center < (HG2dPoint x: 0.0 y: 0.0).
	self deny: center < (HG2dPoint x: 0.0 y: -1.0).
	self deny: center < (HG2dPoint x: -1.0 y: 1.0).
	self deny: center < (HG2dPoint x: -1.0 y: 0.0).
	self deny: center < (HG2dPoint x: -1.0 y: -1.0)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:44'!
testMinMax1
	self
		assert: (HG2dPoint x: 1.0 y: 2.0)
		equals: ((HG2dPoint x: 1.0 y: 2.0) min: (HG2dPoint x: 2.0 y: 3.0) max: (HG2dPoint x: 0.0 y: 1.0))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:44'!
testMinMax2
	self
		assert: (HG2dPoint x: 0.5 y: 2.0)
		equals: ((HG2dPoint x: 1.0 y: 2.0) min: (HG2dPoint x: 0.5 y: 3.0) max: (HG2dPoint x: 0.0 y: 1.0))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:45'!
testMinMax3
	self
		assert: (HG2dPoint x: 1.5 y: 2.0)
		equals: ((HG2dPoint x: 1.0 y: 2.0) min: (HG2dPoint x: 2.0 y: 3.0) max: (HG2dPoint x: 1.5 y: 1.0))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:45'!
testMinMax4
	self
		assert: (HG2dPoint x: 1.0 y: 1.5)
		equals: ((HG2dPoint x: 1.0 y: 2.0) min: (HG2dPoint x: 2.0 y: 1.5) max: (HG2dPoint x: 0.0 y: 1.0))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:45'!
testMinMax5
	self
		assert: (HG2dPoint x: 1.0 y: 2.5)
		equals: ((HG2dPoint x: 1.0 y: 2.0) min: (HG2dPoint x: 2.0 y: 3.0) max: (HG2dPoint x: 0.0 y: 2.5))
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:39'!
testMinus
	| point |
	point := (HG2dPoint x: 2.0 y: 3.0) - (HG2dPoint x: 4.0 y: 7.0).
	self assert: -2.0 equals: point x accuracy: 1.0e-8.
	self assert: -4.0 equals: point y accuracy: 1.0e-8.
	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/12/2011 09:16'!
testMul
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point mul: 3.0.
	self assert: (HG2dPoint x: 3.0 y: 6.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:46'!
testNorm1
	self assert: 3.0 equals: (HG2dPoint x: 1.0 y: -2.0) norm1! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:46'!
testNorm2
	self assert: 2.0 equals: (HG2dPoint theta: 1.0 r: 2.0) norm2 accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:48'!
testNorm3
	self assert: (9.0 raisedTo: 1.0 / 3.0) equals: ((HG2dPoint x: 1.0 y: 2.0) norm: 3.0) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:38'!
testPlus
	| point |
	point := (HG2dPoint x: 2.0 y: 3.0) + (HG2dPoint x: 4.0 y: 5.0).
	self assert: 6.0 equals: point x accuracy: 1.0e-8.
	self assert: 8.0 equals: point y accuracy: 1.0e-8.
	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:50'!
testPlusBy
	self
		assert: (HG2dPoint x: 16.0 y: 22.0)
		equals: ((HG2dPoint x: 1.0 y: 2.0) plus: (HG2dPoint x: 3.0 y: 4.0) by: 5.0)
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:50'!
testPlusOver
	self
		assert: (HG2dPoint x: 16.0 y: 22.0)
		equals: ((HG2dPoint x: 1.0 y: 2.0) plus: (HG2dPoint x: 3.0 y: 4.0) over: 0.2)
		accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:51'!
testProduct
	self assert: 6 equals: (HG2dPoint x: 2 y: 3) product! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:53'!
testQuo
	| point |
	point := (HG2dPoint x: 4 y: 13) // 2.
	self assert: 2 equals: point x.
	self assert: 6 equals: point y! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:48'!
testR
	self assert: 2.0 equals: (HG2dPoint theta: 1.0 r: 2.0) r accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:52'!
testSet
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point set: (HG2dPoint x: 3.0 y: 4.0).
	self assert: (HG2dPoint x: 3.0 y: 4.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:52'!
testSetXY
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point setX: 3.0 y: 4.0.
	self assert: (HG2dPoint x: 3.0 y: 4.0) equals: point accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/12/2011 09:17'!
testSlash
	| point |
	point := (HG2dPoint x: 2.0 y: 3.0) / 4.0.
	self assert: 0.5 equals: point x accuracy: 1.0e-8.
	self assert: 0.75 equals: point y accuracy: 1.0e-8.
	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/12/2011 09:16'!
testStar
	| point |
	point := (HG2dPoint x: 2.0 y: 3.0) * 4.0.
	self assert: 8.0 equals: point x accuracy: 1.0e-8.
	self assert: 12.0 equals: point y accuracy: 1.0e-8.
	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:48'!
testTheta1
	self assert: 1.0 equals: (HG2dPoint theta: 1.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:49'!
testTheta2
	self assert: 2.0 equals: (HG2dPoint theta: 2.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:49'!
testTheta3
	self assert: 3.0 equals: (HG2dPoint theta: 3.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:50'!
testTheta4
	self assert: 4.0 equals: (HG2dPoint theta: 4.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:50'!
testTheta5
	self assert: 5.0 equals: (HG2dPoint theta: 5.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:50'!
testTheta6
	self assert: 6.0 equals: (HG2dPoint theta: 6.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 11:50'!
testTheta7
	self assert: 7.0 - (Float pi * 2.0) equals: (HG2dPoint theta: 7.0 r: 2.0) theta accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 14:58'!
testToConflictsWithLineSegmentTo1
	| from1 to1 from2 to2 |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	from2 := HG2dPoint x: 1.0 y: 4.0.
	to2 := HG2dPoint x: 2.0 y: 2.0.
	self assert: (from1 to: to1 conflictsWithLineSegment: from2 to: to2)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 14:59'!
testToConflictsWithLineSegmentTo2
	| from1 to1 from2 to2 |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	from2 := HG2dPoint x: 1.0 y: 1.0.
	to2 := HG2dPoint x: 0.0 y: 4.0.
	self deny: (from1 to: to1 conflictsWithLineSegment: from2 to: to2)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:00'!
testToConflictsWithLineSegmentTo3
	| from1 to1 from2 to2 |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	from2 := HG2dPoint x: 1.5 y: 5.0.
	to2 := HG2dPoint x: 1.5 y: 6.0.
	self deny: (from1 to: to1 conflictsWithLineSegment: from2 to: to2)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:02'!
testToContains1
	| from1 to1 point |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	point := HG2dPoint x: 1.5 y: 3.0.
	self assert: (from1 to: to1 contains: point)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:02'!
testToContains2
	| from1 to1 point |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	point := HG2dPoint x: 1.0 y: 2.0.
	self assert: (from1 to: to1 contains: point)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:03'!
testToContains3
	| from1 to1 point |
	from1 := HG2dPoint x: 1.0 y: 2.0.
	to1 := HG2dPoint x: 2.0 y: 4.0.
	point := HG2dPoint x: 1.5 y: 3.5.
	self deny: (from1 to: to1 contains: point)! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:11'!
testToCross
	| from alpha beta to point |
	from := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := 0.5.
	to := from + (HG2dPoint theta: alpha r: 1.0).
	point := from + (HG2dPoint theta: alpha + beta r: 1.0).
	self assert: beta sin equals: (from to: to cross: point) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:56'!
testToCrossPointTo1
	| crossPoint alpha beta from1 to1 from2 to2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := 2.5.
	from1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to1 := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	from2 := crossPoint + (HG2dPoint theta: beta r: 1.0).
	to2 := crossPoint + (HG2dPoint theta: beta + Float pi r: 1.0).
	self assert: crossPoint equals: (from1 to: to1 crossPoint: from2 to: to2) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:58'!
testToCrossPointTo2
	self
		assert:
			((HG2dPoint x: 1.0 y: 2.0)
				to: (HG2dPoint x: 2.0 y: 4.0)
				crossPoint: (HG2dPoint x: -1.0 y: 2.0)
				to: (HG2dPoint x: -2.0 y: 4.0)) isNil! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:58'!
testToCrossPointTo3
	self
		assert:
			((HG2dPoint x: 1.0 y: 2.0)
				to: (HG2dPoint x: 2.0 y: 4.0)
				crossPoint: (HG2dPoint x: 3.0 y: 2.0)
				to: (HG2dPoint x: 4.0 y: 4.0)) isNil! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 15:59'!
testToCrossPointTo4
	self
		assert:
			((HG2dPoint x: 1.0 y: 2.0)
				to: (HG2dPoint x: 2.0 y: 4.0)
				crossPoint: (HG2dPoint x: 1.0 y: 3.0)
				to: (HG2dPoint x: 2.0 y: 5.0)) isNil! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:01'!
testToCrossPointX1
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: crossPoint x equals: (from to: to crossPointX: crossPoint x) x accuracy: 1.0e-8.
	self assert: crossPoint y equals: (from to: to crossPointX: crossPoint x) y accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:01'!
testToCrossPointX2
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: (from to: to crossPointX: 3.0) isNil.
! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:02'!
testToCrossPointX3
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: (from to: to crossPointX: -3.0) isNil.
! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:02'!
testToCrossPointY1
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: crossPoint x equals: (from to: to crossPointY: crossPoint y) x accuracy: 1.0e-8.
	self assert: crossPoint y equals: (from to: to crossPointY: crossPoint y) y accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:02'!
testToCrossPointY2
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: (from to: to crossPointY: 3.0) isNil.
! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 16:03'!
testToCrossPointY3
	| crossPoint alpha from to |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 1.0).
	self assert: (from to: to crossPointY: -3.0) isNil.
! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:22'!
testToDistance1
	| crossPoint alpha beta from to point |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi / 2.0 + alpha.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 2.0).
	point := crossPoint + (HG2dPoint theta: beta r: 3.0).
	self assert: 3.0 equals: (from to: to distance: point) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:26'!
testToDistance2
	| crossPoint alpha beta point1 point2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi + alpha + 0.1.
	point1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	point2 := crossPoint + (HG2dPoint theta: beta r: 2.0).
	self assert: 2.0 equals: (crossPoint to: point1 distance: point2) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:26'!
testToDistance3
	| crossPoint alpha beta point1 point2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi + alpha + 0.1.
	point1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	point2 := crossPoint + (HG2dPoint theta: beta r: 2.0).
	self assert: 1.0 equals: (crossPoint to: point2 distance: point1) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:28'!
testToDot
	| crossPoint alpha beta point1 point2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi + alpha + 0.1.
	point1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	point2 := crossPoint + (HG2dPoint theta: beta r: 2.0).
	self assert: (point1 - crossPoint dot: point2 - crossPoint) equals: (crossPoint to: point2 dot: point1) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:03'!
testToNearestFrom1
	| crossPoint alpha beta from to point |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi / 2.0 + alpha.
	from := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	to := crossPoint + (HG2dPoint theta: alpha + Float pi r: 2.0).
	point := crossPoint + (HG2dPoint theta: beta r: 3.0).
	self assert: crossPoint equals: (from to: to nearestFrom: point) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:21'!
testToNearestFrom2
	| crossPoint alpha beta point1 point2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi + alpha + 0.1.
	point1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	point2 := crossPoint + (HG2dPoint theta: beta r: 2.0).
	self assert: crossPoint equals: (crossPoint to: point1 nearestFrom: point2) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:21'!
testToNearestFrom3
	| crossPoint alpha beta point1 point2 |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	beta := Float pi + alpha + 0.1.
	point1 := crossPoint + (HG2dPoint theta: alpha r: 1.0).
	point2 := crossPoint + (HG2dPoint theta: beta r: 2.0).
	self assert: crossPoint equals: (crossPoint to: point2 nearestFrom: point1) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 10:42'!
testUnit
	self assert: (HG2dPoint theta: 1.0 r: 1.0) equals: (HG2dPoint theta: 1.0 r: 2.0) unit accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:34'!
testUnitVector
	| crossPoint alpha point unit |
	crossPoint := HG2dPoint x: 1.0 y: 2.0.
	alpha := 1.0.
	point := crossPoint + (HG2dPoint theta: alpha r: 2.0).
	unit := HG2dPoint theta: alpha r: 1.0.
	self assert: unit equals: (crossPoint unitVector: point) accuracy: 1.0e-8! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:35'!
testX1
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	self assert: 1.0 equals: point x accuracy: 1.0e-8	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:35'!
testX2
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point x: 3.0.
	self assert: 3.0 equals: point x accuracy: 1.0e-8.
	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:35'!
testY1
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	self assert: 2.0 equals: point y accuracy: 1.0e-8	! !

!HG2dPointTest methodsFor: 'tests' stamp: 'TomohiroOda 10/7/2011 09:36'!
testY2
	| point |
	point := HG2dPoint x: 1.0 y: 2.0.
	point y: 3.0.
	self assert: 3.0 equals: point y accuracy: 1.0e-8.
	! !

HGTestCase subclass: #HGKernelTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Tests'!

!HGKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGKernelTest methodsFor: 'setup' stamp: 'TomohiroOda 10/9/2011 09:43'!
setUp
	kernel := self targetClass support: 2.0! !

!HGKernelTest methodsFor: 'testing' stamp: 'TomohiroOda 10/9/2011 09:42'!
shouldPass
	^ false! !

!HGKernelTest methodsFor: 'private' stamp: 'TomohiroOda 10/9/2011 09:41'!
targetClass
	^ self subclassResponsibility ! !

!HGKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:47'!
testAtGradient
	0.0 to: 3.0 by: 1.0 do: [ :r | 
		self
			assert: (kernel gradient: r)
			equals: (kernel at: (HG2dPoint theta: 1.0 r: 1.0) gradient: (HG2dPoint theta: 1.0 r: 1.0 + r)) r ]! !

!HGKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:46'!
testAtValue
	0.0 to: 3.0 by: 1.0 do: [ :r | self assert: (kernel r: r) equals: (kernel at: (HG2dPoint theta: 1.0 r: 1.0) value: (HG2dPoint theta: 1.0 r: 1.0 + r)) ]! !

HGKernelTest subclass: #HGSimpleKernelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Tests'!

!HGSimpleKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSimpleKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSimpleKernelTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testGradient1
	self assert: 0.5 equals: (kernel gradient: 0.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testGradient2
	self assert: 0.5 equals: (kernel gradient: 1.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testGradient3
	self assert: 0.0 equals: (kernel gradient: 2.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testGradient4
	self assert: 0.0 equals: (kernel gradient: 3.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testR1
	self assert: 1.0 equals: (kernel r: 0.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testR2
	self assert: 0.5 equals: (kernel r: 1.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:56'!
testR3
	self assert: 0.0 equals: (kernel r: 2.0) accuracy: 1.0e-8! !

!HGSimpleKernelTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 09:57'!
testR4
	self assert: 0.0 equals: (kernel r: 3.0) accuracy: 1.0e-8! !

!HGTestCase class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTestCase class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTestCase class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTestCase methodsFor: 'asserting' stamp: 'TomohiroOda 10/7/2011 13:22'!
assert: expected equals: actual accuracy: acceptableError
	self assert: (expected - actual) abs <= acceptableError! !

HGTestCase subclass: #HGVoronoiEdgeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Tests'!

!HGVoronoiEdgeTest methodsFor: 'tests' stamp: 'TomohiroOda 2/10/2012 09:46'!
testForesideBackside1
	"tests if the HGVoronoiEdge class can create a line between the given two regions."

	| point1 point2 foreside backside edge |
	point1 := HG2dPoint x: 1.0 y: 2.0.
	point2 := HG2dPoint x: 3.0 y: 5.0.
	foreside := HGVoronoiRegion at: point1.
	backside := HGVoronoiRegion at: point2.
	edge := HGVoronoiEdge foreside: foreside backside: backside.
	-2.0 to: 2.0 by: 0.1 do: [ :t | 
		| point |
		point := edge atT: t.
		self assert: (point distance: point1) equals: (point distance: point2) accuracy: 0.01 ]! !

TestCase subclass: #HoneyGingerSerializerTest
	instanceVariableNames: 'serializer buffer deserializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerSerializerTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerSerializerTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerSerializerTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerSerializerTest methodsFor: 'setups' stamp: 'TomohiroOda 10/9/2011 13:12'!
setUp
	buffer := HoneyGingerTestStream new.
	serializer := HoneyGingerSerializer on: buffer.
	deserializer := HoneyGingerDeserializer on: buffer! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 13:53'!
testBinary
	self try: (0 to: 255 by: 3) asByteArray.
	! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:12'!
testDict
	| testData |
	testData := Dictionary new.
	testData at: 1 put: '1'.
	testData at: '2' put: 2.
	testData at: #(3 '4') put: #('3' 4).
	testData at: #[5 6] put: #[7 8].
	testData
		at:
			((Dictionary new)
				at: 1 put: '1';
				yourself)
		put:
			((Dictionary new)
				at: '2' put: 2;
				yourself).
	testData at: nil put: 0.
	testData at: 0 put: nil.
	self try: testData! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:10'!
testFloat
	self try: 0.0 accuracy: 0.00001.
	self try: 3.14 accuracy: 0.00001.
	self try: -15.8 accuracy: 0.00001! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:10'!
testHG2dPoint
	self try: (HG2dPoint x: 1.0 y: -2.0) accuracy: 0.00001! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:05'!
testInteger
	self try: 0.
	self try: 1.
	self try: -2.
	self try: 20 factorial.
	self try: 20 factorial negated! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:12'!
testList
	| testData |
	testData := OrderedCollection new.
	testData add: 1.
	testData add: '2'.
	testData add: #(3 '4').
	testData add: #[5 6].
	testData
		add:
			((Dictionary new)
				at: 1 put: '1';
				yourself).
	testData add: nil.
	self try: testData asArray! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 14:19'!
testNextN
	| testData |
	testData := OrderedCollection new.
	testData add: 1.
	testData add: '2'.
	testData add: #(3 '4').
	testData add: #[5 6].
	testData
		add:
			((Dictionary new)
				at: 1 put: '1';
				yourself).
	testData add: nil.
	serializer nextPutAll: testData.
	self assert: testData asArray equals: (deserializer next: testData size)! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 14:20'!
testNextPutAll
	| testData |
	testData := OrderedCollection new.
	testData add: 1.
	testData add: '2'.
	testData add: #(3 '4').
	testData add: #[5 6].
	testData
		add:
			((Dictionary new)
				at: 1 put: '1';
				yourself).
	testData add: nil.
	serializer nextPutAll: testData.
	testData do: [ :datum |
		self assert: datum equals: deserializer next]! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:12'!
testNil
	self try: nil! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:39'!
testScan
	| testData |
	testData := Dictionary new.
	testData at: 1 put: '1'.
	testData at: '2' put: 2.
	testData at: #(3 '4') put: #('3' 4).
	testData at: #[5 6] put: #[7 8].
	testData
		at:
			((Dictionary new)
				at: 1 put: '1';
				yourself)
		put:
			((Dictionary new)
				at: '2' put: 2;
				yourself).
	testData at: 'point' put: (HG2dPoint x: 1.0 y: -2.0).
	testData at: 'float' put: 2.0.
	testData at: nil put: 0.
	testData at: 0 put: nil.
	serializer write: testData.
	deserializer
		scanDo: [ :key :bytes | 
			(#('point' 'float') includes: key)
				ifTrue: [ self assert: ((testData at: key) - (HoneyGingerDeserializer on: bytes readStream) next) abs < 0.0001 ]
				ifFalse: [ self assert: (testData at: key) equals: (HoneyGingerDeserializer on: bytes readStream) next ] ]! !

!HoneyGingerSerializerTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:13'!
testString
	self try: ''.
	self try: 'this is a string'.! !

!HoneyGingerSerializerTest methodsFor: 'private' stamp: 'TomohiroOda 10/5/2011 13:53'!
try: anObject
	serializer nextPut: anObject.
	self assert: anObject equals: deserializer next! !

!HoneyGingerSerializerTest methodsFor: 'private' stamp: 'TomohiroOda 10/6/2011 15:11'!
try: anObject accuracy: aNumber
	serializer nextPut: anObject.
	self assert: (anObject - deserializer next) abs <= aNumber! !

TestCase subclass: #HoneyGingerSocketStreamTest
	instanceVariableNames: 'serverStream clientStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerSocketStreamTest methodsFor: 'private' stamp: 'TomohiroOda 10/6/2011 11:41'!
deserialize: aByteArray
	^ (HoneyGingerDeserializer on: aByteArray readStream) next! !

!HoneyGingerSocketStreamTest methodsFor: 'private' stamp: 'TomohiroOda 10/6/2011 09:40'!
fork: aBlock and: anotherBlock
	| semaphore results |
	results := Array new: 2.
	semaphore := Semaphore new.
	[ 
	results at: 1 put: aBlock value.
	semaphore signal ] fork.
	[ 
	results at: 2 put: anotherBlock value.
	semaphore signal ] fork.
	semaphore wait.
	semaphore wait! !

!HoneyGingerSocketStreamTest methodsFor: 'private' stamp: 'TomohiroOda 10/6/2011 11:41'!
serialize: anObject
	| stream |
	stream := ByteArray new writeStream.
	(HoneyGingerSerializer on: stream) nextPut: anObject.
	^ stream contents! !

!HoneyGingerSocketStreamTest methodsFor: 'running' stamp: 'TomohiroOda 10/9/2011 13:24'!
setUp
	| connection |
	connection := HoneyGingerTestConnection new.
	serverStream := HoneyGingerServerSocketStream on: connection serverStream.
	clientStream := HoneyGingerClientSocketStream on: connection clientStream! !

!HoneyGingerSocketStreamTest methodsFor: 'running' stamp: 'TomohiroOda 10/6/2011 14:20'!
tearDown
	serverStream ifNotNil: [ serverStream close ].
	clientStream ifNotNil: [ clientStream close ]! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 10:56'!
testClientID
	| clientID |
	clientID := 441.
	clientStream clientID: clientID.
	self fork: [ serverStream startSession ] and: [ clientStream startSession ].
	self assert: clientID equals: serverStream clientID.
	self assert: clientID equals: clientStream clientID! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 10:56'!
testClientIDBlock
	| clientIDBlock |
	clientIDBlock := [ :id | 441 ].
	serverStream clientIDBlock: clientIDBlock.
	self assert: clientIDBlock equals: serverStream clientIDBlock.
	self fork: [ serverStream startSession ] and: [ clientStream startSession ].
	self assert: 441 equals: serverStream clientID.
	self assert: 441 equals: clientStream clientID! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 11:45'!
testDownload
	| testdata |
	testdata := Dictionary new.
	testdata at: 38 put: 441.
	testdata at: 39 put: 392.
	self
		fork: [ 
			serverStream startSession.
			self assert: serverStream downloadCommand equals: serverStream next.
			serverStream
				downloadBlock: [ :id | 
					| serializedTestdata |
					serializedTestdata := Dictionary new.
					testdata keysAndValuesDo: [ :key :value | serializedTestdata at: key put: (self serialize: value) ].
					serializedTestdata ].
			serverStream download ]
		and: [ 
			| receivedData |
			clientStream startSession.
			receivedData := clientStream download.
			self assert: testdata equals: receivedData ]! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 11:45'!
testDownloadDo
	| testdata |
	testdata := Dictionary new.
	testdata at: 38 put: 441.
	testdata at: 39 put: 392.
	self
		fork: [ 
			serverStream startSession.
			self assert: serverStream downloadCommand equals: serverStream next.
			serverStream
				downloadBlock: [ :id | 
					| serializedTestdata |
					serializedTestdata := Dictionary new.
					testdata keysAndValuesDo: [ :key :value | serializedTestdata at: key put: (self serialize: value) ].
					serializedTestdata ].
			serverStream download ]
		and: [ 
			| receivedData |
			clientStream startSession.
			receivedData := Dictionary new.
			clientStream downloadDo: [ :key :value | receivedData at: key put: value ].
			self assert: testdata equals: receivedData ]! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 10:53'!
testStartSession
	self fork: [ serverStream startSession ] and: [ clientStream startSession ].
	self assert: serverStream clientID notNil.
	self assert: clientStream clientID notNil.
	self assert: serverStream clientID equals: clientStream clientID! !

!HoneyGingerSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/6/2011 13:26'!
testUpload
	| testdata |
	testdata := Dictionary new.
	testdata at: 38 put: 441.
	testdata at: 39 put: 392.
	self
		fork: [ 
			| receivedData |
			receivedData := Dictionary new.
			serverStream uploadBlock: [ :id :key :bytes | receivedData at: key put: (self deserialize: bytes) ].
			serverStream startSession.
			self assert: serverStream uploadCommand equals: serverStream next.
			serverStream upload.
			self assert: testdata equals: receivedData ]
		and: [ 
			clientStream startSession.
			clientStream upload: testdata ]! !

TestCase subclass: #HoneyGingerTestSocketStreamTest
	instanceVariableNames: 'serverStream clientStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerTestSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HoneyGingerTestSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerTestSocketStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerTestSocketStreamTest methodsFor: 'setup' stamp: 'TomohiroOda 10/9/2011 13:14'!
setUp
	| connection |
	connection := HoneyGingerTestConnection new.
	serverStream := connection serverStream.
	clientStream := connection clientStream! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:18'!
testClientNextPutAllServerNext
	clientStream nextPutAll: #(4 4 1).
	self assert: 4 equals: serverStream next.
	self assert: 4 equals: serverStream next.
	self assert: 1 equals: serverStream next! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:19'!
testClientNextPutClientNext
	clientStream nextPut: 1.
	self assert: 1 equals: serverStream next! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:21'!
testClientNextPutServerNext2
	clientStream nextPut: 4.
	clientStream nextPut: 4.
	clientStream nextPut: 1.
	self assert: #(4 4) equals: (serverStream next: 2).
	self assert: 1 equals: serverStream next! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:17'!
testServerNextPutAllClientNext
	serverStream nextPutAll: #(4 4 1).
	self assert: 4 equals: clientStream next.
	self assert: 4 equals: clientStream next.
	self assert: 1 equals: clientStream next! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:16'!
testServerNextPutClientNext
	serverStream nextPut: 1.
	self assert: 1 equals: clientStream next! !

!HoneyGingerTestSocketStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:22'!
testServerNextPutClientNext2
	serverStream nextPut: 4.
	serverStream nextPut: 4.
	serverStream nextPut: 1.
	self assert: #(4 4) equals: (clientStream next: 2).
	self assert: 1 equals: clientStream next! !

TestCase subclass: #HoneyGingerTestStreamTest
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerTestStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HoneyGingerTestStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerTestStreamTest class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerTestStreamTest methodsFor: 'setups' stamp: 'TomohiroOda 10/9/2011 13:12'!
setUp
	buffer := HoneyGingerTestStream new! !

!HoneyGingerTestStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 13:47'!
testContents
	0 to: 255 do: [ :byte | buffer nextPut: byte ].
	self assert: (buffer contents hasEqualElements: (0 to: 255) asByteArray)! !

!HoneyGingerTestStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/5/2011 14:00'!
testNextN
	0 to: 255 do: [ :byte | buffer nextPut: byte ].
	0 to: 200 by: 10 do: [ :base | self assert: ((0 to: 9) collect: [ :digit | base + digit ]) asArray equals: (buffer next: 10) ]! !

!HoneyGingerTestStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:49'!
testNextPut1
	0 to: 255 do: [ :byte | buffer nextPut: byte ].
	0 to: 255 do: [ :byte | self assert: byte equals: buffer next ]! !

!HoneyGingerTestStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:49'!
testNextPut2
	0 to: 255 do: [ :byte | 
		buffer nextPut: byte.
		self assert: byte equals: buffer next ]! !

!HoneyGingerTestStreamTest methodsFor: 'tests' stamp: 'TomohiroOda 10/9/2011 13:49'!
testNextPutAll
	buffer nextPutAll: (0 to: 255) asByteArray.
	0 to: 255 do: [ :byte | self assert: byte equals: buffer next ]! !

Object subclass: #HG2dRegion
	instanceVariableNames: 'bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

HG2dRegion subclass: #HG2dBlockRegion
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dBlockRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HG2dBlockRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dBlockRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/21/2011 08:09'!
on: aBlock
	^ (self new)
		block: aBlock;
		yourself! !

!HG2dBlockRegion methodsFor: 'accessing' stamp: 'TomohiroOda 10/21/2011 08:08'!
block
	^ block! !

!HG2dBlockRegion methodsFor: 'accessing' stamp: 'TomohiroOda 10/21/2011 08:08'!
block: aBlock
	block := aBlock! !

!HG2dBlockRegion methodsFor: 'accessing' stamp: 'TomohiroOda 10/21/2011 08:29'!
borderAt: anHG2dPoint
	| delta |
	delta := 1.
	[ 
	delta negated to: delta do: [ :dx | 
		| p |
		p := anHG2dPoint + (HG2dPoint x: dx y: delta).
		(self contains: p)
			ifFalse: [ ^ p ].
		p := anHG2dPoint + (HG2dPoint x: dx y: delta negated).
		(self contains: p)
			ifFalse: [ ^ p ] ].
	delta negated to: delta do: [ :dy | 
		| p |
		p := anHG2dPoint + (HG2dPoint x: delta y: dy).
		(self contains: p)
			ifFalse: [ ^ p ].
		p := anHG2dPoint + (HG2dPoint x: delta negated y: dy).
		(self contains: p)
			ifFalse: [ ^ p ] ].
	delta := delta + 1 ] repeat! !

!HG2dBlockRegion methodsFor: 'testing' stamp: 'TomohiroOda 10/21/2011 08:09'!
contains: anHG2dPoint
	^ block value: anHG2dPoint! !

!HG2dBlockRegion methodsFor: 'drawing' stamp: 'TomohiroOda 10/21/2011 08:22'!
drawOn: aCanvas color: aColor! !

HG2dRegion subclass: #HG2dCircle
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dCircle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dCircle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dCircle class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/9/2011 08:23'!
center: anHG2dPoint radius: aNumber
	^ self new setCenter: anHG2dPoint radius: aNumber! !

!HG2dCircle class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/2/2011 10:31'!
centerX: x centerY: y radius: r
	^ self new setCenter: (HG2dPoint x: x y: y) radius: r! !

!HG2dCircle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:54'!
area
	^Float pi * radius * radius! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 7/5/2011 14:13'!
borderAt: anHG2dPoint
	^ center plus: (self normAt: anHG2dPoint) by: radius! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 08:36'!
center
	^ center! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 15:06'!
center: anHG2dPoint
	center := anHG2dPoint.
	bounds := HG2dRectangle
		originX: center x - radius
		originY: center y - radius
		cornerX: center x + radius
		cornerY: center y + radius! !

!HG2dCircle methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 12:50'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	^ (center distance: (anHG2dPoint to: anotherHG2dPoint nearestFrom: center)) < radius! !

!HG2dCircle methodsFor: 'testing' stamp: 'TomohiroOda 6/9/2011 08:24'!
contains: anHG2dPoint
	^ (bounds contains: anHG2dPoint) and: [(anHG2dPoint x - center x) squared + (anHG2dPoint y - center y) squared < (radius * radius)]! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:23'!
depth: anHG2dPoint
	^ radius - ((center x - anHG2dPoint x) squared + (center y - anHG2dPoint y) squared) sqrt max: 0.0! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:23'!
distance: anHG2dPoint
	^ ((center x - anHG2dPoint x) squared + (center y - anHG2dPoint y) squared) sqrt - radius max: 0.0! !

!HG2dCircle methodsFor: 'drawing' stamp: 'TomohiroOda 7/5/2011 14:46'!
drawOn: aCanvas color: aColor
	aCanvas
		fillOval: ((center x - radius) @ (center y - radius) extent: radius @ radius * 2)
		fillStyle: aColor
		borderWidth: 0
		borderColor: nil! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:31'!
normAt: anHG2dPoint
	| x y r |
	x := anHG2dPoint x - center x.
	y := anHG2dPoint y - center y.
	r := (x * x + (y * y)) sqrt.
	^ r > 0.0
		ifTrue: [ HG2dPoint x: x / r y: y / r ]
		ifFalse: [ HG2dPoint x: 1.0 y: 0.0 ]! !

!HG2dCircle methodsFor: 'printing' stamp: 'TomohiroOda 6/9/2011 08:24'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	center printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	radius printOn: aStream.
	aStream nextPut: $)! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:52'!
radius
	^ radius! !

!HG2dCircle methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 15:06'!
radius: aNumber
	radius := aNumber.
	bounds := HG2dRectangle
		originX: center x - radius
		originY: center y - radius
		cornerX: center x + radius
		cornerY: center y + radius! !

!HG2dCircle methodsFor: 'private' stamp: 'TomohiroOda 10/2/2011 10:45'!
setCenter: anHG2dPoint radius: aNumber
	center := anHG2dPoint.
	radius := aNumber.
	bounds := HG2dRectangle
		originX: center x - radius
		originY: center y - radius
		cornerX: center x + radius
		cornerY: center y + radius! !

HG2dRegion subclass: #HG2dDiffRegion
	instanceVariableNames: 'positive negative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dDiffRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HG2dDiffRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dDiffRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/20/2011 08:58'!
within: anHG2dRegion except: anotherHG2dRegion
	^ (self new)
		setPositive: anHG2dRegion negative: anotherHG2dRegion;
		yourself! !

!HG2dDiffRegion methodsFor: 'testing' stamp: 'TomohiroOda 10/20/2011 08:59'!
contains: anHG2dPoint
	^ (positive contains: anHG2dPoint) and: [ (negative contains: anHG2dPoint) not ]! !

!HG2dDiffRegion methodsFor: 'private' stamp: 'TomohiroOda 10/20/2011 08:57'!
setPositive: anHG2dRegion negative: anotherHG2dRegion
	positive := anHG2dRegion.
	negative := anotherHG2dRegion! !

HG2dRegion subclass: #HG2dRectangle
	instanceVariableNames: 'origin corner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dRectangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dRectangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dRectangle class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/8/2011 11:47'!
origin: anHG2dPoint corner: anotherHG2dPoint
	^ self new setOrigin: anHG2dPoint corner: anotherHG2dPoint! !

!HG2dRectangle class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/2/2011 10:31'!
originX: x0 originY: y0 cornerX: x1 cornerY: y1
	^ self new setOrigin: (HG2dPoint x: x0 y: y0) corner: (HG2dPoint x: x1 y: y1)! !

!HG2dRectangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:54'!
area
	^ (corner x - origin x) * (corner y - origin y)! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:31'!
borderAt: anHG2dPoint
	^ (self contains: anHG2dPoint)
		ifTrue: [ 
			| dx x dy y |
			anHG2dPoint x - origin x < (corner x - anHG2dPoint x)
				ifTrue: [ 
					dx := anHG2dPoint x - origin x.
					x := origin x ]
				ifFalse: [ 
					dx := corner x - anHG2dPoint x.
					x := corner x ].
			anHG2dPoint y - origin y < (corner y - anHG2dPoint y)
				ifTrue: [ 
					dy := anHG2dPoint y - origin y.
					y := origin y ]
				ifFalse: [ 
					dy := corner y - anHG2dPoint y.
					y := corner y ].
			dx < dy
				ifTrue: [ HG2dPoint x: x y: anHG2dPoint y ]
				ifFalse: [ HG2dPoint x: anHG2dPoint x y: y ] ]
		ifFalse: [ 
			HG2dPoint
				x:
					(anHG2dPoint x < origin x
						ifTrue: [ origin x ]
						ifFalse: [ 
							anHG2dPoint x > corner x
								ifTrue: [ corner x ]
								ifFalse: [ anHG2dPoint x ] ])
				y:
					(anHG2dPoint y < origin y
						ifTrue: [ origin y ]
						ifFalse: [ 
							anHG2dPoint y > corner y
								ifTrue: [ corner y ]
								ifFalse: [ anHG2dPoint y ] ]) ]! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:51'!
center
	^ origin + corner div: 2! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 2/2/2012 15:31'!
center: anHG2dPoint
	| diff |
	diff := anHG2dPoint - self center.
	origin := origin + diff.
	corner := corner + diff.
	bounds := HG2dRectangle
		originX: origin x
		originY: origin y
		cornerX: corner x
		cornerY: corner y! !

!HG2dRectangle methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 13:16'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	| x1 y1 x2 y2 xMin xMax yMin yMax xAtOrigin xAtCorner yAtOrigin yAtCorner |
	x1 := anHG2dPoint x.
	y1 := anHG2dPoint y.
	x2 := anotherHG2dPoint x.
	y2 := anotherHG2dPoint y.
	(x1 > origin x and: [ x1 < corner x and: [ y1 > origin y and: [ y1 < corner y ] ] ])
		ifTrue: [ ^ true ].
	(x2 > origin x and: [ x2 < corner x and: [ y2 > origin y and: [ y2 < corner y ] ] ])
		ifTrue: [ ^ true ].
	xMin := x1 min: x2.
	xMin > corner x
		ifTrue: [ ^ false ].
	xMax := x1 max: x2.
	xMax < origin x
		ifTrue: [ ^ false ].
	yMin := y1 min: y2.
	yMin > corner y
		ifTrue: [ ^ false ].
	yMax := y1 max: y2.
	yMax < origin y
		ifTrue: [ ^ false ].
	xAtOrigin := (x2 - x1) * (origin y - y1) / (y2 - y1) + x1.
	(xAtOrigin > origin x and: [ xAtOrigin < corner x ])
		ifTrue: [ ^ true ].
	xAtCorner := (x2 - x1) * (corner y - y1) / (y2 - y1) + x1.
	(xAtCorner > origin x and: [ xAtCorner < corner x ])
		ifTrue: [ ^ true ].
	yAtOrigin := (y2 - y1) * (origin x - x1) / (x2 - x1) + y1.
	(yAtOrigin > origin y and: [ yAtOrigin < corner y ])
		ifTrue: [ ^ true ].
	yAtCorner := (y2 - y1) * (corner x - x1) / (x2 - x1) + y1.
	(yAtCorner > origin y and: [ yAtCorner < corner y ])
		ifTrue: [ ^ true ].
	^ false! !

!HG2dRectangle methodsFor: 'testing' stamp: 'TomohiroOda 6/8/2011 11:45'!
contains: anHG2dPoint
	| x y |
	x := anHG2dPoint x.
	y := anHG2dPoint y.
	^ origin x <= x and: [ x <= corner x and: [ origin y <= y and: [ y <= corner y ] ] ]! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:44'!
corner
	^ corner! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:45'!
depth: anHG2dPoint
	| dx1 dy1 dx2 dy2 |
	(dx1 := anHG2dPoint x - origin x) < 0.0
		ifTrue: [ ^ 0.0 ].
	(dy1 := anHG2dPoint y - origin y) < 0.0
		ifTrue: [ ^ 0.0 ].
	(dx2 := corner x - anHG2dPoint x) < 0.0
		ifTrue: [ ^ 0.0 ].
	(dy2 := corner y - anHG2dPoint y) < 0.0
		ifTrue: [ ^ 0.0 ].
	^ ((dx1 min: dy1) min: dx2) min: dy2! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:46'!
distance: anHG2dPoint
	anHG2dPoint x <= origin x
		ifTrue: [ 
			anHG2dPoint y <= origin y
				ifTrue: [ ^ ((origin x - anHG2dPoint x) squared + (origin y - anHG2dPoint y) squared) sqrt ].
			corner y <= anHG2dPoint y
				ifTrue: [ ^ ((origin x - anHG2dPoint x) squared + (corner y - anHG2dPoint y) squared) sqrt ].
			^ (origin x - anHG2dPoint x) abs ].
	corner x <= anHG2dPoint x
		ifTrue: [ 
			anHG2dPoint y <= origin y
				ifTrue: [ ^ ((corner x - anHG2dPoint x) squared + (origin y - anHG2dPoint y) squared) sqrt ].
			corner y <= anHG2dPoint y
				ifTrue: [ ^ ((corner x - anHG2dPoint x) squared + (corner y - anHG2dPoint y) squared) sqrt ].
			^ (corner x - anHG2dPoint x) abs ].
	anHG2dPoint y <= origin y
		ifTrue: [ ^ (origin y - anHG2dPoint y) abs ].
	corner y <= anHG2dPoint y
		ifTrue: [ ^ (corner y - anHG2dPoint y) abs ].
	^ 0.0! !

!HG2dRectangle methodsFor: 'drawing' stamp: 'TomohiroOda 7/15/2011 13:43'!
drawOn: aCanvas color: aColor
	aCanvas fillRectangle: (origin x @ origin y corner: corner x @ corner y) fillStyle: aColor borderStyle: BorderStyle default
! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:31'!
normAt: anHG2dPoint
	| minDistance norm d |
	minDistance := (origin x - anHG2dPoint x) abs.
	norm := #left.
	d := (corner x - anHG2dPoint x) abs.
	d <= minDistance
		ifTrue: [ 
			minDistance := d.
			norm := #right ].
	d := (origin y - anHG2dPoint y) abs.
	d <= minDistance
		ifTrue: [ 
			minDistance := d.
			norm := #up ].
	d := (corner y - anHG2dPoint y) abs.
	d < minDistance
		ifTrue: [ norm := #down ].
	norm == #left
		ifTrue: [ ^ HG2dPoint x: -1.0 y: 0.0 ].
	norm == #right
		ifTrue: [ ^ HG2dPoint x: 1.0 y: 0.0 ].
	norm == #up
		ifTrue: [ ^ HG2dPoint x: 0.0 y: -1.0 ].
	^ HG2dPoint x: 0 y: 1.0! !

!HG2dRectangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:44'!
origin
	^ origin! !

!HG2dRectangle methodsFor: 'printing' stamp: 'TomohiroOda 6/9/2011 08:25'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	origin printOn: aStream.
	aStream nextPut: $-.
	aStream space.
	corner printOn: aStream.
	aStream nextPut: $)! !

!HG2dRectangle methodsFor: 'private' stamp: 'TomohiroOda 6/8/2011 11:47'!
setOrigin: anHG2dPoint corner: anotherHG2dPoint
	origin := anHG2dPoint .
	corner := anotherHG2dPoint ! !

!HG2dRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dRegion methodsFor: 'arithmetics' stamp: 'TomohiroOda 10/20/2011 09:00'!
- anHG2dRegion
	^ HG2dDiffRegion within: self except: anHG2dRegion! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:54'!
area
	^ self subclassResponsibility! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 7/5/2011 14:12'!
borderAt: anHG2dPoint
	^ self subclassResponsibility ! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 08:36'!
center
	^ self subclassResponsibility ! !

!HG2dRegion methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 12:44'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	^ self subclassResponsibility ! !

!HG2dRegion methodsFor: 'testing' stamp: 'TomohiroOda 5/31/2011 14:56'!
contains: anHGPoint
	^ self subclassResponsibility! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:43'!
corner
	^ bounds corner! !

!HG2dRegion methodsFor: 'drawing' stamp: 'TomohiroOda 7/5/2011 14:40'!
drawOn: aCanvas color: aColor
	^ self subclassResponsibility! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2011 08:51'!
normAt: anHGPoint
	^ self subclassResponsibility ! !

!HG2dRegion methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:43'!
origin
	^ bounds origin! !

HG2dRegion subclass: #HG2dSweep
	instanceVariableNames: 'from to radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dSweep class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/13/2012 14:32'!
from: anHG2dPoint1 to: anHG2dPoint2 radius: aNumber
	^ self new setFrom: anHG2dPoint1 to: anHG2dPoint2 radius: aNumber! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:05'!
area
	^ Float pi * radius * radius + (radius * (from distance: to) * 2.0)! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:07'!
borderAt: anHG2dPoint
	| base |
	base := from to: to nearestFrom: anHG2dPoint.
	^ base plus: (base unitVector: anHG2dPoint) by: radius! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:08'!
center
	^ HG2dPoint x: (from x + to x) / 2.0 y: (from y + to y) / 2.0! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:12'!
center: anHG2dPoint
	| vx vy |
	vx := anHG2dPoint x - (from x + to x / 2.0).
	vy := anHG2dPoint y - (from y + to y / 2.0).
	from := HG2dPoint x: from x + vx y: from y + vy.
	to := HG2dPoint x: to x + vx y: to y + vy.
	self updateBounds! !

!HG2dSweep methodsFor: 'testing' stamp: 'TomohiroOda 2/13/2012 14:25'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	^ (from to: to conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint)
		or: [ 
			(from to: to distance: anHG2dPoint) <= radius
				or: [ 
					(from to: to distance: anotherHG2dPoint) <= radius
						or: [ 
							(anHG2dPoint to: anotherHG2dPoint distance: from) <= radius
								or: [ (anHG2dPoint to: anotherHG2dPoint distance: to) <= radius ] ] ] ]! !

!HG2dSweep methodsFor: 'testing' stamp: 'TomohiroOda 2/13/2012 14:26'!
contains: anHG2dPoint
	^ (bounds contains: anHG2dPoint) and: [(from to: to distance: anHG2dPoint) <= radius]! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:19'!
depth: anHG2dPoint
	^ radius - (from to: to nearestFrom: anHG2dPoint) max: 0.0! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:19'!
distance: anHG2dPoint
	^ (from to: to nearestFrom: anHG2dPoint) - radius max: 0.0! !

!HG2dSweep methodsFor: 'drawing' stamp: 'TomohiroOda 2/13/2012 14:21'!
drawOn: aCanvas color: aColor
	aCanvas
		line: from asPoint
		to: to asPoint
		width: radius * 2
		color: aColor! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:04'!
from
	^ from! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:12'!
from: anHG2dPoint
	from := anHG2dPoint.
	self updateBounds! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:26'!
from: anHG2dPoint1 to: anHG2dPoint2
	from := anHG2dPoint1.
	to := anHG2dPoint2.
	self updateBounds! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:20'!
normAt: anHG2dPoint
	| base |
	base := from to: to nearestFrom: anHG2dPoint.
	^ base unitVector: anHG2dPoint! !

!HG2dSweep methodsFor: 'printing' stamp: 'TomohiroOda 2/13/2012 14:22'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	from printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	to printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	radius printOn: aStream.
	aStream nextPut: $)! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:04'!
radius
	^ radius! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:13'!
radius:  aNumber
	radius := aNumber.
	self updateBounds! !

!HG2dSweep methodsFor: 'private' stamp: 'TomohiroOda 2/13/2012 14:28'!
setFrom: anHG2dPoint1 to: anHG2dPoint2 radius: aNumber
	from := anHG2dPoint1.
	to := anHG2dPoint2.
	radius := aNumber.
	self updateBounds! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:04'!
to
	^ to! !

!HG2dSweep methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:13'!
to: anHG2dPoint
	to := anHG2dPoint.
	self updateBounds! !

!HG2dSweep methodsFor: 'private' stamp: 'TomohiroOda 2/13/2012 14:14'!
updateBounds
	bounds := HG2dRectangle
		originX: (from x min: to x) - radius
		originY: (from y min: from y) - radius
		cornerX: (from x max: to x) + radius
		cornerY: (from y max: to y) + radius! !

HG2dRegion subclass: #HG2dTriangle
	instanceVariableNames: 'vertex1 vertex2 vertex3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dTriangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dTriangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dTriangle class methodsFor: 'examples' stamp: 'TomohiroOda 10/2/2011 10:46'!
example1
	"HG2dTriangle example1"
	| triangle |
	triangle := HG2dTriangle on: (HG2dPoint x: 1.0 y: -1.0) on: (HG2dPoint x: 0.0 y: 1.0) on: (HG2dPoint x: -1.0 y: -1.0).
	triangle contains: (HG2dPoint x: 0.0 y: 0.0).
	^triangle! !

!HG2dTriangle class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/6/2011 12:00'!
on: anHG2dPoint1 on: anHG2dPoint2 on: anHG2dPoint3
	^ self new setVertex1: anHG2dPoint1 vertex2: anHG2dPoint2 vertex3: anHG2dPoint3! !

!HG2dTriangle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 08:55'!
area
	^ (vertex1 to: vertex2 cross: vertex3) / 2.0! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 7/14/2011 12:49'!
borderAt: anHG2dPoint
	|  point distance minDistance nearestPoint |
	point := vertex1 to: vertex2 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	minDistance := distance.
	nearestPoint := point.
	point := vertex2 to: vertex3 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestPoint := point ].
	point := vertex3 to: vertex1 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestPoint := point ].
	^ nearestPoint! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 08:37'!
center
	^ vertex1 + vertex2 + vertex3 / 3.0! !

!HG2dTriangle methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 14:09'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	^ (self contains: anHG2dPoint)
		or: [ 
			(self contains: anotherHG2dPoint)
				or: [ 
					(vertex1 to: vertex2 conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint)
						or: [ 
							(vertex2 to: vertex3 conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint)
								or: [ vertex3 to: vertex1 conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint ] ] ] ]! !

!HG2dTriangle methodsFor: 'testing' stamp: 'TomohiroOda 6/10/2011 08:22'!
contains: anHG2dPoint
	^ (bounds contains: anHG2dPoint)
		and: [ 
			(vertex1 to: vertex2 cross: anHG2dPoint) >= 0.0
				and: [ (vertex2 to: vertex3 cross: anHG2dPoint) >= 0.0 and: [ (vertex3 to: vertex1 cross: anHG2dPoint) >= 0.0 ] ] ]! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2011 13:52'!
depth: anHG2dPoint
	^ (self contains: anHG2dPoint)
		ifTrue: [ 
			((vertex1 to: vertex2 distance: anHG2dPoint) min: (vertex2 to: vertex3 distance: anHG2dPoint))
				min: (vertex3 to: vertex1 distance: anHG2dPoint) ]
		ifFalse: [ 0.0 ]! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2011 13:52'!
distance: anHG2dPoint
	^ (self contains: anHG2dPoint)
		ifTrue: [ 0.0 ]
		ifFalse: [ 
			((vertex1 to: vertex2 distance: anHG2dPoint) min: (vertex2 to: vertex3 distance: anHG2dPoint))
				min: (vertex3 to: vertex1 distance: anHG2dPoint) ]! !

!HG2dTriangle methodsFor: 'drawing' stamp: 'TomohiroOda 7/6/2011 15:04'!
drawOn: aCanvas color: aColor
	"Display the receiver, a spline curve, approximated by straight 
	line segments."

	aCanvas
		drawPolygon: (Array with: vertex1 x @ vertex1 y with: vertex2 x @ vertex2 y with: vertex3 x @ vertex3 y)
		fillStyle: aColor! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/10/2011 08:25'!
minAngle
	| area d l12 l23 l31 angle1 angle2 angle3 |
	area := vertex1 to: vertex2 cross: vertex3.
	l12 := (d := vertex1 x - vertex2 x) * d + ((d := vertex1 y - vertex2 y) * d).
	l23 := (d := vertex2 x - vertex3 x) * d + ((d := vertex2 y - vertex3 y) * d).
	l31 := (d := vertex3 x - vertex1 x) * d + ((d := vertex3 y - vertex1 y) * d).
	^l12 < l23
		ifTrue: [ 
			l12 < l31
				ifTrue: [ area / (l23 * l31) sqrt ]
				ifFalse: [ area /( l12 * l23) sqrt ] ]
		ifFalse: [ 
			l23 < l31
				ifTrue: [ area / (l12 * l31) sqrt ]
				ifFalse: [ area / (l12 * l23) sqrt ] ]! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:31'!
normAt: anHG2dPoint
	| nearestPointBlock point distance minDistance norm |
	nearestPointBlock := [ :p1 :p2 :p3 | (p2 - p1) * ((p1 to: p2 dot: p3) min: 1.0 max: 0.0) + p1 ].
	point := nearestPointBlock value: vertex1 value: vertex2 value: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	minDistance := distance.
	norm := HG2dPoint x: vertex2 y - vertex1 y y: vertex1 x - vertex2 x.
	point := nearestPointBlock value: vertex2 value: vertex3 value: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			norm := HG2dPoint x: vertex3 y - vertex2 y y: vertex2 x - vertex3 x ].
	point := nearestPointBlock value: vertex3 value: vertex1 value: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			norm := HG2dPoint x: vertex1 y - vertex3 y y: vertex3 x - vertex1 x ].
	^ norm unit! !

!HG2dTriangle methodsFor: 'printing' stamp: 'TomohiroOda 6/9/2011 08:25'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	vertex1 printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	vertex2 printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	vertex3 printOn: aStream.
	aStream nextPut: $)! !

!HG2dTriangle methodsFor: 'private' stamp: 'TomohiroOda 10/2/2011 10:45'!
setVertex1: anHG2dPoint1 vertex2: anHG2dPoint2 vertex3: anHG2dPoint3
	vertex1 := anHG2dPoint1.
	vertex2 := anHG2dPoint2.
	vertex3 := anHG2dPoint3.
	bounds := HG2dRectangle
		origin: (HG2dPoint x: ((vertex1 x min: vertex2 x) min: vertex3 x) y: ((vertex1 y min: vertex2 y) min: vertex3 y))
		corner: (HG2dPoint x: ((vertex1 x max: vertex2 x) max: vertex3 x) y: ((vertex1 y max: vertex2 y) max: vertex3 y))! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 12:12'!
vertex1
	^ vertex1! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 12:14'!
vertex2
	^ vertex2! !

!HG2dTriangle methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 12:13'!
vertex3
	^ vertex3! !

HG2dRegion subclass: #HG2dUnionRegion
	instanceVariableNames: 'regions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Regions'!

!HG2dUnionRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dUnionRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dUnionRegion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dUnionRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:55'!
with: anHG2dRegion
	^ self new add: anHG2dRegion ; yourself! !

!HG2dUnionRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:56'!
with: anHG2dRegion with: anotherHG2dRegion
	^ (self new)
		add: anHG2dRegion;
		add: anotherHG2dRegion;
		yourself! !

!HG2dUnionRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:56'!
with: anHG2dRegion with: anotherHG2dRegion with: yetAnotherHG2dRegion
	^ (self new)
		add: anHG2dRegion;
		add: anotherHG2dRegion;
		add: yetAnotherHG2dRegion;
		yourself! !

!HG2dUnionRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:56'!
with: anHG2dRegion with: anotherHG2dRegion with: yetAnotherHG2dRegion with: yetYetAnotherHG2dRegion
	^ (self new)
		add: anHG2dRegion;
		add: anotherHG2dRegion;
		add: yetAnotherHG2dRegion;
		add: yetYetAnotherHG2dRegion;
		yourself! !

!HG2dUnionRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:57'!
withAll: aCollectionOfHG2dRegion
	^ (self new)
		addAll: aCollectionOfHG2dRegion;
		yourself! !

!HG2dUnionRegion methodsFor: 'adding' stamp: 'TomohiroOda 7/13/2011 11:55'!
add: anHG2dRegion
	^ regions add: anHG2dRegion ! !

!HG2dUnionRegion methodsFor: 'adding' stamp: 'TomohiroOda 7/13/2011 11:55'!
addAll: aCollectionOfHG2dRegion
	^ regions addAll: aCollectionOfHG2dRegion ! !

!HG2dUnionRegion methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 14:12'!
conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint
	^ regions anySatisfy: [ :region | region conflictsWithLineSegment: anHG2dPoint to: anotherHG2dPoint ]! !

!HG2dUnionRegion methodsFor: 'testing' stamp: 'TomohiroOda 7/13/2011 11:54'!
contains: anHG2dPoint
	^ regions anySatisfy: [ :region | region contains: anHG2dPoint ]! !

!HG2dUnionRegion methodsFor: 'initialize-release' stamp: 'TomohiroOda 7/13/2011 11:54'!
initialize
	super initialize.
	regions := OrderedCollection new! !

Object subclass: #HGAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Kernel'!

HGAction subclass: #HGAbstractFakeHand
	instanceVariableNames: 'particleIndex lastPosition lastDelta mickey image cursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGAbstractFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGAbstractFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGAbstractFakeHand class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 10:04'!
at: anInteger image: aForm
	^ self at: anInteger mickey: 1.0 image: aForm cursor: self dot! !

!HGAbstractFakeHand class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 10:04'!
at: anInteger image: aForm cursor: anotherForm
	^ self at: anInteger mickey: 1.0 image: aForm cursor: anotherForm! !

!HGAbstractFakeHand class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 10:04'!
at: anInteger mickey: aNumber image: aForm
	^ self
		at: anInteger
		mickey: aNumber
		image: aForm
		cursor: self dot! !

!HGAbstractFakeHand class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 10:04'!
at: anInteger mickey: aNumber image: aForm cursor: anotherForm
	^ (self new)
		particleIndex: anInteger;
		mickey: aNumber;
		image: aForm;
		cursor: anotherForm;
		yourself! !

!HGAbstractFakeHand class methodsFor: 'cursors' stamp: 'TomohiroOda 10/14/2011 19:53'!
circle: radius
	^self circle: radius color: Color black! !

!HGAbstractFakeHand class methodsFor: 'cursors' stamp: 'TomohiroOda 10/14/2011 19:53'!
circle: radius color: aColor
	| form |
	form := Form extent: radius @ radius * 2 depth: 32.
	(form getCanvas)
		fillColor: Color transparent;
		fillOval: (0 @ 0 extent: radius @ radius * 2) color: aColor;
		flush.
	^ form! !

!HGAbstractFakeHand class methodsFor: 'cursors' stamp: 'TomohiroOda 10/12/2011 10:04'!
dot
	| form |
	form := Form extent: 1 @ 1 depth: 32.
	(form getCanvas)
		fillColor: Color black;
		flush.
	^ form! !

!HGAbstractFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGAbstractFakeHand methodsFor: 'testing' stamp: 'TomohiroOda 10/12/2011 11:39'!
collidesIn: anHGSimulator
	| me radius |
	me := anHGSimulator particleAt: particleIndex.
	radius := image width max: image height.
	anHGSimulator
		neighborsOf: me position
		within: radius
		do: [ :particle :distance | 
			particle ~~ me
				ifTrue: [ ^ true ] ].
	^ false! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:01'!
cursor
	^ cursor! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:01'!
cursor: aForm
	cursor := aForm! !

!HGAbstractFakeHand methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 09:57'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGAbstractFakeHand methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 09:57'!
effectIn: anHGSimulator deltaT: aNumber
	^ self subclassResponsibility ! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:01'!
image
	^ image! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:02'!
image: aForm
	image := aForm! !

!HGAbstractFakeHand methodsFor: 'evaluating' stamp: 'TomohiroOda 10/21/2011 07:07'!
in: anHGSimulator motionLineDo: aBlock
	^ lastPosition
		ifNotNilDo: [ :p1 | (anHGSimulator particleAt: particleIndex) ifNotNilDo: [ :particle | aBlock value: p1 value: particle position ] ]! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:02'!
in: anHGSimulator particlesDo: aBlock
	(anHGSimulator particleAt: particleIndex) ifNotNilDo: aBlock! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:02'!
mickey
	^ mickey! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:03'!
mickey: aNumber
	mickey := aNumber! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:03'!
particleIndex
	^ particleIndex! !

!HGAbstractFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:03'!
particleIndex: anInteger
	particleIndex := anInteger ! !

HGAbstractFakeHand subclass: #HGFakeHand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGFakeHand methodsFor: 'simulating' stamp: 'TomohiroOda 10/4/2011 10:20'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position canvas |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	ActiveHand
		showTemporaryCursor:
			((anHGSimulator bounds containsPoint: globalPoint)
				ifTrue: [ cursor ]
				ifFalse: [ Cursor normal ]).
	position := globalPoint - bounds origin.
	canvas := anHGSimulator form getCanvas.
	lastPosition
		ifNil: [ 
			self
				in: anHGSimulator
				particlesDo: [ :particle | 
					particle position set: position.
					particle velocity set: HG2dPoint zero ] ]
		ifNotNil: [ 
			| deltaPosition |
			deltaPosition := position - lastPosition.
			self
				in: anHGSimulator
				particlesDo: [ :particle | 
					particle addPosition: deltaPosition by: mickey.
					particle velocity set: deltaPosition * (mickey / aNumber).
					canvas
						translucentImage: image
						at: (particle position x - (image width // 2)) @ (particle position y - (image height // 2)) ] ].
	lastPosition := position! !

HGAbstractFakeHand subclass: #HGFullyFakeHand
	instanceVariableNames: 'lastVelocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGFullyFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGFullyFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGFullyFakeHand methodsFor: 'simulating' stamp: 'TomohiroOda 10/19/2011 16:31'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position canvas |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	ActiveHand
		showTemporaryCursor:
			((anHGSimulator bounds containsPoint: globalPoint)
				ifTrue: [ cursor ]
				ifFalse: [ Cursor normal ]).
	position := globalPoint - bounds origin.
	canvas := anHGSimulator form getCanvas.
	lastPosition
		ifNil: [ 
			self
				in: anHGSimulator
				particlesDo: [ :particle | 
					particle position set: position.
					particle velocity set: (lastVelocity := HG2dPoint zero) ] ]
		ifNotNil: [ 
			| deltaPosition velocity |
			deltaPosition := position - lastPosition.
			velocity := deltaPosition * (mickey / aNumber).
			self
				in: anHGSimulator
				particlesDo: [ :particle | 
					particle velocity set:  velocity.
					lastVelocity := velocity ] ].
	lastPosition := position! !

HGAbstractFakeHand subclass: #HGInertialFakeHand
	instanceVariableNames: 'dumpingRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGInertialFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGInertialFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGInertialFakeHand class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGInertialFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:44'!
dumpingRate
	^ dumpingRate! !

!HGInertialFakeHand methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 10:44'!
dumpingRate: aNumber
	dumpingRate := aNumber! !

!HGInertialFakeHand methodsFor: 'simulating' stamp: 'TomohiroOda 10/16/2011 16:26'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position canvas |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	ActiveHand
		showTemporaryCursor:
			((anHGSimulator bounds containsPoint: globalPoint)
				ifTrue: [ cursor ]
				ifFalse: [ Cursor normal ]).
	position := globalPoint - bounds origin.
	canvas := anHGSimulator form getCanvas.
	lastPosition
		ifNotNil: [ 
			(self collidesIn: anHGSimulator)
				ifFalse: [ 
					| deltaPosition |
					deltaPosition := position - lastPosition.
					self
						in: anHGSimulator
						particlesDo: [ :particle | 
							"particle velocity mul: dumpingRate.
							particle velocity add: deltaPosition by: mickey / aNumber"
							particle addPosition: deltaPosition by: mickey.
							particle velocity setX: 0.0 y: 0.0 ] ] ].
	self
		in: anHGSimulator
		particlesDo: [ :particle | 
			canvas
				translucentImage: image
				at: (particle position x - (image width // 2)) @ (particle position y - (image height // 2)) ].
	lastPosition := position! !

!HGInertialFakeHand methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/12/2011 10:44'!
initialize
	super initialize.
	dumpingRate := 0.5! !

!HGAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGAction methodsFor: 'simulating' stamp: 'TomohiroOda 5/25/2011 11:20'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	^self subclassResponsibility ! !

!HGAction methodsFor: 'simulating' stamp: 'TomohiroOda 6/29/2011 09:55'!
effectIn: anHGSimulator deltaT: aNumber
	anHGSimulator particlesDo: [ :particle | self effect: particle in: anHGSimulator deltaT: aNumber ]! !

HGAction subclass: #HGAddTrindingElasticBody
	instanceVariableNames: 'region numberOfParticles mass elasticForceAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGAddTrindingElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGAddTrindingElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGAddTrindingElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 10:17'!
on: anHGTrindingElasticForce region: anHG2dRegion numberOfParticles: anInteger mass: aNumber
	^ (self new)
		elasticForceAction: anHGTrindingElasticForce;
		region: anHG2dRegion;
		numberOfParticles: anInteger;
		mass: aNumber;
		yourself! !

!HGAddTrindingElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGAddTrindingElasticBody methodsFor: 'simulating' stamp: 'TomohiroOda 1/23/2012 17:21'!
effectIn: anHGSimulator deltaT: aNumber
	| random particles triangulator kernel |
	random := Random new.
	particles := IdentityDictionary new.
	triangulator := HGTriangulator
		origin: anHGSimulator simulationOrigin
		corner: anHGSimulator simulationCorner
		step: 80.
	numberOfParticles
		timesRepeat: [ 
			| position particle |
			[ 
			position := region origin class randomFrom: region origin to: region corner with: random.
			region contains: position ] whileFalse.
			particle := anHGSimulator addParticleAt: position temperature: 390 mass: mass.
			particle at: #radius put: 0.
			triangulator divideAt: particle position.
			particles at: particle position put: particle ].
	triangulator
		trianglesDo: [ :triangle | 
			| particle1 particle2 particle3 |
			particle1 := particles at: triangle vertex1 ifAbsent: [  ].
			particle2 := particles at: triangle vertex2 ifAbsent: [  ].
			particle3 := particles at: triangle vertex3 ifAbsent: [  ].
			(particle1 notNil and: [ particle2 notNil and: [ particle3 notNil ] ])
				ifTrue: [ elasticForceAction addTrindingAmong: particle1 and: particle2 and: particle3 ] ]! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
elasticForceAction
	^ elasticForceAction! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
elasticForceAction: anHGElasticForceAction
	elasticForceAction := anHGElasticForceAction ! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:16'!
mass
	^ mass! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:16'!
mass: aNumber
	mass := aNumber! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
numberOfParticles
	^ numberOfParticles ! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
numberOfParticles: aNumber
	numberOfParticles := aNumber ! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
region
	^ region! !

!HGAddTrindingElasticBody methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 10:07'!
region: anHG2dRegion
	region := anHG2dRegion! !

HGAction subclass: #HGBoundingBox
	instanceVariableNames: 'reflectionRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGBoundingBox class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/31/2011 11:54'!
reflectionRate: aNumber
	^ self new setReflectionRate: aNumber! !

!HGBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGBoundingBox methodsFor: 'simulating' stamp: 'TomohiroOda 5/31/2011 11:56'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| x0 y0 x1 y1 position velocity |
	x0 := anHGSimulator simulationOrigin x.
	y0 := anHGSimulator simulationOrigin y.
	x1 := anHGSimulator simulationCorner x.
	y1 := anHGSimulator simulationCorner y.
	position := anHGParticle position.
	velocity := anHGParticle velocity.
	[ 
	| changed |
	changed := false.
	position x < x0
		ifTrue: [ 
			position x: (position x - x0) * reflectionRate + x0.
			velocity x: velocity x * reflectionRate .
			changed := true ].
	position x > x1
		ifTrue: [ 
			position x: ( position x - x1)* reflectionRate + x1.
			velocity x: velocity x * reflectionRate.
			changed := true ].
	position y < y0
		ifTrue: [ 
			position y: (position y - y0) * reflectionRate + y0.
			velocity y: velocity y * reflectionRate.
			changed := true ].
	position y > y1
		ifTrue: [ 
			position y: (position y - y1) * reflectionRate + y1.
			velocity y: velocity y * reflectionRate.
			changed := true ].
	changed ] whileTrue! !

!HGBoundingBox methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 11:52'!
setReflectionRate: aNumber
	reflectionRate := aNumber abs negated! !

HGAction subclass: #HGClosedBoundingBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGClosedBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGClosedBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGClosedBoundingBox class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGClosedBoundingBox methodsFor: 'simulating' stamp: 'TomohiroOda 11/2/2011 14:22'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| x0 y0 x1 y1 position velocity |
	x0 := anHGSimulator simulationOrigin x.
	y0 := anHGSimulator simulationOrigin y.
	x1 := anHGSimulator simulationCorner x.
	y1 := anHGSimulator simulationCorner y.
	position := anHGParticle position.
	velocity := anHGParticle velocity.
	[ 
	| changed |
	changed := false.
	position x < x0
		ifTrue: [ 
			position x: x1 - x0 + position x.
			changed := true ].
	position x > x1
		ifTrue: [ 
			position x: x0 - x1 + position x.
			changed := true ].
	position y < y0
		ifTrue: [ 
			position y: y1 - y0 + position y.
			changed := true ].
	position y > y1
		ifTrue: [ 
			position y: y0 - y1 + position y.
			changed := true ].
	changed ] whileTrue! !

HGAction subclass: #HGCommunicator
	instanceVariableNames: 'address port honeyGingerClientStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGCommunicator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGCommunicator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGCommunicator class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/21/2011 14:02'!
address: aByteArray port: anInteger
	^ (self new)
		setAddress: aByteArray port: anInteger;
		yourself! !

!HGCommunicator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGCommunicator methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:21'!
getStream
	^ honeyGingerClientStream
		ifNil: [ 
			| socket |
			socket := Socket newTCP.
			socket connectTo: address port: port.
			honeyGingerClientStream := (HoneyGingerClientSocketStream onSocket: socket)
				startSession;
				yourself ]! !

!HGCommunicator methodsFor: 'private' stamp: 'TomohiroOda 6/21/2011 13:24'!
setAddress: aByteArray port: anInteger
	address := aByteArray.
	port := anInteger! !

HGCommunicator subclass: #HGDownloader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGDownloader methodsFor: 'simulating' stamp: 'TomohiroOda 6/27/2011 10:55'!
effectIn: anHGSimulator deltaT: aNumber
	self getStream
		downloadDo: [ :index :data | 
			(anHGSimulator particleAt: index)
				ifNotNilDo: [ :particle | data keysAndValuesDo: [ :key :value | particle at: key put: value ] ] ]! !

HGDownloader subclass: #HGPVTDownloader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGPVTDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPVTDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPVTDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPVTDownloader methodsFor: 'simulating' stamp: 'TomohiroOda 6/23/2011 13:26'!
effectIn: anHGSimulator deltaT: aNumber
	self getStream
		downloadDo: [ :index :data | 
			(anHGSimulator particleAt: index)
				ifNotNilDo: [ :particle | 
					particle position: data first.
					particle velocity: data second.
					particle temperature: data third ] ]! !

HGDownloader subclass: #HGPositionDownloader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGPositionDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPositionDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPositionDownloader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPositionDownloader methodsFor: 'simulating' stamp: 'TomohiroOda 6/23/2011 11:59'!
effectIn: anHGSimulator deltaT: aNumber
	self getStream
		downloadDo: [ :index :data | (anHGSimulator particleAt: index) ifNotNilDo: [ :particle | particle position: data ] ]! !

HGCommunicator subclass: #HGUploader
	instanceVariableNames: 'conditionBlock lockConditionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

HGUploader subclass: #HGPVTUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGPVTUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPVTUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPVTUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPVTUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 11:53'!
particleDataFrom: anHGParticle
	^ Array with: anHGParticle position with: anHGParticle velocity with: anHGParticle temperature! !

HGUploader subclass: #HGPositionUploader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Networking'!

!HGPositionUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPositionUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPositionUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPositionUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 11:54'!
particleDataFrom: anHGParticle
	^ anHGParticle position! !

!HGUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGUploader class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 11:51'!
buildDataDictionaryFrom: anHGSimulator
	| data |
	data := Dictionary new.
	1 to: anHGSimulator numberOfParticles do: [ :particleIndex | 
		(conditionBlock value: particleIndex)
			ifTrue: [ data at: particleIndex put: (self particleDataFrom: (anHGSimulator particleAt: particleIndex)) ] ].
	^ data! !

!HGUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 11:48'!
dataDictionary
	! !

!HGUploader methodsFor: 'simulating' stamp: 'TomohiroOda 7/1/2011 11:53'!
effectIn: anHGSimulator deltaT: aNumber
	self getStream upload: (self buildDataDictionaryFrom: anHGSimulator)! !

!HGUploader methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/5/2011 15:15'!
initialize
	super initialize.
	conditionBlock := [ :index | true ].
	lockConditionBlock := [ :index | false ]! !

!HGUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 14:41'!
particleDataFrom: anHGParticle
	| dict |
	dict := Dictionary new.
	anHGParticle keysAndValuesDo: [ :key :value |
		dict at: key put: value].
	^ dict! !

!HGUploader methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 11:40'!
suchThat: aBlock
	conditionBlock := aBlock! !

HGAction subclass: #HGCrusher
	instanceVariableNames: 'particleIndex elasticForce radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGCrusher class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGCrusher class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGCrusher class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/11/2011 13:01'!
at: anInteger radius: aNumber against: anHGElasticTrindingForce
	^ (self new)
		particleIndex: anInteger;
		radius: aNumber;
		elasticForce: anHGElasticTrindingForce;
		yourself! !

!HGCrusher class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGCrusher methodsFor: 'simulating' stamp: 'TomohiroOda 8/11/2011 13:02'!
effectIn: anHGSimulator deltaT: aNumber
	elasticForce breakTrindingsAround: (anHGSimulator particleAt: particleIndex) position within:  radius! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:04'!
elasticForce 
	^ elasticForce ! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:04'!
elasticForce: anHGElasticForce
	elasticForce := anHGElasticForce ! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:04'!
particleIndex 
	^ particleIndex ! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:04'!
particleIndex: anInteger
	particleIndex := anInteger ! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:59'!
radius
	^ radius! !

!HGCrusher methodsFor: 'accessing' stamp: 'TomohiroOda 8/11/2011 12:59'!
radius: aNumber
	radius := aNumber! !

HGAction subclass: #HGElasticForce
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

HGElasticForce subclass: #HGBindingElasticForce
	instanceVariableNames: 'bindings color width breakrate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGBindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 1/20/2012 14:25'!
color: aColor
	^ (self new)
		color: aColor;
		yourself! !

!HGBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGBindingElasticForce methodsFor: 'adding' stamp: 'TomohiroOda 7/8/2011 14:17'!
addBindingBetween: anHGParticle and: anotherHGParticle
	| binding |
	binding := bindings
		detect: [ :bind | 
			(bind particle1 == anHGParticle and: [ bind particle2 == anotherHGParticle ])
				or: [ bind particle2 == anHGParticle and: [ bind particle1 == anotherHGParticle ] ] ]
		ifNone: [ bindings add: (HGBinding between: anHGParticle and: anotherHGParticle) ].
	binding standardDistance: binding distance.
	^ binding! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 11:55'!
breakrate
	^ breakrate ! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 11:56'!
breakrate: aNumber
	breakrate := aNumber! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:07'!
color
	^ color! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:07'!
color: aColor
	color := aColor! !

!HGBindingElasticForce methodsFor: 'drawing' stamp: 'TomohiroOda 1/20/2012 14:43'!
draw: anHGSimulator on: aCanvas
	bindings do: [ :binding |
		aCanvas line: binding particle1 position asPoint to: binding particle2 position asPoint width: width color: color ]
! !

!HGBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 2/7/2012 12:01'!
effectIn: anHGSimulator deltaT: aNumber
	| distanceBlock outlines |
	self effectShapesIn: anHGSimulator deltaT: aNumber.
	breakrate
		ifNotNil: [ self removeBindingSuchThat: [ :binding | binding distance > (binding standardDistance * breakrate) ] ].
	self color ifNotNil: [ self draw: anHGSimulator on: anHGSimulator form getCanvas ]! !

!HGBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 1/20/2012 14:09'!
effectShapesIn: anHGSimulator deltaT: aNumber.
	^ self subclassResponsibility ! !

!HGBindingElasticForce methodsFor: 'initialize-release' stamp: 'TomohiroOda 1/20/2012 14:42'!
initialize
	super initialize.
	width := 1.
	bindings := OrderedCollection new: 160000.! !

!HGBindingElasticForce methodsFor: 'removing' stamp: 'TomohiroOda 7/12/2011 14:28'!
removeBindingSuchThat: aBlock
	bindings removeAllSuchThat: aBlock! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:41'!
width
	^ width! !

!HGBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:42'!
width: aNumber
	width := aNumber! !

HGBindingElasticForce subclass: #HGHardBindingElasticForce
	instanceVariableNames: 'convergenceCoefficient steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGHardBindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 1/20/2012 14:24'!
steps: anInteger convergenceCoefficient: aNumber color: aColor
	^ (super color: aColor)
		steps: anInteger;
		convergenceCoefficient: aNumber;
		yourself! !

!HGHardBindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/6/2012 15:53'!
steps: anInteger convergenceCoefficient: aNumber color: aColor width: width
	^ (super color: aColor)
		steps: anInteger;
		convergenceCoefficient: aNumber;
		width: width;
		yourself! !

!HGHardBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:03'!
convergenceCoefficient
	^ convergenceCoefficient! !

!HGHardBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:03'!
convergenceCoefficient: anObject
	convergenceCoefficient := anObject! !

!HGHardBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 1/20/2012 14:05'!
effect: particle1 and: particle2 deltaPosition: delta deltaT: deltaT
	| v |
	particle1 addPosition: (particle1 position unitVector: particle2 position) by: delta / 2.0.
	particle2 addPosition: (particle2 position  unitVector: particle1 position) by: delta / 2.0.
	v := ((particle1 velocity * particle1 mass) + (particle2 velocity * particle2 mass)) / (particle1 mass + particle2 mass).
	particle1 velocity: v.
	particle2 velocity: v! !

!HGHardBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 1/20/2012 14:25'!
effectShapesIn: anHGSimulator deltaT: aNumber
	| distanceBlock alpha |
	distanceBlock := [ :particle1 :particle2 | particle1 velocity * aNumber + particle1 position distance: particle2 velocity * aNumber + particle2 position ].
	alpha := convergenceCoefficient.
	steps
		timesRepeat: [ 
			| gamma |
			gamma := 1.0 - alpha.
			bindings
				do: [ :binding | 
					self
						effect: binding particle1
						and: binding particle2
						deltaPosition:
							((distanceBlock value: binding particle1 value: binding particle2) - binding standardDistance) * gamma
						deltaT: aNumber ].
			alpha := alpha * convergenceCoefficient ]! !

!HGHardBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:03'!
steps
	^ steps! !

!HGHardBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:03'!
steps: anObject
	steps := anObject! !

HGBindingElasticForce subclass: #HGSpringBindingElasticForce
	instanceVariableNames: 'k'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGSpringBindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 1/20/2012 14:24'!
k: aNumber color: aColor
	^ (self color: aColor)
		k: aNumber;
		yourself! !

!HGSpringBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 1/20/2012 14:05'!
effect: particle1 and: particle2 deltaPosition: delta deltaT: deltaT
	| unit f |
	unit := particle1 position unitVector: particle2 position.
	f := (delta abs * k min: 100.0) * delta sign.
	f := delta * k.
	particle1 addForce: unit by: f.
	particle2 addForce: unit by: f * -1.0! !

!HGSpringBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 2/7/2012 08:21'!
effectShapesIn: anHGSimulator deltaT: aNumber
	| distanceBlock |
	distanceBlock := [ :particle1 :particle2 | particle1 velocity * aNumber + particle1 position distance: particle2 velocity * aNumber + particle2 position ].
	bindings
		do: [ :binding | 
			self
				effect: binding particle1
				and: binding particle2
				deltaPosition: (distanceBlock value: binding particle1 value: binding particle2) - binding standardDistance
				deltaT: aNumber ]! !

!HGSpringBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:04'!
k
	^ k! !

!HGSpringBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 1/20/2012 14:04'!
k: anObject
	k := anObject! !

!HGElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 12:36'!
maxDistance: aNumber color: aColor
	^ (self new)
		maxDistance: aNumber;
		color: aColor;
		yourself! !

!HGElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

HGElasticForce subclass: #HGTrindingElasticForce
	instanceVariableNames: 'color trindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

HGTrindingElasticForce subclass: #HGHardTrindingElasticForce
	instanceVariableNames: 'convergenceCoefficient steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGHardTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGHardTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGHardTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGHardTrindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/21/2011 10:39'!
steps: anInteger convergenceCoefficient: aNumber color: aColor
	^ (super color: aColor)
		steps: anInteger;
		convergenceCoefficient: aNumber;
		yourself! !

!HGHardTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:29'!
convergenceCoefficient
	^ convergenceCoefficient ! !

!HGHardTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:29'!
convergenceCoefficient: aNumber
	convergenceCoefficient := aNumber min: 1.0 max: 0.0! !

!HGHardTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/21/2011 11:10'!
effect: particle1 and: particle2 deltaPosition: delta deltaT: deltaT
	| v |
	particle1 addPosition: (particle1 position unitVector: particle2 position) by: delta / 2.0.
	particle2 addPosition: (particle2 position  unitVector: particle1 position) by: delta / 2.0.
	v := ((particle1 velocity * particle1 mass) + (particle2 velocity * particle2 mass)) / (particle1 mass + particle2 mass).
	particle1 velocity: v.
	particle2 velocity: v! !

!HGHardTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/21/2011 13:29'!
effectShapesIn: anHGSimulator deltaT: aNumber
	| distanceBlock alpha |
	distanceBlock := [ :particle1 :particle2 | particle1 velocity * aNumber + particle1 position distance: particle2 velocity * aNumber + particle2 position ].
	alpha := convergenceCoefficient.
	steps
		timesRepeat: [ 
			| gamma |
			gamma := 1.0 - alpha.
			trindings
				do: [ :trinding | 
					self
						effect: trinding particle1
						and: trinding particle2
						deltaPosition: (distanceBlock value: trinding particle1 value: trinding particle2) - trinding standardDistance12 * gamma 
						deltaT: aNumber.
					self
						effect: trinding particle2
						and: trinding particle3
						deltaPosition: (distanceBlock value: trinding particle2 value: trinding particle3) - trinding standardDistance23 * gamma
						deltaT: aNumber.
					self
						effect: trinding particle3
						and: trinding particle1
						deltaPosition: (distanceBlock value: trinding particle3 value: trinding particle1) - trinding standardDistance31 * gamma
						deltaT: aNumber ].
					alpha := alpha * convergenceCoefficient  ]! !

!HGHardTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:38'!
steps
	^steps! !

!HGHardTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:38'!
steps: anInteger
	steps := anInteger! !

HGTrindingElasticForce subclass: #HGSpringTrindingElasticForce
	instanceVariableNames: 'k'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGSpringTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSpringTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSpringTrindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/21/2011 10:36'!
k: aNumber color: aColor
	^ (self color: aColor)
		k: aNumber;
		yourself! !

!HGSpringTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSpringTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/21/2011 10:32'!
effect: particle1 and: particle2 deltaPosition: delta deltaT: deltaT
	| unit f |
	unit := particle1 position unitVector: particle2 position.
	f := (delta abs * k min: 100.0) * delta sign.
	f := delta * k.
	particle1 addForce: unit by: f.
	particle2 addForce: unit by: f * -1.0! !

!HGSpringTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/21/2011 10:42'!
effectShapesIn: anHGSimulator deltaT: aNumber
	| distanceBlock |
	distanceBlock := [ :particle1 :particle2 | particle1 velocity * aNumber + particle1 position distance: particle2 velocity * aNumber + particle2 position ].
	trindings
		do: [ :trinding | 
			self
				effect: trinding particle1
				and: trinding particle2
				deltaPosition: (distanceBlock value: trinding particle1 value: trinding particle2) - trinding standardDistance12
				deltaT: aNumber.
			self
				effect: trinding particle2
				and: trinding particle3
				deltaPosition: (distanceBlock value: trinding particle2 value: trinding particle3) - trinding standardDistance23
				deltaT: aNumber.
			self
				effect: trinding particle3
				and: trinding particle1
				deltaPosition: (distanceBlock value: trinding particle3 value: trinding particle1) - trinding standardDistance31
				deltaT: aNumber ].! !

!HGSpringTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:31'!
k
	^ k! !

!HGSpringTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/21/2011 10:32'!
k: aNumber
	k := aNumber! !

!HGTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTrindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/21/2011 10:34'!
color: aColor
	^ (self new)
		color: aColor;
		yourself! !

!HGTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTrindingElasticForce methodsFor: 'adding' stamp: 'TomohiroOda 7/8/2011 14:16'!
addTrindingAmong: anHGParticle1 and: anHGParticle2 and: anHGParticle3
	^ trindings add: (HGTrinding among: anHGParticle1 and: anHGParticle2 and: anHGParticle3)! !

!HGTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 8/11/2011 11:48'!
breakTrindingsAround: anHG2dPoint within: aNumber
	trindings
		removeAllSuchThat: [ :trinding | ((trinding borderAt: anHG2dPoint) distance: anHG2dPoint ) < aNumber]! !

!HGTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:10'!
color
	^ color! !

!HGTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:10'!
color: aColor
	color := aColor! !

!HGTrindingElasticForce methodsFor: 'drawing' stamp: 'TomohiroOda 7/21/2011 11:57'!
draw: anHGSimulator on: aCanvas
	trindings
		do: [ :trinding | 
			aCanvas
				drawPolygon:
					(Array
						with: trinding particle1 position asPoint
						with: trinding particle2 position asPoint
						with: trinding particle3 position asPoint)
				fillStyle: (color).
			aCanvas
				line: trinding particle1 position asPoint
				to: trinding particle2 position asPoint
				width: 1
				color: color.
			aCanvas
				line: trinding particle2 position asPoint
				to: trinding particle3 position asPoint
				width: 1
				color: color.
			aCanvas
				line: trinding particle3 position asPoint
				to: trinding particle1 position asPoint
				width: 1
				color: color ]! !

!HGTrindingElasticForce methodsFor: 'drawing' stamp: 'TomohiroOda 8/11/2011 11:25'!
draw: anHGSimulator outlines: aCollectionOfArrayOfVerticePairs on: aCanvas
	trindings
		do: [ :trinding | 
			aCanvas
				drawPolygon:
					(Array
						with: trinding particle1 position asPoint
						with: trinding particle2 position asPoint
						with: trinding particle3 position asPoint)
				fillStyle: (color mixed: 0.6 with: anHGSimulator color) ].
	aCollectionOfArrayOfVerticePairs
		do: [ :outline | 
			outline
				do: [ :pair | 
					aCanvas
						line: (pair at: 1) position asPoint
						to: (pair at: 2) position asPoint
						width: 3
						color: color ] ]! !

!HGTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 8/4/2011 14:33'!
effectIn: anHGSimulator deltaT: aNumber
	| distanceBlock outlines |
	trindings removeAllSuchThat: [ :trinding | trinding area < 0.0 ].
	self effectShapesIn: anHGSimulator deltaT: aNumber.
	outlines := OrderedCollection new.
	(HGElasticBody isolatedBodiesWithAll: trindings)
		do: [ :body | 
			| outline |
			outline := Array new writeStream.
			body pairsDo: [ :vertex1 :vertex2 | outline nextPut: (Array with: vertex1 with: vertex2)].
			outlines add: outline contents.
			anHGSimulator particlesDo: [ :particle | body bump: particle ] ].
	self color ifNotNil: [ self draw: anHGSimulator outlines: outlines on: anHGSimulator form getCanvas ]! !

!HGTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/21/2011 10:43'!
effectShapesIn: anHGSimulator deltaT: aNumber.
	^ self subclassResponsibility ! !

!HGTrindingElasticForce methodsFor: 'initialize-release' stamp: 'TomohiroOda 7/8/2011 14:22'!
initialize
	super initialize.
	trindings := OrderedCollection new: 100.! !

HGAction subclass: #HGFacialFriction
	instanceVariableNames: 'mu viscuss'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGFacialFriction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGFacialFriction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGFacialFriction class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/14/2011 11:58'!
mu: aNumber
	^ (self new)
		mu: aNumber;
		yourself! !

!HGFacialFriction class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/13/2012 14:37'!
mu: aNumber viscuss: aBoolean
	^ (self new)
		mu: aNumber;
		viscuss: aBoolean;
		yourself! !

!HGFacialFriction methodsFor: 'simulating' stamp: 'TomohiroOda 2/13/2012 14:38'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| m v v0 |
	m := anHGParticle mass.
	v := anHGParticle velocity.
	v0 := v norm2.
	v0 > 1.0e-8
		ifTrue: [ 
			| a theta |
			a := HG2dPoint
				theta: v theta + Float pi
				r:
					(mu
						*
							(viscuss
								ifTrue: [ anHGParticle viscosity ]
								ifFalse: [ 1.0 ]) min: v norm2 / aNumber).
			anHGParticle addForce: a by: m ]! !

!HGFacialFriction methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/13/2012 14:38'!
initialize
	super initialize.
	viscuss := true! !

!HGFacialFriction methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 09:39'!
mu
	^ mu! !

!HGFacialFriction methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 11:51'!
mu: aNumber
	mu := aNumber! !

!HGFacialFriction methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:37'!
viscuss
	^ viscuss! !

!HGFacialFriction methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 14:37'!
viscuss: aBoolean
	viscuss := aBoolean = true! !

HGAction subclass: #HGForceInitialization
	instanceVariableNames: 'force'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGForceInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGForceInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGForceInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGForceInitialization class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/25/2011 13:13'!
with: anHGPoint
	^ self new setForce: anHGPoint! !

!HGForceInitialization methodsFor: 'simulating' stamp: 'TomohiroOda 5/25/2011 13:11'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle force: force copy! !

!HGForceInitialization methodsFor: 'private' stamp: 'TomohiroOda 5/25/2011 13:13'!
setForce: anHGPoint
	force := anHGPoint! !

HGAction subclass: #HGForceIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGForceIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGForceIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGForceIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGForceIntegration methodsFor: 'simulating' stamp: 'TomohiroOda 5/25/2011 13:07'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle addVelocity: anHGParticle force by: aNumber / anHGParticle mass! !

HGAction subclass: #HGGravity
	instanceVariableNames: 'g'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGGravity class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGGravity class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGGravity class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/17/2011 14:47'!
g: anHGPoint
	^ (self new)
		g: anHGPoint;
		yourself! !

!HGGravity class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGGravity methodsFor: 'simulating' stamp: 'TomohiroOda 5/30/2011 10:48'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle addForce: g by: anHGParticle mass! !

!HGGravity methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 09:40'!
g
	^g! !

!HGGravity methodsFor: 'private' stamp: 'TomohiroOda 10/17/2011 14:47'!
g: anHGPoint
	g := anHGPoint! !

HGAction subclass: #HGHandParticle
	instanceVariableNames: 'particleIndex lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGHandParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGHandParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGHandParticle class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/12/2011 13:20'!
at: anInteger
	^ self new particleIndex: anInteger! !

!HGHandParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGHandParticle methodsFor: 'simulating' stamp: 'TomohiroOda 6/29/2011 11:01'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGHandParticle methodsFor: 'simulating' stamp: 'TomohiroOda 7/14/2011 10:12'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	position := globalPoint - bounds origin.
	lastPosition ifNil: [lastPosition := position].
	(ActiveHand anyButtonPressed and: [ bounds containsPoint: globalPoint ])
		ifTrue: [ 
			self
				in: anHGSimulator
				particlesDo: [ :particle | 
					particle position set: position.
					particle velocity set: (position - lastPosition) / aNumber ] ].
	lastPosition := position! !

!HGHandParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/14/2011 10:13'!
in: anHGSimulator particlesDo: aBlock
	(anHGSimulator particleAt: particleIndex) ifNotNilDo: aBlock! !

!HGHandParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:40'!
particleIndex
	^particleIndex! !

!HGHandParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:41'!
particleIndex: anInteger
	particleIndex := anInteger! !

HGAction subclass: #HGHeatTransferBySmoothing
	instanceVariableNames: 'kernel changes rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Thermal'!

!HGHeatTransferBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGHeatTransferBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGHeatTransferBySmoothing class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 12:23'!
rate: aNumber kernel: anHGKernel
	^ (self new)
		setKernel: anHGKernel;
		rate: aNumber;
		yourself! !

!HGHeatTransferBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGHeatTransferBySmoothing methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 12:26'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| denominator temperature |
	denominator := 0.0.
	temperature := 0.0.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | 
			| gradient |
			gradient := kernel r: distance.
			temperature := neighbor temperature * gradient + temperature.
			denominator := denominator + gradient ].
	denominator > 0.0
		ifTrue: [ 
			temperature := anHGParticle temperature * (1.0 - rate) + (temperature * rate / denominator).
			changes add: anHGParticle -> temperature ]! !

!HGHeatTransferBySmoothing methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 12:22'!
effectIn: anHGSimulator deltaT: aNumber
	changes := OrderedCollection new: anHGSimulator numberOfParticles.
	super effectIn: anHGSimulator deltaT: aNumber.
	changes do: [ :atomic | atomic key temperature: atomic value ].
	changes := nil! !

!HGHeatTransferBySmoothing methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 12:21'!
rate
	^ rate! !

!HGHeatTransferBySmoothing methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 12:21'!
rate: aNumber
	rate := aNumber! !

!HGHeatTransferBySmoothing methodsFor: 'private' stamp: 'TomohiroOda 10/11/2011 13:55'!
setKernel: anHGKernel
	kernel := anHGKernel! !

HGAction subclass: #HGJet
	instanceVariableNames: 'region v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGJet class methodsFor: 'instance creation' stamp: 'TomohiroOda 12/27/2011 14:05'!
v: anHG2dPoint in: anHG2dRegion
	^ (self new)
		v: anHG2dPoint;
		region: anHG2dRegion;
		yourself! !

!HGJet methodsFor: 'drawing' stamp: 'TomohiroOda 12/27/2011 14:44'!
draw: anHGSimulator on: aCanvas
	aCanvas frameOval: (self region origin asPoint corner: self region corner asPoint) color: Color black.
	aCanvas line: self region center asPoint to: (self region center + self v) asPoint width: 5 color: Color black! !

!HGJet methodsFor: 'simulating' stamp: 'TomohiroOda 12/27/2011 14:49'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	(region contains: anHGParticle position)
		ifTrue: [ 
			anHGParticle velocity: v copy.
			anHGParticle force: HG2dPoint zero.
			anHGParticle position: self region center copy ]! !

!HGJet methodsFor: 'simulating' stamp: 'TomohiroOda 12/27/2011 14:41'!
effectIn: anHGSimulator deltaT: aNumber
	super effectIn: anHGSimulator deltaT: aNumber .
	self draw: anHGSimulator on: anHGSimulator form getCanvas! !

!HGJet methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:00'!
region
	^ region! !

!HGJet methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:00'!
region: anObject
	region := anObject! !

!HGJet methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:00'!
v
	^ v! !

!HGJet methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:00'!
v: anObject
	v := anObject! !

HGAction subclass: #HGLocalAction
	instanceVariableNames: 'action region'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGLocalAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGLocalAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGLocalAction class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 09:50'!
on: anHGAction in: anHGRegion
	^ self new setAction: anHGAction region: anHGRegion! !

!HGLocalAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGLocalAction methodsFor: 'simulating' stamp: 'TomohiroOda 6/22/2011 09:49'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	(region contains: anHGParticle position)
		ifTrue: [ action effect: anHGParticle in: anHGSimulator deltaT: aNumber ]! !

!HGLocalAction methodsFor: 'private' stamp: 'TomohiroOda 6/22/2011 09:49'!
setAction: anHGAction region: anHGRegion
	action := anHGAction.
	region := anHGRegion! !

HGAction subclass: #HGLocalityMap
	instanceVariableNames: 'rejectOutOfBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGLocalityMap class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGLocalityMap class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGLocalityMap class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGLocalityMap class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/25/2012 11:19'!
withOutOfBoundsRemoval
	^ (self new)
		rejectOutOfBounds: true;
		yourself! !

!HGLocalityMap methodsFor: 'simulating' stamp: 'TomohiroOda 6/25/2012 11:29'!
effectIn: anHGSimulator deltaT: aNumber
	rejectOutOfBounds = true
		ifTrue: [ 
			| originX originY cornerX cornerY |
			originX := anHGSimulator simulationOrigin x.
			originY := anHGSimulator simulationOrigin y.
			cornerX := anHGSimulator simulationCorner x.
			cornerY := anHGSimulator simulationCorner y.
			anHGSimulator
				removeParticlesSuchThat: [ :particle | (particle position x between: originX and: cornerX) not or: [ (particle position y between: originY and: cornerY) not ] ] ]
		ifFalse: [ anHGSimulator updateParticleMap ]! !

!HGLocalityMap methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/25/2012 11:10'!
initialize
	super initialize.
	rejectOutOfBounds := false! !

!HGLocalityMap methodsFor: 'accessing' stamp: 'TomohiroOda 6/25/2012 11:10'!
rejectOutOfBounds
	^ rejectOutOfBounds! !

!HGLocalityMap methodsFor: 'accessing' stamp: 'TomohiroOda 6/25/2012 11:10'!
rejectOutOfBounds: aBoolean
	rejectOutOfBounds := aBoolean = true! !

HGAction subclass: #HGMaxVelocity
	instanceVariableNames: 'maxVelocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGMaxVelocity class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGMaxVelocity class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGMaxVelocity class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGMaxVelocity class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 13:44'!
within: aNumber
	^ self new setMaxVelocity: aNumber  ! !

!HGMaxVelocity methodsFor: 'simulating' stamp: 'TomohiroOda 5/31/2011 09:21'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| speed |
	(speed := anHGParticle velocity norm2) > maxVelocity 
		ifTrue: [ anHGParticle velocity: anHGParticle velocity / (speed / maxVelocity) ]! !

!HGMaxVelocity methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 15:37'!
maxVelocity
	^ maxVelocity! !

!HGMaxVelocity methodsFor: 'accessing' stamp: 'TomohiroOda 10/20/2011 15:38'!
maxVelocity: aNumber
	maxVelocity := aNumber! !

!HGMaxVelocity methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 09:18'!
setMaxVelocity: aNumber
	maxVelocity := aNumber! !

HGAction subclass: #HGNewtonianCooling
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Thermal'!

!HGNewtonianCooling class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGNewtonianCooling class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGNewtonianCooling class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/31/2011 13:30'!
kernel: anHGKernel
	^ self new setKernel: anHGKernel   ! !

!HGNewtonianCooling class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGNewtonianCooling methodsFor: 'simulating' stamp: 'TomohiroOda 6/23/2011 09:47'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGNewtonianCooling methodsFor: 'simulating' stamp: 'TomohiroOda 6/29/2011 09:56'!
effectIn: anHGSimulator deltaT: aNumber
	anHGSimulator particlesDo: [ :particle | self stage1: particle in: anHGSimulator deltaT: aNumber ].
	anHGSimulator particlesDo: [ :particle | self stage2: particle in: anHGSimulator deltaT: aNumber ].
	anHGSimulator particlesDo: [ :particle | self stage3: particle in: anHGSimulator deltaT: aNumber ]! !

!HGNewtonianCooling methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 13:30'!
setKernel: anHGKernel
	kernel := anHGKernel ! !

!HGNewtonianCooling methodsFor: 'simulating' stamp: 'TomohiroOda 6/23/2011 09:45'!
stage1: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle heat: 0.0! !

!HGNewtonianCooling methodsFor: 'simulating' stamp: 'TomohiroOda 7/1/2011 07:51'!
stage2: anHGParticle in: anHGSimulator deltaT: aNumber
	| c |
	c := anHGParticle heatConductivity * anHGParticle area / anHGParticle heatCapacity * aNumber negated.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | anHGParticle addHeat: neighbor temperature - anHGParticle temperature by: anHGParticle heatCapacity * (c exp - 1) ]! !

!HGNewtonianCooling methodsFor: 'simulating' stamp: 'TomohiroOda 6/23/2011 09:46'!
stage3: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle addTemperature: anHGParticle heat by: 1.0 / anHGParticle heatCapacity! !

HGAction subclass: #HGNoAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGNoAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGNoAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGNoAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGNoAction methodsFor: 'simulating' stamp: 'TomohiroOda 6/22/2011 13:58'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGNoAction methodsFor: 'simulating' stamp: 'TomohiroOda 6/22/2011 13:58'!
effectIn: anHGSimulator deltaT: aNumber! !

HGAction subclass: #HGObstacle
	instanceVariableNames: 'region color afterEffect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

HGObstacle subclass: #HGBumpyObstacle
	instanceVariableNames: 'rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGBumpyObstacle class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/7/2012 08:15'!
with: anHG2dRegion  color: aColor
	^ self with: anHG2dRegion rate: 1.0 color: aColor! !

!HGBumpyObstacle class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/7/2012 08:12'!
with: anHG2dRegion rate: aNumber color: aColor
	^ (self new)
		setRegion: anHG2dRegion color: aColor;
		rate: aNumber;
		yourself! !

!HGBumpyObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 2/13/2012 15:09'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| position |
	position := anHGParticle position.
	(region contains: position)
		ifTrue: [ 
			| newPosition |
			newPosition := region borderAt: position.
			anHGParticle addVelocity: (position unitVector: newPosition) by: rate / aNumber.
			anHGParticle position set: newPosition.
			afterEffect ifNotNil: [ afterEffect value: anHGParticle value: aNumber] ]! !

!HGBumpyObstacle methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/7/2012 08:15'!
initialize
	super initialize.
	rate := 1.0! !

!HGBumpyObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 08:12'!
rate
	^ rate! !

!HGBumpyObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 08:13'!
rate: aNumber
	rate := aNumber! !

!HGObstacle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGObstacle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGObstacle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGObstacle class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/5/2011 14:43'!
with: anHG2dRegion
	^ self with: anHG2dRegion color: nil! !

!HGObstacle class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/5/2011 14:43'!
with: anHG2dRegion color: aColor
	^ self new setRegion: anHG2dRegion  color: aColor! !

!HGObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 15:06'!
afterEffect
	^ afterEffect! !

!HGObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 2/13/2012 15:06'!
afterEffect: aBlock
	afterEffect := aBlock! !

!HGObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 2/13/2012 15:09'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| position |
	position := anHGParticle position.
	(region contains: position)
		ifTrue: [ 
			anHGParticle velocity set: HG2dPoint zero.
			anHGParticle position set: (region borderAt: position).
			afterEffect ifNotNil: [ afterEffect value: anHGParticle value: aNumber ] ]! !

!HGObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 2/6/2012 15:25'!
effectIn: anHGSimulator deltaT: aNumber
	super effectIn: anHGSimulator deltaT: aNumber.
	color ifNotNil: [region drawOn: anHGSimulator form getCanvas color: color]! !

!HGObstacle methodsFor: 'private' stamp: 'TomohiroOda 7/5/2011 14:43'!
setRegion: anHG2dRegion color: aColor
	region := anHG2dRegion.
	color := aColor! !

HGObstacle subclass: #HGSlipperyObstacle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGSlipperyObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 6/9/2012 11:17'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| position |
	position := anHGParticle position.
	(region contains: position)
		ifTrue: [ 
			| newPosition |
			newPosition := region borderAt: position.
			anHGParticle addVelocity: (newPosition plus: position by: -1.0) by: 1.0.
			anHGParticle position set: (newPosition).
			afterEffect ifNotNil: [ afterEffect value: anHGParticle value: aNumber ] ]! !

HGObstacle subclass: #HGStickyObstacle
	instanceVariableNames: 'relativePositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGStickyObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 2/13/2012 15:09'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| position |
	position := anHGParticle position.
	(region contains: position)
		ifTrue: [ 
			anHGParticle velocity set: HG2dPoint zero.
			anHGParticle position
				set:
					(relativePositions at: anHGParticle ifAbsentPut: [ (region borderAt: position) - region center ]) + region center.
			afterEffect ifNotNil: [ afterEffect value: anHGParticle value: aNumber] ]
		ifFalse: [ relativePositions removeKey: anHGParticle ifAbsent: [  ] ]! !

!HGStickyObstacle methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/9/2012 09:59'!
initialize
	super initialize.
	relativePositions := IdentityDictionary new.! !

HGAction subclass: #HGParticleGripper
	instanceVariableNames: 'offsets radius lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGParticleGripper class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGParticleGripper class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGParticleGripper class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGParticleGripper class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/14/2011 09:57'!
within: aNumber
	^ (self new)
		radius: aNumber;
		yourself! !

!HGParticleGripper methodsFor: 'simulating' stamp: 'TomohiroOda 7/14/2011 09:58'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGParticleGripper methodsFor: 'simulating' stamp: 'TomohiroOda 10/2/2011 10:31'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position oldPosition currentParticle |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	position := HG2dPoint fromPoint: globalPoint - bounds origin.
	lastPosition ifNil: [ lastPosition := position ].
	oldPosition := nil.
	currentParticle := nil.
	(ActiveHand anyButtonPressed and: [ bounds containsPoint: globalPoint ])
		ifTrue: [ 
			offsets
				ifNil: [ 
					offsets := IdentityDictionary new.
					anHGSimulator
						neighborsOf: position
						within: radius
						do: [ :particle :distance | offsets at: particle put: particle position - position ] ].
			offsets
				keysAndValuesDo: [ :particle :offset | 
					particle position: position + offset.
					particle velocity: (position - lastPosition) / aNumber.
					oldPosition := position ] ]
		ifFalse: [ offsets := nil ].
	lastPosition := oldPosition! !

!HGParticleGripper methodsFor: 'enumerating' stamp: 'TomohiroOda 7/14/2011 10:32'!
in: anHGSimulator particlesDo: aBlock
	offsets ifNotNilDo: [ :dict | dict keysDo: aBlock]! !

!HGParticleGripper methodsFor: 'accessing' stamp: 'TomohiroOda 7/14/2011 09:56'!
radius
	^ radius! !

!HGParticleGripper methodsFor: 'accessing' stamp: 'TomohiroOda 7/14/2011 09:56'!
radius: aNumber
	radius := aNumber! !

HGAction subclass: #HGParticlePicker
	instanceVariableNames: 'pickedParticle lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGParticlePicker class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGParticlePicker class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGParticlePicker class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGParticlePicker methodsFor: 'simulating' stamp: 'TomohiroOda 7/12/2011 13:21'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber! !

!HGParticlePicker methodsFor: 'simulating' stamp: 'TomohiroOda 10/2/2011 10:31'!
effectIn: anHGSimulator deltaT: aNumber
	| bounds globalPoint position oldPosition currentParticle |
	bounds := anHGSimulator bounds.
	globalPoint := ActiveHand position.
	position := globalPoint - bounds origin.
	lastPosition ifNil: [ lastPosition := position ].
	oldPosition := nil.
	currentParticle := nil.
	(ActiveHand anyButtonPressed and: [ bounds containsPoint: globalPoint ])
		ifTrue: [ 
			pickedParticle ifNil: [ self pickParticleAt: (HG2dPoint fromPoint: position) in: anHGSimulator ].
			pickedParticle
				ifNotNil: [ 
					pickedParticle position set: position.
					pickedParticle velocity set: (position - lastPosition) / aNumber.
					oldPosition := position.
					currentParticle := pickedParticle ] ].
	lastPosition := oldPosition.
	pickedParticle := currentParticle! !

!HGParticlePicker methodsFor: 'enumerating' stamp: 'TomohiroOda 7/14/2011 10:13'!
in: anHGSimulator particlesDo: aBlock
	pickedParticle ifNotNilDo: aBlock! !

!HGParticlePicker methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:38'!
pickParticleAt: anHG2dPoint in: anHGSimulator
	| nearest minDistance |
	nearest := nil.
	minDistance := Float infinity.
	anHGSimulator
		neighborsOf: anHG2dPoint
		within: 10.0
		do: [ :particle :distance | 
			distance < minDistance
				ifTrue: [ 
					minDistance := distance.
					nearest := particle ] ].
	^ pickedParticle := nearest! !

!HGParticlePicker methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:32'!
pickedParticle 
	^ pickedParticle ! !

!HGParticlePicker methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:32'!
pickedParticle: anHGParticle
	pickedParticle := anHGParticle ! !

HGAction subclass: #HGPhonator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGPhonator subclass: #HGCollisionPhonator
	instanceVariableNames: 'particleIndex radius sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGCollisionPhonator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGCollisionPhonator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGCollisionPhonator class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/17/2011 22:16'!
at: anInteger radius: aNumber sound: aSound
	^ (self new)
		particleIndex: anInteger;
		radius: aNumber;
		sound: aSound;
		yourself! !

!HGCollisionPhonator methodsFor: 'simulating' stamp: 'TomohiroOda 10/17/2011 22:19'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
! !

!HGCollisionPhonator methodsFor: 'simulating' stamp: 'TomohiroOda 10/17/2011 22:33'!
effectIn: anHGSimulator deltaT: aNumber
	| particle volume |
	particle := anHGSimulator particleAt: particleIndex.
	particle ifNil: [ ^ self ].
	volume := 0.0.
	 anHGSimulator
		neighborsOf: particle position
		within: radius
		do: [ :neighbor :distance | 
			neighbor ~~ particle
				ifTrue: [ volume := volume max: (radius - distance) / radius ] ].
	volume > 0.0
		ifTrue: [ 
			(sound respondsTo: #loudness:) ifTrue: [sound loudness: volume].
			sound play ]! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
particleIndex
	^ particleIndex! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
particleIndex: anInteger
	particleIndex := anInteger! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
radius
	^ radius! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
radius: aNumber
	radius := aNumber! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
sound
	^ sound! !

!HGCollisionPhonator methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 22:15'!
sound: aSound
	sound := aSound! !

!HGPhonator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGPhonator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPhonator class methodsFor: 'sounds' stamp: 'TomohiroOda 10/17/2011 22:41'!
coffeeCupClink
	^ SampledSound samples: SampledSound coffeeCupClink samplingRate: 11025 / 4! !

!HGPhonator class methodsFor: 'sounds' stamp: 'TomohiroOda 10/17/2011 22:31'!
motorSound
	^ SoundBuffer
		fromArray:
			#(36 199 190 508 332 167 253 302 788 884 1233 1145 977 904 991 1371 1361 1495 1253 1346 1696 1454 1631 1784 1752 1826 1389 1234 1202 1152 1188 1000 1048 898 724 937 1145 1537 2023 2079 2371 2156 2098 1855 1843 2208 2126 2218 1664 1457 1389 1454 1481 1458 1661 1400 1548 1499 1949 2055 2130 2220 2038 1904 1750 1993 2114 2272 2418 2101 1976 1791 2161 2690 2958 3013 2888 2798 2792 2875 3207 3627 3732 3842 3791 3836 3964 4082 4351 4550 4755 4746 4851 5180 5507 6100 6491 6533 6133 5394 4627 3886 3133 2209 1073 -368 -1876 -3170 -4067 -4641 -4963 -5049 -4922 -4634 -4147 -3544 -2805 -1962 -1219 -592 -326 -374 -627 -901 -1075 -1159 -1252 -1312 -1444 -1397 -1338 -1142 -748 -541 -350 -314 -265 -143 52 464 653 927 1269 1617 2048 2365 2654 2924 3306 3669 3855 3799 3160 2372 1629 1289 1635 1841 1838 1557 987 630 557 857 1005 868 435 -309 -1083 -1765 -2025 -2055 -2219 -2388 -2409 -2438 -2314 -2002 -1687 -1477 -1533 -1641 -1878 -1885 -1776 -1580 -1005 -525 -164 -84 396 768 1160 1788 2219 2365 1836 1435 1097 988 1326 1423 2106 2191 1965 1829 1578 1835 1429 1570 1596 1301 1357 1233 1634 2386 2597 3037 3225 3406 3339 3049 2935 2611 2428 2340 2728 2621 2994 2599 2591 3010 3341 3922 3992 3824 2982 2128 1376 1455 1437 2022 1927 1730 1841 1832 2334 2942 3183 3124 3362 3342 3549 3322 3474 3686 4164 4550 4051 3701 2742 2656 3210 4011 4641 4416 3697 2998 3382 3715 3729 3687 3375 3521 3932 4273 4172 3970 3598 3675 4879 5887 6320 5794 4623 4179 4453 5626 6412 6353 5563 4689 4683 5058 5905 6270 6218 6134 5704 5297 4087 2627 1221 -181 -1351 -2616 -4341 -6598 -8702 -9888 -10087 -9286 -8357 -7568 -6878 -6063 -4839 -3540 -2281 -1176 -315 248 409 337 -353 -1326 -2135 -2392 -2324 -2288 -2486 -3272 -3618 -3573 -2804 -1503 -604 267 808 1389 2069 2643 3328 3964 4706 5502 6136 6163 5665 4956 4491 4507 4409 4042 3132 1996 998 330 -116 -475 -877 -1370 -1250 -1048 -851 -740 -1207 -1166 -1040 -395 405 441 342 -281 -763 -799 -774 -447 -319 -190 -120 115 182 91 207 387 959 1462 1811 1767 1335 972 730 979 1157 1338 1347 807 591 232 417 696 664 1406 1512 2065 2416 2374 2539 2395 2483 2677 2674 2585 2299 1134 320 -336 -65 676 743 538 16 -374 -515 138 463 1043 1533 1786 2332 2258 2566 2663 2961 3599 3498 3518 2952 2309 2045 1667 1571 1504 1213 1118 1029 874 843 710 977 1377 1816 2236 2114 1989 1698 1618 1672 1682 1602 1382 1044 689 364 55 -24 4 322 669 948 1148 1193 1280 1463 1873 2261 2578 2654 2543 2312 1976 1772 1738 1763 1855 1834 1664 1469 1312 1399 1484 1732 1880 2004 2124 2090 2056 2000 2048 2227 2464 2670 2721 2511 2234 2056 2081 2263 2522 2737 2768 2728 2693 2711 2768 2891 3068 3182 3126 2913 2545 2171 1950 1820 1765 1710 1538 1319 1020 764 600 538 607 742 808 710 517 307 162 62 17 -8 -205 -486 -858 -1288 -1581 -1720 -1795 -1834 -1863 -1906 -1966 -1895 -1855 -1651 -1350 -1049 -721 -464 -265 -65 75 189 306 412 472 458 374 222 113 101 178 309 481 568 576 516 497 582 724 844 964 914 774 662 509 472 576 610 572 554 517 605 785 1008 1312 1555 1786 1957 2044 2081 2118 2193 2264 2328 2335 2277 2205 2098 2002 1981 1982 2017 1972 1912 1788 1611 1519 1428 1393 1367 1209 1045 842 624 564 509 465 398 172 11 -157 -264 -259 -269 -248 -249 -222 -266 -355 -372 -288 -158 -55 1 71 91 102 228 420 619 798 829 930 1012 1047 1210 1359 1531 1676 1702 1787 1809 1729 1668 1653 1721 1808 1793 1747 1616 1485 1476 1516 1751 1961 2029 2057 2006 1955 1893 1904 1960 1967 1975 1934 1827 1814 1749 1809 1947 2037 2098 2067 1970 1754 1627 1667 1759 1904 1890 1819 1747 1644 1698 1746 1834 1959 1922 1887 1864 1712 1734 1770 1895 2029 2062 2153 2132 2203 2206 2202 2194 2075 2019 1889 1923 1930 2090 2250 2335 2372 2209 2085 1902 1805 1826 1843 1804 1761 1605 1580 1680 1713 1825 1904 2097 2269 2373 2384 2235 2351 2445 2530 2610 2560 2618 2511 2445 2374 2111 1959 1760 1602 1474 1208 1021 786 688 654 573 526 409 452 566 694 746 831 914 1008 1043 821 513 214 -45 -242 -453 -723 -898 -1103 -1078 -1081 -1087 -1015 -1073 -869 -884 -720 -555 -329 -24 -63 14 -96 5 260 412 636 623 611 785 788 1001 1025 989 1162 1215 1404 1408 1305 1311 1120 1076 956 785 740 371 389 164 202 522 478 770 483 259 250 79 497 987 1288 1453 1283 1350 1436 1441 1804 1861 2059 2156 1969 2142 2148 2384 2652 2470 2383 1883 1739 1618 1475 1523 1134 1167 1031 816 674 274 251 162 301 387 23 -176 -345 -333 -198 -356 -363 -444 -421 -192 -226 -230 -239 -326 10 106 195 132 95 202 79 -68 -222 -45 429 788 954 1256 1426 1521 1704 1729 2053 1867 1581 1434 1367 1554 1386 1221 1165 1253 1571 1394 1425 1390 948 1288 999 1421 1568 1292 1478 1019 1053 591 693 520 302 314 116 847 1340 1792 1883 1582 1474 1821 2140 2486 2651 2167 1728 1380 1345 1811 1993 2052 2325 2231 2148 2271 2450 2831 2866 2908 2721 2623 2252 2025 2393 2667 3015 2817 2668 2588 2540 2736 2761 3275 3232 3252 3168 3112 3284 3138 3458 3716 3876 3928 3824 3928 4040 4330 4923 5226 5205 5183 5172 5510 5926 6225 6306 6020 5433 4448 3261 2118 959 -239 -1741 -3208 -4507 -5623 -6134 -6133 -5617 -4931 -4192 -3378 -2817 -2219 -1588 -817 -110 199 281 -5 -417 -652 -749 -679 -890 -1261 -1549 -1905 -1928 -2002 -1885 -1552 -1185 -655 -235 222 793 1424 1992 2599 2940 3081 2982 2695 2667 2771 2919 2980 2662 2146 1537 1215 1217 1374 1337 1061 790 376 250 -97 -111 5 -149 -243 -733 -936 -1395 -1810 -1781 -1762 -1500 -1716 -2039 -2318 -2398 -1907 -1592 -1422 -1900 -2619 -3034 -3024 -2335 -1429 -557 323 1051 1587 2021 2282 2438 2207 1843 1789 1482 1392 1056 742 1220 1294 1464 1641 1731 1847 1291 1682 1970 2097 2253 1624 1474 1312 1312 1873 2315 2523 2486 2323 2385 2924 3638 4341 4431 4045 3644 2945 2939 2935 2867 3411 2886 2731 2211 1405 1001 640 1077 1430 1688 1803 1857 2036 2447 3394 3628 3702 3468 3361 3782 3668 3672 4050 3895 4188 4564 4217 3965 2693 1946 1878 2245 3152 3267 3120 2670 2675 3308 4567 5358 5556 5114 3953 3653 3658 4111 4688 4262 3819 3732 4224 4771 5579 5622 5585 5613 5501 5593 5452 5570 5632 6094 5985 5579 4982 4206 3878 3683 3274 2172 698 -1224 -2821 -3890 -4742 -5518 -6463 -7297 -7730 -8054 -7991 -7508 -6683 -5163 -3562 -2162 -1401 -1000 -650 -255 344 643 475 -347 -1530 -2545 -3189 -3506 -3525 -3563 -3239 -2710 -1975 -1174 -649 117 1250 2603 3929 4750 4920 4876 4692 4897 5263 5455 5008 4285 3535 2650 2480 2198 1908 1831 1412 1060 602 80 -281 -245 -37 518 694 559 449 134 264 395 501 454 294 14 -188 -258 -603 -471 -526 -212 202 413 643 447 674 1151 2015 2779 2830 2783 2349 2213 2223 1805 1467 750 640 762 709 685 202 48 360 1103 1707 1935 1604 992 986 883 1293 1285 840 880 25 72 -201 -568 -194 -266 416 698 748 1106 930 1391 2268 2672 3350 3207 3010 3183 2888 3077 3048 2737 2684 2102 1594 1047 146 -39 -397 -420 -237 -520 -465 -526 -247 398 929 1605 2176 2568 2979 3102 3165 3206 3205 3315 3167 2841 2330 1660 1172 909 881 992 1021 1063 1098 1184 1407 1681 1927 2245 2498 2652 2755 2740 2720 2600 2599 2547 2529 2425 2327 2216 1983 1798 1578 1501 1596 1707 1778 1775 1794 1832 1945 2157 2368 2534 2679 2726 2647 2546 2482 2500 2613 2715 2858 2909 2875 2798 2847 3002 3238 3544 3763 3906 3870 3762 3684 3570 3510 3375 3115 2665 2099 1534 1114 848 744 650 462 329 147 161 282 430 614 681 701 635 505 263 -31 -284 -523 -787 -1040 -1310 -1530 -1694 -1726 -1660 -1541 -1319 -1101 -872 -661 -468 -289 -53 235 439 581 607 542 488 496 442 476 539 528 480 404 353 383 409 514 643 801 911 1039 1099 1060 1002 1008 1079 1079 1088 1043 998 953 947 1077 1232 1417 1630 1737 1807 1861 1947 2139 2352 2521 2494 2388 2251 2163 2142 2183 2246 2312 2333 2215 2167 2080 1954 1856 1767 1725 1685 1560 1366 1157 915 754 677 570 434 268 50 -48 -106 -80 23 -6 3 -105 -143 -106 -86 -10 15 72 129 151 224 269 377 540 615 755 802 841 986 1126 1263 1430 1501 1565 1592 1629 1704 1769 1780 1815 1868 1875 1853 1767 1657 1676 1777 1954 2063 2033 2006 1997 2052 2132 2218 2192 2163 2068 1935 1832 1731 1692 1644 1603 1587 1656 1704 1735 1707 1693 1778 1855 1886 1808 1854 1866 2020 2082 2051 2063 1922 1994 2055 1979 1867 1654 1725 1958 2103 2250 2210 2181 2136 1990 1769 1538 1555 1690 1847 1927 1833 1861 1845 1916 1901 1878 1827 1965 2079 2011 1813 1442 1294 1314 1438 1527 1471 1351 1346 1433 1541 1742 1882 2055 2187 2137 2094 2026 2216 2547 2788 2910 2700 2476 2276 2271 2219 2140 2106 1948 1839 1563 1271 991 871 785 695 490 237 93 101 302 452 541 637 735 773 731 667 554 479 381 262 -30 -313 -571 -871 -940 -1094 -1156 -946 -946 -789 -822 -1016 -846 -729 -380 -130 -174 -291 -393 -459 -370 -385 -488 -235 -189 -29 66 20 251 506 931 1376 1399 1348 1192 940 1022 839 916 1173 1247 1303 1207 950 888 944 1151 1385 1216 1012 762 741 964 995 1072 1129 1201 1243 1189 1214 1209 1090 1188 1226 962 840 480 309 201 8 -27 -108 19 120 122 175 188 247 298 326 490 659 638 530 299 294 391 561 749 632 677 592 520 445 175 452 195 476 279 54 216 -444 -153 -497 -42 65 -76 89 -307 613 424 736 729 692 1203 923 1051 761 782 993 912 1361 971 671 640 713 1230 870 821 292 243 774 1172 1686 1286 1348 1303 1523 1622 1578 1833 1810 1913 1658 1535 1352 1375 1673 2156 2537 2408 2275 2078 2090 2117 2030 2120 2227 2296 2388 2667 2966 3152 3134 2987 2799 2665 2686 2666 2584 2637 2572 2631 2836 3106 3325 3066 2882 2869 3046 3325 3369 3339 3398 3350 3293 3457 3587 3759 3999 4191 4413 4437 4477 4519 4628 4905 5061 5239 5014 4922 5179 5616 6008 6053 5515 4650 3634 2615 2101 1403 430 -981 -2592 -4097 -5331 -6002 -6365 -6339 -5996 -5552 -4825 -4058 -3378 -2538 -1678 -858 -70 377 250 -342 -1019 -1354 -1355 -1196 -1361 -1521 -1624 -1862 -1561 -1109 -638 -510 -705 -845 -1026 -585 -35 768 1668 2308 2850 3002 3103 3216 3453 3876 4335 4501 4065 3249 2233 1669 1518 1717 1688 1115 370 -493 -662 -599 -225 85 -153 -466 -954 -1270 -1132 -935 -978 -1481 -2039 -2683 -3353 -3678 -3673 -3362 -2780 -2386 -2281 -2137 -2034 -1498 -801 -239 351 480 608 886 1176 1592 1788 2106 2205 2010 1893 1582 1539 1597 1795 1990 2158 2092 1255 800 1029 1404 1884 2085 1537 1103 919 870 2111 3220 3367 3480 2671 2319 2914 3620 4073 3498 2841 2067 1810 2225 2669 3168 2603 1347 499 729 1563 2063 1953 1175 432 458 1393 2521 3149 3279 2822 2467 2697 3005 3756 4386 4418 4555 3662 3241 3320 3520 3914 4087 3923 2896 2532 1732 1807 2221 2972 3933 3101 2464 1657 1615 2639 3948 4718 5026 4305 3909 3815 3811 4014 3853 4090 4153 4670 4783 4527 4113 4296 4866 5695 6258 6024 5748 5089 5020 5101 4974 4353 3499 2056 779 -738 -2628 -4028 -5515 -6213 -6815 -7376 -7953 -8558 -8565 -7680 -6158 -4573 -3152 -2390 -1579 -792 -128 414 470 360 165 -390 -1164 -2225 -3460 -4085 -4255 -3862 -3277 -2975 -2731 -2390 -1656 -387 1008 2146 3014 3428 3832 4526 4822 4875 4472 3941 3954 3945 3710 2856 1848 931 619 1054 1206 877 318 -270 -412 34 160 399 532 402 655 568 472 246 -92 356 716 776 540 -331 -730 -548 -242 338 202 -72 4 -6 637 885 1005 1330 1619 2174 2350 2069 1709 1412 1476 1747 1558 1230 711 321 398 293 313 92 81 454 659 806 581 346 351 585 870 851 436 -76 -479 -756 -907 -1190 -1414 -1586 -1628 -1483 -1389 -1238 -816 -177 556 1249 1735 2074 2385 2710 3065 3264 3285 3143 2928 2692 2297 1832 1387 1022 955 1088 1101 1028 872 870 1090 1475 1976 2316 2578 2716 2705 2557 2467 2367 2328 2364 2301 2073 1686 1366 1175 1116 1199 1196 1109 962 920 934 983 1051 1258 1536 1752 1836 1770 1680 1643 1800 1954 2082 2111 1986 1885 1813 1824 1898 2088 2236 2353 2399 2340 2255 2213 2244 2350 2365 2326 2266 2154 2072 2068 2093 2130 2223 2295 2394 2515 2449 2426 2527 2778 3021 3240 3286 3216 3108 3004 3042 3106 3147 2990 2690 2282 1902 1641 1457 1359 1172 825 473 189 106 166 377 569 634 551 403 364 415 437 366 107 -242 -524 -723 -824 -959 -1100 -1264 -1381 -1408 -1252 -1072 -932 -889 -819 -581 -341 -107 56 128 156 158 185 260 284 270 324 376 391 423 449 446 429 521 569 566 584 546 589 624 594 594 584 607 725 876 976 1004 1046 1082 1193 1341 1372 1434 1446 1409 1528 1618 1747 1911 1985 2090 2092 2110 2170 2230 2360 2411 2433 2402 2317 2280 2227 2126 2017 1878 1729 1564 1406 1237 1073 957 906 841 788 706 548 437 429 449 554 653 664 582 500 486 511 519 430 339 318 294 287 265 288 299 429 605 681 822 808 887 950 1042 1240 1348 1547 1638 1752 1787 1765 1864 1949 2025 2058 1990 1921 1818 1707 1755 1810 2007 2069 2017 1840 1623 1633 1646 1803 1962 2002 1985 1838 1694 1588 1493 1551 1685 1756 1784 1604 1458 1532 1660 1898 1986 1737 1551 1457 1665 1890 2078 2066 2082 2181 2156 2167 2174 2290 2341 2314 2302 2134 2114 2054 2020 2109 1974 1916 1841 1628 1718 1718 1860 1951 1774 1893 1745 1701 1769 1541 1733 1542 1509 1547 1370 1640 1572 1480 1679 1501 1747 1697 1748 1973 1763 1949 1795 2000 2185 2249 2600 2532 2713 2672 2558 2572 2506 2691 2760 2797 2680 2299 1992 1796 1558 1444 1055 663 489 6 -197 -508 -713 -632 -763 -579 -532 -472 -253 -174 -66 75 -39 72 208 312 339 87 16 -170 -198 -166 -227 -270 -498 -495 -406 -544 -569 -766 -656 -500 -344 -121 -161 -67 -60 97 96 47 31 -76 163 173 417 465 257 332 5 48 -14 -135 124 -51 17 -190 -361 -127 -23 352 410 491 632 489 608 746 1100 1463 1473 1668 1380 1289 1319 1575 1979 1935 1824 1385 1265 1351 1528 1675 1429 1018 548 133 -254 -466 -736 -796 -815 -994 -916 -948 -584 -366 -196 -132 -119 -108 -165 12 -235 -107 -353 -349 -579 -765 -953 -1235 -888 -764 -286 -769 -804 -787 -508 255 127 169 -177 -373 -111)! !

!HGPhonator class methodsFor: 'sounds' stamp: 'TomohiroOda 10/17/2011 22:46'!
whiteNoiseRate: aNumber length: anInteger
	| random noise |
	random := Random new.
	noise := Array new writeStream.
	anInteger timesRepeat: [noise nextPut: (random nextInt: 10000) - 5000].
	^ SampledSound samples: noise contents samplingRate: aNumber! !

HGAction subclass: #HGPositionNoise
	instanceVariableNames: 'randomBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGPositionNoise class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/24/2012 08:45'!
withBlock: aRandomBlock
	^ (self new)
		randomBlock: aRandomBlock;
		yourself! !

!HGPositionNoise methodsFor: 'simulating' stamp: 'TomohiroOda 5/24/2012 08:49'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle addPosition: randomBlock value by: 1.0.! !

!HGPositionNoise methodsFor: 'accessing' stamp: 'TomohiroOda 5/24/2012 08:46'!
randomBlock
	^ randomBlock! !

!HGPositionNoise methodsFor: 'accessing' stamp: 'TomohiroOda 5/24/2012 08:46'!
randomBlock: aBlock
	randomBlock := aBlock! !

HGAction subclass: #HGPressure
	instanceVariableNames: 'gasConstant kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-FluidDynamics'!

!HGPressure class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPressure class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPressure class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/31/2011 10:57'!
gasConstant: aNumber kernel: anHGKernel
	^ self new setGasConstant: aNumber kernel: anHGKernel! !

!HGPressure class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPressure methodsFor: 'simulating' stamp: 'TomohiroOda 7/1/2011 08:10'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| count |
	count := 0.0.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | count := (kernel r: distance) + count ].
	anHGParticle pressure: count * gasConstant! !

!HGPressure methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 11:18'!
gasConstant
	^gasConstant! !

!HGPressure methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 13:22'!
kernel
	^ kernel! !

!HGPressure methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 10:57'!
setGasConstant: aNumber kernel: anHGKernel
	gasConstant := aNumber.
	kernel := anHGKernel! !

HGAction subclass: #HGPressureInitialization
	instanceVariableNames: 'pressure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-FluidDynamics'!

!HGPressureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPressureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPressureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPressureInitialization class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/2/2011 09:40'!
with: aNumber
	^ self new setPressure: aNumber! !

!HGPressureInitialization methodsFor: 'simulating' stamp: 'TomohiroOda 6/2/2011 09:41'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle pressure: pressure! !

!HGPressureInitialization methodsFor: 'private' stamp: 'TomohiroOda 6/2/2011 09:40'!
setPressure: aNumber
	pressure := aNumber! !

HGAction subclass: #HGPressureRepulsion
	instanceVariableNames: 'kernel maxPressure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-FluidDynamics'!

!HGPressureRepulsion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPressureRepulsion class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPressureRepulsion class methodsFor: 'instance creation' stamp: 'TomohiroOda 12/29/2011 08:43'!
kernel: anHGKernel
	^ self kernel: anHGKernel maxPressure: Float infinity! !

!HGPressureRepulsion class methodsFor: 'instance creation' stamp: 'TomohiroOda 12/29/2011 08:42'!
kernel: anHGKernel maxPressure: aNumber
	^ self new setKernel: anHGKernel maxPressure: aNumber! !

!HGPressureRepulsion class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPressureRepulsion methodsFor: 'simulating' stamp: 'TomohiroOda 12/29/2011 08:44'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| f denominator position area |
	denominator := 0.0.
	f := anHGParticle force class zero.
	position := anHGParticle position.
	area := anHGParticle area.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | 
			| gradient factor |
			gradient := kernel r: distance.
			factor := neighbor mass * area * gradient.
			f add: (neighbor position unitVector: position) by: (neighbor pressure * factor min: maxPressure max: maxPressure negated).
			denominator := denominator + gradient ].
	denominator > 0.0
		ifTrue: [ 
			anHGParticle addForce: f by: 1.0 / denominator]! !

!HGPressureRepulsion methodsFor: 'accessing' stamp: 'TomohiroOda 2/7/2012 13:24'!
kernel
	^ kernel! !

!HGPressureRepulsion methodsFor: 'accessing' stamp: 'TomohiroOda 12/29/2011 08:42'!
maxPressure
	^ maxPressure! !

!HGPressureRepulsion methodsFor: 'accessing' stamp: 'TomohiroOda 12/29/2011 08:42'!
maxPressure: aNumber
	maxPressure := aNumber! !

!HGPressureRepulsion methodsFor: 'private' stamp: 'TomohiroOda 12/29/2011 08:43'!
setKernel: anHGKernel maxPressure: aNumber
	kernel := anHGKernel.
	maxPressure := aNumber! !

HGAction subclass: #HGPump
	instanceVariableNames: 'position v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGPump class methodsFor: 'instance creation' stamp: 'TomohiroOda 12/27/2011 14:12'!
v: anHG2dPoint at: anotherHG2dPoint
	^ (self new)
		v: anHG2dPoint;
		position: anotherHG2dPoint;
		yourself! !

!HGPump methodsFor: 'drawing' stamp: 'TomohiroOda 12/27/2011 14:32'!
draw: anHGSimulator on: aCanvas
	aCanvas frameOval: (self position asPoint - (10@10) extent: 20@20) color: Color black.
	aCanvas line: self position asPoint to: (self position + self v) asPoint width: 5 color: Color blue muchDarker! !

!HGPump methodsFor: 'simulating' stamp: 'TomohiroOda 12/27/2011 14:59'!
effectIn: anHGSimulator deltaT: aNumber
	(anHGSimulator addParticleAt: 0 @ 0 temperature: 400 mass: 300)
		velocity: v copy;
		position: self position copy;
		viscosity: 0.9.
	self draw: anHGSimulator on: anHGSimulator form getCanvas! !

!HGPump methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:08'!
position
	^ position! !

!HGPump methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:08'!
position: anObject
	position := anObject! !

!HGPump methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:08'!
v
	^ v! !

!HGPump methodsFor: 'accessing' stamp: 'TomohiroOda 12/27/2011 14:08'!
v: anObject
	v := anObject! !

HGAction subclass: #HGRandomPosition
	instanceVariableNames: 'origin corner random region'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGRandomPosition class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGRandomPosition class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGRandomPosition class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/5/2011 14:48'!
origin: aPoint corner: anotherPoint
	^ self origin: aPoint corner: anotherPoint region: nil! !

!HGRandomPosition class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/2/2011 10:31'!
origin: aPoint corner: anotherPoint region: anHG2dRegion
	^ self new setOrigin: (HG2dPoint fromPoint: aPoint) corner: (HG2dPoint fromPoint: anotherPoint) region: anHG2dRegion! !

!HGRandomPosition class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGRandomPosition methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 15:06'!
corner
	^corner! !

!HGRandomPosition methodsFor: 'simulating' stamp: 'TomohiroOda 7/5/2011 14:49'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	[ anHGParticle position: (origin class randomFrom: origin to: corner with: random) ]
		doWhileFalse: [ region isNil or: [ region contains: anHGParticle position ] ]! !

!HGRandomPosition methodsFor: 'initialize-release' stamp: 'TomohiroOda 5/25/2011 15:07'!
initialize
	super initialize.
	random := Random new! !

!HGRandomPosition methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 15:06'!
origin
	^origin! !

!HGRandomPosition methodsFor: 'accessing' stamp: 'TomohiroOda 7/5/2011 14:32'!
region
	^ region! !

!HGRandomPosition methodsFor: 'private' stamp: 'TomohiroOda 7/5/2011 14:32'!
setOrigin: anHGPoint corner: anotherHGPoint region: anHG2dRegion
	origin := anHGPoint.
	corner := anotherHGPoint.
	region := anHG2dRegion ! !

!HGRandomPosition methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 15:43'!
width: aNumber
	| delta |
	delta := aNumber - corner x + origin x.
	origin x: delta / -2.0 + origin x.
	corner x: delta / 2.0 + corner x.! !

HGAction subclass: #HGRecyclingBoundingBox
	instanceVariableNames: 'recyclingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGRecyclingBoundingBox class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/7/2012 07:20'!
recyclingBlock: aBlock
	^ (self new)
		recyclingBlock: aBlock;
		yourself! !

!HGRecyclingBoundingBox class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/7/2012 08:07'!
sprintAtHand
	^ self
		recyclingBlock: [ :simulator :particle | 
			particle velocity: HG2dPoint zero.
			particle
				position:
					(HG2dPoint fromPoint: (simulator random next - 0.5) @ (simulator random next * 2.0 - 1.8) * 40.0 + ActiveHand position - simulator position ) ]! !

!HGRecyclingBoundingBox methodsFor: 'simulating' stamp: 'TomohiroOda 6/7/2012 07:19'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| x0 y0 x1 y1 position velocity |
	x0 := anHGSimulator simulationOrigin x.
	y0 := anHGSimulator simulationOrigin y.
	x1 := anHGSimulator simulationCorner x.
	y1 := anHGSimulator simulationCorner y.
	position := anHGParticle position.
	velocity := anHGParticle velocity.
	(position x < x0 or: [ position x > x1 or: [ position y < y0 or: [ position y > y1 ] ] ])
		ifTrue: [ recyclingBlock value: anHGSimulator value: anHGParticle ]! !

!HGRecyclingBoundingBox methodsFor: 'accessing' stamp: 'TomohiroOda 6/7/2012 07:19'!
recyclingBlock
	^ recyclingBlock ! !

!HGRecyclingBoundingBox methodsFor: 'accessing' stamp: 'TomohiroOda 6/7/2012 07:19'!
recyclingBlock: aBlock
	recyclingBlock := aBlock! !

HGAction subclass: #HGSetupBindingElasticForce
	instanceVariableNames: 'maxDistance elasticForceAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGSetupBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSetupBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSetupBindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 11:37'!
on: anHGElasticForceAction within: aNumber
	^ (self new)
		elasticForceAction: anHGElasticForceAction;
		maxDistance: aNumber;
		yourself! !

!HGSetupBindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSetupBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/15/2011 10:10'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
! !

!HGSetupBindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 10/2/2011 10:43'!
effectIn: anHGSimulator deltaT: aNumber
	| particles triangulator kernel |
	particles := IdentityDictionary new.
	triangulator := HGTriangulator
		origin: anHGSimulator simulationOrigin
		corner: anHGSimulator simulationCorner
		step: 80.
	anHGSimulator
		particlesDo: [ :particle | 
			triangulator divideAt: particle position.
			particles at: particle position put: particle ].
	triangulator
		trianglesDo: [ :triangle | 
			| particle1 particle2 particle3 |
			particle1 := particles at: triangle vertex1 ifAbsent: [  ].
			particle2 := particles at: triangle vertex2 ifAbsent: [  ].
			particle3 := particles at: triangle vertex3 ifAbsent: [  ].
			(particle1 notNil and: [ particle2 notNil and: [ (particle1 position distance: particle2 position) < maxDistance ] ])
				ifTrue: [ elasticForceAction addBindingBetween: particle1 and: particle2 ].
			(particle2 notNil and: [ particle3 notNil and: [ (particle2 position distance: particle3 position) < maxDistance ] ])
				ifTrue: [ elasticForceAction addBindingBetween: particle2 and: particle3 ].
			(particle3 notNil and: [ particle1 notNil and: [ (particle3 position distance: particle1 position) < maxDistance ] ])
				ifTrue: [ elasticForceAction addBindingBetween: particle3 and: particle1 ] ]! !

!HGSetupBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 11:03'!
elasticForceAction
	^ elasticForceAction! !

!HGSetupBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 11:03'!
elasticForceAction: anHGElasticForceAction
	elasticForceAction := anHGElasticForceAction ! !

!HGSetupBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 11:38'!
maxDistance
	^ maxDistance! !

!HGSetupBindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 11:38'!
maxDistance: aNumber
	maxDistance := aNumber ! !

HGAction subclass: #HGSetupTrindingElasticForce
	instanceVariableNames: 'maxDistance elasticForceAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Elasticity'!

!HGSetupTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSetupTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSetupTrindingElasticForce class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 14:34'!
on: anHGElasticForceAction within: aNumber
	^ (self new)
		elasticForceAction: anHGElasticForceAction;
		maxDistance: aNumber;
		yourself! !

!HGSetupTrindingElasticForce class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSetupTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 7/15/2011 10:10'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	! !

!HGSetupTrindingElasticForce methodsFor: 'simulating' stamp: 'TomohiroOda 10/2/2011 10:43'!
effectIn: anHGSimulator deltaT: aNumber
	| particles triangulator kernel |
	particles := IdentityDictionary new.
	triangulator := HGTriangulator
		origin: anHGSimulator simulationOrigin
		corner: anHGSimulator simulationCorner
		step: 80.
	anHGSimulator
		particlesDo: [ :particle | 
			triangulator divideAt: particle position.
			particles at: particle position put: particle ].
	triangulator
		trianglesDo: [ :triangle | 
			| particle1 particle2 particle3 |
			particle1 := particles at: triangle vertex1 ifAbsent: [  ].
			particle2 := particles at: triangle vertex2 ifAbsent: [  ].
			particle3 := particles at: triangle vertex3 ifAbsent: [  ].
			(particle1 notNil
				and: [ 
					particle2 notNil
						and: [ 
							particle3 notNil
								and: [ 
									(particle1 position distance: particle2 position) < maxDistance
										and: [ 
											(particle2 position distance: particle3 position) < maxDistance
												and: [ (particle3 position distance: particle1 position) < maxDistance ] ] ] ] ])
				ifTrue: [ elasticForceAction addTrindingAmong: particle1 and: particle2 and: particle3 ] ]! !

!HGSetupTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:32'!
elasticForceAction
	^ elasticForceAction! !

!HGSetupTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:32'!
elasticForceAction: anHGElasticForceAction
	elasticForceAction := anHGElasticForceAction ! !

!HGSetupTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:32'!
maxDistance
	^ maxDistance! !

!HGSetupTrindingElasticForce methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 14:32'!
maxDistance: aNumber
	maxDistance := aNumber ! !

HGAction subclass: #HGSpeaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGSpeaker subclass: #HGStationaryPressureSpeaker
	instanceVariableNames: 'lastVelocity volumeScale minVolume maxVolume pitchScale minPitch maxPitch durationScale kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGStationaryPressureSpeaker class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/30/2012 19:47'!
kernel: anHGKernel
	^ self new kernel: anHGKernel ; yourself! !

!HGStationaryPressureSpeaker methodsFor: 'simulating' stamp: 'TomohiroOda 5/30/2012 20:21'!
effectIn: anHGSimulator deltaT: aNumber 
	| newPosition position sound pitch volume velocity denominator |
	newPosition := ActiveHand position.
	(anHGSimulator bounds containsPoint: newPosition)
		ifFalse: [^ self].
	position := HG2dPoint fromPoint: newPosition - anHGSimulator bounds origin.
	velocity := anHGSimulator countAt: position kernel: kernel.
	volume := (lastVelocity - velocity) abs * volumeScale min: maxVolume max: minVolume.
	pitch :=  (lastVelocity - velocity) abs * pitchScale min: maxPitch max: minPitch.
	lastVelocity := velocity.
	sound := FMSound new.
	sound
		setPitch: pitch
		dur: aNumber * durationScale
		loudness: volume.
	sound play! !

!HGStationaryPressureSpeaker methodsFor: 'initialize-release' stamp: 'TomohiroOda 5/30/2012 20:25'!
initialize
	super initialize.
	lastVelocity := 0.0.
	volumeScale := 0.3.
	minVolume := 0.0.
	maxVolume := 0.2.
	pitchScale := 0.0.
	minPitch := 100.0.
	maxPitch := 1000.0.
	durationScale := 100.0 / 1000.0! !

!HGStationaryPressureSpeaker methodsFor: 'accessing' stamp: 'TomohiroOda 5/30/2012 19:46'!
kernel
	^ kernel! !

!HGStationaryPressureSpeaker methodsFor: 'accessing' stamp: 'TomohiroOda 5/30/2012 19:46'!
kernel: anHGKernel
	 kernel := anHGKernel! !

!HGStationaryPressureSpeaker methodsFor: 'simulating' stamp: 'TomohiroOda 5/30/2012 20:12'!
oldeffectIn: anHGSimulator deltaT: aNumber 
	| newPosition position sound pitch volume velocity denominator |
	newPosition := ActiveHand position.
	(anHGSimulator bounds containsPoint: newPosition)
		ifFalse: [^ self].
	position := HG2dPoint fromPoint: newPosition - anHGSimulator bounds origin.
	velocity := HG2dPoint zero.
	denominator := 0.0.
	anHGSimulator
		neighborsOf: position
		within: kernel support
		do: [:neighbor :distance | 
			| r |
			r := kernel r: distance.
			velocity add: neighbor velocity by: r.
			denominator := denominator + r].
	denominator > 0.0
		ifTrue: [velocity := velocity / denominator].
	volume := (lastVelocity - velocity) r * volumeScale min: maxVolume max: minVolume.
	pitch := (lastVelocity - velocity) r * pitchScale min: maxPitch max: minPitch.
	lastVelocity := HG2dPoint fromPoint: velocity.
	Transcript cr; show: 'p:', pitch printString, ' v:', volume printString.
	sound := FMSound new.
	sound
		setPitch: pitch
		dur: aNumber * durationScale
		loudness: volume.
	sound play! !

!HGStationaryPressureSpeaker methodsFor: 'initialize-release' stamp: 'TomohiroOda 5/30/2012 20:16'!
oldinitialize
	super initialize.
	lastVelocity := HG2dPoint zero.
	volumeScale := 0.01.
	minVolume := 0.0.
	maxVolume := 0.2.
	pitchScale := 0.0.
	minPitch := 100.0.
	maxPitch := 1000.0.
	durationScale := 200.0 / 1000.0! !

HGAction subclass: #HGTemperatureInitialization
	instanceVariableNames: 'temperature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Thermal'!

!HGTemperatureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTemperatureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTemperatureInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTemperatureInitialization class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/30/2011 09:00'!
with: aNumber
	^ self new setTemperature: aNumber  ! !

!HGTemperatureInitialization methodsFor: 'simulating' stamp: 'TomohiroOda 5/30/2011 09:00'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle temperature: temperature! !

!HGTemperatureInitialization methodsFor: 'private' stamp: 'TomohiroOda 5/30/2011 08:59'!
setTemperature: aNumber
	temperature := aNumber! !

HGAction subclass: #HGTemperatureViscosityCurve
	instanceVariableNames: 'curve'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Thermal'!

!HGTemperatureViscosityCurve class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTemperatureViscosityCurve class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTemperatureViscosityCurve class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/31/2011 09:12'!
butter
	^ self on: self butterCurve! !

!HGTemperatureViscosityCurve class methodsFor: 'constants' stamp: 'TomohiroOda 7/6/2011 11:52'!
butterCurve
	^ [ :temperature | ((-0.03 * temperature + 13) * 2.302585092994046) exp ]! !

!HGTemperatureViscosityCurve class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 09:44'!
normalizedButter
	^ self on: self normalizedButterCurve! !

!HGTemperatureViscosityCurve class methodsFor: 'constants' stamp: 'TomohiroOda 10/12/2011 09:41'!
normalizedButterCurve
	^ [ :temperature | 1.0 / (temperature - 230.0 / 50.0 max: 1.0) ]! !

!HGTemperatureViscosityCurve class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/31/2011 09:11'!
on: aBlock
	^ self new setCurve: aBlock! !

!HGTemperatureViscosityCurve class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTemperatureViscosityCurve methodsFor: 'simulating' stamp: 'TomohiroOda 5/31/2011 09:10'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle viscosity: (curve value: anHGParticle temperature)! !

!HGTemperatureViscosityCurve methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 09:10'!
setCurve: aBlock
	curve := aBlock! !

HGAction subclass: #HGTriggerAction
	instanceVariableNames: 'action conditionBlock oneShot loaded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGTriggerAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTriggerAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTriggerAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTriggerAction class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/4/2011 14:53'!
when: conditionBlock action: anHGAction
	^ (self new)
		conditionBlock: conditionBlock;
		action: anHGAction;
		oneShot: true;
		yourself! !

!HGTriggerAction class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/4/2011 14:54'!
whenever: conditionBlock action: anHGAction
	^ (self new)
		conditionBlock: conditionBlock;
		action: anHGAction;
		oneShot: false;
		yourself! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:40'!
action
	^ action! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:40'!
action: anHGAction
	action := anHGAction! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:47'!
conditionBlock
	^ conditionBlock ! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:47'!
conditionBlock: aBlock
	conditionBlock := aBlock! !

!HGTriggerAction methodsFor: 'simulating' stamp: 'TomohiroOda 8/4/2011 14:52'!
effectIn: anHGSimulator deltaT: aNumber
	(loaded = true and: conditionBlock)
		ifTrue: [ 
			action effectIn: anHGSimulator deltaT: aNumber.
			oneShot = true
				ifTrue: [ self unload ] ]! !

!HGTriggerAction methodsFor: 'initialize-release' stamp: 'TomohiroOda 8/4/2011 14:54'!
initialize
	self load! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:51'!
load
	self loaded: true! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:51'!
loaded
	^ loaded! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:51'!
loaded: aBoolean
	loaded := aBoolean = true! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:54'!
oneShot
	^ oneShot ! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:54'!
oneShot: aBoolean
	oneShot := aBoolean! !

!HGTriggerAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/4/2011 14:52'!
unload
	self loaded: false! !

HGAction subclass: #HGTriggerBlockAction
	instanceVariableNames: 'actionBlock conditionBlock oneShot loaded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGTriggerBlockAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTriggerBlockAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTriggerBlockAction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTriggerBlockAction class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/10/2011 11:06'!
when: conditionBlock do: aBlock
	^ (self new)
		conditionBlock: conditionBlock;
		actionBlock: aBlock;
		oneShot: true;
		load;
		yourself! !

!HGTriggerBlockAction class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/11/2011 11:48'!
whenever: conditionBlock do: aBlock
	^ (self new)
		conditionBlock: conditionBlock;
		actionBlock: aBlock;
		oneShot: false;
		load;
		yourself! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:58'!
actionBlock
	^ actionBlock! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
actionBlock: aBlock
	actionBlock := aBlock! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
conditionBlock
	^ conditionBlock ! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
conditionBlock: aBlock
	conditionBlock := aBlock! !

!HGTriggerBlockAction methodsFor: 'simulating' stamp: 'TomohiroOda 8/10/2011 11:00'!
effectIn: anHGSimulator deltaT: aNumber
	(loaded = true and: conditionBlock)
		ifTrue: [ 
			actionBlock value.
			oneShot = true
				ifTrue: [ self unload ] ]! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
load
	self loaded: true! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
loaded
	^ loaded! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
loaded: aBoolean
	loaded := aBoolean = true! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
oneShot
	^ oneShot ! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 10:59'!
oneShot: aBoolean
	oneShot := aBoolean! !

!HGTriggerBlockAction methodsFor: 'accessing' stamp: 'TomohiroOda 8/10/2011 11:08'!
unload
	self loaded: false! !

HGAction subclass: #HGVelocityDumper
	instanceVariableNames: 'dumpRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGVelocityDumper class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGVelocityDumper class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGVelocityDumper class methodsFor: 'instance creation' stamp: 'TomohiroOda 8/9/2011 14:15'!
rate: aNumber
	^ (self new)
		dumpRate: aNumber;
		yourself! !

!HGVelocityDumper class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGVelocityDumper methodsFor: 'accessing' stamp: 'TomohiroOda 8/9/2011 14:13'!
dumpRate 
	^ dumpRate ! !

!HGVelocityDumper methodsFor: 'accessing' stamp: 'TomohiroOda 8/9/2011 14:13'!
dumpRate: aNumber
	dumpRate := aNumber ! !

!HGVelocityDumper methodsFor: 'simulating' stamp: 'TomohiroOda 8/9/2011 14:14'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle velocity: anHGParticle velocity * (dumpRate raisedTo: aNumber)! !

HGAction subclass: #HGVelocityInitialization
	instanceVariableNames: 'velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGVelocityInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGVelocityInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGVelocityInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGVelocityInitialization class methodsFor: 'instance reation' stamp: 'TomohiroOda 5/26/2011 10:13'!
with: anHGPoint
	^ self new setVelocity: anHGPoint ! !

!HGVelocityInitialization methodsFor: 'simulating' stamp: 'TomohiroOda 5/25/2011 13:12'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle velocity: velocity copy! !

!HGVelocityInitialization methodsFor: 'private' stamp: 'TomohiroOda 5/25/2011 13:14'!
setVelocity: anHGPoint
	velocity := anHGPoint! !

HGAction subclass: #HGVelocityIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Mechanics'!

!HGVelocityIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGVelocityIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGVelocityIntegration class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGVelocityIntegration methodsFor: 'simulating' stamp: 'TomohiroOda 5/26/2011 10:38'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle addPosition: anHGParticle velocity by: aNumber! !

HGAction subclass: #HGViscosityBySmoothing
	instanceVariableNames: 'kernel changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-FluidDynamics'!

!HGViscosityBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGViscosityBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGViscosityBySmoothing class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/17/2011 18:00'!
kernel: anHGKernel
	^ (self new)
		kernel: anHGKernel;
		yourself! !

!HGViscosityBySmoothing class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGViscosityBySmoothing methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 11:14'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| denominator velocity |
	denominator := 0.0.
	velocity := anHGParticle force class zero.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | 
			neighbor ~~ anHGParticle
				ifTrue: [ 
					| gradient |
					gradient := (kernel r: distance) * neighbor viscosity.
					velocity add: neighbor velocity by: gradient.
					denominator := denominator + gradient ] ].
	denominator > 0.0
		ifTrue: [ 
			| viscosity |
			viscosity := anHGParticle viscosity.
			velocity mul: viscosity / denominator.
			velocity add: anHGParticle velocity by: 1.0 - viscosity.
			changes add: anHGParticle -> velocity ]! !

!HGViscosityBySmoothing methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 09:21'!
effectIn: anHGSimulator deltaT: aNumber
	changes := OrderedCollection new: anHGSimulator numberOfParticles.
	super effectIn: anHGSimulator deltaT: aNumber.
	changes do: [ :atomic | atomic key velocity: atomic value ].
	changes := nil! !

!HGViscosityBySmoothing methodsFor: 'simulating' stamp: 'TomohiroOda 2/13/2012 15:01'!
kernel
	^ kernel! !

!HGViscosityBySmoothing methodsFor: 'private' stamp: 'TomohiroOda 10/17/2011 17:37'!
kernel: anHGKernel
	kernel := anHGKernel! !

HGAction subclass: #HGViscosityInitialization
	instanceVariableNames: 'viscosity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Thermal'!

!HGViscosityInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGViscosityInitialization class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGViscosityInitialization class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/19/2011 16:05'!
with: aNumber
	^ (self new)
		viscosity: aNumber;
		yourself! !

!HGViscosityInitialization methodsFor: 'simulating' stamp: 'TomohiroOda 10/19/2011 16:00'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	anHGParticle viscosity: viscosity! !

!HGViscosityInitialization methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 15:59'!
viscosity
	^ viscosity! !

!HGViscosityInitialization methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 15:59'!
viscosity: aNumber
	viscosity := aNumber! !

HGAction subclass: #HGViscosityTraction
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-FluidDynamics'!

!HGViscosityTraction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGViscosityTraction class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGViscosityTraction class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 09:34'!
kernel: anHGKernel
	^ (self new)
		setKernel: anHGKernel;
		yourself! !

!HGViscosityTraction class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGViscosityTraction methodsFor: 'simulating' stamp: 'TomohiroOda 10/12/2011 11:13'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| f denominator area viscosity velocity |
	denominator := 0.0.
	f := anHGParticle force class zero.
	area := anHGParticle area.
	viscosity := anHGParticle viscosity.
	velocity := anHGParticle velocity.
	anHGSimulator
		neighborsOf: anHGParticle position
		within: kernel support
		do: [ :neighbor :distance | 
			neighbor ~~ anHGParticle
				ifTrue: [ 
					| gradient |
					gradient := kernel r: distance.
					f
						add: neighbor velocity
						minus: velocity
						by: ((viscosity + neighbor viscosity) / (distance + 1.0e-8) * area min: anHGParticle mass / aNumber) * gradient.
					denominator := denominator + gradient ] ].
	denominator = 0.0
		ifTrue: [ denominator := 1.0 ].
	anHGParticle addForce: f over: denominator! !

!HGViscosityTraction methodsFor: 'private' stamp: 'TomohiroOda 5/31/2011 11:22'!
setKernel: anHGKernel
	kernel := anHGKernel! !

HGAction subclass: #HGVisualizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGVisualizer subclass: #HGAbstractBorderlinePressureVisualizer
	instanceVariableNames: 'pressure kernel xgrids ygrids marchingSquares'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/4/2011 08:57'!
bottom: args
	| leftBottomValue left |
	leftBottomValue := (args at: 3) abs asFloat.
	left := args at: 5.
	^ (leftBottomValue / (leftBottomValue + (args at: 4) abs) * ((args at: 6) - left) + left) @ (args at: 8)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 11/3/2011 18:34'!
draw: anHGSimulator on: aCanvas
	| simulationOrigin simulationCorner pressureArrayBlock upperPressures xstep ystep args |
	simulationOrigin := anHGSimulator simulationOrigin.
	simulationCorner := anHGSimulator simulationCorner.
	xstep := (simulationCorner x - simulationOrigin x) / (xgrids-1) asFloat.
	ystep := (simulationCorner y - simulationOrigin y) / (ygrids-1) asFloat.
	pressureArrayBlock := [ :yIndex | 
	| y |
	y := ystep / 2.0 + (ystep * yIndex) + simulationOrigin y.
	(0 to: xgrids - 1)
		collect: [ :xIndex | 
			| x p denominator |
			x := xstep / 2.0 + (xstep * xIndex) + simulationOrigin x.
			p := 0.0.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: (HG2dPoint x: x y: y)
				within: kernel support
				do: [ :neighbor :distance | 
					| r |
					r := kernel r: distance.
					p := neighbor pressure * r + p.
					denominator := denominator + r ].
			(denominator > 0.0
				ifTrue: [ p / denominator ]
				ifFalse: [ p ]) - pressure ] ].
	args := Array new: 9.
	args at: 9 put: aCanvas.
	upperPressures := pressureArrayBlock value: 0.
	1 to: ygrids - 1 do: [ :yIndex | 
		| lowerPressures y |
		lowerPressures := pressureArrayBlock value: yIndex.
		y := ystep * (yIndex - 1) + simulationOrigin y.
		1 to: xgrids - 1 do: [ :xIndex | 
			| leftTop rightTop leftBottom rightBottom squareIndex |
			leftTop := upperPressures at: xIndex.
			rightTop := upperPressures at: xIndex + 1.
			leftBottom := lowerPressures at: xIndex.
			rightBottom := lowerPressures at: xIndex + 1.
			squareIndex := self
				indexFor: leftTop
				and: rightTop
				and: leftBottom
				and: rightBottom.
			squareIndex > 0
				ifTrue: [ 
					| x |
					x := xstep * (xIndex - 1) + simulationOrigin x.
					args at: 1 put: leftTop.
					args at: 2 put: rightTop.
					args at: 3 put: leftBottom.
					args at: 4 put: rightBottom.
					args at: 5 put: x rounded.
					args at: 6 put: (x + xstep) rounded.
					args at: 7 put: y rounded.
					args at: 8 put: (y + ystep) rounded.
					(marchingSquares at: squareIndex) value: args ] ].
		upperPressures := lowerPressures ]! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/3/2011 18:00'!
indexFor: leftTop and: rightTop and: leftBottom and: rightBottom
	^ (leftTop > 0.0
		ifTrue: [ 1 ]
		ifFalse: [ 0 ])
		+
			(rightTop > 0.0
				ifTrue: [ 2 ]
				ifFalse: [ 0 ])
		+
			(leftBottom > 0.0
				ifTrue: [ 4 ]
				ifFalse: [ 0 ])
		+
			(rightBottom > 0.0
				ifTrue: [ 8 ]
				ifFalse: [ 0 ])! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 11/3/2011 18:04'!
initialize
	super initialize.
	marchingSquares := Array new: 2r1111.
	self initialize0001to0111.
	self initialize1000to1111! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
kernel
	^ kernel! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
kernel: anHGKernel
	kernel := anHGKernel! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/4/2011 08:57'!
left: args
	| leftTopValue top |
	leftTopValue := (args at: 1) abs asFloat.
	top := args at: 7.
	^ (args at: 5) @ (leftTopValue / (leftTopValue + (args at: 3) abs) * ((args at: 8) - top) + top)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/3/2011 18:00'!
leftBottom: args
	^ (args at: 5) @ (args at: 8)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/3/2011 18:00'!
leftTop: args
	^ (args at: 5) @ (args at: 7)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
pressure
	^ pressure! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
pressure: aNumber
	pressure := aNumber! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/4/2011 08:58'!
right: args
	| rightTopValue top |
	rightTopValue := (args at: 2) abs asFloat.
	top := args at: 7.
	^ (args at: 6) @ (rightTopValue / (rightTopValue + (args at: 4) abs) * ((args at: 8) - top) + top)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/3/2011 18:00'!
rightBottom: args
	^ (args at: 6) @ (args at: 8)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/3/2011 18:00'!
rightTop: args
	^ (args at: 6) @ (args at: 7)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'private' stamp: 'TomohiroOda 11/4/2011 08:58'!
top: args
	| leftTopValue left |
	leftTopValue := (args at: 1) abs asFloat.
	left := args at: 5.
	^ (leftTopValue / (leftTopValue + (args at: 2) abs) * ((args at: 6) - left) + left) @ (args at: 7)! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
xgrids
	^ xgrids! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
xgrids: aNumber
	xgrids := aNumber! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
ygrids
	^ ygrids! !

!HGAbstractBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 17:55'!
ygrids: aNumber
	ygrids := aNumber! !

HGAbstractBorderlinePressureVisualizer subclass: #HGBorderlineFillPressureVisualizer
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGBorderlineFillPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/4/2011 09:05'!
pressure: pressure color: aColor
	^ self
		pressure: pressure
		xgrids: 40
		ygrids: 40
		kernel: (HGSimpleKernel support: 30)
		color: aColor! !

!HGBorderlineFillPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 18:31'!
pressure: pressure xgrids: xgrids ygrids: ygrids kernel: kernel color: aColor
	^ self new
		pressure: pressure;
		xgrids: xgrids;
		ygrids: ygrids;
		kernel: kernel;
		color: aColor;
		yourself! !

!HGBorderlineFillPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:04'!
color
	^ color! !

!HGBorderlineFillPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:04'!
color: aColor
	color := aColor! !

!HGBorderlineFillPressureVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 11/3/2011 18:36'!
initialize0001to0111
	marchingSquares
		at: 2r0001
		put: [ :args | 
			(args at: 9)
				drawPolygon: (Array with: (self leftTop: args) with: (self top: args) with: (self left: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0010
		put: [ :args | 
			(args at: 9)
				drawPolygon: (Array with: (self rightTop: args) with: (self right: args) with: (self top: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0011
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self rightTop: args)
						with: (self right: args)
						with: (self left: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0100
		put: [ :args | 
			(args at: 9)
				drawPolygon: (Array with: (self leftBottom: args) with: (self left: args) with: (self bottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0101
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self top: args)
						with: (self bottom: args)
						with: (self leftBottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0110
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self rightTop: args)
						with: (self right: args)
						with: (self bottom: args)
						with: (self leftBottom: args)
						with: (self left: args)
						with: (self top: args))
				fillStyle: color ].
	marchingSquares
		at: 2r0111
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self rightTop: args)
						with: (self right: args)
						with: (self bottom: args)
						with: (self leftBottom: args))
				fillStyle: color ]! !

!HGBorderlineFillPressureVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 11/3/2011 18:39'!
initialize1000to1111
	marchingSquares
		at: 2r1000
		put: [ :args | 
			(args at: 9)
				drawPolygon: (Array with: (self right: args) with: (self rightBottom: args) with: (self bottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1001
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self top: args)
						with: (self right: args)
						with: (self rightBottom: args)
						with: (self bottom: args)
						with: (self left: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1010
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self top: args)
						with: (self rightTop: args)
						with: (self rightBottom: args)
						with: (self bottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1011
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self rightTop: args)
						with: (self rightBottom: args)
						with: (self bottom: args)
						with: (self left: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1100
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self left: args)
						with: (self right: args)
						with: (self rightBottom: args)
						with: (self leftBottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1101
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self leftTop: args)
						with: (self top: args)
						with: (self right: args)
						with: (self rightBottom: args)
						with: (self leftBottom: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1110
		put: [ :args | 
			(args at: 9)
				drawPolygon:
					(Array
						with: (self top: args)
						with: (self rightTop: args)
						with: (self rightBottom: args)
						with: (self leftBottom: args)
						with: (self left: args))
				fillStyle: color ].
	marchingSquares
		at: 2r1111
		put: [ :args | (args at: 9) fillRectangle: ((self leftTop: args) corner: (self rightBottom: args)) color: color ]! !

HGAbstractBorderlinePressureVisualizer subclass: #HGBorderlinePressureVisualizer
	instanceVariableNames: 'width color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGBorderlinePressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/4/2011 09:06'!
pressure: pressure width: width color: aColor
	^ self
		pressure: pressure
		xgrids: 40
		ygrids: 40
		kernel: (HGSimpleKernel support: 30)
		width: width
		color: aColor! !

!HGBorderlinePressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 18:01'!
pressure: pressure xgrids: xgrids ygrids: ygrids kernel: kernel width: width color: aColor
	^ self new
		pressure: pressure;
		xgrids: xgrids;
		ygrids: ygrids;
		kernel: kernel;
		width: width;
		color: aColor;
		yourself! !

!HGBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:01'!
color
	^ color! !

!HGBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:01'!
color: aColor
	color := aColor! !

!HGBorderlinePressureVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 11/3/2011 18:25'!
initialize0001to0111
	marchingSquares
		at: 2r0001
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self top: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0010
		put: [ :args | 
			(args at: 9)
				line: (self right: args)
				to: (self top: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0011
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self right: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0100
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0101
		put: [ :args | 
			(args at: 9)
				line: (self top: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0110
		put: [ :args | 
			(args at: 9)
				line: (self top: args)
				to: (self left: args)
				width: width
				color: color.
			(args at: 9)
				line: (self right: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r0111
		put: [ :args | 
			(args at: 9)
				line: (self right: args)
				to: (self bottom: args)
				width: width
				color: color ]! !

!HGBorderlinePressureVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 11/3/2011 18:29'!
initialize1000to1111
	marchingSquares
		at: 2r1000
		put: [ :args | 
			(args at: 9)
				line: (self right: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1001
		put: [ :args | 
			(args at: 9)
				line: (self top: args)
				to: (self right: args)
				width: width
				color: color.
			(args at: 9)
				line: (self left: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1010
		put: [ :args | 
			(args at: 9)
				line: (self top: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1011
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self bottom: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1100
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self right: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1101
		put: [ :args | 
			(args at: 9)
				line: (self top: args)
				to: (self right: args)
				width: width
				color: color ].
	marchingSquares
		at: 2r1110
		put: [ :args | 
			(args at: 9)
				line: (self left: args)
				to: (self top: args)
				width: width
				color: color ].
	marchingSquares at: 2r1111 put: [ :args |  ]! !

!HGBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:00'!
width
	^ width! !

!HGBorderlinePressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 11/3/2011 18:00'!
width: aNumber
	width := aNumber! !

HGVisualizer subclass: #HGBackgroundImageVisualizer
	instanceVariableNames: 'form offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGBackgroundImageVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGBackgroundImageVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGBackgroundImageVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/19/2011 10:22'!
form: aForm
	^ self form: aForm offset: 0@0! !

!HGBackgroundImageVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/19/2011 10:22'!
form: aForm offset: aPoint
	^ (self new)
		form: aForm;
		offset: aPoint;
		yourself! !

!HGBackgroundImageVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/19/2011 10:21'!
draw: anHGSimulator on: aCanvas
	aCanvas drawImage: form at: 0@0 sourceRect: (offset extent: anHGSimulator extent)! !

!HGBackgroundImageVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 10:20'!
form
	^ form! !

!HGBackgroundImageVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 10:20'!
form: aForm
	form := aForm! !

!HGBackgroundImageVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 10:21'!
offset
	^ offset! !

!HGBackgroundImageVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/19/2011 10:22'!
offset: aPoint
	offset := aPoint asPoint! !

HGVisualizer subclass: #HGDotVisualizer
	instanceVariableNames: 'radius color particleIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGDotVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGDotVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGDotVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/29/2011 14:45'!
at: anInteger radius: aNumber color: aColor
	^ (self basicNew)
		particleIndex: anInteger;
		radius: aNumber;
		color: aColor;
		yourself! !

!HGDotVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:38'!
color
	^ color! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:38'!
color: aColor
	color := aColor! !

!HGDotVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 7/14/2011 10:12'!
draw: anHGSimulator on: aCanvas
	self
		in: anHGSimulator
		particlesDo: [ :particle | 
			| p form |
			p := particle position.
			p ifNotNil: [ aCanvas fillOval: ((p x - radius) @ (p y - radius) extent: 2 @ 2 * radius) color: color ] ]! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/14/2011 10:13'!
in: anHGSimulator particlesDo: aBlock
	(anHGSimulator particleAt: particleIndex) ifNotNilDo: aBlock! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:40'!
particleIndex
	^ particleIndex! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:40'!
particleIndex: anInteger
	particleIndex := anInteger! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:38'!
radius
	^radius ! !

!HGDotVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 14:39'!
radius: aNumber
	radius := aNumber! !

HGVisualizer subclass: #HGDotsVisualizer
	instanceVariableNames: 'radius color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:25'!
dot
	^ self radius: 0.5 color: Color black! !

!HGDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:21'!
new
	^ self dot! !

!HGDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:24'!
radius: aNumber color: aColor
	^ (self basicNew)
		radius: aNumber;
		color: aColor;
		yourself! !

!HGDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:24'!
color
	^ color! !

!HGDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:24'!
color: aColor
	color := aColor! !

!HGDotsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 1/23/2012 17:21'!
draw: anHGSimulator on: aCanvas
	anHGSimulator
		particlesDo: [ :particle | 
			| p form |
			p := particle position.
			p ifNotNil: [ | r |
				r := particle at: #radius ifAbsent: [radius].
				 aCanvas fillOval: ((p x - r) @ (p y - r) extent: 2 @ 2 * r) color: color ] ]! !

!HGDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:20'!
radius
	^ radius! !

!HGDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:20'!
radius: aNumber
	radius := aNumber! !

HGDotsVisualizer subclass: #HGMassDotsVisualizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGMassDotsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/6/2012 08:19'!
draw: anHGSimulator on: aCanvas
	anHGSimulator
		particlesDo: [ :particle | 
			| p form |
			p := particle position.
			p ifNotNil: [ | r |
				r := particle mass * radius.
				 aCanvas fillOval: ((p x - r) @ (p y - r) extent: 2 @ 2 * r) color: color ] ]! !

HGVisualizer subclass: #HGDynamicDotsVisualizer
	instanceVariableNames: 'radiusBlock colorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGDynamicDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
LICENSE
	^ self MITLicense! !

!HGDynamicDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGDynamicDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/14/2011 09:12'!
radius: radiusBlock color: colorBlock
	^ (self new)
		radiusBlock: radiusBlock;
		colorBlock: colorBlock;
		yourself! !

!HGDynamicDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 09:09'!
colorBlock
	^ colorBlock! !

!HGDynamicDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 09:09'!
colorBlock: aBlock
	colorBlock := aBlock! !

!HGDynamicDotsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/14/2011 09:11'!
draw: anHGSimulator on: aCanvas
	anHGSimulator
		particlesDo: [ :particle | 
			| p |
			p := particle position.
			p
				ifNotNil: [ 
					| radius color |
					radius := radiusBlock value: anHGSimulator value: particle.
					color := colorBlock value: anHGSimulator value: particle.
					aCanvas fillOval: ((p x - radius) @ (p y - radius) extent: 2 @ 2 * radius) color: color ] ]! !

!HGDynamicDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 09:08'!
radiusBlock
	^ radiusBlock! !

!HGDynamicDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/14/2011 09:09'!
radiusBlock: aBlock
	radiusBlock := aBlock! !

HGVisualizer subclass: #HGFormVisualizer
	instanceVariableNames: 'formBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGFormVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGFormVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/3/2011 11:11'!
capuccino
	^ self
		from:
			(Array
				with:
					(
(Form
	extent: 32@32
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)))! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 14:49'!
chromeball
	| form |
	form :=  Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 9013641 0 0 25988236 378243979 1586269324 2811203471 3683750289 4270952849 4287730065 4203843985 3096547729 2207157902 932023693 9474192 9145227 0 0 8947848 0 0 0 0 8684676 0 8750469 495684491 2123140236 4102983310 4287927444 4288453788 4288980132 4289243304 4272597674 4289243304 4288782753 4288322202 4287861651 3230568078 1082952844 92768135 0 0 8882055 0 0 8289918 0 25593478 1350993542 3549072010 4287730065 4288585374 4273058225 4290953922 4291809231 4292203989 4292269782 4292072403 4291414473 4273650362 4289243304 4288190616 4220423822 2357823881 411535239 0 0 8289918 7763574 0 42304901 1719697536 4035282309 4287664272 4272202916 4273913534 4292335575 4293585642 4294111986 4294375158 4294375158 4294243572 4293914607 4293059298 4291611852 4273058225 4288322202 4287335307 2877588612 495026561 0 0 0 24409204 1282963576 4118773631 4287335307 4271873951 4290427578 4292401368 4293980400 4294704123 4294901502 4294901502 4294901502 4294901502 4294835709 4294440951 4293322470 4291480266 4272729260 4288059030 4287006342 2809953404 209024373 0 0 292778867 3765925751 4286874756 4271281814 4289506476 4291217094 4293059298 4294309365 4294835709 4294967295 4294967295 4294967295 4294967295 4294901502 4294638330 4293783021 4292269782 4290427578 4272005537 4287532686 4286414205 1785819505 0 40989041 2540728432 4286216826 4287401100 4288585374 4289967027 4291546059 4292993505 4294046193 4294638330 4294835709 4294901502 4294901502 4294901502 4294769916 4294440951 4293651435 4292335575 4290822336 4289374890 4271281814 4286743170 4201804402 443115881 309095532 4168184177 4286545791 4270952849 4288914339 4290230199 4291546059 4292730333 4293651435 4294177779 4294506744 4294638330 4294704123 4294638330 4294440951 4293980400 4293322470 4292203989 4290953922 4289638062 4288322202 4270294919 4285953654 2104257644 1751870315 4285887861 4269965954 4287861651 4289045925 4290230199 4291348680 4292335575 4293059298 4293651435 4293980400 4294111986 4294111986 4294111986 4293783021 4293388263 4292796126 4291940817 4290822336 4289572269 4288322202 4287203721 4286151033 3815599469 2876141166 4286019447 4286808963 4287730065 4288848546 4289967027 4290953922 4291809231 4292467161 4292927712 4293256677 4293519849 4293519849 4293388263 4293125091 4292730333 4292138196 4291348680 4290361785 4289243304 4288124823 4287072135 4269439610 4285427310 3765333614 4285887861 4286545791 4287466893 4288387995 4289440683 4290295992 4291085508 4291677645 4292203989 4292532954 4292796126 4292861919 4292730333 4292401368 4291940817 4291348680 4290624957 4289769648 4288716960 4287730065 4286874756 4286019447 4285361517 4285361517 4269044852 4286414205 4287137928 4287861651 4288716960 4289506476 4290164406 4290822336 4291282887 4291743438 4292006610 4292138196 4291875024 4291480266 4290953922 4290427578 4289703855 4288980132 4288059030 4287269514 4286545791 4285953654 4285427310 4285098345 4268715887 4286019447 4286611584 4287203721 4287861651 4288453788 4289045925 4289638062 4290032820 4290493371 4290822336 4290888129 4290624957 4290230199 4289703855 4289177511 4288585374 4287993237 4287269514 4286677377 4286085240 4285624689 4285164138 3949027681 4284900966 4285493103 4286019447 4286479998 4286940549 4287335307 4287664272 4288124823 4288453788 4288782753 4289111718 4289111718 4288914339 4288585374 4288124823 4287730065 4287269514 4286874756 4286414205 4285953654 4285427310 4284966759 4284637794 3143129176 4284111450 4284572001 4285164138 4285558896 4285887861 4286085240 4286282619 4286479998 4286677377 4286874756 4287072135 4287072135 4286940549 4286677377 4286414205 4286216826 4286019447 4285756275 4285427310 4285032552 4284506208 4267334234 4283979864 2001817937 4283453520 4283716692 4284045657 4284440415 4284769380 4285032552 4285164138 4285295724 4285295724 4285361517 4285493103 4285427310 4285427310 4285295724 4285229931 4285098345 4284966759 4284703587 4284374622 4284045657 4283650899 4283453520 4065547091 558977361 4283321934 4283190348 4283321934 4283519313 4283782485 4284045657 4284308829 4284440415 4284572001 4284637794 4284637794 4284703587 4284637794 4284637794 4284440415 4284243036 4284111450 4283848278 4283519313 4283321934 4266347339 4283256141 2622574929 22106449 2840678737 4283321934 4266347339 4283124555 4283256141 4283321934 4283519313 4283716692 4283979864 4284045657 4284177243 4284177243 4284111450 4283979864 4283782485 4283585106 4283453520 4283256141 4283124555 4266413132 4283321934 4283585106 659772243 5921370 727144279 4149498964 4283453520 4266544718 4283256141 4283256141 4283321934 4283387727 4283519313 4283585106 4283650899 4283650899 4283585106 4283585106 4283453520 4283387727 4283321934 4283321934 4283387727 4266742097 4283782485 2488751959 0 0 23356516 1801149275 4284111450 4283848278 4266939476 4283650899 4283585106 4283585106 4283650899 4283650899 4283716692 4283716692 4283716692 4283650899 4283716692 4283716692 4283782485 4283914071 4267268441 4284243036 3361627742 375612259 9013641 5921370 0 91123310 2321769315 4284703587 4284506208 4267597406 4284374622 4284374622 4284374622 4284374622 4284440415 4284440415 4284506208 4284506208 4284572001 4284572001 4267860578 4267926371 4284900966 3429328743 812148840 0 0 0 4934475 0 175075183 2003660141 4117655150 4285295724 4285164138 4268386922 4285229931 4285229931 4285295724 4285361517 4285361517 4285361517 4285361517 4268584301 4285427310 4285624689 3111219569 779120752 0 0 6645093 0 6974058 0 0 57766257 947221877 3111680120 4286085240 4285953654 4285953654 4285887861 4269110645 4285822068 4269110645 4285887861 4285953654 4286085240 4000938361 1786280056 292976246 0 0 7105644 0 0 0 7434609 7434609 0 8224125 0 1082031742 2659024253 3866983805 4269702782 4286545791 4286479998 4286414205 4169039486 3246226813 1803320444 293436797 7566195 0 0 7697781 0 0)
		offset: 0 @ 0.
	^ self on: [ :index | form ]! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 14:18'!
footballs
	^ self
		from:
			(Array
				with:
					(Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 0 0 13095376 0 447393965 1893063384 2951803379 3790335471 4224306377 4222793649 3785335460 2945290390 1884115282 436207616 0 11317419 0 0 0 0 0 0 0 0 0 0 213696193 3067338203 4292402910 4290889156 4268190055 4284309341 4285559923 4286941579 4287533463 4270624915 4287994261 4289508009 3065889465 211723167 0 0 0 0 0 0 0 0 0 1540347096 4291876570 4273257919 4283783772 4287797398 4287928210 4287336070 4292862435 4292270560 4291941849 4291547086 4291481544 4288586905 4269967997 4288389527 1540478671 0 0 0 0 0 0 0 1842074325 4292798186 4288916398 4264178483 4291810773 4294901759 4286085751 4291086017 4287006861 4291481301 4292468191 4291152580 4283125833 4282731075 4267401817 4282666309 4282073146 1837534087 0 0 0 0 0 1541531112 4291942877 4291022546 4282732624 4287469457 4292600287 4281152049 4292270295 4286480513 4288520099 4292205019 4291284167 4282467903 4288454812 4291415503 4291811285 4290298301 4290231995 4283981144 1533833580 0 0 16777215 218103807 4290757575 4293587701 4272534966 4279311385 4287141259 4294047986 4285363569 4286349184 4290559937 4291086791 4291087301 4282534210 4289310633 4290757830 4290560456 4290758348 4291087569 4272994747 4290495683 4286087291 211657884 16777215 0 3014832822 4257926868 4293586930 4289509041 4280167202 4281221174 4288062876 4292996069 4291022277 4291548107 4287206790 4280561697 4287601301 4290035138 4290429900 4290232521 4290034629 4290956246 4288984259 4289116611 4255626938 3014045869 0 419430399 4285953914 4293257710 4293718516 4291745749 4280232740 4280102181 4280233510 4281154098 4281219378 4279771162 4282798408 4287996314 4287995810 4290100937 4290101194 4289903559 4289969600 4289180853 4290036938 4288523958 4289049786 4288785327 415023044 1911682289 4284440674 4293191918 4293257967 4293522162 4288588198 4282666829 4281351226 4282009156 4284311653 4287996318 4288061855 4287469980 4289180348 4290101196 4290035405 4289969609 4289246642 4289641396 4286351751 4286746770 4287864743 4289838278 1907143095 2949303493 4267926629 4292994538 4293126381 4293192942 4293127405 4292601062 4289903806 4287930272 4286549133 4287536028 4288457133 4289510082 4289707464 4289444037 4289180863 4287996841 4287207826 4280102435 4280495911 4279969314 4283851110 4271745972 2948120257 3804415421 4283256654 4292928746 4292731624 4292469222 4292139742 4291876828 4291745499 4291417046 4290496971 4290102470 4289707715 4289575876 4289510086 4289378498 4288786612 4287602589 4281287482 4280102435 4281088045 4281877049 4280298794 4286484370 3803889600 4224438213 4281283118 4292336862 4292402658 4291942621 4291482325 4291481816 4290890193 4290627535 4289970118 4289773764 4289115835 4289181373 4288786874 4288984252 4287668128 4285891709 4279313437 4286155139 4289575087 4289706159 4284509029 4283852901 4222859191 4225491163 4281349934 4287732109 4291153607 4291482578 4291087821 4290693576 4290166984 4290364881 4289444034 4289576386 4288983988 4288786614 4288524219 4288655805 4286615442 4283719255 4284706923 4289049524 4287272860 4287272089 4288851116 4282863691 4222924468 3805270995 4287665552 4280231966 4285166698 4288719782 4290824388 4290626753 4289245363 4289838277 4289378756 4288393143 4288655541 4289378750 4289050563 4288524732 4286549392 4281811515 4288391332 4289641918 4282337870 4280099623 4290167233 4283192656 3804020412 2948381889 4274046403 4287732113 4281877562 4280298535 4280100127 4283125835 4288193185 4287404702 4288392372 4288591037 4290234316 4290694868 4289576907 4288524475 4287668130 4281219378 4289312433 4284772979 4282338384 4282863957 4287206292 4267204957 2949040839 1911089387 4286546303 4290692543 4290496193 4289707963 4289114801 4286942603 4281219125 4283786081 4287273884 4287800747 4289773764 4289510337 4288655806 4288656317 4286812821 4281679672 4289114798 4282733397 4285101690 4286877074 4288785324 4287732374 1907603378 419430399 4289704107 4288389532 4289246644 4289049788 4288457652 4289049527 4289773244 4283259476 4282470220 4287864735 4288720304 4288721078 4288655805 4288524475 4288194474 4282337859 4288325282 4289378489 4289180856 4289377464 4287074706 4289903542 418246889 0 3018057181 4252137588 4289312184 4288523447 4288721344 4288787901 4288655793 4289049773 4281153329 4283784281 4288127649 4288523698 4288655804 4288656318 4288523183 4285166701 4284706924 4288720559 4289838786 4290298566 4252335742 3016018888 0 16777215 218103807 4291678929 4284311652 4272732853 4288984502 4288063920 4288852664 4288786611 4284575086 4279969061 4287404439 4288590002 4288919234 4288590272 4288852407 4288061596 4281088821 4289707961 4272864183 4287074188 4289967540 218103038 16777215 0 0 1543175676 4288126876 4283522136 4289181364 4288852917 4288720817 4289049779 4283653981 4280495659 4284312168 4288655538 4288524217 4288327098 4289115066 4290627523 4279377433 4289838778 4290759366 4285758072 1540346064 0 0 0 0 0 1843258337 4287797654 4282206277 4271022237 4289377971 4287404437 4281154102 4280429862 4284509546 4289378491 4289115838 4288853179 4289575870 4290232766 4262994206 4290430401 4287732118 1838060433 0 0 0 0 0 0 0 1541925609 4289310636 4266810711 4280561451 4279837728 4280298538 4282535499 4288654252 4289246649 4288918456 4289576383 4289706940 4286547589 4265756486 4290823619 1537649320 0 0 0 0 0 0 0 0 0 218103807 3064639406 4289113517 4289048240 4272534712 4289969858 4289969346 4289706686 4290299848 4273785802 4287864734 4280823085 3063783327 216064224 0 0 0 0 0 0 0 0 0 0 16777215 0 450748384 1890169015 2947726532 3786653126 4222860227 4222794944 3784614561 2942332780 1882735425 449366731 0 16184564 0 0 0 0 0)
		offset: 0 @ 0)
				with:
					(Form
						extent: 24 @ 24
						depth: 32
						fromArray:
							#(0 0 0 13752288 0 0 64214752 348901335 1420604087 2795678380 3683094930 4168055932 4250166885 3914491749 3194584704 2004784024 581285569 162511818 0 0 10597564 0 0 0 0 0 0 0 0 583453907 2211633116 4007584744 4293389809 4293915896 4294113532 4294245117 4293587961 4293128695 4291945962 4291551463 4290761181 2965096660 1151776444 16777215 0 9413038 0 0 0 0 14342111 0 1356455909 3671251678 4293257963 4294441979 4277927678 4294704638 4294835710 4294769918 4294507519 4293785080 4293062642 4275431403 4291616484 4290892504 4122266323 2458624430 0 0 10005172 0 0 10002855 0 1659298795 4291152592 4293259249 4294638842 4294704378 4294704636 4294835966 4294835967 4294046709 4292139485 4294245630 4293983228 4293128947 4292208616 4291551456 4290697703 4289447383 3345908625 0 0 11057082 0 0 1334417051 4284837748 4274179281 4294179322 4294901498 4294901499 4294639100 4294442493 4291351252 4284575345 4282338900 4284509811 4291614940 4293260020 4292998131 4291880677 4291026155 4274117357 4287669939 2990362453 16777215 0 0 506483281 3793435965 4263394879 4290431180 4294572540 4294834939 4294703610 4293784565 4288392109 4282933090 4282539618 4282145889 4282407522 4282931553 4287865512 4292602606 4292209130 4291418856 4291353321 4273458132 4196282675 1613643325 16777215 55337824 2300198204 4279648834 4266224751 4292535786 4294703356 4294637048 4294506490 4289969600 4282735456 4282014046 4282213224 4282016617 4282277736 4282669924 4282076243 4290825940 4292339435 4292338413 4291681254 4290432470 4284379510 3694412355 207513705 288180808 3978774600 4280632909 4292470768 4294243322 4294769147 4294703865 4294704895 4289970114 4282998886 4282145892 4282212714 4282278506 4282343014 4282473314 4282800481 4291878115 4292929775 4292469994 4291747304 4291024613 4288721601 4282075471 1516202343 1399225466 4279711542 4271618238 4292667633 4294046198 4294703610 4294967294 4294705151 4292206818 4283590252 4282604901 4282145636 4282408806 4282473571 4282406493 4284576378 4292601839 4293127411 4292470251 4291813353 4291221736 4290695648 4283260774 3344985966 2756600420 4281159248 4290237915 4292864756 4293849077 4294375416 4294769916 4294770687 4294311935 4286220942 4282406236 4282275678 4282406493 4282406234 4282273879 4286944412 4293193975 4292996339 4292339178 4291879402 4291222247 4290893797 4286156955 4265366617 3665596825 4287015084 4290763746 4292865010 4293455347 4293916407 4294441722 4294639615 4294639615 4291417303 4287075738 4287009946 4287141531 4287141788 4287272861 4290825682 4293457404 4292667888 4292076778 4291682536 4291156710 4290697190 4270960829 4284449422 4169439911 4290436322 4291290087 4292470252 4293192688 4293522165 4294113015 4294376443 4293981688 4293784823 4293916409 4293916665 4293916408 4293719031 4293587960 4293062131 4292668145 4292733939 4291945706 4291551206 4291156709 4290500069 4287410625 4284583584 4236483756 4290041566 4290895073 4292272358 4292864237 4293127921 4293718514 4293981686 4293849845 4294113016 4294047222 4294047481 4294112760 4293784052 4293324273 4292535531 4291878630 4292668146 4291814377 4291485669 4291025123 4290303204 4286687676 4284848300 3917782955 4289252313 4291026407 4292206821 4292666857 4292930288 4293586163 4293783797 4293455346 4293719286 4293588213 4293456884 4293522422 4293390580 4293127411 4293127926 4291221214 4291880173 4291814122 4291813093 4291023840 4289843431 4285703099 4284849070 3196034215 4288331472 4291093747 4290169038 4291813348 4292668918 4293456121 4293127155 4293061873 4293259250 4293193968 4293193969 4292996850 4292996082 4292864241 4292469998 4291747559 4290236375 4291091686 4291222755 4290764006 4288334303 4267874740 4285636787 1989127353 4286884285 4273001961 4280566347 4281552983 4281882721 4282802278 4286156692 4292735221 4292733935 4292864494 4292995309 4292864238 4292797935 4292666350 4292535792 4291879404 4286815654 4283724927 4283463292 4281361257 4282154124 4284191917 3867847874 579314609 4286095025 4288728546 4279450439 4279911244 4279846222 4280174668 4281094484 4289777105 4292406257 4292667375 4292732398 4292535790 4292469484 4292272363 4292076270 4290433243 4282671980 4278924352 4278597437 4278337347 4263205993 4284782508 2274010296 143107762 2994117806 4286557890 4279452496 4278729024 4279256395 4279321671 4279846731 4284120707 4290895074 4291550950 4292273132 4291813095 4291878631 4291747817 4291420138 4285567129 4279647814 4278991685 4279189573 4278796097 4280441188 4201880493 580498114 0 1232576432 4117536431 4263925857 4278467133 4278797125 4278862149 4279387210 4279780169 4287607224 4291355369 4291748843 4291814636 4291683307 4291288807 4287935420 4280832857 4278992965 4278664771 4279254335 4262540600 4282146153 2458626743 62642658 0 0 2693377210 4285701799 4262611537 4278205248 4278598970 4279321155 4278990651 4284976019 4290698727 4290171102 4289709265 4289117642 4288263618 4284119941 4279515969 4279254591 4278729021 4278858038 4263788355 3767180966 464701394 0 11719650 0 0 3364267439 4285900982 4280706160 4262216259 4279190085 4282477939 4289647325 4290303202 4291025130 4291681002 4291221993 4290697705 4288199625 4280699988 4262803774 4279252541 4281225305 4103121584 1033482161 0 11058117 0 10333880 0 67108863 2810226352 4251951538 4282679964 4265375118 4287874266 4288924125 4289645531 4290038745 4290366166 4289775830 4288988887 4288070356 4269255097 4280768613 4283264889 3599146663 1017362367 0 9874608 0 0 0 10336449 0 96255937 1599832725 3780085922 4284520369 4284981176 4285573054 4285967555 4286164678 4286229189 4285769409 4268663999 4284585647 4284782250 4285965233 2441848496 497727680 0 10335162 0 0 0 0 0 0 0 21454710 205551246 1582267529 3461645717 4248993426 4282484381 4282353572 4282418861 4282615212 4282613664 3914432922 2373295276 546090937 78891474 0 0 0 0 0)
						offset: 0 @ 0)
				with:
					(Form
						extent: 24 @ 24
						depth: 32
						fromArray:
							#(0 0 0 0 14542063 0 83886079 498187199 1589627083 2949897439 3789481448 4225294820 4208189666 3788232410 2949766882 1589168075 494044296 83886079 0 12177108 0 0 0 0 0 0 0 14409444 0 632866770 2757918084 4066013815 4286156435 4286419606 4286945692 4291353052 4292010470 4286551192 4285236104 4283987579 4062924628 2754632029 628594073 0 11055035 0 0 0 0 0 11646402 0 1641930725 4290035399 4282145634 4282014047 4265301596 4283722608 4284708733 4291286748 4292667370 4284445303 4282210911 4263330632 4279846476 4279189058 4286420895 1638773181 0 0 0 0 0 14673386 0 1860297446 4292007901 4275429351 4266749041 4282736484 4285037184 4289114294 4292468451 4294638590 4294112761 4293061614 4289905865 4284973961 4280830288 4263199559 4271750600 4287472568 1854053809 0 9876411 0 15397622 0 1541728750 4291876829 4292140260 4292469736 4284248695 4284971389 4292732906 4294572541 4294900223 4294966527 4294638075 4294375675 4293521911 4293063415 4286156180 4281027920 4287344314 4289646827 4286687421 1536932289 0 12506335 0 553254911 4290825170 4275298794 4293062645 4292140769 4284575858 4292141283 4294244860 4294440698 4292991711 4293846761 4294769402 4294770174 4294179323 4292930287 4293654782 4284579714 4287014061 4290764528 4271423952 4285303445 552270847 0 50331647 2930554296 4291089371 4292340209 4293260281 4290298822 4292271840 4294443007 4293981430 4292862433 4289177512 4292795610 4292466900 4291875280 4292008153 4292469733 4292996850 4290763485 4285631117 4289446085 4290962409 4285634469 2929046473 50331647 464764869 4088446147 4274771935 4293326073 4290958807 4283853930 4289245876 4294770431 4294440697 4293190886 4287138442 4292861920 4294440180 4293716972 4292533984 4293390064 4293193199 4290432467 4281684568 4284054141 4290895850 4272606433 4084570802 464966629 1590023642 4289971665 4292274160 4292603123 4285302152 4283000166 4288917169 4294770687 4294440441 4294703869 4292796897 4288322716 4291611083 4294572539 4294507516 4293390321 4293324786 4290300883 4281489244 4280701267 4287146935 4289910508 4285766833 1589891804 2932136417 4289053134 4292078584 4287999673 4282408807 4282146402 4286220943 4294836223 4294573309 4294046197 4294705151 4294836223 4294967295 4294441723 4293916152 4292930286 4293522681 4287670448 4280503889 4279715656 4282345070 4286819002 4286491580 2931214028 3786590672 4288923605 4288000961 4283658107 4281356634 4281488477 4283459435 4290168266 4294442751 4293717746 4294113273 4294178809 4293586673 4293521137 4293127664 4292996850 4292339433 4282868844 4279978059 4279650632 4281621601 4282147696 4285636780 3786458054 4204507832 4284318606 4288395461 4282934640 4281619035 4281817181 4281684566 4285300868 4292337892 4294179070 4294310395 4294047739 4294047995 4293719545 4293588987 4292668144 4285629321 4281881950 4280438354 4279979083 4280896849 4284843922 4280108881 4202863517 4203389348 4279647300 4288329662 4286289309 4287934388 4287079848 4283921784 4284841088 4291549405 4289113779 4292205792 4294114301 4293851388 4293062387 4288786613 4291814120 4287077282 4283065967 4286687662 4288530632 4289185482 4287408307 4279778887 4202009747 3785207983 4280041029 4288132034 4292075240 4292732394 4292537589 4292405484 4287865511 4291944421 4285630092 4284448386 4283923582 4283002736 4282145373 4282999398 4288789183 4290566106 4289711832 4291683307 4291484129 4290960620 4287015870 4280766039 3783169425 2932069331 4282211426 4290764268 4291615460 4292272101 4291813353 4292536816 4292667888 4289181374 4282801250 4281751388 4280568911 4280898132 4281619545 4283197037 4287276203 4290500572 4289579219 4290826971 4290168785 4288331218 4285900734 4283201926 2929176234 1590680796 4285170827 4289251803 4290499038 4291681507 4291682538 4292010986 4292405488 4292865782 4289577675 4281356118 4280699985 4280305997 4281158739 4286881447 4291552237 4289974230 4290631136 4291155937 4290499809 4287742425 4284192690 4283795349 1588709575 469041149 4084566930 4270370241 4289514459 4291090659 4291419881 4291551463 4291945450 4291944939 4292274677 4286486691 4281093975 4280174411 4283922303 4291749873 4291157735 4289711060 4291091687 4291025123 4289976035 4286691537 4266427806 4084572076 463255484 50331647 2930886095 4284648610 4287345862 4290368736 4290696417 4291156964 4291485159 4291681769 4291748077 4290170843 4283001716 4280634965 4288988110 4291157738 4290434014 4291618802 4290237920 4290041053 4288070092 4284520621 4284780708 2931084501 50331647 0 553648127 4288135379 4269713851 4288724683 4290565604 4290762464 4291155940 4291484649 4290432219 4290894053 4284974994 4284055174 4289448147 4288788935 4288657090 4284053123 4284647316 4283266688 4282150008 4266558099 4288066753 553648127 0 15400959 0 1540874984 4285236367 4286293432 4286887631 4290039525 4290564582 4289907162 4289710550 4291486960 4289645010 4289183686 4290235607 4290499040 4288724688 4287871691 4286492107 4284848822 4284387490 4286554538 1539954909 0 14872565 0 13820650 0 1856881096 4284842897 4268990386 4269585608 4286427588 4288464601 4290106596 4290696164 4282342758 4280044622 4287608510 4289317853 4288593622 4287278279 4268464305 4267674270 4285697949 1855236529 0 12899803 0 0 0 1263201 0 1642329335 4284513931 4282613135 4284521133 4268991926 4286227635 4284186765 4279842626 4279644218 4281488223 4285767085 4268334769 4283206559 4284190104 4285961114 1640814303 0 0 0 0 0 0 0 13624038 0 636025599 2757985173 4065752451 4283594114 4280898655 4279189577 4279451462 4279908930 4279712323 4280041803 4282541939 4065030528 2758709397 635500017 0 12504276 0 0 0 0 0 0 0 14412786 0 83886079 495820197 1588511174 2945559475 3782513565 4218328219 4201880477 3782449049 2944835747 1588707010 494371211 83886079 0 14348017 0 0 0 0)
						offset: 0 @ 0))! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:32'!
from: anArrayOfForms
	^ self on: [ :index | anArrayOfForms at: index \\ anArrayOfForms size + 1 ]! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:34'!
gas
	| form |
	form := Form
	extent: 24@24
	depth: 32
	fromArray: #( 16777215 33488637 49017300 66188770 97837476 132180414 165931972 215737778 249620924 282715311 300149699 316598200 316598200 300149699 282715311 249620924 215737778 165931972 132180414 97837476 66188770 49017300 33488637 16777215 33488637 49017300 66188770 100071916 133428965 182906314 232646583 282715311 316598200 350218427 383378350 400155566 400155566 383378350 350218427 316598200 282715311 232646583 182906314 133428965 100071916 66188770 49017300 33488637 50265853 66188770 100071916 148891835 199026357 249620926 316466868 366535596 400287154 433907381 467264430 484041903 484041903 467264430 433907381 400287154 366535596 316466868 249620926 199026357 148891835 100071916 66188770 50265853 66188770 97837476 133428965 199749325 266529473 333244085 400287154 450815928 500950450 517859255 551150767 551413687 551413687 551150767 517859255 500950450 450815928 400287154 333244085 266529473 199749325 133428965 97837476 66188770 98363061 132180414 198960562 266398140 349758380 417195959 484041903 534307756 567993521 585099451 601876667 618456757 618456757 601876667 585099451 567993521 534307756 484041903 417195959 349758380 266398140 198960562 132180414 98363061 131917492 182051758 249620926 333244085 417195959 484501948 551413687 585099451 618456757 635365304 652011189 668656817 668656817 652011189 635365304 618456757 585099451 551413687 484501948 417195959 333244085 249620926 182051758 131917492 166194893 232646583 316466868 400221361 484041903 551413687 601613746 635233973 652011189 668919736 685434033 685565620 685565620 685434033 668919736 652011189 635233973 601613746 551413687 484041903 400221361 316466868 232646583 166194893 215737778 282715311 366930106 450815928 534570677 585099451 635365304 668656817 685434033 685762747 702211249 702211249 702211249 702211249 685762747 685434033 668656817 635365304 585099451 534570677 450815928 366930106 282715311 215737778 248832420 316466868 400287154 500950450 568256440 618456757 668591279 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 668591279 618456757 568256440 500950450 400287154 316466868 248832420 282715311 350218427 434038970 517859255 585099451 635365304 668919736 685565620 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685565620 668919736 635365304 585099451 517859255 434038970 350218427 282715311 300149699 383378350 467658939 551413687 618456757 652011189 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 652011189 618456757 551413687 467658939 383378350 300149699 317058247 400155566 484041903 551413687 618456757 668656817 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 668656817 618456757 551413687 484041903 400155566 317058247 317058247 400155566 484041903 551413687 618456757 668656817 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 668656817 618456757 551413687 484041903 400155566 317058247 300149699 383378350 467658939 551413687 618456757 652011189 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 652011189 618456757 551413687 467658939 383378350 300149699 282715311 350218427 434038970 517859255 585099451 635365304 668919736 685565620 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685565620 668919736 635365304 585099451 517859255 434038970 350218427 282715311 248832420 316466868 400287154 500950450 568256440 618456757 668591279 685434033 702211249 702211249 702211249 702211249 702211249 702211249 702211249 702211249 685434033 668591279 618456757 568256440 500950450 400287154 316466868 248832420 215737778 282715311 366930106 450815928 534570677 585099451 635365304 668656817 685434033 685762747 702211249 702211249 702211249 702211249 685762747 685434033 668656817 635365304 585099451 534570677 450815928 366930106 282715311 215737778 166194893 232646583 316466868 400221361 484041903 551413687 601613746 635233973 652011189 668919736 685434033 685565620 685565620 685434033 668919736 652011189 635233973 601613746 551413687 484041903 400221361 316466868 232646583 166194893 131917492 182051758 249620926 333244085 417195959 484501948 551413687 585099451 618456757 635365304 652011189 668656817 668656817 652011189 635365304 618456757 585099451 551413687 484501948 417195959 333244085 249620926 182051758 131917492 98363061 132180414 198960562 266398140 349758380 417195959 484041903 534570677 568256440 601613746 618456756 618456757 618456757 618456756 601613746 568256440 534570677 484041903 417195959 349758380 266398140 198960562 132180414 98363061 66188770 97837476 133428965 199749325 266529473 333244085 400287154 450815928 500950450 534570677 551413687 551413687 551413687 551413687 534570677 500950450 450815928 400287154 333244085 266529473 199749325 133428965 97837476 66188770 50265853 66188770 100071916 148891835 199026357 249620926 316466868 366535596 400287154 450355881 467264430 484041903 484041903 467264430 450355881 400287154 366535596 316466868 249620926 199026357 148891835 100071916 66188770 50265853 33488637 49017300 66188770 100071916 133428965 182906314 232646583 282715311 316598200 350218427 383378350 400155566 400155566 383378350 350218427 316598200 282715311 232646583 182906314 133428965 100071916 66188770 49017300 33488637 16777215 33488637 49017300 66188770 97837476 132180414 165931972 215737778 249620924 282715311 300149699 316598200 316598200 300149699 282715311 249620924 215737778 165931972 132180414 97837476 66188770 49017300 33488637 16777215)
	offset: 0@0.
	^ self on: [ :index | form ]! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 14:10'!
natto
	^ self
		from:
			(Array
				with:
					(Form
						extent: 48 @ 48
						depth: 32
						fromArray:
							#(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290357637 4289567605 4289040748 4289106027 4288711269 4288579172 4289237100 4289039973 4290290039 4290487676 4288843369 4288186470 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291214489 4291147666 4290752131 4289567343 4288448346 4288645212 4289697389 4289960561 4289696620 4289367908 4290353771 4290486125 4289960296 4289368676 4288448348 4287922780 4288186730 4289371782 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290752908 4290423682 4289633136 4288909413 4288316760 4289368935 4290224244 4289631850 4289960043 4290486387 4289959783 4290353764 4290814314 4289893725 4289302105 4288645206 4288382294 4287592784 4287790942 4288054892 4288449912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291278215 4290224495 4289368929 4289763432 4290224246 4289698162 4289238129 4288448611 4289698160 4289368935 4290355052 4290288998 4290420067 4290156893 4289630292 4288643656 4288183107 4288446024 4288643405 4288117579 4287723851 4287460941 4287527511 4288252012 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291475853 4290816373 4289565530 4290946158 4291012469 4289763182 4289039721 4289567096 4290685577 4290750850 4290421877 4290486892 4289697114 4289433170 4288774981 4288446016 4288445503 4287984954 4287655989 4287984956 4288445253 4288379974 4287722819 4287329093 4286868550 4286935121 4288449138 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290817411 4290224238 4290486377 4290551655 4289498714 4289499492 4289697390 4294105782 4293974196 4294237106 4291012729 4290090849 4289498452 4288708677 4287721782 4287524403 4287984184 4287786807 4287457842 4287721014 4288116542 4288051008 4287130166 4286801977 4287197255 4286934858 4286803535 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290817413 4290026859 4289959263 4289695833 4291735417 4292327561 4293051801 4293578406 4293315234 4294038696 4290748783 4289300562 4288444735 4288378685 4287852341 4287523376 4287523376 4287588915 4287786294 4287721014 4287392049 4287260979 4287524665 4286604338 4286604598 4287065669 4287197517 4286013504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290553987 4290289776 4290156642 4290551140 4292327294 4291537784 4289958754 4288840533 4292853906 4294961849 4288313668 4288970822 4288772671 4288180023 4288113717 4287851060 4287456302 4287259182 4287588147 4287457331 4286799914 4286866221 4286735148 4285945892 4286077994 4286604598 4286999360 4285749810 4285552951 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291278225 4290026606 4291406709 4291077484 4289498193 4289892953 4289563734 4288313670 4291011183 4290023258 4288641087 4288443447 4288179762 4287850029 4287784238 4287849777 4287521584 4286929447 4286534947 4286667046 4286667816 4286931245 4285484569 4285156117 4286340650 4286077226 4285879848 4286209331 4285683763 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292265120 4289960813 4290157412 4290419808 4289695824 4289234505 4288378683 4288970822 4288378685 4287982898 4288508727 4288310831 4287783976 4287520035 4287256611 4287322406 4287191336 4286271262 4285679640 4285745946 4285878046 4286010145 4286208294 4285681950 4285945381 4286142762 4285747749 4286799926 4285880113 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291079553 4289696863 4290090843 4288643136 4288642365 4289365831 4288838717 4288903997 4289035326 4287521315 4288244779 4287651874 4287190557 4286795803 4286532890 4286204442 4285744150 4285415957 4285153042 4284824592 4284627981 4286404905 4286075686 4287589695 4289168728 4286010410 4285220126 4285353001 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290948482 4289631583 4289564756 4288906307 4288576826 4288707383 4288772663 4288640564 4288442415 4288310572 4287915044 4287059737 4286664213 4286203666 4285743374 4285349133 4285217808 4285020945 4284889873 4284890130 4284890900 4284891413 4285812517 4287391549 4288772948 4288115020 4285812266 4284629028 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289106014 4288907600 4289103946 4288642365 4288576311 4288641077 4288443185 4288179243 4288047146 4287652388 4286928667 4286401556 4286006544 4285611790 4285217547 4285020431 4284823567 4284823826 4284824339 4284825109 4284693525 4285022747 4284627991 4284496406 4285483049 4285614637 4284629031 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289107046 4288250446 4288512070 4288116538 4287984435 4287917613 4287719977 4287522085 4287652903 4287323683 4286731548 4286402072 4286138648 4285875477 4285612564 4285284118 4285021205 4284890132 4284955927 4284825111 4284627478 4285285922 4285286438 4284496924 4283838742 4283707157 4284037412 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288645466 4287920965 4287854140 4287590194 4287457579 4287325479 4287259173 4287324968 4286995749 4286272028 4285613332 4285547541 4285547543 4285481496 4285284631 4285021205 4284824341 4284890134 4285745959 4286404402 4285615401 4284233752 4284234011 4284036379 4283773722 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287592778 4287525440 4287130164 4286800682 4286668326 4286602020 4286602022 4286141218 4285351704 4285087762 4285021971 4285021716 4285087509 4285087511 4285021720 4285087513 4285219099 4284956697 4285549093 4285023264 4284168470 4284497696 4284103455 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286934335 4286735926 4286471723 4286208294 4286076708 4286142247 4285879078 4285155101 4285417759 4285154587 4284825368 4284759318 4284759318 4284890134 4285153306 4285219869 4285417505 4284234001 4284300053 4284497946 4283972120 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287262532 4287064122 4286603313 4286274093 4286405681 4286405942 4286142770 4285615913 4285220898 4284694554 4284562198 4284495892 4284496146 4284627732 4284759316 4285023001 4284891929 4285352993 4284630301 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287131463 4286472762 4285749040 4285814833 4286143546 4286143546 4285616943 4285222185 4284958243 4284760864 4284760605 4284694812 4284760347 4284694811 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286145090 4285947711 4285684539 4285421365 4285223727 4284960555 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
						offset: 0 @ 0)
				with:
					(Form
						extent: 48 @ 48
						depth: 32
						fromArray:
							#(16119287 15987701 15921906 15592941 15724527 16250871 16382457 16053492 16053494 16382459 16645631 16185080 16382459 16777215 16777215 16777215 16777215 16645631 16513530 16776959 16776959 16776959 16381944 16645116 16645116 16710909 16316151 16776959 16579577 16579577 16777211 16777211 16777211 16316403 15527146 15856113 16316664 16448250 16185078 15921906 16053492 16316664 15790320 16053492 15856113 15724527 15658734 15592941 16053494 15856115 16514043 16382457 16514043 16777215 16777215 16579836 16514043 16711422 16777215 16645631 16711423 16777215 16711423 16777215 16711423 16382459 16381946 16513532 16447739 16776959 16579325 16381946 16184565 16776702 16381944 16513530 16119026 15855854 15724266 15263715 15066336 15132129 15198181 15000802 14935009 15132388 15329767 15263974 14935009 14737630 14737630 15132388 15527146 15066595 14671837 14737630 16382459 15921908 16382457 16777215 16777215 16711422 16579836 16711422 16514043 16119285 16645631 16711423 16579838 16053494 15790322 16250873 16448252 15987701 15592430 16118774 15592430 15460844 15526637 15921393 15329256 15131877 15592428 15526635 15790061 15066338 14803164 14934750 14539992 15132129 14869470 14869470 14803423 14606298 14211286 13882575 13948114 14145747 14342872 14211540 14540251 13948368 13882321 14343126 16777215 16579836 16711422 16645629 16250871 16448250 16579836 16382457 16250871 15724527 15987699 15987699 15987699 15724527 15395562 15198183 15198183 15263976 14869218 15132390 15987699 15921906 14671839 14474460 14869218 14671837 14935009 14671837 14342872 14211286 14474458 14540251 14277079 13816782 13882062 13882061 14211027 14474198 14276820 14013647 13750476 13355717 13421511 13355717 13421511 13618889 13750476 13618889 16777215 15856113 15527148 15658734 15461355 15527148 15329769 14935011 15132390 15198183 14408667 14606044 14803425 14935009 14869218 14803423 14803423 14869216 14145493 13948114 14474458 14671837 14079700 13948114 14079954 13619403 13158852 14014161 14672091 14408919 13487817 12895680 13290184 13947855 13487303 13290178 13420996 13224385 13157824 13158592 13552582 13421764 12960445 12763834 12828859 12698041 12763066 12434869 15724525 15527146 15198181 15198181 14935009 15066595 14671837 14145493 14474458 14737630 13882321 13948368 14079700 14211540 14211286 14079954 14014161 13948368 14013648 13355718 13553097 13947855 13882061 13947854 14013647 13618889 13421510 13289924 13158338 13224131 13092545 12895166 12895167 13026752 13026236 12894648 12959930 12828855 12565172 12499890 12696758 12565683 12499379 12368304 12302000 12236718 12170414 12039339 15263974 15395560 14935009 14474458 13948114 14211286 14145493 13553356 13619149 13685196 13619403 13487817 13487817 13553610 13685196 13816781 13882575 14013647 13948108 13420992 13355201 13684164 13552578 13552832 13684164 13684164 13289406 12828855 12565683 12631476 12631478 12434099 12499892 12763064 12499633 12433838 12631219 12565424 12170668 11973287 11907496 11710115 11775910 11644322 11578531 11578529 11578531 11644322 14869470 14408919 14737371 14211027 13684683 14013648 14079441 13553097 13487304 13421510 13553096 13355717 13158338 13092545 13224131 13355971 13421510 13421762 13552319 12960435 12697009 12894642 12828849 12631468 12499884 12499884 12236712 12170919 12302251 12433837 12236459 11775908 11775910 12170666 11972517 11841186 11840931 11775393 11511966 11512221 11709345 11709600 11643552 11446428 11248794 11249049 11380380 11380635 13816782 13882575 13355718 13224132 12895167 13158339 13026753 12566202 12763580 12763580 13289924 13092545 12960959 12829373 12763834 12698041 12566455 12565937 12959663 12630952 12433060 12565159 12762024 12499365 12169887 11907228 12104095 11709850 11577753 11643803 11774878 11578012 11511708 11446428 11380635 11117463 11183256 11183256 11051670 11117463 11314842 11183256 11249049 11183256 11051670 10985877 11117463 11183256 13093058 13619402 12895166 12960959 12697787 12829373 12697787 12368822 12631994 12631994 12303283 12303283 12369076 12369076 12369076 12369076 12303281 12368557 12630952 12696485 12498591 12235932 12301212 12038553 11840661 11841174 11445905 11380625 11380114 11051406 10787722 10722444 10984849 11248534 10853776 10722190 10787983 10919569 10853776 10853776 10722190 10459018 10393225 10459018 10459018 10393225 10393225 10524811 12763580 12237236 12566202 12566201 12105904 12302513 12368308 12236722 12434101 12170927 12303283 12237490 12105904 12105132 11973799 11907745 364294558 2008527257 2294330775 2647177624 2864952982 2729879945 1940758656 1587977083 1084857982 11576709 10984574 11050114 10984582 10853000 10786952 10721161 10458759 10261380 10525065 10261893 10261639 10393479 10393225 10459272 10459018 10195846 10130053 10327432 10393225 10130053 9932674 9998467 12434101 11974065 12105653 12039858 11973546 11907496 11972521 11972267 11907242 11907242 12105134 11644585 11973550 11973286 11709588 1085911183 3988565900 4290423680 4291145340 4293184405 4291737222 4289895533 4289106276 4287659600 4288383834 2895940445 10786156 10654321 10588538 10522753 9798778 10457478 10129022 9603448 9932926 9932926 10064514 10130305 10130307 10064512 9932928 9801342 10129794 10064001 9735036 9866622 9998208 9932415 12105136 11776171 11776688 11710893 11710374 11644322 11774629 11774375 11775142 11710117 11578277 11184034 11578279 11709085 1085648013 4156535432 4291278472 4290487921 4289893464 4289432398 4291011694 4289235542 4290026087 4290355820 4289369436 4289369951 1924045162 11311219 11179646 11245705 10654087 10720650 10260608 10261633 9538168 9603961 9669754 9669754 9669754 9669754 9669754 9735547 9735036 9866622 9735036 9669243 9537657 9471864 11775656 11381413 11381930 11316134 11381663 11315357 11511457 11576996 11577763 11512738 11709863 11381411 11578277 11511960 3534988932 4290094200 4290751353 4289039446 4288445764 4288971851 4290419557 4288446028 4288709968 4290223720 4290553452 4289501022 4188179547 732270440 10587249 10587773 10259583 9997438 9472117 9538167 9340276 9406071 9537657 9537657 9471864 9537657 9603450 9669243 9471864 9537657 9734268 9668475 9471096 9405303 11446691 11249312 11117986 11118241 11117977 11249049 11314591 11314337 11380384 11315359 10920860 10920347 11446175 363767443 4289963394 4289632618 4290881396 4289103954 4287524405 4288707911 4289432151 4289892959 4290222437 4289104724 4287986496 4287065653 4287197758 3750590028 311260505 9402981 9272685 9142127 8946030 8617065 8946033 9076852 9208438 9274231 9340024 9274231 9208438 9142645 9603196 9405817 9668475 9602682 9668221 9734268 11183003 11248796 10854556 10854554 10854805 11051670 11117212 11182751 11248798 11117726 11381411 11249566 11643039 1051960979 4289699189 4288579411 4290090591 4289300044 4288049979 4288247360 4294960048 4294498212 4289037904 4287722043 4287524916 4286867245 4286670385 4286473014 3044894019 8876377 9140840 8879210 9143410 8814958 9143158 9143160 9143160 9274746 9406332 9406332 9405819 9340026 9734784 9405819 9603198 9405819 9537406 9800577 10853523 10985109 10656661 10591636 10788496 10854291 10919833 10854557 10854556 10855067 10789274 10657429 11051157 1437507464 4289238379 4288183622 4289629263 4290023506 4288575810 4289300048 4294169245 4290550630 4287853116 4287786805 4287194922 4286866473 4286998320 4287195707 4286538558 864250703 9338217 8747369 9012083 9012855 9340797 9275006 9340286 9340799 9537665 9735044 9800837 9800837 9669251 9406079 9866117 9340286 9339773 9734531 10524813 10656144 10525075 10525073 10591117 10722705 10657177 10722971 10657690 10526618 10987169 10986394 11182743 2108464518 4288974177 4287788347 4288246580 4289167423 4289102408 4288839495 4288773704 4288115772 4287984184 4287654960 4287589165 4286997030 4286997291 4289300311 4287590986 2188795712 9404264 9208690 9144187 9210240 9407110 9604490 9932685 9933455 10064270 10064270 10130063 10261649 10393235 9998477 10524308 9998477 10063757 10392722 10327434 10392972 10459282 10525073 10591119 10722705 10657178 10657437 10526619 10526618 10460825 10723481 11182743 2158927493 4289303142 4288380225 4287983149 4289035322 4289694541 4290484318 4287523633 4288115511 4287260200 4287917615 4287325478 4286799135 4286667297 4291339376 4288971867 2959954997 9666923 10524552 10131085 9737103 10262679 10789025 11315369 11446955 11249574 11052195 11052195 11117988 11380647 10788510 11183268 10920096 11117475 11446440 10392972 10261388 10130063 10196624 10525071 10525071 10327959 10196888 10263449 10329753 10658718 10526102 10985364 2158993288 4288711005 4288643397 4288706872 4289561920 4292523895 4290616156 4288049716 4287260455 4287720234 4287654184 4287325219 4286864414 4286732831 4287720504 4286932538 3211218733 9272165 11444886 11511716 11447469 11381678 12763331 12894917 12500159 11973815 12565952 12302780 12039608 11644848 11644848 12499643 11512748 11710127 12433850 10261388 10130317 9933455 10065040 10196878 10262417 10393754 10459806 10526880 10658464 10921636 11316134 11906211 2158993547 4288579421 4289498967 4289365061 4289825351 4290418519 4289300295 4287655211 4287326246 4288048940 4287917354 4287522085 4286732571 4286930210 4286009885 4286339886 3211941941 7955789 10984335 12761784 13354698 14145243 13158861 13882071 13224654 14013657 14671587 12829383 12697797 13092809 12895430 12632258 11513777 11908022 12829637 9998731 9933454 9867921 9933714 10131346 10328725 10657185 10855336 11119019 11251116 11777460 12500409 12959416 1538829208 4288251486 4289236312 4289497677 4289694796 4288970818 4288444986 4287194660 4286799900 4287456803 4287588391 4287390501 4286666523 4286732577 4286536229 4286669106 4000668724 74735687 11115406 13156029 14078423 14276830 14014685 14540515 14277857 15395824 14935273 14277342 13422033 13948377 14014170 13487824 12829894 12632258 12435136 9801868 9867919 9934232 10197404 10658205 11118756 11644852 12039868 12566211 12764101 13356238 13882321 14473171 803197891 4289304435 4288184655 4289366868 4289431884 4289431884 4289366089 4288115762 4287194660 4287325476 4287588137 4287653418 4287061542 4285877270 4286536229 4286076967 4285551660 1047880260 10720131 13353407 14604765 14671587 15133421 14936042 15001835 14936042 13949147 14869479 15132649 13816789 13816789 13290445 13488078 13224906 12238011 9933714 9934230 10526629 11052973 11908533 12631743 13223629 13684695 14276829 14606307 14080733 14737891 15460326 16314595 3585320067 4286869314 4288907606 4288643145 4288971081 4289365578 4288378936 4287326248 4287128099 4287128100 4287127335 4286600993 4286864167 4286536229 4285879840 4285946668 1903386428 8812384 13418423 15130078 15921908 15066856 15264235 15658993 15724786 15461868 14145495 14606046 14671839 14277079 12895426 12961219 13027012 12303289 10197402 10460835 11908541 12500678 13356238 13948118 14342112 14605797 15066859 15461616 14738663 15330030 15460842 15985890 2109386641 4286409793 4288645464 4288578382 4288839242 4289233740 4288247097 4287325993 4287259432 4287391020 4287456304 4286930218 4287259182 4287917882 4286800941 4286012714 2155110713 7627850 11773338 14142923 14342615 16382970 16777215 16711677 15921904 15856111 15461353 15461607 14474712 14672091 13356231 12566714 12368822 12106163 11119019 11974075 13356759 13751517 14408926 14737891 14934762 15197680 15527156 15856375 15593717 15922682 15921908 15986919 769513146 4287858014 4288383069 4289236318 4288379209 4288444227 4287194411 4286470686 4286668067 4286996778 4287259183 4286732841 4285943323 4287063086 4286274595 4285289245 2154847022 7562307 9865593 12564143 13618120 15724525 15000545 14737884 14934750 15197922 15921645 14211026 13026752 13487557 13158592 12566455 12302513 11908525 12303293 13422034 14146021 14409447 14738663 15132651 15395570 15790328 16185340 16383487 15527926 15725303 16382206 16776696 16777194 3651903100 4287462481 4288776539 4288445515 4288378434 4287062571 4286536227 4287062571 4287325745 4287193390 4286272804 4286404644 4285024017 4285354008 4285749542 2154123301 7627843 9338732 11576988 13354688 14211026 15461093 15197921 15066335 14145233 13947854 13947854 13290178 12763834 12499890 12434097 12236718 11578531 14014168 14212319 14343654 15462135 15067375 14804201 15199214 15659763 16383484 16251900 16185854 16580607 16776959 16776445 16776947 2394599060 4287594585 4289040222 4288182341 4287918395 4287918395 4288049979 4287128364 4286536227 4286667815 4286273057 4285879327 4285419035 4285025308 4284960547 2154057771 6903868 8680287 10589062 12564654 13289406 13749957 14210508 14342094 13881545 13618373 13289408 12368306 12960443 12302254 11381152 11578529 11446173 14343903 14672870 14935789 14935789 14869996 15659510 15922935 15396589 15988980 16515071 16580607 16580095 16776959 16775934 16776694 1256379842 4288450155 4288711516 4287853889 4287457844 4287457589 4288049981 4287588917 4286667813 4286403873 4285878299 4285221397 4285484830 4284893469 4284237084 2153991212 7166270 8153684 9339248 10656397 11578529 12170666 12631730 12763062 12236718 12039339 11841960 11512997 11973546 11644324 10986392 11183001 11051415 14804454 15265005 15067628 15396593 15790581 16185339 16119544 15988980 16515066 16580603 16580607 16645887 16776959 16776191 16775923 50263009 3434523017 4288515168 4287591235 4286668843 4286339110 4286996781 4287324976 4286601252 4286140189 4286140702 4285220370 4285550110 4284892955 4284104985 2154188332 7363392 7758924 8417630 9735036 10788498 11512221 11907493 12039080 11578529 11446943 11249564 10854808 11052185 11117208 10854036 10787730 10787985 14936040 15462384 15265003 16054519 16645887 16316923 16054005 16711677 16711675 16252149 16646138 16711679 16250873 16710395 16117480 15787992 784513436 4221275237 4287592265 4286471725 4285615903 4285943841 4286535462 4286337570 4285810713 4286008605 4285548313 4285220377 4284629272 4284433180 2154254125 7297597 7824202 8153943 8550760 9538429 10195846 10722703 10920084 10460047 10525326 10196875 10590864 10525326 10656912 10590606 10261641 10458505 14935270 15593454 15923185 15923185 16514556 16646142 16448250 16711420 16777210 16514805 16580087 16185330 16053490 15987440 15196892 14341320 12367520 1587516018 4287987285 4286932538 4286010921 4285812515 4286337318 4286271266 4285415187 4285415189 4285350424 4284561937 4284300053 4284366876 1717585191 7296827 8152654 7825232 8484452 9143412 9669243 10196100 10656397 10459531 10459018 10262152 10261641 9932674 10130053 10195587 9800829 10063231 15001063 15659245 16120563 15791598 16317175 16448250 16447737 16579577 16316402 16316913 16251120 14869467 15856365 15066336 14736856 14210251 12235940 11642766 3214838375 4287130692 4286274354 4285615138 4285745182 4285876255 4285217298 4285020178 4284691729 4284232720 4284102677 4283971866 761086501 7625792 8416080 7561545 8089179 8747624 9076589 9537655 10129792 10064512 10195587 9998721 9932415 9603450 9735036 9931643 9602678 9800312 15330028 16119796 16055024 16186610 16448761 15856113 16052981 16644602 15920875 15461347 15395554 14408659 15066849 14014161 14013648 14078926 12697010 12893353 783129980 4220154444 4286011699 4285023519 4284824341 4285086487 4284756495 4284822547 4284034059 4284232469 4283839253 3361027867 6769970 7889736 8021581 7627338 7957077 8615523 8878695 9339761 9800312 9669496 9997436 9800827 9800057 9602933 9602933 9734006 9536627 9602418 15659247 16514554 16383989 16383989 16514041 15789809 16183799 16381176 15328740 15065821 14606038 14803417 14145747 13290438 13158341 13157569 13025977 13156783 12365198 2374924371 4286078007 4285089057 4284495123 4284494352 4284033032 4284033548 4283771148 4284035351 4283378962 1532312095 7625794 7889995 7363651 7824717 7693646 8483421 8812386 9076328 9405293 9208173 9470832 9405552 9668211 9536625 9470832 9471086 9405293 9470316 15987699 16119796 15989231 15923438 15987699 15855604 15723248 15788782 15459813 14736856 14277073 13882315 13618890 13355720 13091778 12697018 12367793 12104097 12628372 162766200 3213191492 4284957471 4284692502 4284231181 4284033548 4284231442 4283837459 4283181072 2790470941 6902073 7758409 7496007 7430214 7824972 7890510 7956818 8219990 8680798 9207142 9339500 9404523 9142121 9272937 9272937 9207144 9207142 9272935 9404264 16250871 15790318 15462119 15198947 15198183 15329260 15131112 14933473 14670297 14210512 13882061 13618889 13224134 12960192 12762813 12630967 12301482 12038044 11444096 11442289 262374751 2859815213 4284955416 4284033802 4284165134 4283244293 4283311629 2790930979 40718909 7955276 7956303 7758924 7561800 7561800 7627593 7759179 7956303 8351574 8746332 8943970 8943970 8943970 9075556 9009763 8878177 8812638 8812125 8943710 16053492 15724525 15593450 15132899 15132392 15329260 15131111 14670558 14473431 14342098 13487303 13355717 13025985 12697020 12630968 12433070 12038304 12102804 12298629 11244650 10650201 9333055 1301308477 3782164251 4284296974 3866248745 1551586876 8281930 8217680 7561547 7364168 7430472 7496007 7364419 7626821 7627591 7824972 8088144 8351316 8548953 8680539 8746332 8943711 8877918 8812125 8746331 8746331 8812378 15724527 15790318 15725038 15263974 15066086 14934502 14604765 14276054 14144464 14013133 13092545 12960960 12762813 12630968 12630451 12103330 11708305 12102024 12495230 11638630 10452303 9792574 10120769 9856829 7685923 8542007 9004363 8414286 7889742 7627340 7562060 7562058 7430212 7363649 7429442 7626821 7889993 7956556 8088144 8285523 8483159 8614745 8746332 8746331 8812124 8878171 8943964 8878171 15395562 15132388 15724525 15329769 14868707 14276570 13750224 13684683 13684936 13355971 12829373 12434616 12302262 12498611 12300711 11905173 11904645 12561537 12625525 10979409 10846283 10713155 9988151 10909254 9462071 7949867 7886648 7954246 8021582 7759439 7496265 7298628 7363903 7494976 7231804 7363903 7627075 7824454 7824970 8022349 8154448 8351827 8548952 8549206 8614999 8614999 8746072 8746070 15592939 15395560 15724527 15263976 14737119 14013396 13553097 13684936 13619141 13092797 12698041 12105650 12104624 12300973 12037019 12167567 12561797 12758138 12690540 10385982 10187061 10778171 11369025 10908478 9527860 8608049 7820853 8020550 8153167 7496265 7035713 7101247 7363388 7494460 7100216 7297597 7429696 7627075 7693384 7890763 8022862 8154448 8680792 8549206 8417620 8351827 8417105 8482898 15855854 16184819 15131877 14539740 14013396 13684685 13355717 13290176 13027515 12566964 12501173 12039857 12236209 12037797 11773587 12496525 12693375 11902051 10979400 11898445 10778422 9790244 11302458 11302975 9527600 8476716 7031589 7033908 7429442 7693643 7824970 7692868 7494459 7296821 7297081 7231802 7298110 7495489 7561798 7824970 8022349 8219728 8614999 8549206 8483413 8417620 8482898 8482898 15066338 15329510 14605533 13881810 13553097 13618889 13421762 13158588 12829623 12434865 12303283 12105132 12498348 12102812 11706757 12758402 12560752 10519619 10189114 13411944 12686168 11171646 10184493 11171389 9593645 8016417 7031075 6441512 6837046 7759177 7956040 7166009 7033649 7559993 7362873 7232057 7231802 7232317 7495489 7627591 7956556 8088142 8286034 8417618 8549204 8680531 8746324 8811346 15131877 14868705 14802398 14341845 14144717 13750211 13026488 12894902 12894650 12499894 12367795 12498348 12431519 11575169 12034164 13217654 11110985 10452539 10190145 10255433 11371353 12489063 10908484 10579772 8804129 7555606 6965021 6440227 7164728 7100218 7429181 7955010 7164981 7033395 7231285 6968883 7100471 6837556 7100729 7692868 7627589 8088140 8219726 8417359 8483151 8745807 8943182 8745544 15197672 14868705 14670812 14210257 13881543 13487038 13026487 12829109 12631480 12367796 12432818 12169125 12365460 11837817 12494191 12492639 10977852 10123059 9137457 11242328 16775375 14199943 10514246 9658417 8475164 7489300 7490851 5847063 6638125 8217670 7625786 7757368 7822648 7164202 8151866 8744516 8744517 7889467 7757883 7889985 7758658 7627073 7758659 8285002 8548428 8614219 8877132 8811337 15197670 14671326 14868191 14407891 13618625 13092278 12960692 12631730 12302002 12170417 12103853 11708572 11970701 12100987 12888434 11637329 10846266 10319921 9597230 11307597 15845269 11962203 10513728 9592624 8277533 7291668 6306066 6504734 6834476 7493687 6967593 7888176 8611637 8808500 10190151 11506783 11440736 10125136 8744255 7889207 7955260 8349766 8218952 8679503 8679248 8481869 8547917 8613710 15658221 15329510 14868189 14342098 13223866 12631727 12697520 12368557 12038828 12235439 11840422 11642263 11575684 12166779 12493676 11045192 10911546 10582834 10122542 10451510 9988914 10317370 10579262 8868644 7816213 6961933 7226396 6307095 6241819 7953205 8611386 9269051 9531702 10782021 11637330 11834455 10847564 10189894 9663811 8414261 7953717 7888441 7954749 8349768 8612941 8679250 8876629 8679250 15987440 15461096 14276050 13946825 12960181 12499882 12631468 12302505 11972517 12104105 11643039 11774102 11246717 12034677 11507036 10650434 10779960 10582321 10253610 9200154 9791527 9987372 9526825 8013334 7684627 6896394 6371338 6109195 8018222 10123598 10123849 10650185 10386231 10188335 11043645 10846014 10056501 9596468 9465657 8939573 8281905 7821872 8480064 8283201 8020803 8283976 8481871 8284492)
						offset: 0 @ 0)
				with:
					(Form
						extent: 48 @ 48
						depth: 32
						fromArray:
							#(11642261 11774619 11971998 12235170 12432295 12564396 12827568 13090998 13354172 14341583 13420483 13552327 14605015 14211029 14605787 15066084 14144982 14211288 13817043 14540255 13684946 12697536 12960192 12499382 12236207 12170668 12302251 12630702 12893872 12959667 13025205 13091770 13289408 13224131 13421510 13947854 13947854 14014161 14408919 14343126 14606298 15132388 15263974 15987697 16382455 16119798 16317177 16711679 11773847 12037021 12037791 12169377 12366756 12498601 12761775 13025205 13222584 13223102 14209997 13881547 14670808 14211029 13947857 14144982 14474460 13882323 14014422 14079704 13092809 12763329 12566204 12170417 12367793 12368047 12302251 12564909 12828079 13025460 13157046 13157561 13289149 13355201 13421510 13618889 13618889 13685196 14145747 14540505 14803677 15395560 15066595 15856111 16250869 15527661 15856626 16711679 11971228 12037019 11906203 11971996 12103584 12301222 12564396 12827826 12959412 13552067 13881032 14342098 15197152 13816271 14145236 15000291 14277081 14145495 13882836 13487567 13290188 12763329 12303032 12762554 12367795 12433070 12301737 12235944 12433321 12696495 12893874 13025205 13025977 13749959 13750729 13619143 13553350 13684682 14079440 14605784 14868956 14868957 15395301 15395814 15395814 15856111 15921904 16053490 11905435 12102812 11971996 12037789 12169375 12367269 12630187 12828081 12959412 12894391 13552067 12828859 13157824 14145234 14408408 13881810 13750737 14474460 14672352 13553360 13355981 13421259 12500411 12630714 12565174 12433070 12235944 12170151 12301735 12564909 12696495 12827826 12894389 13618373 13816522 13750729 13816522 13947854 14079440 14671577 14737370 14671578 15066336 15461607 15724779 16053490 16514041 16711420 11905435 11971226 11972251 12169375 12366754 12498855 12695980 12828081 13025205 12894391 12894137 13355203 13486789 13882062 14013648 13882064 13948114 14013909 14540766 13750739 13092809 13487052 12829376 12235956 12302002 12433070 12301737 12301737 12499114 12696495 12893874 13025205 13091768 13289408 13749959 13684166 14013131 14144717 14210510 14671577 14539991 14671577 14671577 15592680 15921645 15592680 16579575 16777211 12234141 11576723 11905686 12169375 12366756 12367015 12498603 12696240 12828596 12960184 12828344 13092029 13092031 14670808 14210257 13157571 13684431 13882323 13355979 14342876 13882325 12960708 13553099 13354691 12302000 12235691 12170151 12301735 12564907 12828079 13025460 13091767 13289147 13157820 13684166 13618373 13947340 14013133 13947340 14539477 14342098 14802647 15592163 15592679 15263714 15724266 16382709 16382455 11247246 11905427 12234392 13024169 12564135 12103590 12761522 12959416 12499379 12894137 12697271 13486274 13354690 13223105 13683402 13880013 14209750 13749456 13947605 13750226 13289675 13158087 12895169 12630967 12302254 12433068 12038050 12104097 12630698 13157042 13092019 12960692 13026487 13026488 13223613 13486276 13683656 13814988 13880265 14011850 14604241 15131353 15197144 15328989 15658726 15987438 15987697 15856626 12168348 12365208 12102806 12563618 12629160 12366505 12761524 12630451 12236207 13420481 12894648 12960184 13091516 13748678 14472402 14011599 13222083 13486538 13487052 13552845 13750224 13750478 13224132 12631225 12499379 12433068 12432810 12498601 12696234 12893870 12828849 12763313 12697522 13223867 13552578 13683655 13749449 14078160 14537941 14538194 14670034 14998995 15065558 15526368 15921898 16316403 16382455 16317177 12035992 12365724 11839380 12037019 12102816 12037540 12366764 12433070 12499633 12499631 12960182 13223354 13354940 13420735 13815239 14012621 13288898 13421510 13290437 13290438 13422024 13290184 12960962 12631227 12499382 12235439 12367279 12366764 12169383 12235689 12631217 13025975 13158074 12894902 13290174 13684166 13749706 13881294 14012367 14144207 14407378 14605009 14802645 15328989 15790312 16184817 16250869 16316664 12167578 11839382 11970968 12629158 12760746 12498091 12563630 12300971 12433068 12301737 12697009 12697009 13157560 13354940 13552321 14078413 13224131 13093056 13225155 13356743 13224902 13027012 13092548 13157573 12828093 12629944 12629684 12432559 12235178 12169383 12498348 12828081 13157046 13157814 13223864 13487039 13881545 14144719 13881292 13947085 14276820 14671577 14803417 15198175 15724265 16184816 16382196 16513784 12167578 11970969 12234400 12629158 12300195 12103333 12366505 12169126 12235431 12564396 12762286 12631470 13157560 13092281 12960441 13684166 13290435 13093569 13028546 13554636 13817039 13224391 12763329 12631229 12367542 12366772 12234926 12234665 381596073 582988457 582922916 582988707 163756711 13551794 13552053 13486261 13552572 14013129 14144719 13947855 13948114 14540505 14474712 14672090 15198434 15855851 16250610 16644600 11970198 12037021 12234400 12234402 11839644 12169125 12695469 12366504 12432297 12695467 12761773 12959665 13223353 12894902 12697269 13290178 13619402 13488329 12896707 13685453 14342872 13618892 12762811 12827577 12958649 1221378493 3083188400 4106335144 4291147174 4291147427 4291015326 4291147164 4291476641 3536305310 1221905326 14143668 13749171 13749179 13881797 13947854 14013907 14474971 14343385 14474712 14869469 15395300 15724266 16183536 12102554 11642263 11906205 12497574 12760746 13352883 13352883 12497574 12366502 12958639 12367015 12499116 12762803 13026234 13552580 13355717 13158852 13421772 13158602 13881810 14473431 13881034 449693374 2160902840 3787963311 4290753186 4290357911 4289831306 4289502081 4289238391 4289040752 4289171566 4289303406 4289896311 4257526412 2010366879 14405292 14275254 14144191 14144969 14408919 14606559 14541280 14869727 15198435 15461093 15526887 15986157 11444882 11774617 11774619 11971228 11905435 12234402 12102816 11839644 12694953 12366504 12498090 13353657 13025207 12630965 13157824 13026753 13355720 13355468 13815503 14473172 81252041 2160573875 4223973287 4290226323 4288383858 4288383598 4288581229 4288777580 4288645476 4288447836 4288446552 4288314707 4288051533 4288248396 4288380751 4289697639 2547302806 15260343 14538426 13946560 14079694 14080215 14278108 14869729 15198692 15264227 15329508 15723500 11971996 11511445 11577238 11708054 11839640 12168607 12431779 12431781 12299941 12234919 12563630 12958903 12893369 12959932 13354948 13486534 13618120 14011851 14340302 466798012 3434522263 4288383858 4288251494 4288382818 4287988312 4288053590 4289171556 4288710746 4288052044 4287919430 4288445004 4287654972 4287259699 4287588401 4287719985 4288050747 4289762654 1909636494 14668206 14275006 14078665 14277079 14277594 14278362 14672348 15067361 15527400 16052979 11708826 11577238 11971481 12168605 12037019 11905433 12037019 12234400 12365734 12498091 12168874 12564145 13353407 13419713 12959162 12894139 13748930 81448389 1958587806 4104031352 4287593053 4287395407 4287855437 4288382032 4288776272 4288118342 4288117829 4288117059 4287656251 4287326005 4287259185 4288113466 4287718191 4287585828 4287652388 4287653669 4288313401 3870464353 13416847 14208180 14341320 14211027 14211801 14343383 14541531 15396326 16119794 16185080 11906203 11576723 11905173 12102554 12036761 11839895 11971226 12300193 12563113 12366251 12432046 12432046 12497839 13024694 13616831 13879744 869385655 3585385100 4288382053 4287000138 4287196737 4287590717 4287788088 4288117049 4288380476 4288051256 4286866984 4287721784 4287326258 4286863912 4287981366 4287782706 4287585065 4287847713 4287979550 4287652893 4287654693 4288841287 835104895 14470322 14406085 13749961 14211286 14606810 14738394 15133152 15856622 16119287 12102812 11576210 11707794 11773587 11839380 11905688 12168605 12365986 12234918 11971493 12892595 12958388 12827056 13484215 164939962 2311370663 4221998717 4287789913 4287459911 4287327547 4287392819 4287589420 4287918381 4288247599 4288313393 4288050482 4288708159 4287326254 4291668081 4291403371 4288244024 4287189796 4288044587 4287978016 4287715863 4287388690 4287324955 4288445756 1875028857 14272682 14010811 14209999 14605787 14935262 15001564 15198945 15725291 16250873 11970968 11838866 11970452 12102038 11970966 11971481 12168605 12103584 11972259 12235176 12629677 12695469 13418676 1020051374 3720064149 4289041787 4287593304 4287196735 4287327285 4287458094 4287588648 4287851301 4288311850 4288509229 4288114731 4288181555 4288181302 4289102408 4293509771 4289889360 4287059232 4288110634 4287846947 4287715616 4287321365 4286862605 4286930197 4287919412 2226692461 13877924 14076604 14275276 13947085 13882572 14277582 14738135 15066846 15263976 12299163 11772560 12167318 12365210 12168345 11971481 11971996 12104097 12301222 12695982 12827055 12629158 1841740200 4257000595 4288712815 4288185952 4287855950 4287195699 4287325993 4287785770 4288114474 4288310823 4288310821 4288376362 4288114220 4288641339 4287720753 4287720501 4286864676 4287323685 4288375343 4287386647 4287123475 4287255065 4287124506 4286994709 4287193884 4288116791 2679414121 13614752 14339263 14340302 14078671 14211278 14606547 14869718 14869721 15066595 12298904 11640463 11969428 12167318 12036759 12037274 12169375 12367269 12499114 12630187 13222065 2025961124 4290489493 4289239159 4287725399 4287461449 4286737205 4287655989 4287720236 4287916841 4288113191 4288046370 4288177956 4288638767 4288771384 4288114230 4288048952 4287259950 4287062053 4287455522 4286994195 4287650322 4287781910 4286663956 4287125279 4287127325 4287392291 4288512320 3115819375 13285789 13944505 13879751 14078414 14539473 14606289 14474701 14540241 15000543 11640715 11838094 11838094 11772558 11707794 12037274 12366756 12432808 12367015 12564135 1942075044 4289568391 4288778354 4287922267 4287066691 4287460928 4287196208 4287721263 4287851561 4288047657 4287981605 4288112421 4288507181 4288507699 4287981615 4288508992 4287917113 4287259952 4287588399 4287323938 4287388953 4287058698 4286926860 4287387940 4287718193 4287456552 4287393068 4288973391 3217141115 13615265 13945016 14208968 14341585 14473680 14408655 14606034 15066587 15395301 11837575 11904138 11707017 11773323 11905427 12431779 12957872 12563630 12497321 1438692259 4257395866 4288120424 4288316511 4287658060 4287525440 4287590707 4286998308 4287654695 4287654180 4287851302 4288047911 4287916073 4288113454 4288179510 4287916855 4288048186 4287982908 4287259185 4286863912 4287192101 4286796312 4286400781 4286796054 4287915059 4287258672 4287259953 4287787837 4288710997 2730076282 13484189 13616556 13946301 14341065 14473169 14539477 14539992 14671578 15198435 11114104 11772552 11707016 12036494 12168599 12300193 12628907 12891827 600423346 4156995490 4289107319 4287922267 4287657806 4287591236 4287722044 4286997541 4288115760 4287917865 4287785766 4287851048 4287785255 4287719464 4287982896 4288245816 4288114491 4287785529 4287720252 4287128115 4286601255 4286271262 4285875476 4286072337 4286861855 4286862631 4286601001 4286799663 4287393086 4288382294 1873846901 12827029 13288358 13946298 14209734 14275790 14473429 14868189 14803166 14803677 11311481 11509125 11641226 12036241 12168599 12102814 12234148 12694442 2764289702 4289370752 4287593817 4287987542 4287394116 4287524673 4287853376 4287129129 4287852592 4287917613 4287786027 4287851563 4287851563 4287785516 4287982896 4287983157 4287588915 4287326003 4287194421 4286799663 4286272806 4285679899 4285350162 4285875736 4286599459 4286337059 4286666794 4286865972 4287459650 4288579932 582132600 12827030 13551531 14275264 14275272 14144206 14210257 14605017 14605787 14737884 11246457 11903885 11970452 12233622 12365724 12431777 12694951 448836261 4256408719 4287594334 4287725140 4287855437 4288183373 4287853380 4287721533 4287983673 4287391786 4287983409 4287786030 4287851310 4287785516 4287719724 4287851823 4287786548 4287392049 4286932017 4286273833 4285879077 4285615906 4285351451 4285153302 4285416217 4285744668 4285942558 4286404392 4286669106 4287262530 3298593118 11444345 12497811 13419693 13946301 14143688 14144206 14078671 14210259 14211027 14672090 11312248 11969680 12299163 12365210 12168345 12234398 12760742 1941811359 4288515444 4287725401 4288053586 4287328576 4288906579 4288379211 4288378182 4288641605 4288114743 4287983927 4287720753 4287654190 4287522858 4287325225 4287457581 4287523635 4287195186 4286142760 4285287710 4284827162 4284695322 4284628761 4284562198 4284759064 4285087513 4285746464 4286142249 4286537778 4287197509 1302236003 11510142 12365974 13156525 13222326 13683139 13881035 14078673 14341843 14211027 14474711 11838076 11772299 12496542 12431003 12036759 11905688 12628898 3149704602 4287725668 4287198796 4287395139 4287195959 4288313668 4288575561 4289825112 4288969800 4288312122 4287785778 4287589169 4287719983 4287522604 4286931239 4286733606 4286404901 4285748002 4284892953 4284301334 4284037909 4284037911 4284168727 4284102423 4284759326 4285483301 4286009894 4286274348 4286801466 3079830353 10851183 11839367 12563614 13025199 13288377 13485760 13486277 13815501 14407636 14539991 14672088 11508852 11903883 12496796 12431001 12365978 12234398 12892071 4038962843 4287265117 4286408252 4286801717 4287063601 4287523124 4288377664 4289890390 4288640576 4287785776 4287456811 4287522604 4287654192 4287456813 4286733092 4286075679 4285549596 4284760856 4284234773 4284103704 4283840280 4284037659 4284300831 4284300317 4284760355 4285813295 4285879337 4286077997 3985076035 395937374 10983543 11773837 12301216 12564394 13354172 13354690 13420484 13749708 14407636 14737370 15001053 11179117 11575171 11904655 11642253 12037270 12300191 79803556 4290028692 4286343247 4286802498 4286866996 4286799914 4287456815 4288377406 4288180025 4287719726 4287785517 4287522858 4287391018 4287325227 4286930471 4286206495 4285878048 4285812263 4285418535 4284431903 4284300833 4283906335 4284103712 4284695592 4284366626 4284366110 4285221415 4285946159 4286341430 1401911632 10785390 11378562 11905684 12301476 12301482 12499379 13091519 13617863 14078671 14539477 14671577 14935260 12297339 12627341 12365459 11774092 12169110 12958121 767669671 4289304457 4287000665 4287064902 4286800692 4286733608 4287061542 4287127337 4287126822 4287127586 4287391012 4287457064 4287259686 4286996003 4286732579 4286468902 4286205992 4285811499 4285483567 4284694570 4284563756 4284169255 4283446300 4283248403 4283774487 4284695843 4285485355 4286012211 2928177479 10192738 10851957 11444872 12038044 12433321 12433840 12630967 13091519 13617863 14078671 14473684 14342612 14408916 12231546 12758926 13155227 12497811 12103315 11840410 1303027346 4288646529 4287987562 4287393867 4286865972 4286535459 4286797857 4287192615 4287258662 4286864668 4286535960 4286930718 4286733341 4286535198 4286272030 4285942560 4285482017 4284890401 4284364833 4283444506 4283379742 4282919959 4282393614 4282788622 4284301344 4285485870 4285880626 3833949765 328236373 10522734 11378562 11839891 12104097 12433838 12696758 13091518 13486277 13815242 14012878 14342098 14342612 14672090 10980712 12101250 11970951 11642502 11905936 12235168 1622847138 4289304459 4287132253 4286998596 4286996788 4286929958 4286994720 4287192101 4287127076 4286799134 4286601753 4286667548 4286470170 4286140955 4285877530 4285548060 4285153053 4284495389 4283970077 4283510045 4283116570 4282722580 4282723092 4283644444 4285091630 4286078775 3984286778 864778320 9601630 10522994 11313288 11643286 11709598 12039082 12434099 12894652 13420996 13881547 14144719 14342098 14211026 14408918 11572849 11509113 11576193 12432018 12762015 12300961 1623110824 4289765010 4286407758 4286142771 4286667564 4287061031 4287192099 4287192101 4287126822 4286930721 4286668063 4286339100 4286141723 4285812506 4285483288 4285284888 4284890650 4284759328 4284496932 4284497963 4283906084 4283841573 4284631600 4285486648 4285881659 4068304445 797273926 9535323 9996648 10721404 11510926 11775132 11907493 12236718 12565685 12565687 13157824 13618375 13947340 14276305 14276820 14408406 11375985 12035203 11773061 11576711 11709327 11840410 1018604958 4288909954 4285815874 4285616424 4286075679 4286600732 4286994718 4287323433 4287193130 4286667813 4286076189 4285878557 4285812764 4285615387 4285220631 4284956693 4284825368 4284760605 4284892454 4284893228 4284696621 4285092149 4285882433 4286474056 3581830981 612658761 9205843 9667426 10391667 11116422 11511700 11841184 12302252 12565685 12500408 12894650 13157822 13355201 13618375 14210512 14539992 14934752 11968381 11706241 12233614 11445127 10919813 11051406 329028737 4287462504 4286671435 4285485089 4286010137 4286731546 4287060511 4287191847 4286732326 4286075936 4285616157 4285616418 4285682211 4285681698 4285418526 4285155354 4285023769 4285090080 4285156645 4285025833 4285552694 4285948481 4286146117 2356963399 75656781 9008466 9271897 9733480 10457977 11051145 11380372 11709600 12170925 12369076 12303283 13157822 13486787 13552580 13749959 14342098 14605787 14737119 12494725 12627091 12364947 11445385 11182985 11380625 11248526 3231287664 4286211135 4285616925 4286010133 4286731799 4286994973 4286797091 4286139937 4285615135 4285418784 4285484838 4285550631 4285616165 4285550370 4285550625 4285485089 4285485859 4285486117 4285684527 4286145338 4219169091 1618503748 8153416 8679761 9271898 9404000 10260083 10655871 11248526 11512217 11775907 12170925 12434869 12566455 13026236 13420992 13684164 13881545 14342098 14408408 14342363 11114101 11114367 11115141 12037270 11840661 10656391 11905686 985246096 4286737997 4285814824 4285550615 4285614607 4286205720 4286534434 4286140450 4285483292 4284957976 4285221666 4285025057 4284959262 4285025309 4285288480 4285551652 4285683751 4285552680 4286211384 3648546107 762996802 8154186 8351312 8614484 9206623 9799019 10326393 10459010 10919821 11446424 11710115 11907753 12302511 12632248 12763064 13223615 13420994 13552580 14012878 14276822 14539742 11180922 11246979 11247243 12695204 11445137 11115917 11576211 11969939 2727970157 4285684026 4285485867 4285352993 4285286170 4285482520 4285877278 4286074398 4285483290 4285221917 4285025821 4285025566 4285091359 4285222945 4285552682 4286079285 4286408765 2508089409 159213894 8350796 8613970 8746074 9008991 9601130 10062453 10524035 11182480 11906718 12038563 11841700 11908007 12368304 12763064 12698041 13158338 13355717 13421511 13750476 14079443 14276568 11444609 11313288 10655619 11116172 11313296 11049613 11772822 11640721 228954753 3582686558 4285487161 4284696100 4285287461 4285615652 4285483292 4285745692 4285944354 4285420066 4285421094 4285684268 4285947440 4286144821 4286276666 3581831233 1048537926 8218952 8285003 8613716 8811867 9008991 9272678 9798768 10194555 10918538 11379861 11906464 12038563 12104358 12236459 12499890 12697269 12829373 13224131 13290438 13422024 14145236 14737373 14803166 10654839 11115393 10589567 11115659 11510418 11246992 11246992 11312269 11640976 162306692 1989377381 3866648898 4285223214 4285090597 4285419047 4285813546 4285748010 4285485867 4285552943 4285947702 4286276926 4001261633 1870555717 75393607 8219209 8417105 8417620 8548952 8615259 8878177 9273705 10063223 10655619 11116689 11380120 11774878 11906977 12170151 12368045 12565683 12631476 12960959 13487303 13553097 13487304 14013650 14539994 14605787 10457460 10589049 10917760 12102038 11181452 11642004 11049613 11181453 11180682 10851458 10982783 77564784 1015838552 2156162381 3263984722 3716969039 3716048450 3363990088 2911071306 2005102414 981823824 75854418 8679761 8482898 8417107 8614745 8549466 8681052 8813154 9273707 9866101 10524031 10853770 11182995 11445913 11643292 11775393 11907494 12302252 12499890 12631476 12698041 13553096 13816269 13487304 13553099 13816271 14079443 10654841 10785914 10983294 11706765 10786178 11510418 11115406 10918027 10457730 10326143 10392188 10588795 10325363 9798760 9667174 9732197 9469025 9732197 9732197 9535588 9338209 9009503 8812125 8615259 8549212 8418396 8484448 8879206 9340527 10064252 10656902 10920074 10985614 11314327 11577501 11709600 11775393 11841701 12236459 12499890 12697269 12632248 13421510 13750476 13553097 13553099 13816271 14145236 10720634 10851707 10917501 11049089 10917764 10786695 10918027 10523782 10918538 10852745 10129275 9602672 9339498 8944740 9010017 9207142 9404262 9338471 9470055 9535850 9338728 9009763 8681570 8549730 8484450 8813417 8748394 9011566 9538167 10393477 11117713 11512471 11512217 11577499 11774880 11906979 11906979 11907494 12236459 12565683 12828855 12961213 13290178 13355717 13487304 13816271 13947857 14013650 10983806 10720121 10785915 11180675 11115143 10589315 10589316 10457989 11050124 10260608 9931896 9602929 9273964 9142378 9405291 9405293 9141349 9075558 9338728 9601902 9405293 9141867 8944488 9010283 9076334 9340278 9406584 9735549 10064771 10656910 11380633 11841184 11841954 11775393 11972517 12038310 12038310 11973287 12302252 12565683 12763062 13223615 13289408 13158338 13421510 13750476 13618890 13618892 10522742 10720121 10391670 11312520 10720385 11181452 10786695 10589573 9997436 10326656 9866103 9536879 9273705 8878947 8878947 9272935 9207142 9404521 9601900 9668465 9471086 9141867 8879210 9010541 9077106 9472123 10064262 10722705 11249049 11577759 11840931 11775908 11644322 11972517 12038310 12038310 12038310 12039080 12368045 12499890 12631476 12960443 13092029 13158338 13553096 13618890 13355718 13553099 10391156 10456950 10720381 10917762 10655106 10589315 10655109 10589316 10326143 10063223 9734256 9799533 9536361 9338981 9141602 9009504 9667434 9536361 9931633 9339498 9997430 9405552 9273713 9734266 10195333 10524813 11182488 11906726 12169898 12564658 13025209 12499379 12038828 11907242 11907496 11907496 11907496 12104875 12433840 12697012 12828598 13486787 13355201 13355203 13618375 13750476 13882062 13816271 10654328 10786428 10457211 10457727 10918278 10918280 10391936 10260350 10654592 10062451 9733227 9535847 9141343 9272416 9667174 9601381 9732969 9667946 9537130 9734256 10063480 9668724 10392194 10655884 11116437 11182488 11577248 12367279 13024955 13222334 12959162 12302003 12236209 11907244 11907242 11973035 11973289 12039082 12170668 12302254 12302254 12697271 12697271 12960445 13420996 13684683 13882062 13947857)
						offset: 0 @ 0))! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:30'!
on: aBlock
	^ (self basicNew)
		formBlock: aBlock;
		yourself! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 14:50'!
ruby
	| form |
	form :=  Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 0 0 16342860 0 267872889 1929338197 3103742029 3925759050 4294856773 4294790979 4127150666 3221116493 1996447313 821522531 0 15887461 0 0 0 0 0 0 0 0 0 0 0 2701023306 4294856253 4294852403 4294522669 4294128678 4293865507 4293996838 4294062372 4294260267 4294262579 4294462790 3304087642 401701755 0 0 0 0 0 0 0 0 0 1710777942 4294857797 4294393394 4293733926 4292748574 4292155666 4291760908 4291498507 4291827730 4292091929 4292556845 4292683039 4292947236 4276633141 4293286484 2380823671 0 14972278 0 0 0 0 0 2029807192 4294657857 4293210409 4292418065 4291431174 4291037703 4291037189 4291102725 4291168262 4291102470 4290905608 4290907406 4291301134 4291829017 4292290337 4292227887 4275720010 3185997429 6197153 0 0 0 0 1090283609 4294330947 4293013291 4291694347 4291431433 4291038220 4291038222 4291038735 4291039248 4291104785 4291434007 4290906890 4290775817 4290840583 4290905863 4290972426 4291567646 4291966003 4275393362 2397074547 0 0 16739680 134193048 4294532431 4292817198 4291694866 4291696665 4291171094 4291040537 4291040537 4291040024 4290974488 4290908182 4290973718 4290973717 4290973460 4291039250 4290972942 4290971915 4290643722 4291238172 4291705402 4292699493 970944884 14445169 0 3103681888 4276502336 4291960355 4291366938 4291435808 4291237666 4290910754 4290908446 4291564317 4291827489 4291893533 4291893531 4291761435 4291563292 4291104538 4291105305 4291105300 4291103764 4290971657 4291439405 4292301909 4292504432 8708 234842479 4294460740 4292684595 4291499040 4291237664 4291435564 4291899177 4293217855 4294278237 4294548080 4294746229 4294943613 4294943870 4294877563 4294743146 4294474837 4293810745 4292621088 4291565852 4291236635 4290975518 4291970632 4292564829 1339774816 1912557389 4276820260 4292219168 4291894318 4293222997 4294019449 4294350225 4294089884 4294088608 4293825951 4293825184 4293431707 4293169047 4293431704 4293432475 4293630108 4294155167 4294483102 4294479478 4292957767 4291171100 4291896884 4291761184 3101770055 3154002237 4293071146 4292681783 4292563282 4292371589 4291778445 4291316362 4290920584 4290590596 4291047811 4290914935 4291110514 4291173996 4291237998 4291041649 4291305334 4291113084 4291512712 4291845005 4292768655 4292958038 4291760160 4291956005 4292811819 4026218297 4293005876 4292284985 4292555361 4291498058 4291627569 4291823409 4291757616 4291757361 4291889203 4291889200 4291823154 4291757363 4291757360 4291823152 4291757869 4291888682 4291888680 4291955503 4291496762 4292163415 4292751179 4291889965 4292284450 4294783554 4293070405 4293005638 4292086596 4291954754 4292152134 4291953985 4292084542 4292084543 4292150075 4292150075 4292215611 4292150075 4292215354 4292215609 4292215353 4292149816 4292215354 4292019002 4292085307 4292152894 4292546111 4292546625 4292545834 4294785359 4294318185 4293857633 4293070939 4292741974 4292676179 4292610385 4292675149 4292609356 4292609095 4292609095 4292674630 4292674886 4292675143 4292806728 4292609093 4292608837 4292543301 4292609352 4292610120 4292742218 4293135179 4293003852 4292874035 4026350677 4294910329 4294843253 4294055787 4293726309 4293529185 4293397600 4293266010 4293265753 4293265749 4293331541 4293265750 4293265750 4293199444 4293396823 4293199700 4293265494 4293265751 4293265753 4293266266 4293594718 4293922910 4293857627 4293399133 3154003289 4294779258 4294777986 4294448761 4294514293 4294251374 4294119785 4294053221 4293987427 4293921891 4293856354 4293856354 4293856610 4293986913 4293986657 4293921633 4293921634 4293856356 4293922665 4294053997 4294251121 4294579573 4294776700 4294783142 1912295760 4278072182 4294847377 4294844045 4294777228 4294776707 4294710911 4294710396 4294578810 4294512501 4294446708 4294512243 4294512243 4294512245 4294578038 4294512760 4294578553 4294644605 4294710916 4294711177 4294777228 4294843795 4294714526 3103736761 234836037 4294854233 4294783622 4294780818 4294778772 4294843281 4294908816 4294908557 4294843021 4294907785 4294907785 4294907271 4294907784 4294842248 4294842504 4294842507 4294908044 4294908050 4294908566 4294909589 4294910871 4294780310 4294784932 1341604967 0 3103348302 4278074225 4294913933 4294845848 4294844826 4294844567 4294909589 4294909333 4294909329 4294909585 4294843538 4294843539 4294843540 4294843285 4294843798 4294844055 4294909850 4294844827 4294845850 4294913688 4294719123 4294260555 2425068 16278873 134175028 4294855762 4294916211 4294781832 4294910863 4294845338 4294779547 4294845086 4294910109 4294910108 4294844316 4294910109 4294909853 4294844060 4294844832 4294910623 4294845086 4294911130 4294847637 4294849934 4294260068 970604866 15088957 0 0 1090410834 4294723921 4294916206 4294781564 4294779266 4294910348 4294845072 4294910614 4294910615 4294910615 4294910615 4294845593 4294910872 4294910868 4294911119 4294845578 4294847109 4294784128 4277549404 2396864837 0 0 0 0 0 2029804629 4294855246 4294786147 4294913139 4294844793 4294909053 4294843264 4294843517 4294844286 4294909568 4294909572 4294778494 4294778494 4294911101 4294782069 4294850155 4277353300 3185329489 13488324 0 0 0 0 0 0 1710709849 4294595407 4294788175 4294785374 4294782825 4294845542 4294845031 4294779495 4294845547 4294845806 4294912620 4294849129 4294719840 4277681746 4293476686 2379696725 0 14109785 0 0 0 0 0 0 0 0 2700366420 4294331468 4294920529 4294918999 4294852957 4294786652 4294786908 4294787163 4294853723 4294919510 4294328912 3303163470 400574037 0 0 0 0 0 0 0 0 0 0 15029081 0 263278426 1927562827 3102689863 3924969289 4293870414 4293804116 4125703763 3219603272 1994079811 817447756 0 13780560 0 0 0 0 0)
		offset: 0 @ 0.
	^ self on: [ :index | form ]! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 14:50'!
saphire
	| form |
	form :=  Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 10081260 0 0 64680678 310358765 1260490219 2653793516 3610554349 4247034603 4280325355 4128599274 3223292135 2233500132 790125285 186076389 196824 0 5751785 0 0 0 0 0 6598122 0 0 513395181 2161700072 4021409773 4280715753 4280389865 4280656362 4280453610 4263480811 4279197933 4280062184 4280061157 4279722984 3440857830 1394509035 243657447 0 2528494 0 0 0 2658027 0 0 1385223663 3432762094 4292340454 4293391343 4268594410 4278861283 4279652576 4279587559 4279398640 4279133678 4279793633 4279987676 4263015144 4279791592 4281445868 2805971432 538738672 0 2658028 0 1468145 0 0 1814663661 4032607214 4288860390 4275104482 4293917676 4291156209 4281293280 4279383768 4279581143 4279261676 4279393767 4279518412 4279644855 4279851482 4263548139 4280515818 4280854252 3458570477 740852202 0 2533101 0 0 1394970862 4046237679 4281055983 4283476716 4291289571 4293786348 4294967282 4286487525 4279517916 4279387102 4279581396 4279516635 4279581131 4279776181 4279580622 4279389670 4262543590 4280256236 4280853485 3374752749 438609902 0 0 573339626 3541587948 4280188398 4264342000 4279854309 4280898015 4290828261 4294705136 4292733683 4281426400 4279324128 4279516372 4279581134 4279645891 4279711163 4279386079 4279189991 4279189993 4279455211 4264008685 4282036207 2318968814 86546158 35288307 2117043438 4279920363 4262477285 4279785187 4279515608 4279320023 4280109790 4288066792 4290037215 4281158587 4279644848 4279709346 4279709088 4279643552 4279644584 4279450313 4279320545 4279451105 4279259885 4279988714 4280388074 4280780524 807632109 392336872 4061351148 4279319010 4279581146 4279580630 4279516120 4279450840 4279322849 4279781076 4279841964 4279511960 4279644328 4279578788 4279643291 4279643811 4279578016 4279643034 4279644340 4279451618 4279386342 4279525357 4263078123 4280846830 2938804462 1716424171 4279193580 4262411491 4279450330 4279646158 4279913691 4279915231 4279386585 4279581123 4279643813 4279577235 4279581112 4279514544 4279709345 4279643812 4279709347 4279512210 4279577231 4279449797 4279256296 4279124202 4280186350 4281512177 4214535663 3007615970 4279327201 4279327977 4279518941 4279711436 4279776198 4279780818 4279516108 4279645877 4279579305 4279511950 4279512209 4279577751 4279643550 4279643809 4279577486 4279511690 4279577493 4279708572 4279452125 4279189994 4279197939 4263807472 4282295791 3643369178 4279579065 4279651532 4279591647 4279391717 4279581379 4279645374 4279381132 4279449761 4279587532 4279581606 4279446406 4279511950 4279577755 4279446415 4279446414 4279511956 4279511952 4279511700 4279449791 4278930164 4278870005 4279067890 4280515310 4282607061 4262671034 4279710904 4279645364 4279517387 4279452109 4279644325 4279446927 4279445382 4279514266 4279455935 4279449509 4279511695 4279511692 4279577491 4279577496 4279643033 4279577491 4279577496 4279514045 4278929398 4279396850 4280521967 4280584942 4282216423 4262545110 4279517377 4279517630 4279515055 4279451838 4279514794 4279583421 4279588039 4279583412 4279512213 4279449773 4279449779 4279511184 4279577755 4279643808 4279709348 4279644071 4279709864 4279451085 4278997495 4278998516 4280583408 4281838321 3863057384 4279321539 4279579042 4279516338 4279578528 4279577233 4279383730 4279583675 4279586497 4279581359 4279380618 4279453097 4279515570 4279588555 4279643297 4279709349 4279644330 4279644327 4279578792 4279254483 4278668536 4278666486 4279657459 4281247216 3260258531 4279315102 4279511692 4279579044 4279454160 4279392735 4279592157 4279514804 4279644325 4279512725 4279379585 4279724493 4279579048 4279582131 4279519938 4279643816 4279710382 4279580083 4279709353 4279385305 4278863347 4278798323 4262349552 4279792877 1969522638 4279511959 4262734223 4279446415 4279515565 4279588302 4279381135 4279515312 4279578530 4279512468 4279248249 4279791581 4279512216 4279511957 4279578791 4279645102 4279513513 4280440772 4279579840 4279123948 4278991596 4280054509 4280522733 4263475948 564643034 4247143334 4279445648 4279514276 4279518138 4279511435 4279512729 4279648201 4279645378 4279448480 4279446414 4279521480 4279643030 4279512212 4279577748 4279643551 4279644849 4279450572 4279255268 4279058922 4278928112 4262813420 4280390637 3340731116 56262614 2622649288 4279446947 4262800284 4279577755 4279644333 4279646667 4279646673 4279585755 4279392479 4279387860 4279387086 4279644076 4279578267 4279643552 4279582399 4279388382 4279321829 4279321313 4279789291 4279393005 4280188653 4280125164 1176336876 0 778745068 4013720025 4279451845 4262933699 4279711433 4279581650 4279453917 4279262697 4279915229 4279520228 4279388896 4279655906 4279645643 4279581394 4279386848 4279257828 4279124453 4281830641 4280787181 4262420973 4280324078 2988541932 153060077 0 16777215 1818864369 4280903911 4279581392 4279582164 4279452120 4279392229 4279580882 4279846873 4279453919 4279452123 4279519194 4279387611 4279711436 4279452124 4279256037 4279320289 4263668455 4279332076 4279192549 3927134692 605250283 0 13758195 0 0 2287633376 4230564563 4279580364 4262610397 4279324643 4279519962 4279581139 4279581908 4279451867 4279647187 4279581654 4279646929 4279581910 4279321057 4279386337 4279919075 4279922405 3843783657 1108762854 0 2686975 0 10734829 0 50331647 1987416545 4013645781 4279257566 4279320793 4262743002 4279646672 4279583447 4279587039 4279584729 4279581138 4279581137 4279517655 4262608605 4279256291 4280587242 3425347309 1042052581 0 0 1196258 0 0 11979504 0 33554431 812555498 3027082988 4281621723 4279187152 4279448011 4279522269 4262681576 4279391461 4262280663 4279652056 4280320997 4279919840 4246237415 2098887403 489265387 0 0 1665769 0 0 0 0 15266288 0 0 163503861 782352112 2322702313 3678303716 4246627554 4279260646 4281306348 4287415024 4128204001 3240268008 1847759339 303858665 51538672 0 5634546 2131435 0 0)
		offset: 0 @ 0.
	^ self on: [ :index | form ]! !

!HGFormVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGFormVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 08:34'!
water
	| form |
	form := Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 6843538 0 0 57109396 107572373 1533372562 2875747222 3580587670 4285230999 4285428121 3933106584 3396169622 2053992344 611020182 74083994 23225746 0 10791209 7106971 0 0 0 0 6975127 0 3170360 459761810 2221435540 4234964631 4285757085 4286217890 4286217891 4269440419 4269440163 4286217378 4286085792 4285888415 4285625243 3228397722 1097494166 90862232 0 0 7369369 0 0 7040406 0 22767522 1198091667 3597364629 4286282913 4288848829 4274374103 4291611869 4289769931 4287730612 4287137964 4287072684 4286941356 4286875050 4286611878 4286151585 4201805468 2238673562 342584470 0 0 7567522 6645905 0 7693721 1466658454 3932843413 4287006887 4291678172 4278058751 4294375673 4292401894 4290164943 4288717246 4288322234 4288256699 4288059578 4287993527 4287730099 4270492847 4286612391 4286086047 2725410205 309031837 0 8749477 0 22238852 1315465875 3932974743 4286414756 4275163872 4294375674 4292138721 4290362064 4289309382 4289046211 4289243590 4289375176 4289375176 4289374919 4289243334 4288914883 4288651455 4271216311 4287204270 4286415014 2792848034 124875934 0 0 493185424 3832180117 4285757085 4272335299 4292402150 4290428113 4289507016 4289638601 4290098894 4290296529 4290427859 4290493395 4290493138 4290492625 4290230225 4289967311 4289835212 4289308869 4271676606 4287532978 4286677672 1903918244 24475036 40397969 2238213266 4285625499 4269835176 4288914627 4289243847 4289243844 4290296527 4291086040 4291480540 4291612125 4291611870 4291545565 4291348187 4291347929 4291085272 4290888407 4290821844 4290361296 4289572298 4271873983 4287598515 4068508329 243171756 358901647 4218385304 4286283426 4270361260 4288125368 4289112005 4290099150 4291152088 4292204260 4292730346 4292795625 4292664039 4292400868 4292137698 4292005856 4291874271 4291742685 4291611103 4291216858 4290493908 4289572810 4288519614 4287336112 2122286250 1785359765 4285822878 4269900968 4287664563 4288717248 4289769932 4290822358 4291875041 4292927722 4293651444 4293651187 4293322223 4292993002 4292729577 4292400614 4292269028 4292137442 4292071649 4291874271 4291414236 4290558932 4289440969 4288322745 3817442482 2892918936 4286085793 4287072941 4288256697 4289243588 4290230479 4291413978 4292335077 4293190382 4293914356 4294243321 4293914356 4293453550 4293058796 4292795368 4292532454 4292400869 4292334819 4292203746 4291874783 4291217112 4290230223 4272268738 4287665076 3765465754 4286348964 4287401905 4288651455 4289703882 4290625235 4291677151 4292466406 4293124588 4293716978 4294309113 4294309113 4293848308 4293387760 4292927467 4292729832 4292532454 4292466661 4292466661 4292203747 4291677663 4290756566 4289638346 4288323004 4285625243 4269769383 4287730613 4288980419 4290098638 4291019224 4291874273 4292466406 4292993003 4293453807 4293914612 4294374906 4294177528 4293716977 4293256429 4292927211 4292729833 4292664040 4292664040 4292466662 4292006369 4291151578 4290164432 4288849091 4285691293 4269966763 4287993784 4289243589 4290361809 4291216602 4291874529 4292466406 4292861418 4293124589 4293585393 4294111735 4294375162 4294111733 4293585392 4293190382 4292927211 4292795626 4292795626 4292598759 4292204004 4291480542 4290493652 4289309383 3950081180 4286809773 4288190906 4289441224 4290493651 4291348444 4292005857 4292334822 4292729576 4292927211 4293321966 4293716977 4294243320 4294374905 4293914356 4293453553 4293190381 4292993004 4292927467 4292730601 4292401381 4291677919 4290691030 4289507273 3161618078 4286809771 4288125627 4289441224 4290625237 4291479771 4292006113 4292334821 4292598247 4292664040 4292993003 4293387759 4293914357 4294375162 4294309113 4293848563 4293453808 4293256430 4293125099 4292927722 4292533223 4291809506 4274242519 4289638860 2037610142 4286612136 4288059577 4289441223 4290690773 4291480027 4292006369 4292334821 4292532455 4292598247 4292795625 4293124588 4293585137 4294045942 4294440699 4294243320 4293848564 4293585393 4293453806 4293124844 4292599273 4291875555 4291019736 4071140039 611744417 4286415014 4287796406 4289243847 4290559443 4291545820 4292137442 4292334821 4292532455 4292598247 4292729832 4292927209 4293322221 4293716977 4294177781 4294440698 4294243064 4293914358 4293650929 4293190893 4292599017 4274966753 4290559699 2627839430 41844390 2726199463 4287401650 4272071616 4290164430 4291282649 4292071905 4292400614 4292597991 4292664040 4292729832 4292861417 4293190380 4293585136 4293848819 4294243576 4294309113 4294111736 4293651187 4293125100 4275493350 4291217882 4289836237 463841739 5592468 729710762 4186343598 4288322491 4272861131 4290756567 4291743199 4292269541 4292532455 4292664040 4292729833 4292861418 4293124588 4293388014 4293716977 4293914612 4294046454 4293848820 4293322480 4275887594 4291875553 4290559957 2376773068 27830989 0 75071657 1870890667 4187001523 4288914626 4273321678 4291151320 4291875041 4292335076 4292466919 4292664297 4292861418 4293058796 4293256430 4293519600 4293585650 4293585907 4293322734 4276084714 4292138724 4291086553 3333601234 346533580 0 8422571 0 108952737 2123075506 4187396793 4289178052 4273519056 4291086042 4291808991 4292137955 4292401125 4292598503 4292795882 4292927724 4293059309 4293059823 4292928237 4275822056 4292072932 4291415262 3250504152 666089426 0 0 0 8882605 0 109218479 1871746485 4170882492 4289309639 4290230736 4290954454 4291480540 4291875042 4292138469 4292336101 4292533224 4292533481 4292467945 4292139237 4291744222 4291283420 3066020826 683195096 0 0 11186383 0 0 9278132 0 59084203 898799548 3198132673 4289309382 4290033358 4290625491 4274374362 4291480798 4291743968 4291941089 4275032543 4291480797 4291086297 4072587990 1891352535 163496666 0 0 12172504 0 0 0 0 9541303 0 8949698 60135355 866625476 2578033866 3920672204 4290230991 4290625492 4290757077 4290691543 4290363091 3082403540 1622719699 280608207 28621274 0 0 11974870 0 0)
		offset: 0 @ 0.
	^ self on: [ :index | form ]! !

!HGFormVisualizer class methodsFor: 'defaults' stamp: 'TomohiroOda 6/22/2011 08:33'!
waterFormBlock
	| form |
	form := Form
		extent: 24 @ 24
		depth: 32
		fromArray:
			#(0 0 0 6843538 0 0 57109396 107572373 1533372562 2875747222 3580587670 4285230999 4285428121 3933106584 3396169622 2053992344 611020182 74083994 23225746 0 10791209 7106971 0 0 0 0 6975127 0 3170360 459761810 2221435540 4234964631 4285757085 4286217890 4286217891 4269440419 4269440163 4286217378 4286085792 4285888415 4285625243 3228397722 1097494166 90862232 0 0 7369369 0 0 7040406 0 22767522 1198091667 3597364629 4286282913 4288848829 4274374103 4291611869 4289769931 4287730612 4287137964 4287072684 4286941356 4286875050 4286611878 4286151585 4201805468 2238673562 342584470 0 0 7567522 6645905 0 7693721 1466658454 3932843413 4287006887 4291678172 4278058751 4294375673 4292401894 4290164943 4288717246 4288322234 4288256699 4288059578 4287993527 4287730099 4270492847 4286612391 4286086047 2725410205 309031837 0 8749477 0 22238852 1315465875 3932974743 4286414756 4275163872 4294375674 4292138721 4290362064 4289309382 4289046211 4289243590 4289375176 4289375176 4289374919 4289243334 4288914883 4288651455 4271216311 4287204270 4286415014 2792848034 124875934 0 0 493185424 3832180117 4285757085 4272335299 4292402150 4290428113 4289507016 4289638601 4290098894 4290296529 4290427859 4290493395 4290493138 4290492625 4290230225 4289967311 4289835212 4289308869 4271676606 4287532978 4286677672 1903918244 24475036 40397969 2238213266 4285625499 4269835176 4288914627 4289243847 4289243844 4290296527 4291086040 4291480540 4291612125 4291611870 4291545565 4291348187 4291347929 4291085272 4290888407 4290821844 4290361296 4289572298 4271873983 4287598515 4068508329 243171756 358901647 4218385304 4286283426 4270361260 4288125368 4289112005 4290099150 4291152088 4292204260 4292730346 4292795625 4292664039 4292400868 4292137698 4292005856 4291874271 4291742685 4291611103 4291216858 4290493908 4289572810 4288519614 4287336112 2122286250 1785359765 4285822878 4269900968 4287664563 4288717248 4289769932 4290822358 4291875041 4292927722 4293651444 4293651187 4293322223 4292993002 4292729577 4292400614 4292269028 4292137442 4292071649 4291874271 4291414236 4290558932 4289440969 4288322745 3817442482 2892918936 4286085793 4287072941 4288256697 4289243588 4290230479 4291413978 4292335077 4293190382 4293914356 4294243321 4293914356 4293453550 4293058796 4292795368 4292532454 4292400869 4292334819 4292203746 4291874783 4291217112 4290230223 4272268738 4287665076 3765465754 4286348964 4287401905 4288651455 4289703882 4290625235 4291677151 4292466406 4293124588 4293716978 4294309113 4294309113 4293848308 4293387760 4292927467 4292729832 4292532454 4292466661 4292466661 4292203747 4291677663 4290756566 4289638346 4288323004 4285625243 4269769383 4287730613 4288980419 4290098638 4291019224 4291874273 4292466406 4292993003 4293453807 4293914612 4294374906 4294177528 4293716977 4293256429 4292927211 4292729833 4292664040 4292664040 4292466662 4292006369 4291151578 4290164432 4288849091 4285691293 4269966763 4287993784 4289243589 4290361809 4291216602 4291874529 4292466406 4292861418 4293124589 4293585393 4294111735 4294375162 4294111733 4293585392 4293190382 4292927211 4292795626 4292795626 4292598759 4292204004 4291480542 4290493652 4289309383 3950081180 4286809773 4288190906 4289441224 4290493651 4291348444 4292005857 4292334822 4292729576 4292927211 4293321966 4293716977 4294243320 4294374905 4293914356 4293453553 4293190381 4292993004 4292927467 4292730601 4292401381 4291677919 4290691030 4289507273 3161618078 4286809771 4288125627 4289441224 4290625237 4291479771 4292006113 4292334821 4292598247 4292664040 4292993003 4293387759 4293914357 4294375162 4294309113 4293848563 4293453808 4293256430 4293125099 4292927722 4292533223 4291809506 4274242519 4289638860 2037610142 4286612136 4288059577 4289441223 4290690773 4291480027 4292006369 4292334821 4292532455 4292598247 4292795625 4293124588 4293585137 4294045942 4294440699 4294243320 4293848564 4293585393 4293453806 4293124844 4292599273 4291875555 4291019736 4071140039 611744417 4286415014 4287796406 4289243847 4290559443 4291545820 4292137442 4292334821 4292532455 4292598247 4292729832 4292927209 4293322221 4293716977 4294177781 4294440698 4294243064 4293914358 4293650929 4293190893 4292599017 4274966753 4290559699 2627839430 41844390 2726199463 4287401650 4272071616 4290164430 4291282649 4292071905 4292400614 4292597991 4292664040 4292729832 4292861417 4293190380 4293585136 4293848819 4294243576 4294309113 4294111736 4293651187 4293125100 4275493350 4291217882 4289836237 463841739 5592468 729710762 4186343598 4288322491 4272861131 4290756567 4291743199 4292269541 4292532455 4292664040 4292729833 4292861418 4293124588 4293388014 4293716977 4293914612 4294046454 4293848820 4293322480 4275887594 4291875553 4290559957 2376773068 27830989 0 75071657 1870890667 4187001523 4288914626 4273321678 4291151320 4291875041 4292335076 4292466919 4292664297 4292861418 4293058796 4293256430 4293519600 4293585650 4293585907 4293322734 4276084714 4292138724 4291086553 3333601234 346533580 0 8422571 0 108952737 2123075506 4187396793 4289178052 4273519056 4291086042 4291808991 4292137955 4292401125 4292598503 4292795882 4292927724 4293059309 4293059823 4292928237 4275822056 4292072932 4291415262 3250504152 666089426 0 0 0 8882605 0 109218479 1871746485 4170882492 4289309639 4290230736 4290954454 4291480540 4291875042 4292138469 4292336101 4292533224 4292533481 4292467945 4292139237 4291744222 4291283420 3066020826 683195096 0 0 11186383 0 0 9278132 0 59084203 898799548 3198132673 4289309382 4290033358 4290625491 4274374362 4291480798 4291743968 4291941089 4275032543 4291480797 4291086297 4072587990 1891352535 163496666 0 0 12172504 0 0 0 0 9541303 0 8949698 60135355 866625476 2578033866 3920672204 4290230991 4290625492 4290757077 4290691543 4290363091 3082403540 1622719699 280608207 28621274 0 0 11974870 0 0)
		offset: 0 @ 0.
	^ [ :index | form ]! !

!HGFormVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/22/2011 14:06'!
draw: anHGSimulator on: aCanvas
	1 to: anHGSimulator numberOfParticles do: [ :index | 
		| p form |
		p := (anHGSimulator particleAt: index) position.
		p
			ifNotNil: [ 
				(form := formBlock value: index)
					ifNotNil: [ aCanvas translucentImage: form at: (p x - (form width // 2)) @ (p y - (form height // 2)) ] ] ]! !

!HGFormVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:29'!
formBlock
	^ formBlock! !

!HGFormVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 08:29'!
formBlock: aBlock
	formBlock := aBlock! !

HGVisualizer subclass: #HGMeshPressureVisualizer
	instanceVariableNames: 'xgrids ygrids kernel scale bias color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGMeshPressureVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGMeshPressureVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGMeshPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 16:54'!
color: aColor
	^ self
		xgrids: 60
		ygrids: 60
		kernel: (HGSimpleKernel support: 15)
		scale: 0.2
		bias: 0.0
		color: aColor! !

!HGMeshPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 16:54'!
new
	^ self
		xgrids: 60
		ygrids: 60
		kernel: (HGSimpleKernel support: 10)
		scale: 0.2
		bias: 0.0
		color: Color white! !

!HGMeshPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 16:55'!
scale: scale bias: bias color: aColor
	^ self
		xgrids: 60
		ygrids: 60
		kernel: (HGSimpleKernel support: 15)
		scale: scale
		bias: bias
		color: aColor! !

!HGMeshPressureVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGMeshPressureVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 11/3/2011 16:55'!
xgrids: xgirds ygrids: ygrids kernel: kernel scale: scale bias: bias color: color
	^ (self basicNew)
		initialize;
		xgrids: xgirds;
		ygrids: ygrids;
		kernel: kernel;
		scale: scale;
		bias: bias;
		color: color;
		yourself! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 16:41'!
bias
	^ bias ifNil: [bias := 0.0]! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/17/2011 16:41'!
bias: aNumber
	bias := aNumber! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
color
	^ color! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
color: aColor
	color := aColor ! !

!HGMeshPressureVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 11/4/2011 11:48'!
draw: anHGSimulator on: aCanvas
	| xstep ystep |
	xstep := (anHGSimulator simulationCorner x - anHGSimulator simulationOrigin x) / xgrids asFloat.
	ystep := (anHGSimulator simulationCorner y - anHGSimulator simulationOrigin y) / ygrids asFloat.
	0 to: xgrids - 1 do: [ :xIndex | 
		| x |
		x := xstep / 2.0 + (xstep * xIndex) + anHGSimulator simulationOrigin x.
		0 to: ygrids - 1 do: [ :yIndex | 
			| y pressure denominator |
			y := ystep / 2.0 + (ystep * yIndex) + anHGSimulator simulationOrigin y.
			pressure := 0.0.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: (HG2dPoint x: x y: y)
				within: kernel support
				do: [ :neighbor :distance | 
					| r |
					r := kernel r: distance.
					pressure := neighbor pressure * r + pressure.
					denominator := denominator + r ].
			denominator > 0.0
				ifTrue: [ pressure := pressure / denominator ].
			pressure := pressure * scale + self bias.
			aCanvas
				fillRectangle:
					((x - (xstep / 2.0)) rounded @ (y - (ystep / 2.0)) rounded
						corner: (x + (xstep / 2.0)) rounded @ (y + (ystep / 2.0)) rounded)
				color: (color alpha: (pressure min: 1.0 max: 0.0)) ] ]! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
kernel
	^ kernel! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
kernel: anHGKernel
	kernel := anHGKernel ! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:44'!
scale
	^ scale! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:44'!
scale: aNumber
	scale := aNumber! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
xgrids
	^ xgrids! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
xgrids: anInteger
	xgrids := anInteger ! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
ygrids
	^ ygrids ! !

!HGMeshPressureVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
ygrids: anInteger
	ygrids := anInteger ! !

HGVisualizer subclass: #HGMeshVelocityVisualizer
	instanceVariableNames: 'xgrids ygrids kernel radius width scale color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGMeshVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGMeshVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGMeshVelocityVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/2/2011 10:42'!
new
	^ self
		xgrids: 30
		ygrids: 30
		kernel: (HGSimpleKernel support: 20)
		radius: 0.5
		width: 1
		scale: 1.0
		color: Color black! !

!HGMeshVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGMeshVelocityVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/1/2011 07:59'!
xgrids: xgirds ygrids: ygrids kernel: kernel radius: radius width: width scale: scale color: color
	^ (self basicNew)
		xgrids: xgirds;
		ygrids: ygrids;
		kernel: kernel;
		radius: radius;
		width: width;
		scale: scale;
		color: color;
		yourself! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
color
	^ color! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
color: aColor
	color := aColor ! !

!HGMeshVelocityVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/2/2011 10:31'!
draw: anHGSimulator on: aCanvas
	| xstep ystep |
	xstep := (anHGSimulator simulationCorner x - anHGSimulator simulationOrigin x) / xgrids asFloat.
	ystep := (anHGSimulator simulationCorner y - anHGSimulator simulationOrigin y) / ygrids asFloat.
	0 to: xgrids - 1 do: [ :xIndex | 
		| x |
		x := xstep / 2.0 + (xstep * xIndex) + anHGSimulator simulationOrigin x.
		0 to: ygrids - 1 do: [ :yIndex | 
			| y velocity denominator |
			y := ystep / 2.0 + (ystep * yIndex) + anHGSimulator simulationOrigin y.
			velocity := HG2dPoint zero.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: (HG2dPoint x: x y: y)
				within: kernel support
				do: [ :neighbor :distance | 
					| r |
					r := kernel r: distance.
					velocity add: neighbor velocity by: r.
					denominator := denominator + r ].
			denominator > 0.0
				ifTrue: [ velocity := velocity / denominator ].
			aCanvas fillOval: ((x - radius) @ (y - radius) extent: 2 @ 2 * radius) color: color.
			aCanvas
				line: x @ y
				to: (velocity x * scale + x) @ (velocity y * scale + y)
				width: width
				color: color ] ]! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
kernel
	^ kernel! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
kernel: anHGKernel
	kernel := anHGKernel ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
radius
	^ radius! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
radius: aNumber
	radius := aNumber ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:44'!
scale
	^ scale! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:44'!
scale: aNumber
	scale := aNumber! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
width
	^ width ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:43'!
width: aNumber
	width := aNumber ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
xgrids
	^ xgrids! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
xgrids: anInteger
	xgrids := anInteger ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
ygrids
	^ ygrids ! !

!HGMeshVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/1/2011 07:42'!
ygrids: anInteger
	ygrids := anInteger ! !

HGVisualizer subclass: #HGParticlePickerVisualizer
	instanceVariableNames: 'picker radius color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGParticlePickerVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGParticlePickerVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGParticlePickerVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/12/2011 13:46'!
on: anHGParticlePicker radius: aNumber color: aColor
	^ (self new)
		picker: anHGParticlePicker;
		radius: aNumber;
		color: aColor;
		yourself! !

!HGParticlePickerVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:45'!
color
	^ color! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:45'!
color: aColor
	color := aColor! !

!HGParticlePickerVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 7/14/2011 10:15'!
draw: anHGSimulator on: aCanvas
	self
		in: anHGSimulator
		particlesDo: [ :particle | 
			| p |
			p := particle position.
			aCanvas fillOval: ((p x - radius) @ (p y - radius) extent: 2 @ 2 * radius) color: color ]! !

!HGParticlePickerVisualizer methodsFor: 'enumerating' stamp: 'TomohiroOda 7/14/2011 10:33'!
in: anHGSimulator particlesDo: aBlock
	picker ifNotNil: [ picker in: anHGSimulator particlesDo: aBlock ]! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:48'!
particle
	^ picker pickedParticle! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 14:25'!
picker
	^ picker! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 14:25'!
picker: anHGParticlePicker
	picker := anHGParticlePicker ! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:45'!
radius
	^ radius! !

!HGParticlePickerVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 7/12/2011 13:45'!
radius: aNumber
	radius := aNumber! !

HGVisualizer subclass: #HGParticlesVelocityVisualizer
	instanceVariableNames: 'radius width scale color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGParticlesVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGParticlesVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGParticlesVelocityVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/29/2011 15:20'!
radius: radius width: width scale: scale color: color
	^ (self new)
		radius: radius;
		width: width;
		scale: scale;
		color: color;
		yourself! !

!HGParticlesVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
color
	^color! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
color: aColor
	color := aColor! !

!HGParticlesVelocityVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/29/2011 15:20'!
draw: anHGSimulator on: aCanvas
	anHGSimulator
		particlesDo: [ :particle | 
			| p v form |
			p := particle position.
			v := particle velocity.
			p
				ifNotNil: [ 
					aCanvas fillOval: ((p x - radius) @ (p y - radius) extent: 2 @ 2 * radius) color: color.
					v
						ifNotNil: [ 
							aCanvas
								line: p x @ p y
								to: (v x * scale + p x) @ (v y * scale + p y)
								width: width
								color: color ] ] ]! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
radius
	^radius! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
radius: aNumber
	radius := aNumber! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
scale
	^scale! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 15:11'!
scale: aNumber
	scale := aNumber! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:19'!
width
	^ width! !

!HGParticlesVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:20'!
width: aNumber
	width := aNumber! !

HGVisualizer subclass: #HGPerspectiveVisualizer
	instanceVariableNames: 'eyeHeight depthBlock vanishingPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGPerspectiveVisualizer subclass: #HGPerspectiveDotsVisualizer
	instanceVariableNames: 'colorBlock radius color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGPerspectiveDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/23/2012 11:38'!
radius: radius color: color eyeHeight: depth vanishingPoint: point depthBlock: simulatorAndParticleBlock
	^ self
		radius: radius
		color: color
		eyeHeight: depth
		vanishingPoint: point
		depthBlock: simulatorAndParticleBlock
		colorBlock: [ :c :z | c alpha: depth / (depth + z) ]! !

!HGPerspectiveDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/23/2012 11:36'!
radius: radius color: color eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock colorBlock: colorAndDepthBlock
	^ (self eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock)
		radius: radius;
		color: color;
		colorBlock: colorAndDepthBlock;
		yourself! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:20'!
color
	^ color! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:20'!
color: aColor
	color := aColor! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/17/2012 13:53'!
colorBlock
	^ colorBlock! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/17/2012 13:53'!
colorBlock: aBlock
	colorBlock := aBlock! !

!HGPerspectiveDotsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/21/2012 13:45'!
draw: anHGSimulator on: aCanvas
	self drawCornersIn: anHGSimulator on: aCanvas.
	anHGSimulator
		particlesDo: [ :particle | 
			self
				project: particle
				in: anHGSimulator
				do: [ :x :y :z :a | 
					((x between: 0 and: aCanvas extent x) and: [ y between: 0 and: aCanvas extent y ])
						ifTrue: [ 
							| c r |
							c := colorBlock value: color value: z.
							r := (particle at: #radius ifAbsent: [ radius ]) * a max: 0.5.
							aCanvas fillOval: ((x - r) @ (y - r) extent: 2 @ 2 * r) color: c ] ] ]! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/17/2012 13:12'!
radius
	^ radius! !

!HGPerspectiveDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/17/2012 13:12'!
radius: aNumber
	radius := aNumber! !

HGPerspectiveVisualizer subclass: #HGPerspectiveTriangulatedVisualizer
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGPerspectiveTriangulatedVisualizer subclass: #HGPerspectivePolygonVisualizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGPerspectivePolygonVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:30'!
color
	^ color! !

!HGPerspectivePolygonVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:30'!
color: aColor
	color := aColor! !

!HGPerspectivePolygonVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/21/2012 13:35'!
drawTriangle: aPoint1 and: aPoint2 and: aPoint3 color: aColor on: aCanvas
	aCanvas drawPolygon: (Array with: aPoint1 with: aPoint2 with: aPoint3) fillStyle: aColor! !

!HGPerspectiveTriangulatedVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/23/2012 11:38'!
color: aColor eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock
	^ (self eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock) color: aColor; yourself! !

!HGPerspectiveTriangulatedVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:49'!
color
	^ color! !

!HGPerspectiveTriangulatedVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:49'!
color: aColor
	color := aColor! !

!HGPerspectiveTriangulatedVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/21/2012 14:14'!
draw: anHGSimulator on: aCanvas
	| triangulator particleMap kernel |
	self drawCornersIn: anHGSimulator on: aCanvas.
	triangulator := HGTriangulator origin: anHGSimulator simulationOrigin corner: anHGSimulator simulationCorner step: 80.
	particleMap := IdentityDictionary new: anHGSimulator numberOfParticles.
	kernel := HGSimpleKernel support: 40.0.
	anHGSimulator
		particlesDo: [ :particle | 
			triangulator divideAt: particle position.
			particleMap at: particle position put: particle ].
	triangulator
		trianglesDo: [ :triangle | 
			| p1 p2 p3 v1 v2 v3 |
			p1 := particleMap at: triangle vertex1 ifAbsent: [  ].
			p2 := particleMap at: triangle vertex2 ifAbsent: [  ].
			p3 := particleMap at: triangle vertex3 ifAbsent: [  ].
			(p1 notNil and: [ p2 notNil and: [ p3 notNil ] ])
				ifTrue: [ 
					v1 := self
						project: p1
						in: anHGSimulator
						do: [ :x :y :z :a | 
							((x between: 0 and: aCanvas extent x) and: [ y between: 0 and: aCanvas extent y ])
								ifTrue: [ x @ y ] ].
					v2 := self
						project: p2
						in: anHGSimulator
						do: [ :x :y :z :a | 
							((x between: 0 and: aCanvas extent x) and: [ y between: 0 and: aCanvas extent y ])
								ifTrue: [ x @ y ] ].
					v3 := self
						project: p3
						in: anHGSimulator
						do: [ :x :y :z :a | 
							((x between: 0 and: aCanvas extent x) and: [ y between: 0 and: aCanvas extent y ])
								ifTrue: [ x @ y ] ].
					(v1 notNil and: [ v2 notNil and: [ v3 notNil ] ])
						ifTrue: [ 
							self
								drawTriangle: v1
								and: v2
								and: v3
								color: (self color alpha: ((anHGSimulator countAt: triangle center kernel: kernel) / 5.0 min: 1.0))
								on: aCanvas ] ] ]! !

!HGPerspectiveTriangulatedVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/21/2012 13:35'!
drawTriangle: aPoint1 and: aPoint2 and: aPoint3 color: aColor on: aCanvas
	^ self subclassResponsibility ! !

HGPerspectiveTriangulatedVisualizer subclass: #HGPerspectiveWireframeVisualizer
	instanceVariableNames: 'width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGPerspectiveWireframeVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/23/2012 11:38'!
width: aNumber color: aColor eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock
	^ (self
		color: aColor
		eyeHeight: height
		vanishingPoint: point
		depthBlock: simulatorAndParticleBlock)
		width: aNumber;
		yourself! !

!HGPerspectiveWireframeVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/21/2012 15:29'!
drawTriangle: aPoint1 and: aPoint2 and: aPoint3 color: aColor on: aCanvas
	aCanvas
		line: aPoint1
		to: aPoint2
		width: width
		color: aColor.
	aCanvas
		line: aPoint2
		to: aPoint3
		width: width
		color: aColor.
	aCanvas
		line: aPoint3
		to: aPoint1
		width: width
		color: aColor! !

!HGPerspectiveWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 15:29'!
width
	^ width! !

!HGPerspectiveWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 15:29'!
width: aNumber
	width := aNumber! !

!HGPerspectiveVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/23/2012 11:35'!
eyeHeight: height vanishingPoint: point depthBlock: simulatorAndParticleBlock
	^ self new
		eyeHeight: height;
		vanishingPoint: point;
		depthBlock: simulatorAndParticleBlock;
		yourself! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:20'!
depthBlock
	^ depthBlock! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:20'!
depthBlock: aBlock
	depthBlock := aBlock! !

!HGPerspectiveVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/23/2012 11:33'!
drawCornersIn: anHGSimulator on: aCanvas
	| cornerBlock |
	cornerBlock := [ :position | 
	| x y z a r |
	x := position x - vanishingPoint x.
	y := position y - vanishingPoint y.
	a := 0.5.
	x := x * a + vanishingPoint x.
	y := y * a + vanishingPoint y.
	aCanvas
		line: position asPoint
		to: x @ y
		width: 1
		color: Color black ].
	cornerBlock value: anHGSimulator simulationOrigin x @ anHGSimulator simulationOrigin y.
	cornerBlock value: anHGSimulator simulationOrigin x @ anHGSimulator simulationCorner y.
	cornerBlock value: anHGSimulator simulationCorner x @ anHGSimulator simulationOrigin y.
	cornerBlock value: anHGSimulator simulationCorner x @ anHGSimulator simulationCorner y.
! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:21'!
eyeHeight
	^ eyeHeight! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/21/2012 13:21'!
eyeHeight: aNumber
	eyeHeight := aNumber! !

!HGPerspectiveVisualizer methodsFor: 'projecting' stamp: 'TomohiroOda 2/23/2012 11:33'!
project: anHGParticle in: anHGSimulator do: aBlock
	| p x y z a c r |
	p := anHGParticle position.
	p isNil
		ifTrue: [ ^ nil ].
	x := p x - vanishingPoint x.
	y := p y - vanishingPoint y.
	z := depthBlock value: anHGSimulator value: anHGParticle.
	a := eyeHeight / (eyeHeight + z).
	^ aBlock value: x * a + vanishingPoint x value: y * a + vanishingPoint y value: z value: a! !

!HGPerspectiveVisualizer methodsFor: 'projecting' stamp: 'TomohiroOda 2/23/2012 11:33'!
projectPoint: aPoint z: aNumber in: anHGSimulator do: aBlock
	|  x y a |
	x := aPoint x - vanishingPoint x.
	y := aPoint y - vanishingPoint y.
	a := eyeHeight / (eyeHeight + aNumber).
	^ aBlock value: x * a + vanishingPoint x value: y * a + vanishingPoint y value: aNumber value: a! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/23/2012 11:34'!
vanishingPoint
	^ vanishingPoint! !

!HGPerspectiveVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/23/2012 11:34'!
vanishingPoint: anHG2dPoint
	vanishingPoint := anHG2dPoint! !

HGVisualizer subclass: #HGReflectionVisualizer
	instanceVariableNames: 'vector xgrids ygrids kernel scale color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGReflectionVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/6/2012 13:04'!
vector: anHG2dPoint color: aColor
	^ self xgrids: 60 ygrids: 60 kernel: (HGSimpleKernel support: 40) vector: anHG2dPoint scale: 0.5 color: aColor! !

!HGReflectionVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/6/2012 12:49'!
xgrids: xgirds ygrids: ygrids kernel: kernel vector: anHG2dPoint scale: scale color: aColor
	^ (self new)
		xgrids: xgirds;
		ygrids: ygrids;
		kernel: kernel;
		vector: anHG2dPoint;
		scale: scale;
		color: aColor;
		yourself! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:46'!
color
	^ color! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:46'!
color: aColor
	color := aColor! !

!HGReflectionVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/6/2012 13:16'!
draw: anHGSimulator on: aCanvas
	| random xstep ystep extent |
	random := Random new.
	xstep := (anHGSimulator simulationCorner x - anHGSimulator simulationOrigin x) / xgrids asFloat.
	ystep := (anHGSimulator simulationCorner y - anHGSimulator simulationOrigin y) / ygrids asFloat.
	extent := (xstep @ ystep) ceiling.
	0 to: xgrids - 1 do: [ :xIndex | 
		| x |
		x := xstep / 2.0 + (xstep * xIndex) + anHGSimulator simulationOrigin x.
		0 to: ygrids - 1 do: [ :yIndex | 
			| y position norm r denominator origin |
			y := ystep / 2.0 + (ystep * yIndex) + anHGSimulator simulationOrigin y.
			position := HG2dPoint x: x y: y.
			norm := HG2dPoint zero.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: position
				within: kernel support
				do: [ :neighbor :distance | 
					| gradient |
					gradient := kernel r: distance.
					norm add: (neighbor position unitVector: position) by: (neighbor pressure * gradient min: 100.0 max: -100.0).
					denominator := denominator + gradient ].
			denominator > 0.0
				ifTrue: [ norm div: denominator].
			origin := (x - (xstep / 2.0)) @ (y - (ystep / 2.0)).
			norm add: vector by: -1.0.
			r := norm r.
			r < 0.5 ifTrue: [
			aCanvas fillRectangle: ((x - (xstep / 2.0)) rounded @ (y - (ystep / 2.0)) rounded
						corner: (x + (xstep / 2.0)) rounded @ (y + (ystep / 2.0)) rounded) color: (color alpha: (0.5 - r * 5.0 min: 1.0)) ]]]! !

!HGReflectionVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/6/2012 12:43'!
initialize
	super initialize.
	scale := 1.0.
	vector := HG2dPoint zero.! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:43'!
kernel: anHGKernel
	kernel := anHGKernel ! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:44'!
scale
	^ scale! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:44'!
scale: aNumber
	scale := aNumber! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:52'!
vector
	^ vector! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:52'!
vector: anHG2dPoint
	vector := anHG2dPoint! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:44'!
xgrids: anInteger
	xgrids := anInteger ! !

!HGReflectionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/6/2012 12:44'!
ygrids: anInteger
	ygrids := anInteger ! !

HGVisualizer subclass: #HGRefractionVisualizer
	instanceVariableNames: 'image xgrids ygrids kernel scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGRefractionVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/6/2012 07:10'!
scale: aNumber
	^ self
		xgrids: 60
		ygrids: 60
		kernel: (HGSimpleKernel support: 40)
		scale: aNumber
		image: nil! !

!HGRefractionVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/4/2012 11:45'!
scale: aNumber image: aForm 
	^ self
		xgrids: 60
		ygrids: 60
		kernel: (HGSimpleKernel support: 40)
		scale: aNumber
		image: aForm! !

!HGRefractionVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/4/2012 08:18'!
xgrids: xgirds ygrids: ygrids kernel: kernel scale: scale image: image
	^ (self new)
		xgrids: xgirds;
		ygrids: ygrids;
		kernel: kernel;
		scale: scale;
		image: image;
		yourself! !

!HGRefractionVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/6/2012 07:10'!
draw: anHGSimulator on: aCanvas
	| form xstep ystep extent offset |
	form := image ifNil: [anHGSimulator form].
	xstep := (anHGSimulator simulationCorner x - anHGSimulator simulationOrigin x) / xgrids asFloat.
	ystep := (anHGSimulator simulationCorner y - anHGSimulator simulationOrigin y) / ygrids asFloat.
	extent := (xstep @ ystep) ceiling.
	offset := form extent - anHGSimulator extent // 2.
	0 to: xgrids - 1 do: [ :xIndex | 
		| x |
		x := xstep / 2.0 + (xstep * xIndex) + anHGSimulator simulationOrigin x.
		0 to: ygrids - 1 do: [ :yIndex | 
			| y position norm denominator origin |
			y := ystep / 2.0 + (ystep * yIndex) + anHGSimulator simulationOrigin y.
			position := HG2dPoint x: x y: y.
			norm := HG2dPoint zero.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: position
				within: kernel support
				do: [ :neighbor :distance | 
					| gradient |
					gradient := kernel r: distance.
					norm add: (neighbor position unitVector: position) by: (neighbor pressure * gradient min: 100.0 max: -100.0).
					denominator := denominator + gradient ].
			denominator > 0.0
				ifTrue: [ norm div: denominator ].
			origin := (x - (xstep / 2.0)) @ (y - (ystep / 2.0)).
			aCanvas
				drawImage: form
				at: origin floor
				sourceRect: (((norm mul: scale negated) asPoint + origin) floor + offset extent: extent) ] ]! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 07:50'!
image
	^ image! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/5/2012 08:06'!
image: anImage
	image := anImage! !

!HGRefractionVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/4/2012 08:14'!
initialize
	super initialize.
	scale := 1.0.! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 08:20'!
kernel: anHGKernel
	kernel := anHGKernel ! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 07:50'!
scale
	^ scale! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 07:50'!
scale: aNumber
	scale := aNumber! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 08:21'!
xgrids: anInteger
	xgrids := anInteger ! !

!HGRefractionVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/4/2012 08:21'!
ygrids: anInteger
	ygrids := anInteger ! !

HGVisualizer subclass: #HGSmokeyVisualizer
	instanceVariableNames: 'kernel scale forms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGSmokeyVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/5/2012 09:23'!
kernel: anHGKernel scale: aNumber color: aColor
	^ self
		kernel: anHGKernel
		scale: aNumber
		steps: 50
		extent: 5 @ 5
		color: aColor! !

!HGSmokeyVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/5/2012 08:57'!
kernel: anHGKernel scale: aNumber steps: anInteger extent: aPoint color: aColor
	^ (self new)
		kernel: anHGKernel;
		scale: aNumber;
		initializeForms: anInteger extent: aPoint color: aColor;
		yourself! !

!HGSmokeyVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/5/2012 09:10'!
draw: anHGSimulator on: aCanvas
	| random xstep ystep xgrids ygrids |
	random := Random new.
	xstep := forms first first extent x asFloat.
	ystep := forms first first extent y asFloat.
	xgrids := (anHGSimulator extent x / xstep) ceiling.
	ygrids := (anHGSimulator extent y / ystep) ceiling.
	0 to: xgrids - 1 do: [ :xIndex | 
		| x |
		x := xstep / 2.0 + (xstep * xIndex) + anHGSimulator simulationOrigin x.
		0 to: ygrids - 1 do: [ :yIndex | 
			| y pressure denominator |
			y := ystep / 2.0 + (ystep * yIndex) + anHGSimulator simulationOrigin y.
			pressure := 0.0.
			denominator := 0.0.
			anHGSimulator
				neighborsOf: (HG2dPoint x: x y: y)
				within: kernel support
				do: [ :neighbor :distance | 
					| r |
					r := kernel r: distance.
					pressure := neighbor pressure * r + pressure.
					denominator := denominator + r ].
			denominator > 0.0
				ifTrue: [ pressure := pressure / denominator ].
			pressure := (pressure * scale) floor + 1 min: forms size max: 1.
			aCanvas translucentImage: ((forms at: pressure) at: (random next * 10 + 1) floor) at: (x - (xstep / 2.0)) rounded @ (y - (ystep / 2.0)) rounded]]! !

!HGSmokeyVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/26/2012 09:51'!
initializeForms: anInteger extent: aPoint color: aColor
	| random |
	random := Random new.
	forms := (1 to: anInteger) collect: [ :index | | factor |
		factor := index - 1.0 / (anInteger - 1).
		(1 to: 10) collect: [:variation | | form |
		form := Form extent: aPoint depth: 32.
		0 to: aPoint x - 1 do: [ :x | 0 to: aPoint y - 1 do: [ :y | form colorAt: x@y put: (aColor alpha: (random next * factor min: 1.0 max: 0.0))]].
		form ]]
		! !

!HGSmokeyVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/5/2012 08:58'!
kernel
	^ kernel! !

!HGSmokeyVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/5/2012 08:59'!
kernel: anHGKernel
	kernel := anHGKernel! !

!HGSmokeyVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/5/2012 08:58'!
scale
	^ scale! !

!HGSmokeyVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/5/2012 08:58'!
scale: aNumber
	scale := aNumber! !

HGVisualizer subclass: #HGStationaryVelocityVisualizer
	instanceVariableNames: 'position kernel radius width scale color isTouchy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGStationaryVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGStationaryVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGStationaryVelocityVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/29/2011 15:23'!
at: position kernel: kernel radius: radius width: width scale: scale color: color
	^ (self new)
		position: position;
		kernel: kernel;
		radius: radius;
		width: width;
		scale: scale;
		color: color;
		yourself! !

!HGStationaryVelocityVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
color
	^ color! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
color: aColor
	color := aColor! !

!HGStationaryVelocityVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/2/2011 10:31'!
draw: anHGSimulator on: aCanvas
	| velocity denominator |
	velocity := HG2dPoint zero.
	denominator := 0.0.
	anHGSimulator
		neighborsOf: self position
		within: kernel support
		do: [ :neighbor :distance | 
			| r |
			r := kernel r: distance.
			velocity add: neighbor velocity by: r.
			denominator := denominator + r ].
	denominator > 0.0 ifTrue: [velocity := velocity / denominator].
	aCanvas fillOval: ((position x - radius) @ (position y - radius) extent: 2 @ 2 * radius) color: color.
	aCanvas
		line: position x @ position y
		to: (velocity x * scale + position x) @ (velocity y * scale + position y)
		width: width
		color: color! !

!HGStationaryVelocityVisualizer methodsFor: 'simulating' stamp: 'TomohiroOda 10/2/2011 10:31'!
effectIn: anHGSimulator deltaT: aNumber
	isTouchy
		ifTrue: [ 
			| newPosition |
			newPosition := ActiveHand position.
			(anHGSimulator bounds containsPoint: newPosition)
				ifTrue: [ position := HG2dPoint fromPoint: newPosition - anHGSimulator bounds origin ] ].
	super effectIn: anHGSimulator deltaT: aNumber! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:39'!
handMorph
	^ handMorph! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:40'!
handMorph: aHandMorph
	handMorph := aHandMorph! !

!HGStationaryVelocityVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/29/2011 15:47'!
initialize
	super initialize.
	isTouchy := true! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:48'!
isTouchy
	^ isTouchy! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:48'!
isTouchy: aBoolean
	isTouchy := aBoolean == true! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:13'!
kernel
	^ kernel! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:13'!
kernel: anHGKernel
	kernel := anHGKernel! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:11'!
position
	^ position! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:11'!
position: anHG2dPoint
	position := anHG2dPoint! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:11'!
radius
	^ radius! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:11'!
radius: aNumber
	radius := aNumber! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
scale
	^ scale! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
scale: aNumber
	scale := aNumber! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
width
	^ width! !

!HGStationaryVelocityVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/29/2011 15:12'!
width: aNumber
	width := aNumber! !

HGVisualizer subclass: #HGStringVisualizer
	instanceVariableNames: 'font color defaultString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGStringVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 1/18/2012 12:47'!
color: aColor defaultString: aString
	^ self font: TextStyle defaultFont color: aColor defaultString: aString! !

!HGStringVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 1/18/2012 12:40'!
font: aFont color: aColor defaultString: aString
	^ (self basicNew)
		font: aFont;
		color: aColor;
		defaultString: aString;
		yourself! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
color
	^ color! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
color: anObject
	color := anObject! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
defaultString
	^ defaultString! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
defaultString: anObject
	defaultString := anObject! !

!HGStringVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 1/18/2012 12:49'!
draw: anHGSimulator on: aCanvas
	| h  |
	h := font height / 2.0.
	anHGSimulator
		particlesDo: [ :particle | 
			particle position
				ifNotNilDo: [ :p | 
					| string w |
					string := particle at: #string ifAbsent: [ defaultString ].
					w := (font widthOfString: string) / 2.0.
					aCanvas
						drawString: string
						at: ((p x - w) @ (p y - h))
						font: font
						color: color ] ]! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
font
	^ font! !

!HGStringVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 1/18/2012 12:41'!
font: anObject
	font := anObject! !

HGVisualizer subclass: #HGStudsVisualizer
	instanceVariableNames: 'offsetRadiusColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGStudsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/16/2012 10:03'!
offset: aPoint radius: aNumber color: aColor
	^ self new setOffsetRadiusColors: (Array with: (Array with: aPoint with: aNumber with: aColor))! !

!HGStudsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/16/2012 10:03'!
offset: aPoint1 radius: aNumber1 color: aColor1 offset: aPoint2 radius: aNumber2 color: aColor2
	^ self new
		setOffsetRadiusColors:
			(Array with: (Array with: aPoint1 with: aNumber1 with: aColor1) with: (Array with: aPoint2 with: aNumber2 with: aColor2))! !

!HGStudsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/16/2012 10:04'!
offset: aPoint1 radius: aNumber1 color: aColor1 offset: aPoint2 radius: aNumber2 color: aColor2 offset: aPoint3 radius: aNumber3 color: aColor3
	^ self new
		setOffsetRadiusColors:
			(Array
				with: (Array with: aPoint1 with: aNumber1 with: aColor1)
				with: (Array with: aPoint2 with: aNumber2 with: aColor2)
				with: (Array with: aPoint3 with: aNumber3 with: aColor3))! !

!HGStudsVisualizer methodsFor: 'adding' stamp: 'TomohiroOda 2/16/2012 09:58'!
addOffset: aPoint radius: aNumber color: aColor
	offsetRadiusColors := offsetRadiusColors copyWith: (Array with: aPoint with: aNumber with: aColor)! !

!HGStudsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 2/16/2012 10:01'!
draw: anHGSimulator on: aCanvas
	offsetRadiusColors
		do: [ :spec | 
			| offsetX offsetY radius color |
			offsetX := (spec at: 1) x.
			offsetY := (spec at: 1) y.
			radius := spec at: 2.
			color := spec at: 3.
			anHGSimulator
				particlesDo: [ :particle | 
					| p form |
					p := particle position.
					p
						ifNotNil: [ aCanvas fillOval: ((p x - radius + offsetX) @ (p y - radius + offsetY) extent: 2 @ 2 * radius) color: color ] ] ]! !

!HGStudsVisualizer methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/16/2012 09:57'!
initialize
	offsetRadiusColors := Array new! !

!HGStudsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/16/2012 11:05'!
offset: aPoint radius: aNumber color: aColor
	self setOffsetRadiusColors: (Array with: (Array with: aPoint with: aNumber with: aColor))! !

!HGStudsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/16/2012 11:05'!
offset: aPoint1 radius: aNumber1 color: aColor1 offset: aPoint2 radius: aNumber2 color: aColor2
	self
		setOffsetRadiusColors:
			(Array with: (Array with: aPoint1 with: aNumber1 with: aColor1) with: (Array with: aPoint2 with: aNumber2 with: aColor2))! !

!HGStudsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 2/16/2012 11:05'!
offset: aPoint1 radius: aNumber1 color: aColor1 offset: aPoint2 radius: aNumber2 color: aColor2 offset: aPoint3 radius: aNumber3 color: aColor3
	self
		setOffsetRadiusColors:
			(Array
				with: (Array with: aPoint1 with: aNumber1 with: aColor1)
				with: (Array with: aPoint2 with: aNumber2 with: aColor2)
				with: (Array with: aPoint3 with: aNumber3 with: aColor3))! !

!HGStudsVisualizer methodsFor: 'private' stamp: 'TomohiroOda 2/16/2012 09:58'!
setOffsetRadiusColors: anArray
	offsetRadiusColors := anArray copy! !

HGVisualizer subclass: #HGThermalDotsVisualizer
	instanceVariableNames: 'radius blueTemperature redTemperature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGThermalDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGThermalDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGThermalDotsVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/12/2011 11:24'!
radius: radiusOfDot blueTemperature: minTemperature redTemperature: maxTemperature
	^ (self new)
		radius: radiusOfDot;
		blueTemperature: minTemperature;
		redTemperature: maxTemperature;
		yourself! !

!HGThermalDotsVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
blueTemperature 
	^ blueTemperature ! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
blueTemperature: aNumber
	blueTemperature := aNumber! !

!HGThermalDotsVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/12/2011 11:29'!
draw: anHGSimulator on: aCanvas
	| rate |
	rate := 240.0 / (redTemperature - blueTemperature).
	anHGSimulator
		particlesDo: [ :particle | 
			| p color |
			p := particle position.
			color := Color
				h: (redTemperature - (particle temperature min: redTemperature max: blueTemperature)) * rate
				s: 1.0
				v: 1.0.
			p ifNotNil: [ aCanvas fillOval: ((p x - radius) @ (p y - radius) extent: 2 @ 2 * radius) color: color ] ]! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
radius
	^ radius! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
radius: aNumber
	radius := aNumber! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
redTemperature 
	^ redTemperature ! !

!HGThermalDotsVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 11:23'!
redTemperature: aNumber
	redTemperature := aNumber! !

HGVisualizer subclass: #HGTriangulatedVisualizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

HGTriangulatedVisualizer subclass: #HGPolygonVisualizer
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGPolygonVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPolygonVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPolygonVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 10:55'!
color: aColor
	^ self new color: aColor; yourself! !

!HGPolygonVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPolygonVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:55'!
color
	^color! !

!HGPolygonVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:55'!
color: aColor
	color := aColor! !

!HGPolygonVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 7/1/2011 08:34'!
drawTriangle: anHG2dTriangle alpha: aNumber on: aCanvas
	| v1 v2 v3 |
	v1 := anHG2dTriangle vertex1 x @ anHG2dTriangle vertex1 y.
	v2 := anHG2dTriangle vertex2 x @ anHG2dTriangle vertex2 y.
	v3 := anHG2dTriangle vertex3 x @ anHG2dTriangle vertex3 y.
	aCanvas drawPolygon: (Array with: v1 with: v2 with: v3) fillStyle: (color alpha: aNumber)! !

!HGTriangulatedVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTriangulatedVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTriangulatedVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTriangulatedVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 10/2/2011 10:43'!
draw: anHGSimulator on: aCanvas
	| triangulator kernel |
	triangulator := HGTriangulator
		origin: anHGSimulator simulationOrigin
		corner: anHGSimulator simulationCorner
		step: 80.
	kernel := HGSimpleKernel support: 40.0.
	anHGSimulator particlesDo: [ :particle | triangulator divideAt: particle position ].
	triangulator
		trianglesDo: [ :triangle | self drawTriangle: triangle alpha: ((anHGSimulator countAt: triangle center kernel: kernel) / 5.0 min: 1.0) on: aCanvas ]! !

!HGTriangulatedVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 7/1/2011 08:34'!
drawTriangle: anHG2dTriangle alpha: aNumber on: aCanvas
	^ self subclassResponsibility! !

HGTriangulatedVisualizer subclass: #HGWireframeVisualizer
	instanceVariableNames: 'width color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-UI'!

!HGWireframeVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGWireframeVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGWireframeVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGWireframeVisualizer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/22/2011 10:48'!
width: aNumber color: aColor
	^ (self new)
		width: aNumber;
		color: aColor;
		yourself! !

!HGWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:48'!
color
	^color! !

!HGWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:48'!
color: aColor
	color := aColor! !

!HGWireframeVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 7/1/2011 08:35'!
drawTriangle: anHG2dTriangle alpha: aNumber on: aCanvas
	| v1 v2 v3 c |
	v1 := anHG2dTriangle vertex1 x @ anHG2dTriangle vertex1 y.
	v2 := anHG2dTriangle vertex2 x @ anHG2dTriangle vertex2 y.
	v3 := anHG2dTriangle vertex3 x @ anHG2dTriangle vertex3 y.
	c := color alpha: aNumber.
	aCanvas
		line: v1
		to: v2
		width: width
		color: c.
	aCanvas
		line: v2
		to: v3
		width: width
		color: c.
	aCanvas
		line: v3
		to: v1
		width: width
		color: c! !

!HGWireframeVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/22/2011 10:52'!
drawTriangle: anHG2dTriangle on: aCanvas
	| v1 v2 v3 c |
	v1 := anHG2dTriangle vertex1 x @ anHG2dTriangle vertex1 y.
	v2 := anHG2dTriangle vertex2 x @ anHG2dTriangle vertex2 y.
	v3 := anHG2dTriangle vertex3 x @ anHG2dTriangle vertex3 y.
	c := color alpha: 100.0 / (anHG2dTriangle area max: 100.0).
	aCanvas
		line: v1
		to: v2
		width: width
		color: c.
	aCanvas
		line: v2
		to: v3
		width: width
		color: c.
	aCanvas
		line: v3
		to: v1
		width: width
		color: c! !

!HGWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:48'!
width
	^width! !

!HGWireframeVisualizer methodsFor: 'accessing' stamp: 'TomohiroOda 6/22/2011 10:48'!
width: aNumber
	width := aNumber! !

!HGVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGVisualizer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGVisualizer methodsFor: 'drawing' stamp: 'TomohiroOda 6/22/2011 08:17'!
draw: anHGSimulator on: aCanvas
	^ self subclassResponsibility! !

!HGVisualizer methodsFor: 'simulating' stamp: 'TomohiroOda 6/29/2011 14:18'!
effectIn: anHGSimulator deltaT: aNumber
	self draw: anHGSimulator on: anHGSimulator form getCanvas! !

HGAction subclass: #HGWorldSubmorphsObstacle
	instanceVariableNames: 'simulatorTopMorph boundsExpansion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Actions-Simulation'!

!HGWorldSubmorphsObstacle class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/24/2012 09:22'!
withBoundsExpansion: aNumber
	^ (self new)
		boundsExpansion: aNumber;
		yourself! !

!HGWorldSubmorphsObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 5/24/2012 09:19'!
boundsExpansion
	^ boundsExpansion! !

!HGWorldSubmorphsObstacle methodsFor: 'accessing' stamp: 'TomohiroOda 5/24/2012 09:20'!
boundsExpansion: aNumber
	boundsExpansion := aNumber! !

!HGWorldSubmorphsObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 5/24/2012 09:32'!
effect: anHGParticle in: anHGSimulator deltaT: aNumber
	| position morphicPosition |
	position := anHGParticle position.
	morphicPosition := (position x + anHGSimulator left) @ (position y + anHGSimulator top).
	World
		submorphsDo: [ :submorph | 
			submorph ~~ simulatorTopMorph
				ifTrue: [ 
					self
						effect: anHGParticle
						position: position
						morphicPosition: morphicPosition
						morphicBounds: submorph bounds.
					position := anHGParticle position.
					morphicPosition := (position x + anHGSimulator left) @ (position y + anHGSimulator top) ] ].
	self
		effect: anHGParticle
		position: position
		morphicPosition: morphicPosition
		morphicBounds: (ActiveHand bounds)! !

!HGWorldSubmorphsObstacle methodsFor: 'private' stamp: 'TomohiroOda 5/24/2012 09:30'!
effect: anHGParticle position: position morphicPosition: morphicPosition morphicBounds: bounds
	| morphicBounds delta minDelta newPosition |
	morphicBounds := bounds expandBy: boundsExpansion.
	(morphicBounds containsPoint: morphicPosition) ifFalse: [^self].
	minDelta := Float infinity.
	minDelta := morphicPosition x - morphicBounds left.
	newPosition := HG2dPoint x: position x - minDelta y: position y.
	delta := morphicBounds right - morphicPosition x.
	delta < minDelta
		ifTrue: [ 
			minDelta := delta.
			newPosition := HG2dPoint x: position x + delta y: position y ].
	delta := morphicPosition y - morphicBounds top.
	delta < minDelta
		ifTrue: [ 
			minDelta := delta.
			newPosition := HG2dPoint x: position x y: position y - delta ].
	delta := morphicBounds bottom - morphicPosition y.
	delta < minDelta
		ifTrue: [ 
			minDelta := delta.
			newPosition := HG2dPoint x: position x y: position y + delta ].
	anHGParticle velocity set: HG2dPoint zero.
	anHGParticle position set: newPosition! !

!HGWorldSubmorphsObstacle methodsFor: 'simulating' stamp: 'TomohiroOda 5/24/2012 08:26'!
effectIn: anHGSimulator deltaT: aNumber
	simulatorTopMorph := anHGSimulator.
	[ simulatorTopMorph owner == World or: [ simulatorTopMorph owner isNil ] ]
		whileFalse: [ simulatorTopMorph := simulatorTopMorph owner ].
	super effectIn: anHGSimulator deltaT: aNumber! !

!HGWorldSubmorphsObstacle methodsFor: 'initialize-release' stamp: 'TomohiroOda 5/24/2012 09:20'!
initialize
	super initialize.
	boundsExpansion := 0! !

Object subclass: #HGBinding
	instanceVariableNames: 'particle1 particle2 standardDistance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Particles'!

!HGBinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGBinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGBinding class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 14:18'!
between: anHGParticle and: anotherHGParticle
	| binding |
	binding := (self new)
		particle1: anHGParticle;
		particle2: anotherHGParticle;
		yourself.
	binding standardDistance: binding distance.
	^ binding! !

!HGBinding class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/8/2011 11:16'!
between: anHGParticle and: anotherHGParticle distance: aNumber
	^ (self new)
		particle1: anHGParticle;
		particle2: anotherHGParticle;
		standardDistance: aNumber;
		yourself! !

!HGBinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:10'!
distance
	^ particle1 position distance: particle2 position! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:06'!
particle1
	^ particle1 ! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:06'!
particle1: anHGParticle
	particle1 := anHGParticle ! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:06'!
particle2
	^ particle2! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:06'!
particle2: anHGParticle
	particle2 := anHGParticle ! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:09'!
standardDistance
	^ standardDistance ! !

!HGBinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 09:09'!
standardDistance: aNumber
	standardDistance := aNumber ! !

Object subclass: #HGElasticBody
	instanceVariableNames: 'trindings particles pairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Particles'!

!HGElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGElasticBody class methodsFor: 'utilities' stamp: 'TomohiroOda 7/15/2011 08:46'!
isolatedBodiesWithAll: aCollectionOfHGTrinding
	| bodies |
	bodies := OrderedCollection new.
	aCollectionOfHGTrinding
		do: [ :trinding | 
			| contacts |
			contacts := bodies select: [ :body | body hasContactWith: trinding ].
			contacts isEmpty
				ifTrue: [ bodies add: (self with: trinding) ]
				ifFalse: [ 
					| theOne theRest |
					theOne := contacts at: 1.
					theRest := contacts copyFrom: 2 to: contacts size.
					theRest
						do: [ :obsoleteTrinding | 
							theOne merge: obsoleteTrinding.
							bodies remove: obsoleteTrinding ].
					theOne add: trinding ] ].
	^ bodies! !

!HGElasticBody class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 08:35'!
with: anHGTrinding
	^ (self new)
		add: anHGTrinding;
		yourself! !

!HGElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 08:38'!
with: trinding1 with: trinding2
	^ (self new)
		add: trinding1;
		add: trinding2;
		yourself! !

!HGElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 08:38'!
with: trinding1 with: trinding2 with: trinding3
	^ (self new)
		add: trinding1;
		add: trinding2;
		add: trinding3;
		yourself! !

!HGElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 08:38'!
with: trinding1 with: trinding2 with: trinding3 with: trinding4
	^ (self new)
		add: trinding1;
		add: trinding2;
		add: trinding3;
		add: trinding4;
		yourself! !

!HGElasticBody class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/15/2011 08:39'!
withAll: aCollectionOfHGTrinding
	| body |
	body := self new.
	aCollectionOfHGTrinding do: [ :trinding | body add: trinding ].
	^ body! !

!HGElasticBody methodsFor: 'adding' stamp: 'TomohiroOda 7/15/2011 08:27'!
add: anHGTrinding
	self merge: anHGTrinding.
	^ anHGTrinding! !

!HGElasticBody methodsFor: 'geometry' stamp: 'TomohiroOda 7/15/2011 09:35'!
borderAt: anHG2dPoint
	| minDistance nearestPoint |
	minDistance := Float infinity.
	nearestPoint := nil.
	self
		pairsDo: [ :particle1 :particle2 | 
			| point distance |
			point := particle1 position to: particle2 position nearestFrom: anHG2dPoint.
			distance := anHG2dPoint distance: point.
			distance < minDistance
				ifTrue: [ 
					minDistance := distance.
					nearestPoint := point ] ].
	^ nearestPoint! !

!HGElasticBody methodsFor: 'constraints' stamp: 'TomohiroOda 8/11/2011 10:46'!
bump: anHGParticle
	((self includesParticle: anHGParticle) not and: [ self contains: anHGParticle position ])
		ifTrue: [ 
			self
				nearestPointAndEdgeTo: anHGParticle position
				do: [ :p :vertex1 :vertex2 | 
					| newPosition kickBack v |
					newPosition := (p * (vertex1 mass + vertex2 mass) + (anHGParticle position * anHGParticle mass))
						/ (vertex1 mass + vertex2 mass + anHGParticle mass).
					kickBack := newPosition - p.
					v := (anHGParticle velocity * anHGParticle mass + (vertex1 velocity * vertex1 mass)
						+ (vertex2 velocity * vertex2 mass)) / (anHGParticle mass + vertex1 mass + vertex2 mass).
					anHGParticle position: newPosition.
					anHGParticle velocity: v.
					vertex1 addPosition: kickBack by: 1.0.
					vertex1 velocity: v.
					vertex2 addPosition: kickBack by: 1.0.
					vertex2 velocity: v ] ]! !

!HGElasticBody methodsFor: 'testing' stamp: 'TomohiroOda 7/15/2011 09:17'!
contains: anHG2dPoint
	^ trindings anySatisfy: [ :trinding | trinding contains: anHG2dPoint ]! !

!HGElasticBody methodsFor: 'testing' stamp: 'TomohiroOda 7/15/2011 08:32'!
hasContactWith: anHGElasticBodyOrTrinding
	^ particles anySatisfy: [ :particle | anHGElasticBodyOrTrinding includesParticle: particle ]! !

!HGElasticBody methodsFor: 'testing' stamp: 'TomohiroOda 7/15/2011 08:33'!
includesParticle: anHGParticle
	^ particles includes: anHGParticle  ! !

!HGElasticBody methodsFor: 'initialize-release' stamp: 'TomohiroOda 7/15/2011 10:59'!
initialize
	super initialize.
	trindings := OrderedCollection new.
	particles := IdentitySet new.
	pairs := OrderedCollection new.
! !

!HGElasticBody methodsFor: 'adding' stamp: 'TomohiroOda 7/15/2011 09:17'!
merge: anHGElasticBody
	anHGElasticBody trindingsDo: [ :trinding | trindings add: trinding ].
	anHGElasticBody particlesDo: [ :particle | particles add: particle ].
	anHGElasticBody
		pairsDo: [ :particle1 :particle2 | 
			(pairs detect: [ :edge | (edge at: 1) == particle2 and: [ (edge at: 2) == particle1 ] ] ifNone: [  ])
				ifNil: [ pairs add: (Array with: particle1 with: particle2) ]
				ifNotNilDo: [ :pairEdge | pairs remove: pairEdge ] ]! !

!HGElasticBody methodsFor: 'geometry' stamp: 'TomohiroOda 7/19/2011 10:31'!
nearestPointAndEdgeTo: anHG2dPoint do: aBlock
	| minDistance nearestPoint nearestVertex1 nearestVertex2 |
	minDistance := Float infinity.
	nearestPoint := nil.
	nearestVertex1 := nil.
	nearestVertex2 := nil.
	self
		pairsDo: [ :particle1 :particle2 | 
			| point distance |
			point := particle1 position to: particle2 position nearestFrom: anHG2dPoint.
			distance := anHG2dPoint distance: point.
			distance < minDistance
				ifTrue: [ 
					minDistance := distance.
					nearestPoint := point.
					nearestVertex1 := particle1.
					nearestVertex2 :=  particle2] ].
	nearestPoint ifNotNil: [aBlock value: nearestPoint value: nearestVertex1 value: nearestVertex2  ]! !

!HGElasticBody methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 09:34'!
pairsDo: aBlock
	pairs do: [ :pair | aBlock valueWithArguments: pair]! !

!HGElasticBody methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 08:22'!
particlesDo: aBlock
	particles do: aBlock! !

!HGElasticBody methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 08:21'!
trindingsDo: aBlock
	trindings do: aBlock! !

Object subclass: #HGKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGKernel class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/2/2011 10:42'!
support: aNumber
	^ HGSimpleKernel new setSupport: aNumber! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 11:56'!
at: origin gradient: anHG2dPoint
	^ self at: origin gradient: anHG2dPoint r: (origin distance: anHG2dPoint)! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/12/2011 09:15'!
at: origin gradient: anHG2dPoint r: r
	^ (HG2dPoint x: (anHG2dPoint x - origin x) / r y: anHG2dPoint y - origin y) mul: (self gradient: r)! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 11:54'!
at: origin value: anHG2dPoint
	^ self at: origin value: anHG2dPoint r: (origin distance: anHG2dPoint)! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 11:54'!
at: origin value: anHG2dPoint r: r
	^ self r: r! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 08:58'!
delta
	^ 1.0e-3! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 09:54'!
gradient: r
	^ ((self r: r + self delta) - (self r: r)) / self delta! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 4/15/2011 18:18'!
r: aNumber
	^ self subclassResponsibility ! !

!HGKernel methodsFor: 'accessing' stamp: 'TomohiroOda 4/15/2011 18:19'!
support
	^ self subclassResponsibility ! !

HGKernel subclass: #HGSimpleKernel
	instanceVariableNames: 'support'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGSimpleKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSimpleKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSimpleKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSimpleKernel class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/19/2011 11:07'!
support: aNumber
	^ self new setSupport: aNumber! !

!HGSimpleKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 13:23'!
gradient: r
	^ r < support
		ifTrue: [ 1.0 / support ]
		ifFalse: [ 0 ]! !

!HGSimpleKernel methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 11:01'!
r: aNumber
	^ aNumber < support
		ifTrue: [ (support - aNumber) / support ]
		ifFalse: [ 0.0 ]! !

!HGSimpleKernel methodsFor: 'private' stamp: 'TomohiroOda 4/15/2011 18:20'!
setSupport: aNumber
	support := aNumber ! !

!HGSimpleKernel methodsFor: 'accessing' stamp: 'TomohiroOda 4/15/2011 18:20'!
support
	^ support ! !

HGKernel subclass: #HGSolenthalerKernel
	instanceVariableNames: 'h c halfPi support halfPiOverH cOverHalfPiOverH'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGSolenthalerKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSolenthalerKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSolenthalerKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSolenthalerKernel class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/7/2011 14:49'!
support: aNumber
	^ self new setH: aNumber! !

!HGSolenthalerKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 15:00'!
gradient: aNumber
	| r |
	r := aNumber abs.
	r >= h
		ifTrue: [ ^ 0 ].
	^ ((r + h) * halfPiOverH) sin negated * c! !

!HGSolenthalerKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 14:52'!
r: aNumber
	| r |
	r := aNumber abs.
	r >= h
		ifTrue: [ ^ 0 ].
	^ cOverHalfPiOverH * ((r + h) * halfPiOverH) cos + cOverHalfPiOverH! !

!HGSolenthalerKernel methodsFor: 'private' stamp: 'TomohiroOda 10/7/2011 14:50'!
setH: aNumber
	| pi |
	pi := Float pi.
	h := aNumber.
	c := pi / 8.0 / h / h / h / h / (pi / 3.0 - (8.0 / pi) + (16.0 / pi / pi)).
	halfPi := pi / 2.0.
	halfPiOverH := halfPi / h.
	cOverHalfPiOverH := c / halfPiOverH! !

!HGSolenthalerKernel methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 14:32'!
support
	^ h! !

HGKernel subclass: #HGUniformKernel
	instanceVariableNames: 'support'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGUniformKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGUniformKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGUniformKernel class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGUniformKernel class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/19/2011 11:08'!
support: aNumber
	^ self new setSupport: aNumber! !

!HGUniformKernel methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 08:59'!
gradient: r
	^ r < support
		ifTrue: [ 0.5 ]
		ifFalse: [ 0 ]! !

!HGUniformKernel methodsFor: 'accessing' stamp: 'TomohiroOda 4/19/2011 11:06'!
r: aNumber
	^ aNumber < support
		ifTrue: [ 0.5]
		ifFalse: [ 0.0 ]! !

!HGUniformKernel methodsFor: 'private' stamp: 'TomohiroOda 4/19/2011 11:06'!
setSupport: aNumber
	support := aNumber ! !

!HGUniformKernel methodsFor: 'accessing' stamp: 'TomohiroOda 4/19/2011 11:07'!
support
	^ support ! !

Object subclass: #HGParticle
	instanceVariableNames: 'position velocity pressure force temperature viscosity heat heatConductivity heatCapacity mass attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Particles'!

!HGParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGParticle class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/21/2011 11:21'!
at: position velocity: velocity temperature: temperature mass: mass in: anHGSimulator
	| particle |
	particle := self new.
	particle position: position.
	particle velocity: velocity.
	particle temperature: temperature.
	particle mass: mass.
	^ particle! !

!HGParticle class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 7/6/2011 10:06'!
addForce: anHGPoint by: aNumber
	self force add: anHGPoint by: aNumber! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 7/6/2011 10:23'!
addForce: anHGPoint over: aNumber
	self force add: anHGPoint over: aNumber! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 5/31/2011 08:55'!
addHeat: aNumber by: anotherNumber
	heat := aNumber * anotherNumber + heat! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 6/23/2011 10:17'!
addPosition: anHGPoint by: aNumber
	self position add: anHGPoint by: aNumber! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 7/6/2011 10:07'!
addPressure: anHGPoint by: aNumber
	self pressure add: anHGPoint by: aNumber! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 7/6/2011 09:57'!
addTemperature: aNumber by: anotherNumber
	self temperature: aNumber * anotherNumber + self temperature! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 6/23/2011 10:17'!
addVelocity: anHGPoint by: aNumber
	self velocity add: anHGPoint by: aNumber! !

!HGParticle methodsFor: 'computing' stamp: 'TomohiroOda 5/31/2011 08:56'!
addViscosity: aNumber by: anotherNumber
	viscosity := aNumber * anotherNumber + viscosity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:23'!
area
	^ self position class areaFromVolume: self volume! !

!HGParticle methodsFor: 'accessing - attributes' stamp: 'TomohiroOda 7/15/2011 15:02'!
at: aSymbol ifAbsent: errorBlock
	^ attributes at: aSymbol asSymbol ifAbsent: errorBlock ! !

!HGParticle methodsFor: 'accessing - attributes' stamp: 'TomohiroOda 7/15/2011 15:02'!
at: aSymbol put: anObject
	attributes at: aSymbol asSymbol put: anObject! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/6/2011 10:13'!
force
	^ force! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 15:02'!
force: anHGPoint
	force ifNil: [force := anHGPoint class zero].
	force set: anHGPoint.
	attributes at: #force put: force.
! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:37'!
heat
	^heat! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:37'!
heat: aNumber
	heat := aNumber! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 13:16'!
heatCapacity
	^ heatCapacity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 13:16'!
heatCapacity: aNumber
	heatCapacity := aNumber! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 13:15'!
heatConductivity
	^ heatConductivity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:28'!
heatConductivity: aNumber
	heatConductivity := aNumber! !

!HGParticle methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/2/2011 10:31'!
initialize
	attributes := IdentityDictionary new.
	self force: HG2dPoint zero.
	self velocity: HG2dPoint zero.
	self position: HG2dPoint zero.
	self heatConductivity: 10.0.
	self heatCapacity: 10.0.
	self temperature: 390! !

!HGParticle methodsFor: 'accessing - attributes' stamp: 'TomohiroOda 7/15/2011 15:02'!
keysAndValuesDo: aBlock
	attributes keysAndValuesDo: aBlock.! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:28'!
mass
	^ mass! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:28'!
mass: aNumber
	mass := aNumber! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/6/2011 10:14'!
position
	^ position! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 15:01'!
position: anHGPoint
	position ifNil: [position := anHGPoint].
	position set: anHGPoint.
	attributes at: #p put: position! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/6/2011 10:15'!
pressure
	^ pressure! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 15:01'!
pressure: aNumber
	pressure := aNumber.
	attributes at: #pressure put: aNumber! !

!HGParticle methodsFor: 'printing' stamp: 'TomohiroOda 7/15/2011 09:40'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	self position printOn: aStream.
	aStream nextPut: $)! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/6/2011 10:15'!
temperature
	^  temperature! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 15:01'!
temperature: aNumber
	temperature := aNumber.
	attributes at: #temperature put: aNumber! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/6/2011 10:15'!
velocity
	^ velocity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 7/15/2011 15:01'!
velocity: anHGPoint
	velocity ifNil: [velocity := anHGPoint class zero].
	velocity set: anHGPoint.
	attributes at: #velocity put: velocity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 09:02'!
viscosity
	^ viscosity! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 09:02'!
viscosity: aNumber
	viscosity := aNumber! !

!HGParticle methodsFor: 'accessing' stamp: 'TomohiroOda 6/23/2011 09:36'!
volume
	^ self mass! !

Object subclass: #HGPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Points'!

HGPoint subclass: #HG2dPoint
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Points'!

!HG2dPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HG2dPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HG2dPoint class methodsFor: 'utilities' stamp: 'TomohiroOda 4/27/2011 17:15'!
areaFromVolume: aNumber
	^ aNumber raisedTo: 0.5! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/20/2011 08:00'!
fromNumber: aNumber
	^ self x: aNumber y: aNumber! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/8/2011 07:32'!
fromPoint: aPoint
	^ self x: aPoint x y: aPoint y! !

!HG2dPoint class methodsFor: 'utilities' stamp: 'TomohiroOda 4/27/2011 17:15'!
lengthFromVolume: aNumber
	^ aNumber raisedTo: 0.5! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/25/2011 15:14'!
randomFrom: anHG2dPoint to: anotherHG2dPoint with: aRandom
	^ self
		x: (anotherHG2dPoint x - anHG2dPoint x) * aRandom next + anHG2dPoint x
		y: (anotherHG2dPoint y - anHG2dPoint y) * aRandom next + anHG2dPoint y! !

!HG2dPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/6/2011 15:06'!
theta: rad r: radius
	^ self x: rad cos * radius y: rad sin * radius! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/6/2011 13:23'!
x: aNumber y: anotherNumber
	^self new setX: aNumber y: anotherNumber! !

!HG2dPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/7/2011 10:17'!
zero
	^ self x: 0.0 y: 0.0! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/6/2011 13:29'!
* aNumber
	^ self class x: x * aNumber y: y * aNumber! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:16'!
+ anHG2dPoint
	^ self class x: x + anHG2dPoint x y: y + anHG2dPoint y! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 7/6/2011 10:21'!
- anHG2dPoint
	^ self class x: x - anHG2dPoint x y: y - anHG2dPoint y
	"^self copy minus: anHG2dPoint "! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/6/2011 13:30'!
/ aNumber
	^ self class x: x / aNumber y: y / aNumber! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:05'!
// aNumber
	^ self class x: x // aNumber y: y // aNumber! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:48'!
< anHG2dPoint
	^x < anHG2dPoint x and: [y < anHG2dPoint y]! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:48'!
<= anHG2dPoint
	^x <= anHG2dPoint x and: [y <= anHG2dPoint y]! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 10/7/2011 10:01'!
= anHG2dPoint
	^ self class == anHG2dPoint class and: [ x = anHG2dPoint x and: [ y = anHG2dPoint y ] ]! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:49'!
> anHG2dPoint
	^x > anHG2dPoint x and: [y > anHG2dPoint y]! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:49'!
>= anHG2dPoint
	^x >= anHG2dPoint x and: [y >= anHG2dPoint y]! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:54'!
add: aPoint by: aNumber
	x := aPoint x * aNumber + x.
	y := aPoint y * aNumber + y! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 7/6/2011 10:25'!
add: aPoint minus: anotherPoint by: aNumber
	x := (aPoint x - anotherPoint x) * aNumber + x.
	y := (aPoint y - anotherPoint y) * aNumber + y! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:54'!
add: aPoint over: aNumber
	x := aPoint x / aNumber + x.
	y := aPoint y / aNumber + y! !

!HG2dPoint methodsFor: 'converting' stamp: 'TomohiroOda 7/8/2011 12:38'!
asPoint
	^ x @ y! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:08'!
ceiling 
	^ self class x: x ceiling y: y ceiling! !

!HG2dPoint methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 10:05'!
corner: anHGPoint do: aBlock
	x to: anHGPoint x do: [ :x0 | y to: anHGPoint y do: [ :y0 | aBlock value: (self class x: x0 y: y0) ] ]! !

!HG2dPoint methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 10:05'!
corner: anHGPoint elementsDo: aBlock
	x to: anHGPoint x do: [ :x0 | y to: anHGPoint y do: [ :y0 | aBlock value: x0 value: y0 ] ]! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/20/2011 07:49'!
dimensions
	^2! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:16'!
distance: anHG2dPoint
	^ ((x - anHG2dPoint x) squared + (y - anHG2dPoint y) squared) sqrt! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 10/12/2011 09:16'!
div: aNumber
	x := x / aNumber.
	y := y / aNumber! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 10/7/2011 09:30'!
dot: anHG2dPoint
	^ x * anHG2dPoint x + (y * anHG2dPoint y)! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:08'!
floor
	^ self class x: x floor y: y floor! !

!HG2dPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:47'!
hash
	^x hash bitXor: y hash! !

!HG2dPoint methodsFor: 'testing' stamp: 'TomohiroOda 4/7/2011 08:40'!
in: anHG2dPoint radius: aNumber
	^ (x - anHG2dPoint x) abs < aNumber
		and: [ (y - anHG2dPoint y) abs < aNumber and: [ super in: anHG2dPoint radius: aNumber ] ]! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 10:28'!
indexIn: anHGPoint
	^ (0 <= x and: [ x < anHGPoint x and: [ 0 <= y and: [ y < anHGPoint y ] ] ])
		ifTrue: [ x * anHGPoint y + y + 1 ]! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 10/7/2011 10:34'!
laplace: aBlock delta: aNumber
	| v vx1 vx2 vy1 vy2 |
	v := aBlock value: self.
	vx1 := aBlock value: (self class x: x - aNumber y: y).
	vx2 := aBlock value: (self class x: x + aNumber y: y).
	vy1 := aBlock value: (self class x: x y: y - aNumber).
	vy2 := aBlock value: (self class x: x y: y + aNumber).
	^ ((vx2 - v) / aNumber - ((v - vx1) / aNumber)) / aNumber + (((vy2 - v) / aNumber - ((v - vy1) / aNumber)) / aNumber)! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/19/2011 10:05'!
length: aNumber
	| denominator |
	denominator := ((x * x) + (y * y)) sqrt / aNumber.
	x := x / denominator.
	y := y / denominator! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/24/2011 14:56'!
min: anHG2dPoint max: anotherHG2dPoint
	^ self class x: (x min: anHG2dPoint x max: anotherHG2dPoint x) y: (y min: anHG2dPoint y max: anotherHG2dPoint y)! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 10/12/2011 09:15'!
mul: aNumber
	x := x * aNumber.
	y := y * aNumber! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/6/2011 13:32'!
norm1
	^ x abs + y abs! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/6/2011 13:33'!
norm2
	^ (x squared  + y squared) sqrt! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/6/2011 13:36'!
norm: aNumber
	^ (x raisedTo: aNumber) + (y raisedTo: aNumber) raisedTo: aNumber reciprocal! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:53'!
plus: aPoint by: aNumber
	^ self class x: aPoint x * aNumber + x y: aPoint y * aNumber + y! !

!HG2dPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:53'!
plus: aPoint over: aNumber
	^ self class x: aPoint x / aNumber + x y: aPoint y / aNumber + y! !

!HG2dPoint methodsFor: 'printing' stamp: 'TomohiroOda 4/7/2011 12:40'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	x printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	y printOn: aStream.
	aStream nextPut: $)! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 5/20/2011 08:06'!
product
	^ x * y! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 11:45'!
r
	^ self norm2! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/31/2011 09:03'!
set: aPoint
	x := aPoint x.
	y := aPoint y! !

!HG2dPoint methodsFor: 'private' stamp: 'TomohiroOda 4/6/2011 13:23'!
setX: aNumber y: anotherNumber
	x := aNumber.
	y := anotherNumber! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 10/7/2011 11:48'!
theta
	^ y < 0.0
		ifTrue: [ Float pi * 2.0 - (x / (x * x + (y * y)) sqrt) arcCos ]
		ifFalse: [ (x / (x * x + (y * y)) sqrt) arcCos ]! !

!HG2dPoint methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 14:01'!
to: anHG2dPoint conflictsWithLineSegment: anotherFrom to: anotherTo
	^ (self to: anHG2dPoint cross: anotherFrom) sign ~= (self to: anHG2dPoint cross: anotherTo) sign
		and: [ (anotherFrom to: anotherTo cross: self) sign ~= (anotherFrom to: anotherTo cross: anHG2dPoint) sign ]! !

!HG2dPoint methodsFor: 'testing' stamp: 'TomohiroOda 7/14/2011 15:41'!
to: anHG2dPoint contains: anotherHG2dPoint
	^ (self to: anHG2dPoint cross: anotherHG2dPoint) abs < 1.0e-1
		and: [ 
			| dot |
			dot := self to: anHG2dPoint dot: anotherHG2dPoint.
			dot between: 0.0 and: (self to: anHG2dPoint dot: anHG2dPoint) ]! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 6/6/2011 13:19'!
to: anHG2dPoint cross: anotherHG2dPoint
	| x1 x2 y1 y2 |
	x1 := anHG2dPoint x - x.
	x2 := anotherHG2dPoint x - x.
	y1 := anHG2dPoint y - y.
	y2 := anotherHG2dPoint y - y.
	^ x1 * y2 - (y1 * x2)! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 10/6/2011 15:54'!
to: anHG2dPoint crossPoint: anotherFrom to: anotherTo
	| min1 min2 max1 max2 x1 y1 x2 y2 x3 y3 x4 y4 t1 t2 t x0 y0 |
	min1 := x min: anHG2dPoint x.
	min2 := anotherFrom x min: anotherTo x.
	max1 := x max: anHG2dPoint x.
	max2 := anotherFrom x max: anotherTo x.
	(min1 > max2 or: [ max1 < min2 ])
		ifTrue: [ ^ nil ].
	min1 := y min: anHG2dPoint y.
	min2 := anotherFrom y min: anotherTo y.
	max1 := y max: anHG2dPoint y.
	max2 := anotherFrom y max: anotherTo y.
	(min1 > max2 or: [ max1 < min2 ])
		ifTrue: [ ^ nil ].
	x1 := x.
	y1 := y.
	x2 := anHG2dPoint x.
	y2 := anHG2dPoint y.
	x3 := anotherFrom x.
	y3 := anotherFrom y.
	x4 := anotherTo x.
	y4 := anotherTo y.
	t1 := (x1 - x3) * (y4 - y3) - ((x4 - x3) * (y1 - y3)).
	t2 := (x4 - x3) * (y2 - y1) - ((x2 - x1) * (y4 - y3)).
	t2 = 0.0 ifTrue: [^nil].
	t := t1 / t2.
	x0 := (x2 - x1) * t + x1.
	y0 := (y2 - y1) * t + y1.
	^ (x0 >= (x1 min: x2) and: [ x0 <= (x1 max: x2) ])
		ifTrue: [ HG2dPoint x: x0 y: y0 ]
		ifFalse: [ nil ]! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 7/14/2011 13:23'!
to: anHG2dPoint crossPointX: aNumber
	(x max: anHG2dPoint x) < aNumber
		ifTrue: [ ^ nil ].
	(x min: anHG2dPoint x) > aNumber
		ifTrue: [ ^ nil ].
	^ self class x: aNumber y: (anHG2dPoint y - y) * (aNumber - x) / (anHG2dPoint x - x) + y! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 7/14/2011 13:23'!
to: anHG2dPoint crossPointY: aNumber
	(y max: anHG2dPoint y) < aNumber
		ifTrue: [ ^ nil ].
	(y min: anHG2dPoint y) > aNumber
		ifTrue: [ ^ nil ].
	^ self class x: (anHG2dPoint x - x) * (aNumber - y) / (anHG2dPoint y - y) + x y: aNumber! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 10/7/2011 09:25'!
to: anHG2dPoint distance: anotherHG2dPoint
	^ (self to: anHG2dPoint nearestFrom: anotherHG2dPoint) distance: anotherHG2dPoint ! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 6/6/2011 13:19'!
to: anHG2dPoint dot: anotherHG2dPoint
	| x1 x2 y1 y2 |
	x1 := anHG2dPoint x - x.
	x2 := anotherHG2dPoint x - x.
	y1 := anHG2dPoint y - y.
	y2 := anotherHG2dPoint y - y.
	^ x1 * x2 + (y1 * y2)! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 7/15/2011 13:33'!
to: anHG2dPoint nearestFrom: anotherHG2dPoint
	| distance |
	^ (distance := self distance: anHG2dPoint) < 1.0e-8
		ifTrue: [ self copy ]
		ifFalse: [ 
			(anHG2dPoint - self)
				* ((self to: anHG2dPoint dot: anotherHG2dPoint) / (self to: anHG2dPoint dot: anHG2dPoint) min: 1.0 max: 0.0) + self ]! !

!HG2dPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/19/2011 10:10'!
unitVector: aPoint
	| vx vy denominator |
	vx := aPoint x - x.
	vy := aPoint y - y.
	denominator := (vx * vx + (vy * vy)) sqrt.
	denominator < 1.0e-20
		ifTrue: [ denominator := 1.0 ].
	^ self class x: vx / denominator y: vy / denominator! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 4/6/2011 13:21'!
x 
	^x! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 14:29'!
x: aNumber
	x := aNumber! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 4/6/2011 13:21'!
y 
	^y! !

!HG2dPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/25/2011 14:29'!
y: aNumber
	y := aNumber! !

!HGPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGPoint class methodsFor: 'utilities' stamp: 'TomohiroOda 4/26/2011 15:25'!
areaFromVolume: aNumber
	^ self subclassResponsibility ! !

!HGPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/20/2011 08:00'!
fromNumber: aNumber
	^ self subclassResponsibility ! !

!HGPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/26/2011 15:26'!
fromPoint: aPoint
	^ self subclassResponsibility ! !

!HGPoint class methodsFor: 'utilities' stamp: 'TomohiroOda 4/26/2011 15:25'!
lengthFromVolume: aNumber
	^ self subclassResponsibility ! !

!HGPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 5/25/2011 15:13'!
randomFrom: aHGPoint to: anotherHGPoint with: aRandom
	^ self subclassResponsibility! !

!HGPoint class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGPoint class methodsFor: 'instance creation' stamp: 'TomohiroOda 4/26/2011 15:26'!
zero
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:39'!
* aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:40'!
+ anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:40'!
- anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:39'!
/ aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:05'!
// aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:45'!
< anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:44'!
<= anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:45'!
= anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:45'!
> anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:45'!
>= anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 10/7/2011 10:38'!
abs
	^ self norm1! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/17/2011 11:36'!
add: anHGPoint by: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 7/6/2011 10:25'!
add: aPoint minus: anotherPoint by: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:56'!
add: anHGPoint over: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:08'!
ceiling
	^ self subclassResponsibility! !

!HGPoint methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 10:05'!
corner: anHGPoint do: aBlock
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 10:05'!
corner: anHGPoint elementsDo: aBlock
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/20/2011 07:49'!
dimensions
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:42'!
distance: anHGPoint
	^ (self - anHGPoint) norm2! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/7/2011 08:40'!
dot: anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/20/2011 08:08'!
floor
	^ self subclassResponsibility! !

!HGPoint methodsFor: 'comparing' stamp: 'TomohiroOda 5/19/2011 14:45'!
hash
	^self subclassResponsibility ! !

!HGPoint methodsFor: 'testing' stamp: 'TomohiroOda 4/7/2011 08:41'!
in: anHGPoint radius: aNumber
	^ (self distance: anHGPoint) < aNumber! !

!HGPoint methodsFor: 'accessing' stamp: 'TomohiroOda 5/20/2011 08:22'!
indexIn: anHGPoint
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:43'!
laplace: aBlock delta: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:43'!
length
	^ self norm2! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 10/7/2011 10:37'!
length: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 5/24/2011 14:55'!
min: anHGPoint max: anotherHGPoint
	^ self subclassResponsibility! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:43'!
norm1
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:44'!
norm2
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 08:44'!
norm: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:56'!
plus: anHGPoint by: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'arithmetics' stamp: 'TomohiroOda 4/28/2011 08:56'!
plus: anHGPoint over: aNumber
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 5/20/2011 08:06'!
product
	^ self subclassResponsibility ! !

!HGPoint methodsFor: 'vector' stamp: 'TomohiroOda 4/7/2011 13:07'!
unit
	| n |
	n := self norm2.
	^n < 1.0e-20 ifTrue: [self] ifFalse: [self / self norm2]! !

Object variableSubclass: #HGSpatialPartitionedCollection
	instanceVariableNames: 'origin corner step size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGSpatialPartitionedCollection class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGSpatialPartitionedCollection class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGSpatialPartitionedCollection class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/8/2011 11:34'!
origin: anHGPoint corner: anotherHGPoint step: aNumber
	| size |
	size := ((anotherHGPoint - anHGPoint) / aNumber) floor + (anHGPoint class fromNumber: 1).
	^ (self new: size product)
		setOrigin: anHGPoint
		corner: anotherHGPoint
		step: aNumber
		size: size! !

!HGSpatialPartitionedCollection class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 6/9/2011 09:04'!
at: anHGPoint add: anObject
	^ ((self indexAt: anHGPoint) ifNotNilDo: [ :index | (self at: index) add: anObject ])! !

!HGSpatialPartitionedCollection methodsFor: 'enumerating' stamp: 'TomohiroOda 6/8/2011 12:47'!
at: anHGPoint do: aBlock
	^((self indexAt: anHGPoint) ifNotNilDo: [ :index | (self at: index) do: aBlock ])! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:35'!
at: anHGPoint remove: anObject
	^ self at: ((self indexAt: anHGPoint) ifNotNilDo: [ :partition | partition remove: anObject ])! !

!HGSpatialPartitionedCollection methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 08:04'!
at: anHGPoint within: aNumber do: aBlock
	| from to |
	from := anHGPoint - (anHGPoint class fromNumber: aNumber).
	to := anHGPoint + (anHGPoint class fromNumber: aNumber).
	self from: from to: to do: aBlock! !

!HGSpatialPartitionedCollection methodsFor: 'enumerating' stamp: 'TomohiroOda 5/20/2011 08:55'!
do: aBlock
	1 to: self size do: [ :index | (self at: index) do: aBlock ]! !

!HGSpatialPartitionedCollection methodsFor: 'enumerating' stamp: 'TomohiroOda 5/24/2011 15:11'!
from: anHGPoint to: anotherHGPoint do: aBlock
	(self indexPointAt: anHGPoint)
		corner: (self indexPointAt: anotherHGPoint)
		do: [ :indexPoint | 
			| index |
			index := indexPoint indexIn: size.
			index ifNotNil: [ (self at: index) do: aBlock ] ]! !

!HGSpatialPartitionedCollection methodsFor: 'enumerating' stamp: 'TomohiroOda 6/8/2011 11:39'!
from: anHGPoint to: anotherHGPoint partitionsDo: aBlock
	(self indexPointAt: anHGPoint)
		corner: (self indexPointAt: anotherHGPoint)
		do: [ :indexPoint | 
			| index |
			index := indexPoint indexIn: size.
			index ifNotNil: [ aBlock value: (self at: index) ] ]! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 11:35'!
indexAt: anHGPoint
	^ (self indexPointAt: anHGPoint) indexIn: size! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 5/24/2011 15:08'!
indexPointAt: anHGPoint
	^ ((anHGPoint - origin) / step) floor! !

!HGSpatialPartitionedCollection methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/10/2011 07:50'!
initialize
	1 to: self size do: [ :index | self at: index put: IdentitySet new]! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 5/20/2011 07:58'!
move: anObject from: anHGPoint to: anotherHGPoint
	| from to |
	from := self indexAt: anHGPoint.
	to := self indexAt: anotherHGPoint.
	from = to
		ifFalse: [ 
			(self at: from) remove: anObject.
			(self at: to) add: anObject ].
	^ anObject! !

!HGSpatialPartitionedCollection methodsFor: 'private' stamp: 'TomohiroOda 5/20/2011 12:30'!
setOrigin: anHGPoint corner: anotherHGPoint step: aNumber size: sizePoint
	origin := anHGPoint.
	corner := anotherHGPoint.
	step := aNumber.
	size := sizePoint! !

!HGSpatialPartitionedCollection methodsFor: 'accessing' stamp: 'TomohiroOda 6/8/2011 12:37'!
sizePoint
	^size! !

Object subclass: #HGTriangulator
	instanceVariableNames: 'triangles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Neighbors'!

!HGTriangulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTriangulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTriangulator class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/8/2011 11:26'!
origin: anHGPoint corner: anotherHGPoint step: aNumber
	^ self new setOrigin: anHGPoint corner: anotherHGPoint step: aNumber! !

!HGTriangulator class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTriangulator methodsFor: 'operations' stamp: 'TomohiroOda 6/10/2011 08:48'!
divideAt: anHG2dPoint
	| triangle from to triangle1 from1 to1 triangle2 from2 to2 triangle3 from3 to3 pair1 va1 pair2 va2 pair3 va3 agenda |
	triangle := self triangleAt: anHG2dPoint.
	triangle ifNil: [ ^ nil ].
	triangle1 := HG2dTriangle on: triangle vertex1 on: triangle vertex2 on: anHG2dPoint.
	triangle2 := HG2dTriangle on: triangle vertex2 on: triangle vertex3 on: anHG2dPoint.
	triangle3 := HG2dTriangle on: triangle vertex3 on: triangle vertex1 on: anHG2dPoint.
	self
		neighborPairParams: triangle
		do: [ :params :pairParams | 
			(pairParams at: 5) == triangle vertex3
				ifTrue: [ 
					pairParams at: 1 put: triangle1.
					pairParams at: 5 put: anHG2dPoint.
					pair1 := params at: 1.
					va1 := params at: 5 ]
				ifFalse: [ 
					(pairParams at: 5) == triangle vertex1
						ifTrue: [ 
							pairParams at: 1 put: triangle2.
							pairParams at: 5 put: anHG2dPoint.
							pair2 := params at: 1.
							va2 := params at: 5 ]
						ifFalse: [ 
							(pairParams at: 5) == triangle vertex2
								ifTrue: [ 
									pairParams at: 1 put: triangle3.
									pairParams at: 5 put: anHG2dPoint.
									pair3 := params at: 1.
									va3 := params at: 5 ] ] ] ].
	triangles removeKey: triangle.
	triangles
		at: triangle1
		put:
			(OrderedCollection
				with:
					(Array
						with: triangle2
						with: triangle vertex2
						with: anHG2dPoint
						with: triangle vertex1
						with: triangle vertex3)
				with:
					(Array
						with: triangle3
						with: anHG2dPoint
						with: triangle vertex1
						with: triangle vertex2
						with: triangle vertex3)).
	pair1
		ifNotNil: [ 
			(triangles at: triangle1)
				add:
					(Array
						with: pair1
						with: triangle vertex1
						with: triangle vertex2
						with: anHG2dPoint
						with: va1) ].
	triangles
		at: triangle2
		put:
			(OrderedCollection
				with:
					(Array
						with: triangle3
						with: triangle vertex3
						with: anHG2dPoint
						with: triangle vertex2
						with: triangle vertex1)
				with:
					(Array
						with: triangle1
						with: anHG2dPoint
						with: triangle vertex2
						with: triangle vertex3
						with: triangle vertex1)).
	pair2
		ifNotNil: [ 
			(triangles at: triangle2)
				add:
					(Array
						with: pair2
						with: triangle vertex2
						with: triangle vertex3
						with: anHG2dPoint
						with: va2) ].
	triangles
		at: triangle3
		put:
			(OrderedCollection
				with:
					(Array
						with: triangle1
						with: triangle vertex1
						with: anHG2dPoint
						with: triangle vertex3
						with: triangle vertex2)
				with:
					(Array
						with: triangle2
						with: anHG2dPoint
						with: triangle vertex3
						with: triangle vertex1
						with: triangle vertex2)).
	pair3
		ifNotNil: [ 
			(triangles at: triangle3)
				add:
					(Array
						with: pair3
						with: triangle vertex3
						with: triangle vertex1
						with: anHG2dPoint
						with: va3) ].
	agenda := IdentitySet new: 4.
	agenda add: triangle1.
	agenda add: triangle2.
	agenda add: triangle3.
	self optimize: agenda! !

!HGTriangulator methodsFor: 'private' stamp: 'TomohiroOda 6/10/2011 08:04'!
flip: triangle1 with: neighborParams agenda: agenda
	| triangle2 v1 v2 va vb triangleA triangleB |
	triangle2 := neighborParams at: 1.
	v1 := neighborParams at: 2.
	v2 := neighborParams at: 3.
	va := neighborParams at: 4.
	vb := neighborParams at: 5.
	triangleA := HG2dTriangle on: v1 on: vb on: va.
	triangleB := HG2dTriangle on: v2 on: va on: vb.
	triangles
		at: triangleA
		put:
			(OrderedCollection
				with:
					(Array
						with: triangleB
						with: vb
						with: va
						with: v1
						with: v2)).
	triangles
		at: triangleB
		put:
			(OrderedCollection
				with:
					(Array
						with: triangleA
						with: va
						with: vb
						with: v2
						with: v1)).
	self
		neighborPairParams: triangle1
		do: [ :params1 :paramsX | 
			(paramsX at: 5) == v1
				ifTrue: [ 
					paramsX at: 1 put: triangleB.
					paramsX at: 5 put: vb.
					(triangles at: triangleB)
						add:
							(Array
								with: (params1 at: 1)
								with: v2
								with: va
								with: vb
								with: (params1 at: 5)) ].
			(paramsX at: 5) == v2
				ifTrue: [ 
					paramsX at: 1 put: triangleA.
					paramsX at: 5 put: vb.
					(triangles at: triangleA)
						add:
							(Array
								with: (params1 at: 1)
								with: va
								with: v1
								with: vb
								with: (params1 at: 5)) ] ].
	self
		neighborPairParams: triangle2
		do: [ :params2 :paramsX | 
			(paramsX at: 5) == v1
				ifTrue: [ 
					paramsX at: 1 put: triangleB.
					paramsX at: 5 put: va.
					(triangles at: triangleB)
						add:
							(Array
								with: (params2 at: 1)
								with: vb
								with: v2
								with: va
								with: (params2 at: 5)) ].
			(paramsX at: 5) == v2
				ifTrue: [ 
					paramsX at: 1 put: triangleA.
					paramsX at: 5 put: va.
					(triangles at: triangleA)
						add:
							(Array
								with: (params2 at: 1)
								with: v1
								with: vb
								with: va
								with: (params2 at: 5)) ] ].
	triangles removeKey: triangle1 ifAbsent: [].
	triangles removeKey: triangle2 ifAbsent: [].
	agenda
		ifNotNil: [ 
			agenda remove: triangle2 ifAbsent: [].
			agenda add: triangleA.
			agenda add: triangleB ]! !

!HGTriangulator methodsFor: 'private' stamp: 'TomohiroOda 6/10/2011 08:25'!
minAngleOn: vertex1 on: vertex2 on: vertex3
	| area d l12 l23 l31 angle1 angle2 angle3 |
	area := vertex1 to: vertex2 cross: vertex3.
	l12 := (d := vertex1 x - vertex2 x) * d + ((d := vertex1 y - vertex2 y) * d).
	l23 := (d := vertex2 x - vertex3 x) * d + ((d := vertex2 y - vertex3 y) * d).
	l31 := (d := vertex3 x - vertex1 x) * d + ((d := vertex3 y - vertex1 y) * d).
	^l12 < l23
		ifTrue: [ 
			l12 < l31
				ifTrue: [ area / (l23 * l31) sqrt ]
				ifFalse: [ area /( l12 * l23) sqrt ] ]
		ifFalse: [ 
			l23 < l31
				ifTrue: [ area / (l12 * l31) sqrt ]
				ifFalse: [ area / (l12 * l23) sqrt ] ]! !

!HGTriangulator methodsFor: 'private' stamp: 'TomohiroOda 6/9/2011 08:12'!
neighborPairParams: anHG2dTriangle do: aBlock
	(triangles at: anHG2dTriangle)
		do: [ :params | 
			(triangles at: (params at: 1))
				do: [ :pairParams | 
					(pairParams at: 1) == anHG2dTriangle
						ifTrue: [ aBlock value: params value: pairParams ] ] ]! !

!HGTriangulator methodsFor: 'operations' stamp: 'TomohiroOda 6/9/2011 11:40'!
optimize
	| agenda |
	agenda := IdentitySet new: triangles size.
	self trianglesDo: [ :triangle | agenda add: triangle].
	self optimize: agenda! !

!HGTriangulator methodsFor: 'operations' stamp: 'TomohiroOda 6/9/2011 14:42'!
optimize: anIdentitySet
	[ anIdentitySet isEmpty ]
		whileFalse: [ 
			| triangle |
			triangle := anIdentitySet anyOne.
			anIdentitySet remove: triangle ifAbsent: [].
			self optimize: anIdentitySet triangle: triangle ]! !

!HGTriangulator methodsFor: 'operations' stamp: 'TomohiroOda 6/10/2011 08:28'!
optimize: anIdentitySet triangle: anHG2dTriangle
	| minAngle1 |
	minAngle1 := self minAngleOn: anHG2dTriangle vertex1 on: anHG2dTriangle vertex2 on: anHG2dTriangle vertex3.
	(triangles at: anHG2dTriangle)
		do: [ :params | 
			| v1 v2 va vb |
			v1 := params at: 2.
			v2 := params at: 3.
			va := params at: 4.
			vb := params at: 5.
			((vb to: va cross: v1) > 0.0
				and: [ 
					(va to: vb cross: v2) > 0.0
						and: [ 
							(minAngle1 min: (self minAngleOn: vb on: v2 on: v1))
								< ((self minAngleOn: v1 on: vb on: va) min: (self minAngleOn: v2 on: va on: vb)) ] ])
				ifTrue: [ ^ self flip: anHG2dTriangle with: params agenda: anIdentitySet ] ]! !

!HGTriangulator methodsFor: 'private' stamp: 'TomohiroOda 6/9/2011 08:35'!
sanityCheck
	triangles
		keysAndValuesDo: [ :triangle :paramsList | 
			paramsList
				do: [ :params | 
					| pairParams |
					pairParams := (triangles at: (params at: 1))
						detect: [ :p | p first == triangle ]
						ifNone: [ self error: 'triangle not found in its neighbor''s neighbors list' ].
					(params at: 2) == (pairParams at: 3)
						ifFalse: [ self error: 'wrong edge vertices between neighbors.' ].
					(params at: 3) == (pairParams at: 2)
						ifFalse: [ self error: 'wrong edge vertices between neighbors.' ] ] ]! !

!HGTriangulator methodsFor: 'private' stamp: 'TomohiroOda 10/2/2011 10:31'!
setOrigin: anHGPoint corner: anotherHGPoint step: aNumber
	| x0 x1 y0 y1 v1 v2 v3 v4 t1 t2 |
	x0 := anHGPoint x.
	x1 := anotherHGPoint x.
	y0 := anHGPoint y.
	y1 := anotherHGPoint y.
	v1 := HG2dPoint x: x0 y: y0.
	v2 := HG2dPoint x: x1 y: y0.
	v3 := HG2dPoint x: x1 y: y1.
	v4 := HG2dPoint x: x0 y: y1.
	t1 := HG2dTriangle on: v1 on: v2 on: v3.
	t2 := HG2dTriangle on: v3 on: v4 on: v1.
	triangles := IdentityDictionary new: 1000.
	triangles
		at: t1
		put:
			(OrderedCollection
				with:
					(Array
						with: t2
						with: v3
						with: v1
						with: v2
						with: v4)).
	triangles
		at: t2
		put:
			(OrderedCollection
				with:
					(Array
						with: t1
						with: v1
						with: v3
						with: v4
						with: v2))! !

!HGTriangulator methodsFor: 'accessing' stamp: 'TomohiroOda 6/10/2011 08:05'!
triangleAt: anHG2dPoint
	| bestTriangle bestDepth |
	bestTriangle := nil.
	bestDepth := Float infinity negated.
	triangles associationsDo: [ :assoc | 
			| depth |
			depth := assoc key depth: anHG2dPoint.
			bestDepth < depth
				ifTrue: [ 
					bestDepth := depth.
					bestTriangle := assoc key ] ].
	^ bestTriangle! !

!HGTriangulator methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 11:51'!
trianglesDo: aBlock
	^ triangles keysDo: aBlock! !

Object subclass: #HGTrinding
	instanceVariableNames: 'particle1 particle2 particle3 standardDistance12 standardDistance23 standardDistance31'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Particles'!

!HGTrinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HGTrinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HGTrinding class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/13/2011 11:33'!
among: anHGPartcile1 and: anHGPartcile2 and: anHGPartcile3
	| trinding |
	trinding := (self new)
		particle1: anHGPartcile1;
		particle2: anHGPartcile2;
		particle3: anHGPartcile3;
		yourself.
	trinding standardDistance12: trinding distance12.
	trinding standardDistance23: trinding distance23.
	trinding standardDistance31: trinding distance31.
	^ trinding! !

!HGTrinding class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/8/2011 13:53'!
area
	^ (particle1 position to: particle2 position cross: particle3 position) / 2.0! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/15/2011 08:50'!
borderAt: anHG2dPoint
	|  vertex1 vertex2 vertex3 point distance minDistance nearestPoint |
	vertex1 := particle1 position.
	vertex2 := particle2 position.
	vertex3 := particle3 position.
	point := vertex1 to: vertex2 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	minDistance := distance.
	nearestPoint := point.
	point := vertex2 to: vertex3 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestPoint := point ].
	point := vertex3 to: vertex1 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestPoint := point ].
	^ nearestPoint! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 10/2/2011 10:31'!
center
	^ HG2dPoint x: (particle1 position x + particle2 position x + particle3 position x) / 3.0 y: (particle1 position y + particle2 position y + particle3 position y) / 3.0! !

!HGTrinding methodsFor: 'testing' stamp: 'TomohiroOda 7/15/2011 10:46'!
contains: anHG2dPoint
	^ (((particle1 position x min: particle2 position x) min: particle3 position x) <= anHG2dPoint x
		and: [ 
			((particle1 position y min: particle2 position y) min: particle3 position y) <= anHG2dPoint y
				and: [ 
					anHG2dPoint x <= ((particle1 position x max: particle2 position x) max: particle3 position x)
						and: [ anHG2dPoint y <= ((particle1 position y max: particle2 position y) max: particle3 position y) ] ] ])
		and: [ 
			| sign1 sign2 sign3 |
			sign1 := (particle1 position to: particle2 position cross: anHG2dPoint) sign.
			sign2 := (particle2 position to: particle3 position cross: anHG2dPoint) sign.
			sign3 := (particle3 position to: particle1 position cross: anHG2dPoint) sign.
			sign1 = 0 or: [ sign2 = 0 or: [ sign3 = 0 or: [ sign1 = sign2 and: [ sign2 = sign3 ] ] ] ] ]! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/13/2011 11:42'!
distance12
	^ particle1 position distance: particle2 position! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/13/2011 11:42'!
distance23
	^ particle2 position distance: particle3 position! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/13/2011 11:42'!
distance31
	^ particle3 position distance: particle1 position! !

!HGTrinding methodsFor: 'testing' stamp: 'TomohiroOda 7/15/2011 09:33'!
includesParticle: anHGPartcile
	^ anHGPartcile == particle1 or: [ anHGPartcile == particle2 or: [ anHGPartcile == particle3 ] ]! !

!HGTrinding methodsFor: 'geometry' stamp: 'TomohiroOda 7/19/2011 09:52'!
nearestEdgeTo: anHG2dPoint do: aBlock
	| vertex1 vertex2 vertex3 point distance minDistance nearestVertex1 nearestVertex2 |
	vertex1 := particle1 position.
	vertex2 := particle2 position.
	vertex3 := particle3 position.
	point := vertex1 to: vertex2 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	minDistance := distance.
	nearestVertex1 := vertex1.
	nearestVertex2 := vertex2.
	point := vertex2 to: vertex3 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestVertex1 := vertex2.
			nearestVertex2 := vertex3 ].
	point := vertex3 to: vertex1 nearestFrom: anHG2dPoint.
	distance := anHG2dPoint distance: point.
	distance < minDistance
		ifTrue: [ 
			minDistance := distance.
			nearestVertex1 := vertex3.
			nearestVertex2 := vertex1 ].
	aBlock value: nearestVertex1 value: nearestVertex2! !

!HGTrinding methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 10:51'!
pairsDo: aBlock
	self area > 0.0
		ifTrue: [ 
			aBlock value: particle1 value: particle2.
			aBlock value: particle2 value: particle3.
			aBlock value: particle3 value: particle1 ]! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:47'!
particle1
	^ particle1 ! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:47'!
particle1: anHGParticle
	particle1 := anHGParticle ! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:47'!
particle2
	^ particle2! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:48'!
particle2: anHGParticle
	particle2 := anHGParticle ! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:47'!
particle3
	^ particle3! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/8/2011 13:48'!
particle3: anHGParticle
	particle3 := anHGParticle ! !

!HGTrinding methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 08:26'!
particlesDo: aBlock
	aBlock value: particle1.
	aBlock value: particle2.
	aBlock value: particle3! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:34'!
standardDistance12 
	^ standardDistance12 ! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:34'!
standardDistance12: aNumber
	standardDistance12 := aNumber! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:34'!
standardDistance23 
	^ standardDistance23! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:35'!
standardDistance23: aNumber
	standardDistance23 := aNumber! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:34'!
standardDistance31 
	^ standardDistance31! !

!HGTrinding methodsFor: 'accessing' stamp: 'TomohiroOda 7/13/2011 11:35'!
standardDistance31: aNumber
	standardDistance31 := aNumber! !

!HGTrinding methodsFor: 'enumerating' stamp: 'TomohiroOda 7/15/2011 08:26'!
trindingsDo: aBlock
	aBlock value: self! !

Object subclass: #HGVoronoiDiagram
	instanceVariableNames: 'random distribution regions edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Voronoi'!

!HGVoronoiDiagram class methodsFor: 'examples' stamp: 'TomohiroOda 2/13/2012 11:02'!
exampleVoronoiDiagram
	"HGVoronoiDiagram exampleVoronoiDiagram"

	| random form diagram |
	random := Random new.
	form := Form extent: 500 @ 500 depth: 32.
	diagram := HGVoronoiDiagram new.
	200 timesRepeat: [ | p |
		p := random next @ random next * 500.
		diagram addRegionAt: p ].	
	form getCanvas
		ifNotNilDo: [ :canvas | 
			canvas fillColor: Color lightBlue.
			diagram
				origin: 0 @ 0
				corner: 500 @ 500
				pairsDo: [ :p1 :p2 | 
					canvas
						line: p1 x @ p1 y
						to: p2 x @ p2 y
						width: 10
						color: (Color white alpha: 0.02).
					canvas
						line: p1 x @ p1 y
						to: p2 x @ p2 y
						width: 5
						color: (Color white alpha: 0.02).
					canvas
						line: p1 x @ p1 y
						to: p2 x @ p2 y
						width: 1
						color: (Color white alpha: 0.1) ].
			"diagram regionsDo: [ :region | canvas fillOval: (region center asPoint extent: 1 @ 1) color: Color red ]" ].
	form asMorph openInWindowLabeled: 'Voronoi'.
	^ diagram! !

!HGVoronoiDiagram class methodsFor: 'examples' stamp: 'TomohiroOda 2/11/2012 18:45'!
exampleVoronoiMap
	"HGVoronoiDiagram exampleVoronoiMap"

	| random form diagram |
	random := Random new.
	form := Form extent: 500 @ 500 depth: 32.
	diagram := HGVoronoiDiagram new.
	400
		timesRepeat: [ 
			| p |
			p := random next @ random next * 500.
			diagram addRegionAt: p ].
	form getCanvas
		ifNotNilDo: [ :canvas | 
			canvas fillColor: Color white.
			diagram
				regionsDo: [ :region | 
					| points |
					points := OrderedCollection new: 10.
					region origin: 0 @ 0 corner: 500 @ 500 pointsDo: [ :p | points add: p asPoint ].
					canvas
						drawPolygon: points
						color: Color random
						borderWidth: 0
						borderColor: Color black ].
			diagram
				origin: 0 @ 0
				corner: 500 @ 500
				pairsDo: [ :p1 :p2 | 
					canvas
						line: p1 x @ p1 y
						to: p2 x @ p2 y
						width: 1
						color: Color black ].
			diagram regionsDo: [ :region | canvas fillOval: (region center asPoint extent: 1 @ 1) color: Color red ] ].
	form asMorph openInWindowLabeled: 'Voronoi Map'.
	^ diagram! !

!HGVoronoiDiagram class methodsFor: 'examples' stamp: 'TomohiroOda 2/11/2012 19:13'!
exampleVoronoiPlotter
	"HGVoronoiDiagram exampleVoronoiPlotter"

	| random hueStep hueStream hueBlock imageMorph diagram colorDict plotter |
	random := Random new.
	hueStep := 360.0.
	hueStream := (hueStep / 2.0 to: 360.0 by: hueStep) asArray readStream.
	hueBlock := [hueStream atEnd ifTrue: [hueStep := hueStep / 2.0. hueStream := (hueStep / 2.0 to: 360.0 by: hueStep) asArray readStream]. hueStream next].
	imageMorph := (Form extent: 500 @ 500 depth: 32) asMorph.
	diagram := HGVoronoiDiagram new.
	colorDict := IdentityDictionary new.
	imageMorph
		on: #mouseDown
		send: #value
		to: [ 
			Transcript
				cr;
				show: ActiveHand position printString.
			colorDict
				at: (diagram addRegionAt: ActiveHand position - imageMorph position)
				put: (Color h: hueBlock value s: 1.0 v: 1.0).
			imageMorph form getCanvas
				ifNotNilDo: [ :canvas | 
					canvas fillColor: Color white.
					diagram
						regionsDo: [ :region | 
							| points |
							points := OrderedCollection new: 10.
							region origin: 0 @ 0 corner: 500 @ 500 pointsDo: [ :p | points add: p asPoint ].
							canvas
								drawPolygon: points
								color: (colorDict at: region)
								borderWidth: 0
								borderColor: Color black ].
					diagram regionsDo: [ :region | canvas fillOval: (region center asPoint - 2 extent: 4 @ 4) color: Color black ].
					imageMorph changed ] ].
	plotter := Morph new.
	plotter changeTableLayout.
	plotter listDirection: #bottomToTop.
	plotter wrapCentering: #center.
	plotter addMorph: imageMorph.
	plotter openInWindowLabeled: 'Voronoi Plotter'! !

!HGVoronoiDiagram methodsFor: 'adding' stamp: 'TomohiroOda 2/10/2012 15:11'!
addRegionAt: aPoint
	| thePoint newRegion |
	thePoint := HG2dPoint x: aPoint x asFloat y: aPoint y asFloat.
	newRegion := HGVoronoiRegion at: thePoint.
	(self regionThatContains: thePoint)
		ifNotNilDo: [ :region | 
			| agenda done |
			agenda := OrderedCollection with: region.
			done := OrderedCollection with: region with: newRegion.
			[ agenda notEmpty ]
				whileTrue: [ 
					| currentRegion |
					currentRegion := agenda removeLast.
					(currentRegion
						cutAgainst: newRegion
						conflictEdgesDo: [ :newEdge :edge | 
							| nextRegion |
							nextRegion := edge theOtherSide: currentRegion.
							(done includes: nextRegion)
								ifFalse: [ 
									done add: nextRegion.
									agenda add: nextRegion ] ]) ifNotNilDo: [ :newEdge | edges add: newEdge ] ].
			done do: [ :affected | affected purgeExtraEdges do: [ :e | edges remove: e] ] ].
	^ regions add: newRegion! !

!HGVoronoiDiagram methodsFor: 'enumerating' stamp: 'TomohiroOda 2/9/2012 15:39'!
edgesDo: aBlock
	edges do: aBlock! !

!HGVoronoiDiagram methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/9/2012 16:13'!
initialize
	super initialize.
	regions := OrderedCollection new.
	edges := OrderedCollection new.
	random := Random new.
	distribution := 1.0! !

!HGVoronoiDiagram methodsFor: 'enumerating' stamp: 'TomohiroOda 2/15/2012 15:25'!
origin: aPoint1 corner: aPoint2 pairsDo: aTwoArgumentBlock
	| x1 x2 y1 y2 |
	x1 := aPoint1 x.
	x2 := aPoint2 x.
	y1 := aPoint1 y.
	y2 := aPoint2 y.
	self
		edgesDo: [ :edge | 
			| from to |
			from := edge fromT.
			to := edge toT.
			(edge tAtX: x1)
				ifNotNilDo: [ :t | 
					edge vector x > 0.0
						ifTrue: [ from := from max: t ]
						ifFalse: [ to := to min: t ] ].
			(edge tAtY: y1)
				ifNotNilDo: [ :t | 
					edge vector y > 0.0
						ifTrue: [ from := from max: t ]
						ifFalse: [ to := to min: t ] ].
			(edge tAtX: x2)
				ifNotNilDo: [ :t | 
					edge vector x > 0.0
						ifTrue: [ to := to min: t ]
						ifFalse: [ from := from max: t ] ].
			(edge tAtY: y2)
				ifNotNilDo: [ :t | 
					edge vector y > 0.0
						ifTrue: [ to := to min: t ]
						ifFalse: [ from := from max: t ] ].
			(from <= to and: [ from isInfinite not and: [ to isInfinite not ] ])
				ifTrue: [ 
					| fromPoint toPoint |
					fromPoint := edge atT: from.
					toPoint := edge atT: to.
					((fromPoint x between: x1 and: x2)
						and: [ (toPoint x between: x1 and: x2) and: [ (fromPoint y between: y1 and: y2) and: [ toPoint y between: y1 and: y2 ] ] ])
						ifTrue: [ aTwoArgumentBlock value: (edge atT: from) value: (edge atT: to) ] ] ]! !

!HGVoronoiDiagram methodsFor: 'private' stamp: 'TomohiroOda 2/15/2012 11:21'!
purgeExtraEdges
	regions do: [ :region | region purgeExtraEdges ]! !

!HGVoronoiDiagram methodsFor: 'accessing' stamp: 'TomohiroOda 2/9/2012 15:20'!
regionThatContains: anHG2dPoint
	| x y minSquaredDistance theRegion |
	x := anHG2dPoint x.
	y := anHG2dPoint y.
	minSquaredDistance := Float infinity.
	theRegion := nil.
	regions do: [:region | 
			| center squaredDistance dx dy |
			center := region center.
			squaredDistance := (dx := center x - x) * dx + ((dy := center y - y) * dy).
			squaredDistance < minSquaredDistance
				ifTrue: [ 
					minSquaredDistance := squaredDistance.
					theRegion := region ] ].
	^ theRegion! !

!HGVoronoiDiagram methodsFor: 'enumerating' stamp: 'TomohiroOda 2/9/2012 15:39'!
regionsDo: aBlock
	regions do: aBlock! !

Object subclass: #HGVoronoiEdge
	instanceVariableNames: 'foreside backside origin vector fromT toT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Voronoi'!

!HGVoronoiEdge class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/8/2012 13:35'!
foreside: anHGVoronoiRegion1 backside: anHGVoronoiRegion2
	| x1 y1 x2 y2 originX originY vectorX vectorY |
	x1 := anHGVoronoiRegion1 center x.
	y1 := anHGVoronoiRegion1 center y.
	x2 := anHGVoronoiRegion2 center x.
	y2 := anHGVoronoiRegion2 center y.
	^ self
		foreside: anHGVoronoiRegion1
		backside: anHGVoronoiRegion2
		origin: (HG2dPoint x: (x1 + x2) / 2.0 y: (y1 + y2) / 2.0)
		vector: (HG2dPoint x: y2 - y1 y: x1 - x2)! !

!HGVoronoiEdge class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/8/2012 13:31'!
foreside: anHGVoronoiRegion1 backside: anHGVoronoiRegion2 origin: anHG2dPoint1 vector: anHG2dPoint2
	^ self foreside: anHGVoronoiRegion1  backside: anHGVoronoiRegion2 origin:  anHG2dPoint1 vector: anHG2dPoint2 fromT: Float infinity negated toT:  Float infinity ! !

!HGVoronoiEdge class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/8/2012 13:27'!
foreside: anHGVoronoiRegion1 backside: anHGVoronoiRegion2 origin: anHG2dPoint1 vector: anHG2dPoint2 fromT: aNumber1 toT: aNumber2
	^ (self new)
		foreside: anHGVoronoiRegion1;
		backside: anHGVoronoiRegion2;
		origin: anHG2dPoint1;
		vector: anHG2dPoint2;
		fromT: aNumber1;
		toT: aNumber2;
		yourself! !

!HGVoronoiEdge methodsFor: 'geometry' stamp: 'TomohiroOda 2/8/2012 13:41'!
atT: aNumber
	^ HG2dPoint x: vector x * aNumber + origin x y: vector y * aNumber + origin y! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
backside
	^ backside ! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
backside: anHGVoronoiRegion
	backside  := anHGVoronoiRegion ! !

!HGVoronoiEdge methodsFor: 'testing' stamp: 'TomohiroOda 2/8/2012 13:54'!
containsT: aNumber
	^ fromT <= aNumber and: [ aNumber <= toT ]! !

!HGVoronoiEdge methodsFor: 'testing' stamp: 'TomohiroOda 2/10/2012 14:22'!
containsT: aNumber accuracy: anotherNumber
	^ fromT - anotherNumber <= aNumber and: [ aNumber - anotherNumber <= toT ]! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:28'!
foreside
	^ foreside! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
foreside: anHGVoronoiRegion
	foreside := anHGVoronoiRegion ! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:30'!
fromT
	^ fromT! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:30'!
fromT: aNumber
	fromT := aNumber! !

!HGVoronoiEdge methodsFor: 'testing' stamp: 'TomohiroOda 2/8/2012 13:52'!
isEmpty
	^ fromT > toT! !

!HGVoronoiEdge methodsFor: 'testing' stamp: 'TomohiroOda 2/8/2012 13:52'!
notEmpty
	^ fromT <= toT! !

!HGVoronoiEdge methodsFor: 'topology' stamp: 'TomohiroOda 2/10/2012 14:55'!
on: anHGVoronoiRegion cutAtT: aNumber byEdge: anHGVoronoiEdge
	| center |
	center := anHGVoronoiRegion center.
	^ (fromT - aNumber) abs > (toT - aNumber) abs
		ifTrue: [ 
			| p |
			p := self
				atT:
					(fromT isInfinite
						ifTrue: [ aNumber - 100.0 ]
						ifFalse: [ (aNumber + fromT) / 2.0 ]).
			(anHGVoronoiEdge seesSameSide: center and: p)
				ifTrue: [ 
					(aNumber < toT
						ifTrue: [ toT := aNumber ]) notNil ]
				ifFalse: [ 
					(fromT < aNumber
						ifTrue: [ fromT := aNumber ]) notNil ] ]
		ifFalse: [ 
			| p |
			p := self
				atT:
					(toT isInfinite
						ifTrue: [ aNumber + 100.0 ]
						ifFalse: [ (aNumber + toT) / 2.0 ]).
			(anHGVoronoiEdge seesSameSide: center and: p) not
				ifTrue: [ 
					(aNumber < toT
						ifTrue: [ toT := aNumber ]) notNil ]
				ifFalse: [ 
					(fromT < aNumber
						ifTrue: [ fromT := aNumber ]) notNil ] ]! !

!HGVoronoiEdge methodsFor: 'topology' stamp: 'TomohiroOda 2/10/2012 14:26'!
on: anHGVoronoiRegion cutByEdge: anHGVoronoiEdge ifParallel: aBlock
	| a1 x1 b1 y1 a2 x2 b2 y2 det dx dy t1 t2 |
	a1 := vector x.
	x1 := origin x.
	b1 := vector y.
	y1 := origin y.
	a2 := anHGVoronoiEdge vector x.
	x2 := anHGVoronoiEdge origin x.
	b2 := anHGVoronoiEdge vector y.
	y2 := anHGVoronoiEdge origin y.
	det := a2 * b1 - (a1 * b2).
	det abs < 1.0e-8
		ifTrue: [ ^ aBlock value ].
	dx := x2 - x1.
	dy := y2 - y1.
	t1 := (a2 * dy - (b2 * dx)) / det.
	t2 := (a1 * dy - (b1 * dx)) / det.
	^ (((self containsT: t1 accuracy: 1.0e-8) and: [ anHGVoronoiEdge containsT: t2 accuracy: 1.0e-8 ])
		ifTrue: [ 
			self on: anHGVoronoiRegion cutAtT: t1 byEdge: anHGVoronoiEdge.
			anHGVoronoiEdge on: anHGVoronoiRegion cutAtT: t2 byEdge: self ]) notNil! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
origin
	^ origin! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
origin: anHG2dPoint
	origin := anHG2dPoint! !

!HGVoronoiEdge methodsFor: 'printing' stamp: 'TomohiroOda 2/10/2012 13:51'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	origin x printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	origin y printOn: aStream.
	aStream nextPutAll: '->'.
	vector x printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	vector y printOn: aStream.
	aStream nextPutAll: ' | '.
	fromT printOn: aStream.
	aStream nextPutAll: '->'.
	toT printOn: aStream.
	aStream nextPut: $)! !

!HGVoronoiEdge methodsFor: 'topology' stamp: 'TomohiroOda 2/10/2012 11:15'!
remove
	foreside removeEdge: self.
	backside removeEdge: self! !

!HGVoronoiEdge methodsFor: 'testing' stamp: 'TomohiroOda 2/15/2012 11:17'!
seesSameSide: anHG2dPoint1 and: anHG2dPoint2
	^ ((anHG2dPoint1 x - origin x) * vector y - ((anHG2dPoint1 y - origin y) * vector x)) < 0.0 xor: 
		((anHG2dPoint2 x - origin x) * vector y - ((anHG2dPoint2 y - origin y) * vector x)) > 0.0! !

!HGVoronoiEdge methodsFor: 'geometry' stamp: 'TomohiroOda 2/10/2012 10:43'!
somePoint
	^ self
		atT:
			(fromT isInfinite
				ifTrue: [ 
					toT isInfinite
						ifTrue: [ 0.0 ]
						ifFalse: [ toT - 100.0 ] ]
				ifFalse: [ 
					toT isInfinite
						ifTrue: [ fromT + 100.0 ]
						ifFalse: [ (fromT + toT) / 2.0 ] ])! !

!HGVoronoiEdge methodsFor: 'geometry' stamp: 'TomohiroOda 2/10/2012 13:32'!
tAtX: aNumber
	| t |
	vector x abs < 1.0e-8
		ifTrue: [ ^ nil ].
	t := (aNumber - origin x) / vector x.
	^ (self containsT: t)
		ifTrue: [ t ]! !

!HGVoronoiEdge methodsFor: 'geometry' stamp: 'TomohiroOda 2/10/2012 13:32'!
tAtY: aNumber
	| t |
	vector y abs < 1.0e-8
		ifTrue: [ ^ nil ].
	t := aNumber - origin y / vector y.
	^ (self containsT: t) ifTrue: [ t ]! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 14:17'!
theOtherSide: anHGVoronoiRegion
	anHGVoronoiRegion == foreside
		ifTrue: [ ^ backside ].
	anHGVoronoiRegion == backside
		ifTrue: [ ^ foreside ].
	^ nil! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:30'!
toT
	^ toT! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:30'!
toT: aNumber
	toT := aNumber! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:30'!
vector
	^ vector ! !

!HGVoronoiEdge methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:29'!
vector: anHG2dPoint
	vector := anHG2dPoint ! !

Object subclass: #HGVoronoiRegion
	instanceVariableNames: 'center edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Geometry-Voronoi'!

!HGVoronoiRegion class methodsFor: 'instance creation' stamp: 'TomohiroOda 2/8/2012 13:14'!
at: anHG2dPoint
	^ (self new)
		center: anHG2dPoint;
		yourself! !

!HGVoronoiRegion methodsFor: 'adding' stamp: 'TomohiroOda 2/8/2012 13:15'!
addEdge: anHGVoronoiEdge
	^ edges add: anHGVoronoiEdge ! !

!HGVoronoiRegion methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:14'!
center
	^ center! !

!HGVoronoiRegion methodsFor: 'accessing' stamp: 'TomohiroOda 2/8/2012 13:14'!
center: anHG2dPoint
	center := anHG2dPoint! !

!HGVoronoiRegion methodsFor: 'testing' stamp: 'TomohiroOda 2/10/2012 10:45'!
containsPoint: anHG2dPoint
	^ edges allSatisfy: [:edge |
		edge seesSameSide: center and: anHG2dPoint]! !

!HGVoronoiRegion methodsFor: 'topology' stamp: 'TomohiroOda 2/10/2012 12:11'!
cutAgainst: anHGVoronoiRegion conflictEdgesDo: aBlock
	| newEdge |
	newEdge := HGVoronoiEdge foreside: self backside: anHGVoronoiRegion.
	edges
		do: [ :edge | 
			(edge on: self cutByEdge: newEdge ifParallel: [ true ])
				ifTrue: [ aBlock value: newEdge value: edge ] ].
	self addEdge: newEdge.
	anHGVoronoiRegion addEdge: newEdge.
	^ newEdge! !

!HGVoronoiRegion methodsFor: 'topology' stamp: 'TomohiroOda 2/10/2012 12:12'!
cutAgainst: anHGVoronoiRegion conflictEdgesDo: aBlock parallelEdgesDo: anotherBlock
	| newEdge |
	newEdge := HGVoronoiEdge foreside: self backside: anHGVoronoiRegion.
	edges
		do: [ :edge | 
			(edge
				on: self
				cutByEdge: newEdge
				ifParallel: [ 
					anotherBlock value: newEdge value: edge.
					false ])
				ifTrue: [ aBlock value: newEdge value: edge ] ].
	self addEdge: newEdge.
	anHGVoronoiRegion addEdge: newEdge.
	^ newEdge! !

!HGVoronoiRegion methodsFor: 'enumerating' stamp: 'TomohiroOda 2/11/2012 18:09'!
edgesDo: aBlock
	edges do: aBlock! !

!HGVoronoiRegion methodsFor: 'initialize-release' stamp: 'TomohiroOda 2/8/2012 13:15'!
initialize
	super initialize.
	edges := OrderedCollection new! !

!HGVoronoiRegion methodsFor: 'enumerating' stamp: 'TomohiroOda 2/11/2012 18:38'!
origin: aPoint1 corner: aPoint2 pointsDo: aBlock
	| x1 x2 y1 y2 points |
	x1 := aPoint1 x.
	x2 := aPoint2 x.
	y1 := aPoint1 y.
	y2 := aPoint2 y.
	points := OrderedCollection new: edges size + 4.
	self
		edgesDo: [ :edge | 
			| from to |
			from := edge fromT.
			to := edge toT.
			(edge tAtX: x1)
				ifNotNilDo: [ :t | 
					edge vector x > 0.0
						ifTrue: [ from := from max: t ]
						ifFalse: [ to := to min: t ] ].
			(edge tAtY: y1)
				ifNotNilDo: [ :t | 
					edge vector y > 0.0
						ifTrue: [ from := from max: t ]
						ifFalse: [ to := to min: t ] ].
			(edge tAtX: x2)
				ifNotNilDo: [ :t | 
					edge vector x > 0.0
						ifTrue: [ to := to min: t ]
						ifFalse: [ from := from max: t ] ].
			(edge tAtY: y2)
				ifNotNilDo: [ :t | 
					edge vector y > 0.0
						ifTrue: [ to := to min: t ]
						ifFalse: [ from := from max: t ] ].
			(from <= to and: [ from isInfinite not and: [ to isInfinite not ] ])
				ifTrue: [ 
					| p1 p2 theta1 theta2 |
					p1 := edge atT: from.
					p2 := edge atT: to.
					theta1 := (p1 - center) theta.
					theta2 := (p2 - center) theta.
					edge fromT ~= from
						ifTrue: [ points add: theta1 -> p1 ].
					edge toT ~= to
						ifTrue: [ points add: theta2 -> p2 ].
					(theta2 - theta1) \\ Float twoPi < Float pi
						ifTrue: [ 
							edge fromT isInfinite not
								ifTrue: [ points add: theta1 -> p1 ] ]
						ifFalse: [ 
							edge toT isInfinite not
								ifTrue: [ points add: theta2 -> p2 ] ] ] ].
	(HG2dPoint x: x1 y: y1) in: [:point |
		(self containsPoint: point) ifTrue: [points add: (point - center) theta -> point]].
	(HG2dPoint x: x1 y: y2) in: [:point |
		(self containsPoint: point) ifTrue: [points add: (point - center) theta -> point]].
	(HG2dPoint x: x2 y: y1) in: [:point |
		(self containsPoint: point) ifTrue: [points add: (point - center) theta -> point]].
	(HG2dPoint x: x2 y: y2) in: [:point |
		(self containsPoint: point) ifTrue: [points add: (point - center) theta -> point]].
	(points asSortedCollection: [ :less :more | less key <= more key ]) do: [ :pair | aBlock value: pair value ]! !

!HGVoronoiRegion methodsFor: 'printing' stamp: 'TomohiroOda 2/10/2012 13:49'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	center x printOn: aStream.
	aStream nextPut: $,.
	aStream space.
	center y printOn: aStream.
	aStream nextPut: $)! !

!HGVoronoiRegion methodsFor: 'topology' stamp: 'TomohiroOda 2/15/2012 11:23'!
purgeExtraEdges
	^ (edges
		select: [ :suspect | 
			| point |
			point := suspect somePoint.
			edges anySatisfy: [ :judge | suspect ~~ judge and: [(judge seesSameSide: center and: point) not] ] ])
		do: [ :edge | edge remove ];
		yourself! !

!HGVoronoiRegion methodsFor: 'removing' stamp: 'TomohiroOda 2/8/2012 13:17'!
removeEdge: anHGVoronoiEdge
	^ edges remove: anHGVoronoiEdge ! !

Object subclass: #HoneyGingerObjectProtocol
	instanceVariableNames: 'stream'
	classVariableNames: 'HG2dPointType HGBinaryStopBit HGBinaryType HGDefineType HGDictType HGEndMark HGEndMarkType HGFloatType HGIndexStopBit HGIndexType HGIntegerSignBit HGIntegerStopBit HGIntegerType HGListType HGNilType HGStringType'
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Serializers'!

HoneyGingerObjectProtocol subclass: #HoneyGingerDeserializer
	instanceVariableNames: 'indexedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Serializers'!

!HoneyGingerDeserializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerDeserializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerDeserializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerDeserializer methodsFor: 'initialize-release' stamp: 'TomohiroOda 9/13/2011 13:23'!
initialize
	super initialize.
	indexedObjects := OrderedCollection new! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 9/13/2011 13:33'!
next
	^ self readObject! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 9/13/2011 13:42'!
next: anInteger
	| nexts |
	nexts := Array new: anInteger.
	1 to: anInteger do: [ :index | nexts at: index put: self readObject ].
	^ nexts! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 6/24/2011 14:45'!
read
	^ self readDict! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:32'!
readBinary: firstByte
	| byte length bits stopBit bytes |
	byte := firstByte.
	length := byte bitAnd: 2r1111.
	bits := 4.
	stopBit := byte bitAnd: HGBinaryStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			byte := stream next.
			length := length + ((byte bitAnd: 2r1111111) bitShift: bits).
			bits := bits + 7.
			stopBit := byte bitAnd: 2r10000000 ].
	bytes := ByteArray new: length.
	1 to: length do: [ :index | bytes at: index put: stream next ].
	^ bytes! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 6/24/2011 14:44'!
readDefine
	^ indexedObjects addLast: (self readObject)! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:32'!
readDict
	| dict key |
	dict := Dictionary new.
	[ (key := self readObject) ~= HGEndMark ] whileTrue: [ dict at: key put: (self readObject) ].
	^ dict! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:32'!
readDo: aBlock
	| key |
	[ (key := self readObject) ~= HGEndMark ] whileTrue: [ aBlock value: key value: self readObject ]! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:32'!
readEnd
	^ HGEndMark! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 6/24/2011 12:08'!
readFloat
	^ Float
		fromIEEE32Bit:
			((((stream next bitShift: 24) bitOr: (stream next bitShift: 16)) bitOr: (stream next bitShift: 8)) bitOr: stream next)! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/2/2011 10:34'!
readHG2dPoint
	^HG2dPoint x: self readFloat y: self readFloat! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:32'!
readIndex: firstByte
	| byte index bits stopBit bytes |
	byte := firstByte.
	index := byte bitAnd: 2r11111.
	bits := 5.
	stopBit := byte bitAnd: HGIndexStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			byte := stream next.
			index := index + ((byte bitAnd: 2r1111111) bitShift: bits).
			bits := bits + 7.
			stopBit := byte bitAnd: 2r10000000 ].
	^ (indexedObjects at: index) deepCopy! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:31'!
readInteger: firstByte
	| byte sign integer bits stopBit bytes |
	byte := firstByte.
	sign := byte bitAnd: HGIntegerSignBit.
	integer := byte bitAnd: 2r11111.
	bits := 5.
	stopBit := byte bitAnd: HGIntegerStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			byte := stream next.
			integer := integer + ((byte bitAnd: 2r1111111) bitShift: bits).
			bits := bits + 7.
			stopBit := byte bitAnd: 2r10000000 ].
	^ sign = 0
		ifTrue: [ integer ]
		ifFalse: [ integer negated ]! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/3/2011 15:33'!
readList
	| buffer object |
	buffer := Array new writeStream.
	[ (object := self readObject) ~= HGEndMark ] whileTrue: [ buffer nextPut: object ].
	^ buffer contents! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 9/13/2011 15:16'!
readNil
	^ nil! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 6/27/2011 08:57'!
readObject
	^self readObject: stream next! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/2/2011 10:35'!
readObject: firstByte
	| selector |
	selector := #(#readEnd #readFloat #readString #readList #readDict #readDefine #readNil)
		at: firstByte + 1
		ifAbsent: [  ].
	selector ifNotNil: [ ^ self perform: selector ].
	(firstByte bitAnd: HGIntegerType) ~= 0
		ifTrue: [ ^ self readInteger: firstByte ].
	(firstByte bitAnd: HGIndexType) ~= 0
		ifTrue: [ ^ self readIndex: firstByte ].
	(firstByte bitAnd: HGBinaryType) ~= 0
		ifTrue: [ ^ self readBinary: firstByte ].
	firstByte = HG2dPointType 
		ifTrue: [ ^ self readHG2dPoint ].
	^ self error: 'Undefined type in the stream'! !

!HoneyGingerDeserializer methodsFor: 'reading' stamp: 'TomohiroOda 10/2/2011 10:25'!
readString
	| buffer code |
	buffer := String new writeStream.
	[ (code := stream next) ~= HGEndMarkType ] whileTrue: [ buffer nextPut: (Character value: code) ].
	^ buffer contents! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanBinary: firstByte into: destStream
	| byte length bits stopBit |
	byte := firstByte.
	length := byte bitAnd: 2r1111.
	bits := 4.
	stopBit := byte bitAnd: HGBinaryStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			destStream nextPut: (byte := stream next).
			length := length + ((byte bitAnd: 2r1111111) bitShift: bits).
			bits := bits + 7.
			stopBit := byte bitAnd: 2r10000000 ].
	length timesRepeat: [ destStream nextPut: stream next ]! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 6/24/2011 15:24'!
scanDefineInto: destStream
	self scanObjectInto: destStream! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanDictInto: destStream
	[ (self scanObjectInto: destStream) ~= HGEndMark ] whileTrue: [ self scanObjectInto: destStream ]! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanDo: aBlock
	| key |
	[ (key := self readObject) ~= HGEndMark ]
		whileTrue: [ 
			| buffer |
			buffer := ByteArray new writeStream.
			self scanObjectInto: buffer.
			aBlock value: key value: buffer contents ]! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanEndInto: destStream
	^ HGEndMark! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 6/24/2011 15:25'!
scanFloatInto: destStream
	destStream nextPut: stream next.
	destStream nextPut: stream next.
	destStream nextPut: stream next.
	destStream nextPut: stream next! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:37'!
scanHG2dPointInto: destStream
	self scanFloatInto: destStream.
	self scanFloatInto: destStream! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanIndex: firstByte into: destStream
	| stopBit byte |
	stopBit := firstByte bitAnd: HGIndexStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			destStream nextPut: (byte := stream next).
			stopBit := byte bitAnd: 2r10000000 ]! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanInteger: firstByte into: destStream
	| byte stopBit |
	byte := firstByte.
	stopBit := byte bitAnd: HGIntegerStopBit.
	[ stopBit = 0 ]
		whileTrue: [ 
			destStream nextPut: (byte := stream next).
			stopBit := byte bitAnd: 2r10000000 ]! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:26'!
scanListInto: destStream
	[ (self scanObjectInto: destStream) ~= HGEndMark ] whileTrue! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 9/13/2011 15:15'!
scanNilInto: destStream
	"well, nothing to do... that's my trouble..."! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:37'!
scanObject: firstByte into: destStream
	| selector |
	selector := #(#scanEndInto: #scanFloatInto: #scanStringInto: #scanListInto: #scanDictInto: #scanDefineInto: #scanNilInto:)
		at: firstByte + 1
		ifAbsent: [  ].
	selector ifNotNil: [ ^ self perform: selector with: destStream ].
	(firstByte bitAnd: HGIntegerType) ~= 0
		ifTrue: [ ^ self scanInteger: firstByte into: destStream ].
	(firstByte bitAnd: HGIndexType) ~= 0
		ifTrue: [ ^ self scanIndex: firstByte into: destStream ].
	(firstByte bitAnd: HGBinaryType) ~= 0
		ifTrue: [ ^ self scanBinary: firstByte into: destStream ].
	firstByte = HG2dPointType 
		ifTrue: [ ^self scanHG2dPointInto: destStream ].
	^ self error: 'Undefined type in the stream'! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 6/27/2011 09:02'!
scanObjectInto: destStream
	| byte |
	destStream nextPut: (byte := stream next).
	^ self scanObject: byte into: destStream! !

!HoneyGingerDeserializer methodsFor: 'scanning' stamp: 'TomohiroOda 10/2/2011 10:27'!
scanStringInto: destStream
	[ 
	| code |
	destStream nextPut: (code := stream next).
	code ~= HGEndMarkType ] whileTrue! !

!HoneyGingerObjectProtocol class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerObjectProtocol class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerObjectProtocol class methodsFor: 'class initialization' stamp: 'TomohiroOda 10/2/2011 10:24'!
initialize
	"PcardObjectProtocol initialize"

	super initialize.
	HGEndMarkType := 2r00000000.
	HGFloatType := 2r00000001.
	HGStringType := 2r00000010.
	HGListType := 2r00000011.
	HGDictType := 2r00000100.
	HGDefineType := 2r00000101.
	HGNilType := 2r00000110.
	HGBinaryType := 2r00100000.
	HGBinaryStopBit := 2r00010000.
	HGIndexType := 2r01000000.
	HGIndexStopBit := 2r00100000.
	HGIntegerType := 2r10000000.
	HGIntegerSignBit := 2r01000000.
	HGIntegerStopBit := 2r00100000.
	HG2dPointType := 2r00010000.
	HGEndMark := Object new! !

!HoneyGingerObjectProtocol class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/24/2011 09:49'!
on: aStream
	^ self new setStream: aStream! !

!HoneyGingerObjectProtocol class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerObjectProtocol methodsFor: 'private' stamp: 'TomohiroOda 6/24/2011 09:48'!
setStream: aStream
	stream := aStream! !

HoneyGingerObjectProtocol subclass: #HoneyGingerSerializer
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Serializers'!

!HoneyGingerSerializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerSerializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerSerializer class methodsFor: 'examples' stamp: 'TomohiroOda 10/2/2011 10:12'!
example1
	"PcardSerializer example1"

	| testdata stream serializer |
	testdata := OrderedCollection new.
	testdata add: 123.4.
	stream := ByteArray new writeStream.
	serializer := HoneyGingerSerializer on: stream.
	testdata do: [ :data | serializer writeObject: data ].
	^ stream contents! !

!HoneyGingerSerializer class methodsFor: 'examples' stamp: 'TomohiroOda 10/2/2011 10:12'!
example2
	"PcardSerializer example2"

	| testdata stream serializer bytes buffer scanner deserializer |
	testdata := Dictionary new.
	testdata at: 1 put: #(1 2 3).
	testdata at: 'abc' put: (Dictionary new at: 'xyz' put: -1; yourself).
	stream := ByteArray new writeStream.
	serializer := HoneyGingerSerializer on: stream.
	serializer write: testdata.
	bytes := stream contents.
	buffer := Dictionary new.
	scanner := HoneyGingerDeserializer on: bytes readStream.
	scanner scanDo: [ :key :value | buffer at: key put: value ].
	stream := ByteArray new writeStream.
	serializer := HoneyGingerSerializer on: stream.
	buffer keysAndValuesDo: [ :key :value | serializer writeObject: key. stream nextPutAll: value].
	serializer writeEnd.
	deserializer := HoneyGingerDeserializer on: stream contents readStream.
	^deserializer read! !

!HoneyGingerSerializer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerSerializer methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/2/2011 10:34'!
initialize
	super initialize.
	selectors := IdentityDictionary new.
	selectors at: #Float put: #writeFloat:.
	selectors at: #String put: #writeString:.
	selectors at: #Array put: #writeList:.
	selectors at: #OrderedCollection put: #writeList:.
	selectors at: #Collection put: #writeList:.
	selectors at: #Dictionary put: #writeDict:.
	selectors at: #IdentityDictionary put: #writeDict:.
	selectors at: #ByteArray put: #writeBinary:.
	selectors at: #LargePositiveInteger put: #writeInteger:.
	selectors at: #LargeNegativeInteger put: #writeInteger:.
	selectors at: #SmallInteger put: #writeInteger:.
	selectors at: #UndefinedObject put: #writeNil:.
	selectors at: #HG2dPoint put: #writeHG2dPoint:! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 9/13/2011 13:35'!
nextPut: anObject
	self writeObject: anObject.
	^ anObject! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 9/13/2011 13:35'!
nextPutAll: aCollection
	aCollection do: [ :object | self nextPut: object ].
	^ aCollection! !

!HoneyGingerSerializer methodsFor: 'accessing' stamp: 'TomohiroOda 9/13/2011 15:12'!
searchSelectorFor: anObject
	| class |
	class := anObject class.
	[ class notNil ]
		whileTrue: [ 
			(selectors includesKey: class name)
				ifTrue: [ ^ selectors at: class name ].
			class := class superclass ].
	^ self error: 'Unsupported type'! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 6/24/2011 14:27'!
write: aKeyedCollection
	aKeyedCollection
		keysAndValuesDo: [ :key :value | 
			self writeObject: key.
			self writeObject: value ].
	self writeEnd! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:27'!
writeBinary: aByteArray
	| length first4bits stopBit |
	length := aByteArray size.
	first4bits := length bitAnd: 2r1111.
	stopBit := first4bits = length
		ifTrue: [ HGBinaryStopBit ]
		ifFalse: [ 0 ].
	stream nextPut: ((HGBinaryType bitOr: stopBit) bitOr: first4bits).
	length := length >> 4.
	[ stopBit = 0 ]
		whileTrue: [ 
			| first7bits |
			first7bits := length bitAnd: 2r1111111.
			stopBit := first7bits = length
				ifTrue: [ 2r10000000 ]
				ifFalse: [ 0 ].
			stream nextPut: (stopBit bitOr: first7bits).
			length := length >> 7 ].
	stream nextPutAll: aByteArray! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:27'!
writeDefine
	stream nextPut: HGDefineType! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:28'!
writeDict: aDictionary
	stream nextPut: HGDictType.
	aDictionary keysAndValuesDo: [ :key :value |
		self writeObject: key.
		self writeObject: value].
	stream nextPut: HGEndMarkType! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:28'!
writeEnd
	^ stream nextPut: HGEndMarkType! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:28'!
writeFloat: aFloat
	| bits |
	bits := aFloat asIEEE32BitWord.
	stream nextPut: HGFloatType.
	stream nextPut: (bits bitShift: -24).
	stream nextPut: ((bits bitShift: -16) bitAnd: 255).
	stream nextPut: ((bits bitShift: -8) bitAnd: 255).
	stream nextPut: (bits bitAnd: 255)! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:33'!
writeHG2dPoint: aHG2dPoint
	| bits |
	stream nextPut: 2r00010000.
	bits := aHG2dPoint x asFloat asIEEE32BitWord.
	stream nextPut: (bits bitShift: -24).
	stream nextPut: ((bits bitShift: -16) bitAnd: 255).
	stream nextPut: ((bits bitShift: -8) bitAnd: 255).
	stream nextPut: (bits bitAnd: 255).
	bits := aHG2dPoint y asFloat asIEEE32BitWord.
	stream nextPut: (bits bitShift: -24).
	stream nextPut: ((bits bitShift: -16) bitAnd: 255).
	stream nextPut: ((bits bitShift: -8) bitAnd: 255).
	stream nextPut: (bits bitAnd: 255)! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:28'!
writeIndex: anInteger
	| index first5bits stopBit |
	index := anInteger.
	first5bits := index bitAnd: 2r11111.
	stopBit := first5bits = index
		ifTrue: [ HGIndexStopBit ]
		ifFalse: [ 0 ].
	stream nextPut: ((HGIndexType bitOr: stopBit) bitOr: first5bits).
	index := index >> 5.
	[ stopBit = 0 ]
		whileTrue: [ 
			| first7bits |
			first7bits := index bitAnd: 2r1111111.
			stopBit := first7bits = index
				ifTrue: [ 2r10000000 ]
				ifFalse: [ 0 ].
			stream nextPut: (stopBit bitOr: first7bits).
			index := index >> 7 ]! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:28'!
writeInteger: anInteger
	| integer  signBit first5bits stopBit |
	integer := anInteger abs.
	signBit := anInteger < 0 ifTrue: [HGIntegerSignBit]  ifFalse: [0].
	first5bits := integer bitAnd: 2r11111.
	stopBit := first5bits = integer
		ifTrue: [ HGIntegerStopBit ]
		ifFalse: [ 0 ].
	stream nextPut: (((HGIntegerType bitOr: signBit) bitOr: stopBit) bitOr: first5bits).
	integer := integer >> 5.
	[ stopBit = 0 ]
		whileTrue: [ 
			| first7bits |
			first7bits := integer bitAnd: 2r1111111.
			stopBit := first7bits = integer
				ifTrue: [ 2r10000000 ]
				ifFalse: [ 0 ].
			stream nextPut: (stopBit bitOr: first7bits).
			integer := integer >> 7 ]! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:29'!
writeList: aCollection
	stream nextPut: HGListType.
	aCollection do: [ :object | self writeObject: object].
	stream nextPut: HGEndMarkType! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:29'!
writeNil: nilObject
	stream nextPut: HGNilType ! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 6/24/2011 14:24'!
writeObject: anObject
	self perform: (selectors at: anObject class name ifAbsentPut: [ self searchSelectorFor: anObject ]) with: anObject! !

!HoneyGingerSerializer methodsFor: 'writing' stamp: 'TomohiroOda 10/2/2011 10:29'!
writeString: aString
	stream nextPut: HGStringType.
	stream nextPutAll: aString asByteArray.
	stream nextPut: HGEndMarkType! !

Object subclass: #HoneyGingerServer
	instanceVariableNames: 'socket data locks clientIDs acceptingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Server'!

!HoneyGingerServer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerServer class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerServer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/17/2011 13:55'!
on: aListeningSocket
	^ (self new)
		setSocket: aListeningSocket;
		yourself! !

!HoneyGingerServer class methodsFor: 'instance creation' stamp: 'TomohiroOda 6/20/2011 08:36'!
port: aNumber
	| socket |
	socket := Socket tcpCreateIfFail: [ self error: 'Can''t create a socket' ].
	socket listenOn: aNumber backlogSize: 10.
	^ self on: socket! !

!HoneyGingerServer class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/6/2011 13:59'!
clientIDFor: anInteger
	| id |
	id := self privateClientIDFor: anInteger.
	clientIDs at: id put: TimeStamp now.
	self garbageCollectClientIDs.
	^ id! !

!HoneyGingerServer methodsFor: 'defaults' stamp: 'TomohiroOda 10/6/2011 14:16'!
defaultMaxIdleTimeForClient
	^ Duration seconds: 60! !

!HoneyGingerServer methodsFor: 'private' stamp: 'TomohiroOda 10/6/2011 14:09'!
garbageCollectClientIDs
	| deadline deadClientIDs |
	deadline := TimeStamp now + maxIdleTimeForClient negated.
	deadClientIDs := Array new writeStream.
	clientIDs
		keysAndValuesDo: [ :clientID :timestamp | 
			timestamp < deadline
				ifTrue: [ deadClientIDs nextPut: clientID ] ].
	deadClientIDs contents do: [ :clientID | clientIDs removeKey: clientID ifAbsent: [  ] ]! !

!HoneyGingerServer methodsFor: 'initialize-release' stamp: 'TomohiroOda 10/6/2011 14:10'!
initialize
	super initialize.
	data := Dictionary new: 800.
	locks := Dictionary new: 10.
	clientIDs := Dictionary new: 10.
	maxIdleTimeForClient := self defaultMaxIdleTimeForClient! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/6/2011 14:11'!
maxIdleTimeForClient
	^ maxIdleTimeForClient ! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/6/2011 14:11'!
maxIdleTimeForClient: aDuration
	maxIdleTimeForClient := aDuration! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/5/2011 15:05'!
particleAt: anInteger put: anObject
	^ (locks includesKey: anInteger)
		ifFalse: [ data at: anInteger put: anObject ]! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 6/20/2011 09:17'!
particleData
	^data! !

!HoneyGingerServer methodsFor: 'private' stamp: 'TomohiroOda 10/5/2011 15:29'!
privateClientIDFor: anInteger
	^ (clientIDs includesKey: anInteger)
		ifTrue: [ anInteger ]
		ifFalse: [ 
			| clientID |
			clientID := clientIDs size + 1.
			(clientIDs includesKey: clientID)
				ifTrue: [ clientID ]
				ifFalse: [ 
					clientID := 1.
					[ clientIDs includesKey: clientID ] whileTrue: [ clientID := clientID + 1 ] ].
			clientID ]! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/6/2011 13:59'!
refreshClientID: anInteger
	clientIDs at: anInteger put: TimeStamp now.
	self garbageCollectClientIDs! !

!HoneyGingerServer methodsFor: 'accessing' stamp: 'TomohiroOda 10/6/2011 13:59'!
releaseClientID: anInteger
	clientIDs removeKey: anInteger ifAbsent: [  ].
	self garbageCollectClientIDs! !

!HoneyGingerServer methodsFor: 'servicing' stamp: 'TomohiroOda 10/9/2011 14:00'!
serveFor: aSocket
	[ 
	(HoneyGingerServerWorker
		server: self
		transportStream:
			((SocketStream on: aSocket)
				binary;
				yourself)) process ] fork! !

!HoneyGingerServer methodsFor: 'private' stamp: 'TomohiroOda 6/17/2011 13:53'!
setSocket: aSocket
	socket := aSocket! !

!HoneyGingerServer methodsFor: 'servicing' stamp: 'TomohiroOda 6/21/2011 08:41'!
shutdown
	acceptingProcess
		ifNotNil: [ 
			acceptingProcess terminate.
			acceptingProcess := nil ].
	socket
		ifNotNil: [ 
			socket closeAndDestroy.
			socket := nil ]! !

!HoneyGingerServer methodsFor: 'servicing' stamp: 'TomohiroOda 6/20/2011 09:50'!
startup
	acceptingProcess := [ 
	[ [ (socket waitForAcceptFor: Socket standardTimeout) ifNotNilDo: [ :serverSocket | self serveFor: serverSocket ] ] repeat ]
		ifError: [ socket close ] ] fork! !

Object subclass: #HoneyGingerServerWorker
	instanceVariableNames: 'server stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Server'!

!HoneyGingerServerWorker class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerServerWorker class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerServerWorker class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/9/2011 13:59'!
server: aHoneyGingerServer transportStream: aStream
	^ (self new)
		setServer: aHoneyGingerServer transportStream: aStream;
		yourself! !

!HoneyGingerServerWorker class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerServerWorker methodsFor: 'servicing' stamp: 'TomohiroOda 10/6/2011 13:57'!
process
	[ 
	[ 
	| command |
	stream startSession.
	[ 
	command := stream next.
	command ~= stream closeCommand ]
		whileTrue: [ 
			server refreshClientID: stream clientID.
			command = stream downloadCommand
				ifTrue: [ stream download ].
			command = stream uploadCommand
				ifTrue: [ stream upload ] ] ] on: NetworkError do: [  ] ]
		ensure: [ 
			server releaseClientID: stream clientID.
			stream endSession ]! !

!HoneyGingerServerWorker methodsFor: 'private' stamp: 'TomohiroOda 10/9/2011 12:18'!
setServer: aHoneyGingerServer transportStream: aStream
	server := aHoneyGingerServer.
	stream := HoneyGingerServerSocketStream on: aStream.
	stream clientIDBlock: [:id | server clientIDFor: id].
	stream downloadBlock: [:client | server particleData].
	stream uploadBlock: [:client :key :value | server particleAt: key put: value]! !

Object subclass: #HoneyGingerSocketStream
	instanceVariableNames: 'transportStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Streams'!

HoneyGingerSocketStream subclass: #HoneyGingerClientSocketStream
	instanceVariableNames: 'clientID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Streams'!

!HoneyGingerClientSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerClientSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerClientSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerClientSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 12:52'!
clientID
	^ clientID! !

!HoneyGingerClientSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 12:53'!
clientID: anInteger
	clientID := anInteger! !

!HoneyGingerClientSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:53'!
download
	| objects size |
	transportStream nextPut: self downloadCommand.
	self flush.
	^ self getDeserializer read! !

!HoneyGingerClientSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:53'!
downloadDo: aBlock
	transportStream nextPut: self downloadCommand.
	self flush.
	self getDeserializer readDo: aBlock! !

!HoneyGingerClientSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:53'!
endSession
	transportStream nextPut: self closeCommand.
	self flush.
	self close! !

!HoneyGingerClientSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:14'!
getDeserializer
	^ HoneyGingerDeserializer on: self! !

!HoneyGingerClientSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/2/2011 10:14'!
getSerializer
	^ HoneyGingerSerializer on: self! !

!HoneyGingerClientSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:53'!
startSession
	self getSerializer writeObject: (clientID ifNil: [0]).
	self flush.
	clientID := self getDeserializer readObject! !

!HoneyGingerClientSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:53'!
upload: aDictionary
	transportStream nextPut: self uploadCommand.
	self getSerializer write: aDictionary.
	self flush! !

HoneyGingerSocketStream subclass: #HoneyGingerServerSocketStream
	instanceVariableNames: 'clientID clientIDBlock downloadBlock uploadBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Streams'!

!HoneyGingerServerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerServerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerServerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerServerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 14:15'!
clientID
	^ clientID! !

!HoneyGingerServerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 14:07'!
clientIDBlock
	^ clientIDBlock! !

!HoneyGingerServerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 14:07'!
clientIDBlock: aBlock
	clientIDBlock := aBlock! !

!HoneyGingerServerSocketStream methodsFor: 'defaults' stamp: 'TomohiroOda 10/6/2011 10:53'!
defaultClientIDBlock
	"By default, say you are unidentified."

	^ [ :id | id ]! !

!HoneyGingerServerSocketStream methodsFor: 'defaults' stamp: 'TomohiroOda 6/17/2011 14:12'!
defaultDownloadBlock
	"By default, send empty data."

	^ [ :client | Dictionary new ]! !

!HoneyGingerServerSocketStream methodsFor: 'defaults' stamp: 'TomohiroOda 6/17/2011 14:19'!
defaultUploadBlock
	"The default do nothing. Just throws the data away."

	^ [ :client :key :value |  ]! !

!HoneyGingerServerSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:54'!
download
	| objects serializer |
	objects := downloadBlock value: clientID.
	serializer := self getSerializer.
	objects
		keysAndValuesDo: [ :key :value | 
			serializer writeObject: key.
			transportStream nextPutAll: value ].
	serializer writeEnd.
	self flush.
	^ objects! !

!HoneyGingerServerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 14:49'!
downloadBlock: aBlock
	downloadBlock := aBlock! !

!HoneyGingerServerSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:54'!
endSession
	self close! !

!HoneyGingerServerSocketStream methodsFor: 'initialize-release' stamp: 'TomohiroOda 6/17/2011 14:05'!
initialize
	super initialize.
	self clientIDBlock: self defaultClientIDBlock! !

!HoneyGingerServerSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 10/9/2011 13:54'!
startSession
	clientID := clientIDBlock value: self getDeserializer readObject.
	self getSerializer writeObject: clientID.
	self flush! !

!HoneyGingerServerSocketStream methodsFor: 'sessions' stamp: 'TomohiroOda 6/24/2011 15:42'!
upload
	self getDeserializer scanDo: [ :key :bytes | uploadBlock value: clientID value: key value: bytes ]! !

!HoneyGingerServerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 6/17/2011 14:49'!
uploadBlock: aBlock
	uploadBlock := aBlock! !

!HoneyGingerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:16'!
LICENSE
	^ self MITLicense! !

!HoneyGingerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerSocketStream class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/9/2011 13:29'!
on: aStream
	^ (self basicNew)
		initialize;
		setStream: aStream;
		yourself! !

!HoneyGingerSocketStream class methodsFor: 'instance creation' stamp: 'TomohiroOda 10/9/2011 14:23'!
onSocket: aSocket
	^ self
		on:
			((SocketStream on: aSocket)
				binary;
				yourself)! !

!HoneyGingerSocketStream class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:55'!
close
	transportStream close! !

!HoneyGingerSocketStream methodsFor: 'magic numbers' stamp: 'TomohiroOda 6/17/2011 14:03'!
closeCommand
	^ 0! !

!HoneyGingerSocketStream methodsFor: 'magic numbers' stamp: 'TomohiroOda 6/17/2011 14:03'!
downloadCommand
	^ 101! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:41'!
flush
	transportStream flush! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:13'!
getDeserializer
	^ HoneyGingerDeserializer on: transportStream! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:13'!
getSerializer
	^ HoneyGingerSerializer on: transportStream ! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:41'!
next
	^ transportStream next! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:41'!
next: anInteger
	^ transportStream next: anInteger ! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:42'!
nextPut: byte
	^ transportStream nextPut: byte! !

!HoneyGingerSocketStream methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 13:42'!
nextPutAll: bytes
	^ transportStream nextPutAll: bytes! !

!HoneyGingerSocketStream methodsFor: 'private' stamp: 'TomohiroOda 10/9/2011 12:10'!
setStream: aStream
	transportStream := aStream! !

!HoneyGingerSocketStream methodsFor: 'magic numbers' stamp: 'TomohiroOda 6/17/2011 14:03'!
uploadCommand
	^ 102! !

Object subclass: #HoneyGingerTestConnection
	instanceVariableNames: 'serverSocket clientSocket csStream scStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HoneyGinger-Communications-Tests'!

!HoneyGingerTestConnection class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:17'!
LICENSE
	^ self MITLicense! !

!HoneyGingerTestConnection class methodsFor: 'copyrights' stamp: 'TomohiroOda 10/12/2011 13:25'!
MITLicense
	^ 'Copyright (c) 2011 Tomohiro Oda and Software Research Associates, Inc.\\Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\\The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software\\THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.' withCRs! !

!HoneyGingerTestConnection class methodsFor: 'copyrights' stamp: 'TomohiroOda 11/2/2011 15:01'!
showLicense
	self LICENSE asText asMorph wrapFlag: true;
		 autoFit: false;
		 extent: 400 @ 400;
		 justified;
		 openInWindowLabeled: 'LICENSE'! !

!HoneyGingerTestConnection methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:24'!
clientStream
	^ clientSocket
		ifNotNilDo: [ :socket | 
			clientSocket := nil.
			socket ]
		ifNil: [ self error: 'Can''t listen to the same port more than once.' ]! !

!HoneyGingerTestConnection methodsFor: 'initialie-release' stamp: 'TomohiroOda 10/9/2011 13:12'!
initialize
	csStream := HoneyGingerTestStream new.
	scStream := HoneyGingerTestStream new.
	serverSocket := HoneyGingerTestSocketStream readBuffer: csStream writeBuffer: scStream.
	clientSocket := HoneyGingerTestSocketStream readBuffer: scStream writeBuffer: csStream! !

!HoneyGingerTestConnection methodsFor: 'accessing' stamp: 'TomohiroOda 10/9/2011 12:24'!
serverStream
	^ serverSocket
		ifNotNilDo: [ :socket | 
			serverSocket := nil.
			socket ]
		ifNil: [ self error: 'Can''t listen to the same port more than once.' ]! !
HoneyGingerObjectProtocol initialize!
